
import * as LayerType from 'luciad/view/LayerType';
import * as RasterTileSetLayer from 'luciad/view/tileset/RasterTileSetLayer';
import * as BingMapsTileSetModel from'luciad/model/tileset/BingMapsTileSetModel';
import * as $ from 'jquery';
  // "dojo/request"
export class BingMapsDataLoader {

    /**
     * Creates a layer for Bing Maps data.
     *
     * Summary:
     * - Contact Bing proxy to initialize session
     * - Create a {@link luciad/model/tileset/BingMapsTileSetModel}
     * - Create a {@link luciad/view/tileset/RasterTileSetLayer}
     *
     * @param type {String} One of "road", "aerial" or "AerialWithLabels"
     * @return {Promise} A promise for a layer.
     */
 
    static createLayer(type) {
 
      var bingKey = "Mu6mdsjIZMbll1rtFWR1~M35mX9mHul-XRrqILmUr_g~AsiFaL4BdcFtqnrU_D0IFCtqLzYt5fNO0vE3_ejwmSdkigkAZfHCbNoyVbww4saM";
 
      var metadataURL = "http://dev.virtualearth.net/REST/v1/Imagery/Metadata/" + type + "/";  
      var getBingMetadata = $.ajax({
        url: metadataURL,
        dataType: "jsonp",
        jsonp: "jsonp",
        data: {
          key: bingKey,
          include: "ImageryProviders"
        },
        success: function(response) {
          console.log(response);
        }
      });
 
      return getBingMetadata.then(
          function(data) {
            //Inspect the response             var resourceSet;
            var resource = data;
            // alert('layerBingMaps');

            if (Object.prototype.toString.call(data.resourceSets) === '[object Array]' && data.resourceSets.length > 0) {
               var resourceSet = data.resourceSets[0];
               // alert(1);
              if (Object.prototype.toString.call(resourceSet.resources) === '[object Array]' && resourceSet.resources.length > 0) {
                // alert(2);
                resource = resourceSet.resources[0];
              }
            }
 
             resource.brandLogoUri = resource.brandLogoUri || data.brandLogoUri;
 
             var model = new BingMapsTileSetModel(resource);
            
             var layer = new RasterTileSetLayer(model, {label: type + " (Bing)", layerType: LayerType.BASE, id: "Bing"});

             return layer;
          }
      );
    }
 
}

