import { Component, OnInit, OnDestroy } from '@angular/core';
import { AmChartsService, AmChart } from '@amcharts/amcharts3-angular';
// import { MapCaptors } from './MapCaptors';
import { HttpService } from '../../http.service';
import * as $ from 'jquery'; 
@Component({
  selector: 'app-cap2020',
  templateUrl: './cap2020.component.html',
  styleUrls: ['./cap2020.component.css']
})
export class Cap2020Component implements OnInit, OnDestroy {
  private chart: AmChart;
  title = 'app works :D ';
  mapCaptors : any ;
  dataCap2020 = [];
  constructor(private httpService : HttpService, private AmCharts: AmChartsService ) {
    // this.dataCap2020 = [] ;
  }
  // tslint:disable-next-line:use-life-cycle-interface
  ngOnInit() {
          this.getDataFromeCap2020();
          this.afficherlegraph() ;
    }

  // tslint:disable-next-line:use-life-cycle-interface
  ngOnDestroy() {
    if (this.chart) {
      this.AmCharts.destroyChart(this.chart);
    }
  }
  afficherlegraph(){
    console.log(this.dataCap2020);
     this.createChart(this.dataCap2020) ;
  }
  createChart(array_data){
       this.chart = this.AmCharts.makeChart( "chartdiv", {
        "type": "serial",
        "addClassNames": true,
        "theme": "dark",
        "autoMargins": false,
        "legend": {
          "position": "bottom",
          "divId": "legenddiv"
        },
        "marginLeft": 30,
        "marginRight": 8,
        "marginTop": 10,
        "marginBottom": 26,
        "balloon": {
          "adjustBorderColor": false,
          "horizontalPadding": 10,
          "verticalPadding": 8,
          "color": "#ffffff"
        },

        "dataProvider": array_data,
        "valueAxes": [ {
          "axisAlpha": 0,
          "position": "left"
        } ],
        "startDuration": 1,
        "graphs": [ {
          "alphaField": "alpha",
          "balloonText": "<span style='font-size:12px;'>[[title]] in [[category]]:<br><span style='font-size:20px;'>[[value]]</span> [[additional]]</span>",
          "fillAlphas": 1,
          "title": "Comptages",
          "type": "column",
          "legendValueText": "[[value]]",
          "valueField": "comptage",
          "dashLengthField": "dashLengthColumn"
        }, {
          "id": "graph2",
          "balloonText": "<span style='font-size:12px;'>[[title]] in [[category]]:<br><span style='font-size:20px;'>[[value]]</span> [[additional]]</span>",
          "bullet": "round",
          "lineThickness": 3,
          "bulletSize": 7,
          "bulletBorderAlpha": 1,
          "bulletColor": "#FFFFFF",
          "useLineColorForBulletBorder": true,
          "bulletBorderThickness": 3,
          "fillAlphas": 0,
          "lineAlpha": 1,
          "title": "Température",
          "valueField": "temp",
          "dashLengthField": "dashLengthLine"
        } ,{
          "id": "graph3",
          "balloonText": "<span style='font-size:12px;'>[[title]] in [[category]]:<br><span style='font-size:20px;'>[[value]]</span> [[additional]]</span>",
          "bullet": "round",
          "lineThickness": 3,
          "bulletSize": 7,
          "bulletBorderAlpha": 1,
          "bulletColor": "#FFFXFX",
          "useLineColorForBulletBorder": true,
          "legendValueText": "[[value]]",
          "title": "Humidité",
          "bulletBorderThickness": 3,
          "fillAlphas": 0,
          "lineAlpha": 1,
          "valueField": "hum",
          "dashLengthField": "dashLengthLine"}
          ],
          "chartCursor": {
            "categoryBalloonDateFormat": "MMM DD YYYY JJ:MM",
            "cursorAlpha": 0.1,
            "cursorColor":"#000000",
            "fullWidth":true,
            "valueBalloonsEnabled": false,
            "zoomable": true
          } ,
          "categoryField": "date",
          "categoryAxis": {
            "parseDates": true,
            "minPeriod":  "hh" ,
            "axisColor": "#DADADA",
            "dashLength": 1,
            "minorGridEnabled": false,
            "labelRotation": 45
          },
          "export": {
            "enabled": true
          }
        });
        this.chart.path = '/node_modules/amcharts3/amcharts/';
  }

  getDataFromeCap2020(){

   this.httpService.httpGetPromise('api_recup_data')
                .then((data) =>  {

                  console.log(data);

                  this.cap2020DataToAmchartsData(data);
                  
                },(error)=>{
                       console.error(error);
                });

  }

 cap2020DataToAmchartsData(data){
         var _obj = this ;
         var api_recup = data;
         //console.log(api_recup.api_data);
         //console.log(api_recup.api_geojson);
        
         var api_recup_data = api_recup.api_data;
         var api_recup_geojson = api_recup.api_geojson;
         var api_data_keys = Object.keys(api_recup_data);

         var array_api_data = new Array();
         try{
             var hum; //# humidité relative mesurée par le capteur placé sur le piège en %
             var rssi; //# niveau de signal pour le message (fourni par sigfox)
             var snr ; //ratio signal sur bruit pour le message (fourni par sigfox)
             var comptage ;//# nombre de ravageurs comptés depuis le dernier message
             var temp ; // # température mesurée par le capteur placé sur le piège en °C
             var batt;  //# niveau de batterie du piège en %
             var dateCapDay ; //date et heure en local
             var dateCapHour ; //date et heure en local

             if(!api_recup_data.status){
            
             $.each(api_recup_data, function(key, val){// id piège
                    //console.log("Key :"+key);
                    //console.log("Val :"+val);
                        if(key=="84"){
                           $.each(val, function(keyy, vall){ // description du piège ou data dans la même niveau 
                            //console.log("Keyy :"+keyy);
                            //console.log("Vall :"+vall);
                                $.each(vall, function(keyyy, valll){//
                                         //  console.log("keyyy :"+keyyy);
                                         // console.log("Valll :"+valll);
                                         if(keyy=="data"){
                                           $.each(valll, function(keyyyy, vallll){
                                          // console.log("keyyyy :"+keyyyy);
                                          // console.log("Vallll :"+vallll);
                                          switch(keyyyy) {
                                            case "date":
                                            dateCapHour = new Date(vallll) ;
                                            dateCapDay  = dateCapHour.toDateString("YYYY MMM DD JJ:MM");
                                            break;
                                            case "batt":
                                            batt = vallll;
                                            break;
                                            case "temp":
                                            temp = vallll;
                                            break;
                                            case "hum":
                                            hum  = vallll;
                                            break;
                                            case "rssi":
                                            rssi = vallll;
                                            break;
                                            case "snr":
                                            snr  = vallll;
                                            break;
                                            case "comptage":
                                            comptage = vallll;
                                            break;
                                          }
                                        });

                                           _obj.dataCap2020.push({
                                            "date": dateCapHour ,  
                                            "batt": batt,     
                                            "temp": temp,     
                                            "hum": hum,     
                                            "rssi": rssi, 
                                            "snr": snr,      
                                            "comptage": comptage
                                          });
                                           // console.log(dataCap2020);
                                           
                                         }
                                       }); 
                              });
                            }
                         }); 
                    }
                   var it = 0;
                    //console.log(dataCap2020);
                    //PS1
                    //Algorithme a refaire : Il vaut mieux stocker des dans un tableau puis comparer les nouvelles données au tableau plutot que comparer les données puis les ranger dans un tableau
                    // PS2
                    // Il faut faire une separation a chaque nouvelle itération de each pour ne pas mélanger les dates entres les capteurs
                    var daily_data_by_captor = new Array();
                    // $.each(array_api_data, function(){
                    //   var array_sort_data_by_day = new Array();
                    //   var daily_data = new Array();
                    //   for(var i = 0 ; i < this.data.length-1 ; i++) {
                    //     var current_date = new Date(this.data[i].date);
                    //     var next_date = new Date(this.data[i+1].date);
                    //     daily_data.push(current_date);
                    //     it++;
                    //     if(current_date.getDate() == next_date.getDate() && current_date.getMonth() == next_date.getMonth() && current_date.getYear() == next_date.getYear()) {
                    //       //Gere le cas de la derniere itération du for
                    //       if(i == this.data.length-2){
                    //         daily_data.push(next_date);
                    //         it++;
                    //       }
                    //     }else {
                    //       //Gere le cas de la derniere itération du for
                    //       if(i == this.data.length-2) {
                    //         array_sort_data_by_day.push(daily_data);
                    //         var last_data = new Array();
                    //         last_data.push(next_date);
                    //         it++;
                    //         array_sort_data_by_day.push(last_data)
                    //       } else {
                    //         array_sort_data_by_day.push(daily_data);
                    //         daily_data = new Array();
                    //       }
                    //     } 
                    //   }
                    //   //Next captor
                    //   array_sort_data_by_day.push(daily_data);
                    //   daily_data_by_captor.push(array_sort_data_by_day);
                    // });
                    // //console.log(daily_data_by_captor);        
                    
                    // //Create array's date
                    // var array_data = new Array();
                    // //console.log(array_api_data);
                    // for(var i = 0 ; i < array_api_data[0].data.length ; i++) { 
                    //   var date = new Date(array_api_data[0].data[i]["date"]);
                    //   //var datForDay = date.toDateString("MMM DD JJ:NN");
                    //   var dateHH = new Date(date.getYear(),date.getMonth(),date.getDay(),date.getHours(),date.getMinutes(),date.getSeconds());
                    //   //console.log(dateHH);
                    //   var single_data = {
                    //     "year": date,
                    //     "compt": array_api_data[0].data[i]["comptage"],
                    //     "temp": array_api_data[0].data[i]["temp"],
                    //     "hum": array_api_data[0].data[i]["hum"]
                    //   };
                    //   array_data.push(single_data);
                    // }
         

            }catch(e){
                console.error(e);
                console.log("api_recup_data erreur !");
        }
               // this.createChart(this.dataCap2020); 
 }



   // $.ajax({
   //  url: "getDataFromCapTrap.php",
   //     //data: formData,
   //     processData: false,
   //     contentType: false,
   //     type: 'POST',
   //     success: function(data){
   //      try{
   //       var api_recup = JSON.parse(data);
   //       //console.log(api_recup.api_data);
   //       //console.log(api_recup.api_geojson);
        
   //       var api_recup_data = api_recup.api_data;
   //       var api_recup_geojson = api_recup.api_geojson;
   //       var api_data_keys = Object.keys(api_recup_data);

   //       var array_api_data = new Array();
   //       //Construction du tableau de données triées à l'aide des clés de données récupérées (api_data_keys)
   //      for( var i = 0 ; i < api_data_keys.length ; i++){
   //        array_api_data.push(api_recup_data[api_data_keys[i]]);
   //      }
   //       //Ajout des données dans le selecteur de piège
   //       $(document).ready(function() {
   //        for( var i = 0 ; i < api_recup_geojson.features.length ; i++){
   //          //console.log(api_recup_geojson.features[i]);
   //          var id_objet = api_recup_geojson.features[i].properties.id;
   //          var nom_piege = api_recup_geojson.features[i].properties.nom_piege;
   //          $("#selectPiege").append("<option value='"+id_objet+"'>Captrap "+nom_piege+"</option>");
   //        }
   //      });
   //     // }
   //   });

   // logError(message) {
   //    $('#log_download_chart').html(message);
   //    setTimeout(function(){$('#log_download_chart').html("");},60000);
   //  }

   //  checkDate(){
   //    var date_input_start = new Date($("#date_input_start").val()+"T03:24:00");
   //    var date_input_end   = new Date($("#date_input_end").val()+"T03:24:00");
   //    if(!(date_input_start<date_input_end) && !(date_input_start>date_input_end))  return true;
   //    if(date_input_start<date_input_end)  {
   //      return true;
   //      //getDataFromeCap2020(date_input_start,date_input_end);
   //    }
   //    if(date_input_start>date_input_end) {
   //      //alert("Erreur : Date début inferieur à la date fin !");
   //      this.logError("<strong>Erreur</strong> : Date début inferieur à la date fin !");
        
   //      return false; 
   //    } 
   //  }

   // changeChartWithDates() {
   //    if(this.checkDate()){
   //      var startDate = $("#date_input_start").val();
   //      var endDate = $("#date_input_end").val();
   //      var link = "../php/getDataFromCapTrapWithParam.php?date_input_start="+startDate+"&date_input_end="+endDate;
   //      var mapData = new HashMap();
   //      $.ajax({
   //        url: link,
   //        async: false,
   //        data: mapData,
   //        processData: false,
   //        contentType: false,
   //        type: 'GET',
   //        success: function(data){
   //          var api_recup_data= JSON.parse(data);
   //          if(!api_recup_data["status"]) {
   //            var array_api_data = new Array();
   //            var api_data_keys = Object.keys(api_recup_data);
   //            //Construction du tableau de données triées à l'aide des clés de données récupérées (api_data_keys)
   //            for( var i = 0 ; i < api_data_keys.length ; i++){
   //              array_api_data.push(api_recup_data[api_data_keys[i]]);
   //              var key = parseInt(api_recup_data[api_data_keys[i]]["descriptif"]["id_objet"]);
   //              var value = api_recup_data[api_data_keys[i]];
   //              mapData.set(key,value);
   //            }
   //          }
   //        },
   //        error: function() {
   //          console.error("data aquisition error");
   //        } 
   //      });
   //      console.log(parseInt($("#selectPiege").val()));
   //      var key = parseInt($("#selectPiege").val());
   //      var data = mapData.get(parseInt($("#selectPiege").val()));
   //      console.log(data);
   //      if(key && data)
   //        this.mapCaptors.setChartArrayData(key, data);
   //      else{
   //        if(!key)
   //          //alert("Aucun pièges sélectionnés.\nSélectionner d'abord un piège puis recommencez l'opération");
   //          this.logError("<strong>Erreur</strong> : Aucun pièges sélectionnés.<br/>Sélectionner d'abord un piège puis recommencez l'opération.");
   //        else if(!data)
   //          //alert("Aucune données pour ce piège aux dates choisies");
   //          this.logError("<strong>Erreur</strong> :Aucune données pour ce piège aux dates choisies, veuillez essayer avec d'autres dates.");
   //      }
   //    }
   //  }


}
