import { Component, OnInit } from '@angular/core';
import { Cooperative }    from '../../cooperative';
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
// import { HttpService} from '../../_services/index';
import { HttpService } from '../../http.service';
import { AuthenticationService} from '../../_services/index';
import {NotificationsService} from "angular2-notifications";
 
@Component({
  selector: 'app-cooperative-form',
  templateUrl: './cooperative-form.component.html',
  styleUrls: ['./cooperative-form.component.css']
})
export class CooperativeFormComponent implements OnInit {
   /*  Notify */
     options: any = {
    position: ["bottom", "right"],
  };  

  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';

  title: string;
  msg: string;
  /*  End    */
  model = new Cooperative(
                        '',
                        '',
                         2,
                        '',
                         null,
                        '',
                        '',
                        '',
                        '',
                         0,
                        '',
                        '',
                        '',
                         null ,//id_cooperative_parent
                         1 //id_admin
                       );
  emails : any[] = [];
  cooperativesTree :any ;
  cooperativesTreeInfos : any ;
  submitted = false;
  errorSubmitted = false;
  CooperativeForm: FormGroup;
  constructor(private httpService: HttpService,
             private servicePNotify: NotificationsService) {

 }

  ngOnInit() : void{

     this.formControl();
     this.getCooperativesTreeInfos();

  }
  getCooperativesTreeInfos(){

    this.httpService.httpPostPromise('getCooperativesTreeInfos',{})
                .then((data) =>  {
                  this.cooperativesTreeInfos = data ;
                },(error)=>{
                       this.addNotify({title:'Arbre des coopératives', msg: 'problème vient de serveur ! rafraichir la page :(', type:'error'});
                });
  }
  
  cooperatives = ['Triscalia', 'Admin','Agrigan', 'Triscalia1'];

  get name() {return this.CooperativeForm.get('name');}
  get first_name() {return this.CooperativeForm.get('first_name');}
  get password() {return this.CooperativeForm.get('password');}
  get passwordConfirm() {return this.CooperativeForm.get('passwordConfirm');}
  get email() {return this.CooperativeForm.get('email');}
  get adress() {return this.CooperativeForm.get('adress');}
  get zip_code() {return this.CooperativeForm.get('zip_code');}
  get city() {return this.CooperativeForm.get('city');}
  get country() {return this.CooperativeForm.get('country');}
  get phone() {return this.CooperativeForm.get('phone');}
  get comment() {return this.CooperativeForm.get('comment');}
  get id_coop_parent() {return this.CooperativeForm.get('id_coop_parent');}
  get id_admin() {return this.CooperativeForm.get('id_admin');}


  formControl(){
    this.CooperativeForm = new FormGroup({
    'name': new FormControl(this.model.name, [
      Validators.required,
      Validators.minLength(4)
    ]),
    'first_name': new FormControl(this.model.first_name,[
      // Validators.required,
      // Validators.minLength(4)
    ]),
    'adress': new FormControl(this.model.adress, Validators.required),
    'zip_code': new FormControl(this.model.zip_code, [
      Validators.required,
      Validators.minLength(5)
      ]),
     'city': new FormControl(this.model.city, [
      Validators.required,
      Validators.minLength(3)
      ]),
    'country': new FormControl(this.model.country, [
      Validators.required,
      Validators.minLength(3)
      ]),
    'phone': new FormControl(this.model.phone, [
      Validators.required,
      Validators.pattern("^[0-9]*$"),
      Validators.minLength(10)
      ]),
    'email':  new FormControl(this.model.email, [
      Validators.required,
      Validators.minLength(10),
      Validators.email
      ]),
    'id_coop_parent': new FormControl(this.model.id_coop_parent, [
      ]),
    'comment': new FormControl(this.model.comment, [
      Validators.maxLength(255)
      ]),
    'password': new FormControl(this.model.password,[
        Validators.required,
        Validators.minLength(6)
        ]),
    'passwordConfirm': new FormControl(this.model.passwordConfirm, [
        Validators.required,
        Validators.minLength(6)
        ])
  //},[this.passwordMatchValidator,this.emailValidator]);
  //},[this.passwordMatchValidator]);
  });

  }

  // treeCooperative(){  

  // 	   this.httpService.httpGetPromise('getTechniciansTreeOfACooperative')
  //               .then((data)=>{
                         
  //               	// this.cooperativesTree = JSON.stringify(data.coops);
  //               	this.cooperativesTree = (data.coops);
     
  //                   console.log(this.cooperativesTree);
  //                   console.log(this.cooperativesTree[6].descriptif);
		//           for(var key in data.coops){   // Level O of the tree 
		//               // console.log(data.coops[key]);
		//               //console.log(data.coops[key].coops );
		//                for(var key1 in data.coops[key].coops){ // Level 1 of the tree 
		//                // console.log(data.coops[key].coops[key1]);
		//                // 	for(var key1 in data.coops[key].coops){ // Level 2 of the tree 
		//                //         //console.log(data.coops[key].coops[key1]);
		// 	             // }
		// 	           }
		// 	      }
              
  //           },(error)=>{
  //            console.log(error);
  //           });
  // }
  emailValidator(g: FormGroup){

        this.httpService.httpGetPromise('getEmails')
                .then((data)=>{
                  this.emails=data;
                   for (var i = this.emails.length - 1; i >= 0; i--) {
                      if(this.emails[i].email === g.get('email').value){
                         if(g.controls['email'].errors==null){
                            g.controls['email'].setErrors({'alreadyExist': true});           
                         }
                      }else{
                        console.log(false);
                 }
              }
          },(error)=>{
            console.log(error);
          });
  }
  passwordMatchValidator(g: FormGroup) {
  

  if(g.get('password').value === g.get('passwordConfirm').value){
   
  }else{ 
  	  if(g.controls['passwordConfirm'].errors== null){
           g.controls['passwordConfirm'].setErrors({'mismatch': true});
  	  }
  }
  return g.get('password').value === g.get('passwordConfirm').value ? null : {'mismatch': true};
  }
 
  newUser() {
        this.formControl();
        this.model = new Cooperative('','',2,'',null,'','','','',0,'','','',null,1);
  }
 
 async onSubmit() { 
   await this.httpService.httpPostPromise('store_cooperative_user',this.model)
                .then((data) =>  {
                  console.log(data); 
                  console.log(this.submitted); 
                  if(data.state=="OK"){
                       this.addNotify({title:'Ajout d\'une coopérative', msg: 'La coopérative a été créée avec succès !', type:'success'});
                       this.newUser();
                       this.getCooperativesTreeInfos();
                      //this.emailValidator(this.CooperativeForm);
                    }else if(data.state=="202"){
                       this.addNotify({title:'Ajout d\'une coopérative', msg: 'La coopérative n\'a été créée, Veuillez respecter le format des champs demandé par chaque saisie !', type:'error'});
                    }
                },(error)=>{
                       this.addNotify({title:'Ajout d\'une coopérative', msg: 'La coopérative n\'a été créée, Veuillez respecter le format des champs demandé par chaque saisie !', type:'error'});
                });
   }
    addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.options  = {
      position : [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch(options.type) {
      case 'success':
        this.servicePNotify.success(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg,
            options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
    }
  }
  // TODO: Remove this when we're done
  get diagnostic() { return JSON.stringify(this.model); }

}
