import { Component, OnInit } from '@angular/core';
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { Router } from '@angular/router';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import { NotificationsService} from "angular2-notifications";
import { Http, ResponseContentType } from '@angular/http';
import {fadeInOutTranslate} from '../../shared/elements/animation';

@Component({
  selector: 'app-export',
  templateUrl: './export.component.html',
  styleUrls: ['./export.component.css'],
  animations: [fadeInOutTranslate]
})
export class ExportComponent implements OnInit {
  _selectCooperative:any;
  _selectTechnician : any ;
  _selectFarmer :any ;
  _cooperative_id =0 ;
  _cooperative_id_usr_exp =0 ;
  _technician_id =0 ;
  _farmer_id =0;
  _export_type = {csv : true, shp:false, geojson:false, kml:false};
  _currentUserInfos : any ;
  _currentUserEmailAndToken : any ;
  _errors = {"format" :false };
  _submited = false ;
  _submited_usr = false ;
  _idOfUsers = { "cooperative_id" : 0, "technician_id": 0, "farmer_id":0,"user_type":"t", "export_type": {} };
  _idOfUsers_exp_usr = { "cooperative_id" : 0,"user_type":"t", "export_type": {} };
  constructor(private httpService : HttpService,
              private authenticationService : AuthenticationService,
              private servicePNotify : NotificationsService,
              private http: Http,
              private router : Router) { }

  ngOnInit() {

    if(this.authenticationService.isLoggedIn()){
         this.setIdOfUsersUsingLocalSorage();
         if(this._currentUserInfos.right==1) this.getAllCooperative();
         else if(this._currentUserInfos.right==2){
            this.getAllTechnicinaByIdCoop(this._idOfUsers.cooperative_id);
         }else if(this._currentUserInfos.right==3){
            this.getAllFarmerByIdTech(this._idOfUsers.technician_id);
         }
    }else{
      this.router.navigate(['/login']);
    }
    
  }
downloadFile(file_type) {
  var export_path ="assets/data/export_csv_kml_shp_geojson/" ;
  return this.http
    .get(export_path+'plots_'+file_type+'.zip', {
      responseType: ResponseContentType.Blob
      // search: // query string if have
    })
    .map(res => {
      return {
        filename: 'plots_'+file_type+'.zip',
        data: res.blob()
      };
    })
    .subscribe(res => {
        console.log('start download:',res);
        var url = window.URL.createObjectURL(res.data);
        var a = document.createElement('a');
        document.body.appendChild(a);
        a.setAttribute('style', 'display: none');
        a.href = url;
        a.download = res.filename;
        a.click();
        window.URL.revokeObjectURL(url);
        a.remove(); // remove the element
      }, error => {
        console.log('download error:', JSON.stringify(error));
      }, () => {
        console.log('Completed file download.')
      });
}

downloadFileUsr() {
  var export_path ="assets/data/export_csv_usr/" ;
  return this.http
    .get(export_path+'users.csv', {
      responseType: ResponseContentType.Blob
      // search: // query string if have
    })
    .map(res => {
      return {
        filename: 'users.csv',
        data: res.blob()
      };
    })
    .subscribe(res => {
        console.log('start download:',res);
        var url = window.URL.createObjectURL(res.data);
        var a = document.createElement('a');
        document.body.appendChild(a);
        a.setAttribute('style', 'display: none');
        a.href = url;
        a.download = res.filename;
        a.click();
        window.URL.revokeObjectURL(url);
        a.remove(); // remove the element
      }, error => {
        console.log('download error:', JSON.stringify(error));
      }, () => {
        console.log('Completed file download.')
      });
}

  setIdOfUsersUsingLocalSorage(){

   this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));
     
        switch (this._currentUserInfos.right) {
          case 1: 
                  this._idOfUsers.cooperative_id = 0; 
                  this._idOfUsers.technician_id = 0  ; 
                  this._idOfUsers.farmer_id = 0  ;
                  this._idOfUsers.user_type = "a"  ;
              break;
          case 2:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0; 
                  this._idOfUsers.farmer_id = 0;
                  this._idOfUsers.user_type = "c"  ;
            
              break;
          case 3:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                  this._idOfUsers.technician_id =  this._currentUserInfos.tchnicians_id ; 
                  this._idOfUsers.farmer_id = 0 ;
                  this._idOfUsers.user_type = "t"  ;
              break;
          case 4:
                  this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0 ; 
                  this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id ;
                  this._idOfUsers.user_type = "f"  ;
              
              break;
          // case '5':
          //         this._idOfUsers.cooperative_id = 0; 
          //         this._idOfUsers.adherent_id = 0 ;
          //         this._idOfUsers.technician_id = 0 ; 
          //         this._idOfUsers.farmer_id = 0 ;
          //         this._idOfUsers.user_type = "p"  ;
              
          //     break;
      }
  }
  setExportType(){
    console.log( this._export_type);
    this._submited =false ;
  }
   getAllTechnicinaByIdCoop(cooperative_id){
    if(cooperative_id==0)  { 
       this._idOfUsers.user_type = "a";
       this._technician_id =0 ;
       this._selectTechnician = [];
       this._selectFarmer = [];
       this._farmer_id =0;
    }else{
       this._idOfUsers.cooperative_id = cooperative_id;
       this._idOfUsers.user_type = "c";

       this.httpService.httpPostPromise('getAllUsersTechniciansByIdCooperative',{cooperative_id : cooperative_id})
                .then((data) =>  {
                  console.log(data);
                  this._selectTechnician = data;
                  this._technician_id =0 ;
                  this._selectFarmer = [];
                  this._farmer_id =0;
                },(error)=>{
                  console.log(error);    
                });
        }
   }

   setCoopForUsrExp(cooperative_id) {
    if(cooperative_id==0)  { 
       this._idOfUsers_exp_usr.user_type = "a";
    } else {
       this._idOfUsers_exp_usr.cooperative_id = cooperative_id;
       this._idOfUsers_exp_usr.user_type = "c";                
    }
   }

   getAllFarmerByIdTech(id_technician){

     if(id_technician==0)  { 
      this._idOfUsers.user_type = "c";
     }else{
       this._idOfUsers.cooperative_id = this._cooperative_id;
       this._idOfUsers.technician_id = id_technician;
       this._idOfUsers.user_type = "t";

       this.httpService.httpPostPromise('getAllUsersFarmersByIdTech',{id_technician : id_technician})
                .then((data) =>  {
                  this._selectFarmer = data ;
                  this._farmer_id =0 ;
                },(error)=>{
                  console.log(error);
                     
                });
      }

   }

   getAllCooperative(){
     this.httpService.httpPostPromise('getCooperativesTreeInfos',{}) // getAllUsersCooperatives
          .then((data) =>  {
            console.log(data);
            this._selectCooperative = data ;
          },(error)=>{
            console.log(error);
               
          });
   }

   getAllPlotByIdFarmer(_farmer_id){   
     if(_farmer_id==0)  { 
      this._idOfUsers.user_type = "t";
     }else{
     this._idOfUsers.cooperative_id = this._cooperative_id;
     this._idOfUsers.technician_id  = this._technician_id;
     this._idOfUsers.farmer_id = _farmer_id;
     this._idOfUsers.user_type = "f";
      console.log(this._idOfUsers);
     }
   }

   exportPlotsCSV(){
      this._submited = false ;
      if(this._export_type.csv==false && this._export_type.kml ==false && this._export_type.shp==false && this._export_type.geojson==false){
        this._errors.format =true ;
      }else{
      this._errors.format =false ;
      this._idOfUsers.export_type = this._export_type;
      console.log(this._idOfUsers);
      this.httpService.httpPostPromise('exportPlotsCSV',this._idOfUsers)
                .then((data) =>  {
                  console.log(data);
                  this._submited = true ;
                },(error)=>{
                  console.log(error);    
                });
     }
   }

    exportUsersCSV(){
      this._submited = false ;
      if(this._export_type.csv==false && this._export_type.kml ==false && this._export_type.shp==false && this._export_type.geojson==false){
        this._errors.format =true ;
      }else{
      this._errors.format =false ;
      this._idOfUsers.export_type = this._export_type;
      console.log(this._idOfUsers);
      this.httpService.httpPostPromise('exportUsersCSV',this._idOfUsers_exp_usr)
                .then((data) =>  {
                  console.log(data);
                  this._submited_usr = true ;
                },(error)=>{
                  console.log(error);    
                });
     }
   }
}
