import { Component, OnInit,ViewEncapsulation, ViewChild } from '@angular/core';
import {Http} from "@angular/http";
import { HttpService } from '../../http.service';
import {AuthenticationService,TechnicianService} from '../../_services/index'; 
import { Router } from '@angular/router';
import {fadeInOutTranslate} from "../../shared/elements/animation"; 
import {NotificationsService} from "angular2-notifications";
import swal from 'sweetalert2';
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { DatatableComponent } from '@swimlane/ngx-datatable';

@Component({
  selector: 'app-farmer-list',
  templateUrl: './farmer-list.component.html',
  styleUrls: ['./farmer-list.component.css'],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class FarmerListComponent implements OnInit {
   data: any;
   rowsOnPage: number = 25;
   filterQuery: string = "";
   sortBy: string = "";
   sortOrder: string = "desc";
   user = {
    active: 0,
    adherent: null,
    adress: null,
    city: null,
    comment: null,
    company_code: null,
    country: null,
    created_at: null,
    email: null,
    first_name: null,
    id: null,
    id_technician: null,
    id_user: null,
    user_id: null,
    id_user_v1: null,
    name: null,
    password: null, 
    phone: null, 
    remember_token: null,
    right: null, 
    updated_at: null,
    zip_code :null,
  };
  _modal_user = {
    storage: this.user,
    update: this.user,
    idx: null
  };
  FarmerForm: FormGroup;
  FarmerPasswordForm: FormGroup;
  _radio = {
    password: "0"
  }
  _password = {
    user_id: "",
    newPassword: "",
    password: "",
    newPasswordConfirm: ""
  }
  _currentUserInfos : any ;
  _currentUserStorage : any ;
  _usersFarmerByIdTech :any ;
  _usersFarmerByIdTechCopy :any ;
  _currentUserEmailAndToken : any ;
  
  _idOfUsers = { "cooperative_id" : 0, "technician_id": 0, "farmer_id":0,"user_type":"t" };
  searchTerm :any ; 
  /*  Notify */
  options: any = {
    position: ["bottom", "right"],
  };
  

  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';
  optionsModalAddUser: any = {'width': undefined, 'height': undefined, 
                              'left':undefined, 'right':undefined, 'top':undefined, 'bottom':undefined,
                              'margin-left': undefined, 'margin-right': undefined, 'margin-top': undefined, 'margin-bottom' : undefined,
                              'padding-left': undefined, 'padding-right': undefined, 'padding-top': undefined, 'padding-bottom' : undefined
                            };
  title: string;
  msg: string;
  /*  End    */
  editIcon = 'icofont-edit';
  rowsFarmers = [];


  constructor(
  	      public authenticationService: AuthenticationService,
  			  public technicianService: TechnicianService,
  			  public router: Router,
  			  public http: Http,
          public httpService : HttpService
  			  ) { 
  	
  }

  @ViewChild(DatatableComponent) table: DatatableComponent;
    private changeRowLimits(event) {
      this.table.limit = this.rowsOnPage;
      this.table.recalculate();
  }

  ngOnInit() {
    this.http.get(`assets/data/data.json`)
      .subscribe((data)=> {
         this.data = data.json();
      });
    if(this.authenticationService.isLoggedIn()){
         this.setIdOfUsersUsigLocalSorage();
         this.getAllUsersFarmersByIdTech();
         this.formControl();
    }else{
      this.router.navigate(['/login']);
    } 

  }

  // changeRowLimits(event) {
  //   this.rowsFarmers = this._usersFarmerByIdTechCopy.slice();
  //   this.rowsOnPage = parseInt(""+this.rowsOnPage);
  //   console.log(this.rowsOnPage);
  //   console.log(this.rowsFarmers);
  // }

   setIdOfUsersUsigLocalSorage(){
   this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));
     
        switch (this._currentUserInfos.right) {
          case 1: 
                  this._idOfUsers.cooperative_id = 0; 
                  this._idOfUsers.technician_id = 0  ; 
                  this._idOfUsers.farmer_id = 0  ;
                  this._idOfUsers.user_type = "a"  ;
              break;
          case 2:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0; 
                  this._idOfUsers.farmer_id = 0;
                  this._idOfUsers.user_type = "c"  ;
            
              break;
          case 3:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                  this._idOfUsers.technician_id =  this._currentUserInfos.tchnicians_id ; 
                  this._idOfUsers.farmer_id = 0 ;
                  this._idOfUsers.user_type = "t"  ;
              break;
          case 4:
                  this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0 ; 
                  this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id ;
                  this._idOfUsers.user_type = "f"  ;
              
              break;
          // case '5':
          //         this._idOfUsers.cooperative_id = 0; 
          //         this._idOfUsers.adherent_id = 0 ;
          //         this._idOfUsers.technician_id = 0 ; 
          //         this._idOfUsers.farmer_id = 0 ;
          //         this._idOfUsers.user_type = "p"  ;
              
          //     break;
      }
  }
 
  getAllUsersFarmersByIdTech(){
    console.log(this._idOfUsers);
    this.httpService.httpPostPromise('getAllUsersFarmer',this._idOfUsers)
                .then((data) =>  {
                  this._usersFarmerByIdTech = data ;
                  this._usersFarmerByIdTechCopy = data ;
                  this.rowsFarmers = data;
                  console.log(this._usersFarmerByIdTech) ;
                },(error)=>{
                  console.error(error);
                });
  }

  search(): void {
    if(this.searchTerm == "") {
      this._usersFarmerByIdTech = this._usersFarmerByIdTechCopy; 
    }else{
      let term = this.searchTerm;

      this._usersFarmerByIdTech = this._usersFarmerByIdTechCopy.filter(function(tag) {
          if(tag.name!=null){
           if(tag.name.indexOf(term) >= 0){ return tag.name.indexOf(term) >= 0 ; }
          }
          if(tag.country!=null){
            if(tag.country.indexOf(term) >= 0){ return tag.country.indexOf(term) >= 0; }
          }
          if(tag.adress!=null){
            if(tag.adress.indexOf(term) >= 0){ return tag.adress.indexOf(term) >= 0;}
          }
          if(tag.email!=null){
            if(tag.email.indexOf(term) >= 0){ return tag.email.indexOf(term) >= 0; }
          }
          if(tag.farmer_name!=null){
            if(tag.farmer_name.indexOf(term) >= 0){ return tag.farmer_name.indexOf(term) >= 0;}
          }
          if(tag.phone!=null){
            if(tag.phone.indexOf(term) >= 0){ return tag.phone.indexOf(term) >= 0;}
          }
          if(tag.comment!=null){
            if(tag.comment.indexOf(term) >= 0){  return tag.comment.indexOf(term) >= 0;}
          }
      }); 
    }
 }

  fillForm(user_id) {
    // Get the user's index in the user array (JSON). First, this transform the object array 
    // into an id_user array then get the index of user's id) 
    this._modal_user.idx = this._usersFarmerByIdTech.map(function(e) { return e.farmer_user_id; }).indexOf(user_id);
    console.log(this._usersFarmerByIdTech[this._modal_user.idx]);   
    console.log(this._usersFarmerByIdTech[this._modal_user.idx].farmer_user_id);   
    
    this._modal_user.storage = Object.assign({}, this._usersFarmerByIdTech[this._modal_user.idx]);  
    this._modal_user.storage.user_id = this._usersFarmerByIdTech[this._modal_user.idx].farmer_user_id,
    this._modal_user.storage.name = this._usersFarmerByIdTech[this._modal_user.idx].farmer_name,
    this._modal_user.storage.first_name = this._usersFarmerByIdTech[this._modal_user.idx].farmer_first_name,
    this._modal_user.storage.adress = this._usersFarmerByIdTech[this._modal_user.idx].farmer_adress,
    this._modal_user.storage.zip_code = this._usersFarmerByIdTech[this._modal_user.idx].farmer_zip_code,
    this._modal_user.storage.city = this._usersFarmerByIdTech[this._modal_user.idx].farmer_city,
    this._modal_user.storage.country = this._usersFarmerByIdTech[this._modal_user.idx].farmer_country,
    this._modal_user.storage.phone = this._usersFarmerByIdTech[this._modal_user.idx].farmer_phone,
    this._modal_user.storage.comment = this._usersFarmerByIdTech[this._modal_user.idx].farmer_comment,
    this._modal_user.storage.email = this._usersFarmerByIdTech[this._modal_user.idx].farmer_email
   
    this._modal_user.update = Object.assign({}, this._usersFarmerByIdTech[this._modal_user.idx]);
    this._modal_user.update.user_id = this._usersFarmerByIdTech[this._modal_user.idx].farmer_user_id,
    this._modal_user.update.name = this._usersFarmerByIdTech[this._modal_user.idx].farmer_name,
    this._modal_user.update.first_name = this._usersFarmerByIdTech[this._modal_user.idx].farmer_first_name,
    this._modal_user.update.adress = this._usersFarmerByIdTech[this._modal_user.idx].farmer_adress,
    this._modal_user.update.zip_code = this._usersFarmerByIdTech[this._modal_user.idx].farmer_zip_code,
    this._modal_user.update.city = this._usersFarmerByIdTech[this._modal_user.idx].farmer_city,
    this._modal_user.update.country = this._usersFarmerByIdTech[this._modal_user.idx].farmer_country,
    this._modal_user.update.phone = this._usersFarmerByIdTech[this._modal_user.idx].farmer_phone,
    this._modal_user.update.comment = this._usersFarmerByIdTech[this._modal_user.idx].farmer_comment,
    this._modal_user.update.email = this._usersFarmerByIdTech[this._modal_user.idx].farmer_email

    console.log(this._modal_user.update);
    this._password.user_id = this._modal_user.update.id_user;
  }    
  
  toggleEditFarmer(user_id) {
    this.fillForm(user_id);
    this.openMyModal('effect-7', user_id);
  }

  openMyModal(event, user_id) {
    console.log(event);
    document.querySelector("#"+event).classList.add('md-show');
  } 
  
  closeMyModalByDivId(event) {
    document.querySelector("#"+event).classList.remove('md-show');
  }

  closeMyModal(event) {
    ((event.target.parentElement.parentElement).parentElement).classList.remove('md-show');
  }

  updateUser() {
    this.technicianService.updateUser(this._modal_user.update);
    this._usersFarmerByIdTech[this._modal_user.idx] =  this._modal_user.update;
    this.closeMyModalByDivId('effect-7');
  }

  updatePassword() {
    // this._password.newPassword = "";
    // this.httpService.httpPostPromise('updateUserPassword',this._password);
    var obj = this;
    swal({
      title: 'Êtes-vous sûr ?',
      text: "Souhaitez-vous modifier le mot de passe de cet utilisateur ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Oui',
      cancelButtonText: 'Non, Annuler',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      obj.httpService.httpPostPromise("updateUserPassword",obj._password)
                .then((plot_infos_geometry) =>  {
                   
                    swal(
                        'Modifié !',
                        'Le mot de passe à été modifié.',
                        'success'
                    );
                    obj._password.newPassword = "";
                    obj._password.newPasswordConfirm = "";    
                    
                },(error)=>{
                   swal(
                        'Opération annulée !',
                        'Une erreur est survenue, réessayez ultérieurement ! :(',
                        'error'
                    )
                  console.error(error);
                });
    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
            'Annulé',
            'Le mot de passe n\'a pas été modifié.',
            'error'
        )
      }
    }).catch(swal.noop);
    obj.closeMyModalByDivId("effect-7");
  }

  deleteUser(user_id){
    console.log(user_id);
  	this.deleteUserFromDB(this._idOfUsers,user_id);
  }

  addPlot(farmer_id){
     localStorage.setItem('farmer_id', farmer_id);
     this.router.navigate(['/my-riamap']);
  }

  deleteUserFromDB(idOfCurentUser,farmer_id){   
    var functionToCall;
    var req ={"user_id" : farmer_id } ;
    var _obj = this;
    swal({
      title: 'Êtes-vous sûr ?',
      text: "Souhaitez-vous supprimer définitivement cette utilisateur ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Supprimer !',
      cancelButtonText: 'Non, Annuler !',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      _obj.technicianService.httpPostPromise("destroyuser",req)
                .then((plot_infos_geometry) =>  {
                   
                    swal(
                        'Supprimée!',
                        'L\'utilisateur a été supprimé.',
                        'success'
                    )
                   
                      _obj.getAllUsersFarmersByIdTech();
                },(error)=>{
                   swal(
                        'Annulé !',
                        'L\'utilisateur n\'a pas été supprimé,réessayez ultérieurement ! :(',
                        'error'
                    )
                  console.log(error);
                });
      
    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
            'Annulé',
            'L\'utilisateur n\'a pas été supprimé :)',
            'error'
        )
      }
    }).catch(swal.noop);

    } 

  get name() {return this.FarmerForm.get('_name');}
  get first_name() {return this.FarmerForm.get('_first_name');}
  
  get email() {return this.FarmerForm.get('_email');}
  get adress() {return this.FarmerForm.get('_adress');}
  get zip_code() {return this.FarmerForm.get('_zip_code');}
  get city() {return this.FarmerForm.get('_city');}
  get country() {return this.FarmerForm.get('_country');}
  get phone() {return this.FarmerForm.get('_phone');}
  get comment() {return this.FarmerForm.get('_comment');}
  get company_code() {return this.FarmerForm.get('_company_code');}

  get password() {return this.FarmerPasswordForm.get('_password');}
  get passwordConfirm() {return this.FarmerPasswordForm.get('_passwordConfirm');}

  formControl(){
    this.FarmerForm = new FormGroup({
    '_name': new FormControl(this._modal_user.update.name, [
      Validators.required,
      Validators.minLength(2)
    ]),
    '_first_name': new FormControl(this._modal_user.update.first_name,[
      Validators.required,
      Validators.minLength(2)
    ]),
    '_adress': new FormControl(this._modal_user.update.adress, [/*Validators.required*/]),
    '_zip_code': new FormControl(this._modal_user.update.zip_code, [
      // Validators.required,
      Validators.minLength(5),
      Validators.maxLength(5),
       Validators.pattern("^[0-9]*$")
      ]),
     '_city': new FormControl(this._modal_user.update.city, [
      // Validators.required,
      Validators.minLength(2)
      ]),
    '_country': new FormControl(this._modal_user.update.country, [
      // Validators.required,
      Validators.minLength(3)
      ]),
    '_phone': new FormControl(this._modal_user.update.phone, [
      Validators.required,
      Validators.pattern("^[0-9]*$"),
      Validators.minLength(10),
      Validators.maxLength(10)
      ]),
    '_email':  new FormControl(this._modal_user.update.email, [
      Validators.required,
      Validators.minLength(10),
      Validators.email
      ]),
    '_comment': new FormControl(this._modal_user.update.comment, [
      Validators.maxLength(255)
      ]),
    // 'password': new FormControl(this.model.password,[
    //     Validators.required,
    //     Validators.minLength(6)
    //     ]),
    // 'passwordConfirm': new FormControl(this.model.passwordConfirm, [
    //     Validators.required,
    //     Validators.minLength(6)
    //     ])
  //},[this.passwordMatchValidator,this.emailValidator]);
  // },[this.passwordMatchValidator]);
  });

  this.FarmerPasswordForm = new FormGroup({
    '_passwordConfirm': new FormControl(this._password.newPassword, [
      Validators.minLength(8),
      Validators.required
    ]),
    '_password': new FormControl(this._password.newPasswordConfirm, [
      Validators.minLength(8)
    ])
  });

  }

}
