import { AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone, NgModule } from '@angular/core';
import 'rxjs/add/operator/toPromise';
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Router } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { ExportModule } from '../export/export.module';
import swal from 'sweetalert2';
import { NotificationsService } from "angular2-notifications";
import { NgbDatepickerConfig, NgbDateParserFormatter } from '@ng-bootstrap/ng-bootstrap';
import { NgbDateCustomParserFormatter } from "../../_class/ngb-date-custom-parser-formatter";
import * as $ from 'jquery';
import { retry } from 'rxjs/operator/retry';
import * as moment from 'moment';
import { Chart } from 'chart.js';

@Component({
  selector: 'app-follow-plot-states',
  templateUrl: './follow-plot-states.component.html',
  styleUrls: ['./follow-plot-states.component.css'],
  providers: [{ provide: NgbDateParserFormatter, useClass: NgbDateCustomParserFormatter }],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class FollowPlotStatesComponent implements OnInit {
  _model;
  _plot_infos_geometry: any = [];
  _plot_selected: any;
  _plot_infos_geometryCopy = [];
  _currentUserInfos: any; //--------------!!!!
  _idOfUsersJSON_current: any; //--------------!!!! // = _idOfUsers  these variable is used after the user chose a current user to filter data in the carte 
  _usersFarmerByIdTech: any;//--------------!!!!
  _usersFarmerByIdTechCopy: any;
  _currentUserEmailAndToken: any; //--------------!!!!
  _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id": 0, "user_type": "t", "year": 2019 }; //--------------!!!! // use to load a binding datas of a curent user or to filtering data 
  _errorInputs = { "name": false, "id_farmer": false, "electricline": false, "irrigationsystem": false }; // use to load a binding datas of a curent user or to filtering data 
  _filter = {
    priority: "all",
    status: "all",
    date_since: null,
    searchTerm: "",
  };
  _parameterNbDays: any;
  _globalStatistic = {
    count_total_treatment: 0,
    percentage_total_treatment: 0,
    count_treatment_finished: 0,
    percentage_treatment_finished: 0,
    count_treatment_in_progress: 0,
    percentage_treatment_in_progress: 0,
    count_treatment_preorder: 0,
    percentage_treatment_preorder: 0,
    count_treatment_ordered: 0,
    percentage_treatment_ordered: 0,
    count_total_orders: 0,
    plots_count: 0,
    plot_area: 0,
    tabIdFarmer: [],
    tabIdTech: [],
    tabIdCoop: [],
    tabIdAdhe: [],
    order: {
      tabIdOrder: [],
      order_waiting: [],
      order_validated: [],
      order_in_progress: [],
      order_finished: []
    }
  };
  _globalStatistical = {
    flight_authorizations_by_dgac: 0,
    assigned_to_a_tour: 0,
    flight_made_on_plot: 0,
    image_received: 0,
    treated_ia_tpz_models: 0,
    quality_review: 0,
    treated_plot_delivered: 0,
    plot_taken_into_account_by_farmer: 0,

    datura_to_be_purged : 0,
    datura_purged : 0,
    datura_impossible_to_purge : 0,
    datura_approval_waiting_for_approval : 0 ,
    datura_approval_purged : 0 ,
    datura_approval_review_purged : 0 ,
  };
  _chartStatus: any;
  _chartStatusPurgedAproval : any ;
  _isDatePickerDisplay: any = {};
  _plotDatePicker: any = {};
  constructor(private httpService: HttpService,
    public authenticationService: AuthenticationService,
    private router: Router,
    private http: Http,
    private servicePNotify: NotificationsService,
    private cdRef: ChangeDetectorRef,
    private _ngZone: NgZone) {

    if (this.authenticationService.isLoggedIn()) {
      this.setIdOfUsersUsigLocalSorage();
    } else {
      this.router.navigate(['/login']); //--------------!!!!
    }
  }

  ngOnInit() {
    this.getAndPrintDataPlotFromDB(this._idOfUsers);
  }

  setIdOfUsersUsigLocalSorage() {
    this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));

    switch (this._currentUserInfos.right) {
      case 1:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "a";
        break;
      case 2:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "c";

        break;
      case 3:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "t";
        break;
      case 4:
        this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
        this._idOfUsers.user_type = "f";

        break;
      // case '5':
      //         this._idOfUsers.cooperative_id = 0; 
      //         this._idOfUsers.adherent_id = 0 ;
      //         this._idOfUsers.technician_id = 0 ; 
      //         this._idOfUsers.farmer_id = 0 ;
      //         this._idOfUsers.user_type = "p"  ;

      //     break;
    }
  }

  // changeStates(bntId, bntId2) {
  //   var classdiv = $('#' + bntId).attr("class").split(' ');
  //   for (var i = 0; i < classdiv.length; i++) {
  //     if (classdiv[i] === 'asy-btn-light') {
  //       $('#' + bntId).removeClass('asy-btn-light');
  //       $('#' + bntId).addClass('asy-btn-primary');

  //       $('#' + bntId2).removeClass('asy-btn-primary');
  //       $('#' + bntId2).addClass('asy-btn-light');
  //     } else if (classdiv[i] === 'asy-btn-primary') {
  //       $('#' + bntId).removeClass('asy-btn-primary');
  //       $('#' + bntId).addClass('asy-btn-light');

  //       $('#' + bntId2).removeClass('asy-btn-light');
  //       $('#' + bntId2).addClass('asy-btn-primary');
  //     }
  //   }
  // }
  creatStatusChart() {
    var _obj = this;
    /* create 1*/
    var dataHorizontal = {
      labels: [
        this._globalStatistical.flight_authorizations_by_dgac+" Autorisations de vol par DGAC",
        this._globalStatistical.assigned_to_a_tour+" Affectée à une tournée",
        this._globalStatistical.flight_made_on_plot+" Vol réalisé sur parcelle",
        this._globalStatistical.image_received+" Image reçue",
        this._globalStatistical.treated_ia_tpz_models+" Traitée modèles IA TPZ",
        this._globalStatistical.quality_review+" REVUE QUALITE",
        this._globalStatistical.treated_plot_delivered+" Parcelle traitée livrée",
        this._globalStatistical.plot_taken_into_account_by_farmer+" Prise en compte par agriculteur"
      ],
      datasets: [{
        data: [
          this._globalStatistical.flight_authorizations_by_dgac,
          this._globalStatistical.assigned_to_a_tour,
          this._globalStatistical.flight_made_on_plot,
          this._globalStatistical.image_received,
          this._globalStatistical.treated_ia_tpz_models,
          this._globalStatistical.quality_review,
          this._globalStatistical.treated_plot_delivered,
          this._globalStatistical.plot_taken_into_account_by_farmer
        ],
        label: "Vue globale sur les status de "+this._plot_infos_geometry.length+" parcelles",
        backgroundColor: ["#98C002", "#4A75EA", "#8763DE", "#F5A623", "#95a5a6", "#e74c3c", "#30336b", "#bdc3c7"] // bar color
      }]
    }
    var ctxB = (<HTMLCanvasElement>document.getElementById("chart-bar-status")).getContext("2d");
    this._chartStatus = new Chart(ctxB, {
      type: 'horizontalBar',
      data: dataHorizontal,
      options: {
        scales: {
          xAxes: [{
            stacked: true
          }],
          yAxes: [{
            gridLines: {
              display: false, // hide y-axis line
              drawBorder: false // hide zero grid line
            },
            scaleLabel: {
              display: true // show label name
            },
            ticks: {
              display: true, // show y value text
              mirror: false, // inside position (value name)
              labelOffset: -15, // text positon distance
              fontSize: 13,
              padding: 0,
              fontColor: "#222",
              fontFamliy: "verdana"
            },
            barPercentage: 0.3 // bar thickness
          }]
        }
      }
    });
    $("#chart-bar-status").css("height", 400);
    /*End  */
  }
  creatPurgedAprovalChart(){
    var _obj = this;
    /* create 1*/
    var dataHorizontal = {
      labels: [
        this._globalStatistical.datura_to_be_purged+" En attente d’épuration",
        this._globalStatistical.datura_to_be_purged+" Epurée",
        this._globalStatistical.datura_impossible_to_purge+" Epuration impossible",
        this._globalStatistical.datura_approval_waiting_for_approval+" En attente d'agréage",
        this._globalStatistical.datura_approval_purged+"Agrée",
        this._globalStatistical.datura_approval_review_purged+"Contre visite",
      ],
      datasets: [{
        data: [
          this._globalStatistical.datura_to_be_purged,
          this._globalStatistical.datura_purged,
          this._globalStatistical.datura_impossible_to_purge,
          this._globalStatistical.datura_approval_waiting_for_approval,
          this._globalStatistical.datura_approval_purged,
          this._globalStatistical.datura_approval_review_purged
        ],
        label: "Vue globale sur les status d’épuration/d’agréage de "+this._plot_infos_geometry.length+" parcelles",
        backgroundColor: ["#e1b12c", "#192a56", "#e1b12c", "#273c75", "#353b48", "#9c88ff"] // bar color
      }]
    }
    var ctxB = (<HTMLCanvasElement>document.getElementById("chart-bar-purged-and-aproval")).getContext("2d");
    this._chartStatusPurgedAproval = new Chart(ctxB, {
      type: 'horizontalBar',
      data: dataHorizontal,
      options: {
        scales: {
          xAxes: [{
            stacked: true
          }],
          yAxes: [{
            gridLines: {
              display: false, // hide y-axis line
              drawBorder: false // hide zero grid line
            },
            scaleLabel: {
              display: true // show label name
            },
            ticks: {
              display: true, // show y value text
              mirror: false, // inside position (value name)
              labelOffset: -15, // text positon distance
              fontSize: 13,
              padding: 0,
              fontColor: "#222",
              fontFamliy: "verdana"
            },
            barPercentage: 0.3 // bar thickness
          }]
        }
      }
    });
    $("#chart-bar-purged-and-aproval").css("height", 400);
    /*End  */
  }
  getSaticalStatus() {

    this._globalStatistical.flight_authorizations_by_dgac = 0;
    this._globalStatistical.assigned_to_a_tour = 0;
    this._globalStatistical.flight_made_on_plot = 0;
    this._globalStatistical.image_received = 0;
    this._globalStatistical.treated_ia_tpz_models = 0;
    this._globalStatistical.quality_review = 0;
    this._globalStatistical.treated_plot_delivered = 0;
    this._globalStatistical.plot_taken_into_account_by_farmer = 0;

    this._globalStatistical.datura_to_be_purged = 0;
    this._globalStatistical.datura_purged = 0;
    this._globalStatistical.datura_impossible_to_purge = 0;
    this._globalStatistical.datura_approval_waiting_for_approval = 0;
    this._globalStatistical.datura_approval_purged = 0;
    this._globalStatistical.datura_approval_review_purged = 0;

    for (var i = 0; i < this._plot_infos_geometry.length; i++) {
      if (this._plot_infos_geometry[i].plot_flight_authorizations_by_dgac == true) {
        this._globalStatistical.flight_authorizations_by_dgac++;
      }
      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_status=="en-cours" || this._plot_infos_geometry[i].treatment[0].treatment_status=="termine" ) {
          this._globalStatistical.assigned_to_a_tour++;
        }
      }
      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_status=="termine") {  
          this._globalStatistical.flight_made_on_plot++;
        }
      }
      if (this._plot_infos_geometry[i].image_received == true) {
        this._globalStatistical.image_received++;
      }
      if (this._plot_infos_geometry[i].treated_ia_tpz_models == true) {
        this._globalStatistical.treated_ia_tpz_models++;
      }
      if (this._plot_infos_geometry[i].quality_review == true) {
        this._globalStatistical.quality_review++;
      }
      if (this._plot_infos_geometry[i].treated_plot_delivered == true) {    
        this._globalStatistical.treated_plot_delivered++;
      }
      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_purged != "to_be_purged") {
          this._globalStatistical.plot_taken_into_account_by_farmer++;
        }
      }

      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_purged == "to_be_purged") {
          this._globalStatistical.datura_to_be_purged ++;
        }
      }

      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_purged == "purged") {
          this._globalStatistical.datura_purged++;
        }
      }
      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_purged == "impossible_to_purge") {
          this._globalStatistical.datura_impossible_to_purge++;
        }
      }

      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_approval == "waiting_for_approval") {
          this._globalStatistical.datura_approval_waiting_for_approval++;
        }
      }

      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_approval == "approved") {
          this._globalStatistical.datura_approval_purged++;
        }
      }

      if (this._plot_infos_geometry[i].treatment.length > 0) {
        if (this._plot_infos_geometry[i].treatment[0].treatment_datura_approval == "review_purged") {
          this._globalStatistical.datura_approval_review_purged++;
        }
      }

    }
    console.log(this._globalStatistical);
    this._chartStatus.data.datasets[0].data = [
      this._globalStatistical.flight_authorizations_by_dgac,
      this._globalStatistical.assigned_to_a_tour,
      this._globalStatistical.flight_made_on_plot,
      this._globalStatistical.image_received,
      this._globalStatistical.treated_ia_tpz_models,
      this._globalStatistical.quality_review,
      this._globalStatistical.treated_plot_delivered,
      this._globalStatistical.plot_taken_into_account_by_farmer
    ];
    this._chartStatus.data.labels = [
      this._globalStatistical.flight_authorizations_by_dgac+" Autorisations de vol par DGAC",
      this._globalStatistical.assigned_to_a_tour+" Affectée à une tournée",
      this._globalStatistical.flight_made_on_plot+" Vol réalisé sur parcelle",
      this._globalStatistical.image_received+" Image reçue",
      this._globalStatistical.treated_ia_tpz_models+" Traitée modèles IA TPZ",
      this._globalStatistical.quality_review+" REVUE QUALITE",
      this._globalStatistical.treated_plot_delivered+" Parcelle traitée livrée",
      this._globalStatistical.plot_taken_into_account_by_farmer+" Prise en compte par agriculteur"
    ];
    this._chartStatus.data.datasets[0].label= "Vue globale sur les status de "+this._plot_infos_geometry.length+" parcelles";


    this._chartStatusPurgedAproval.data.datasets[0].data = [
      this._globalStatistical.datura_to_be_purged,
      this._globalStatistical.datura_purged,
      this._globalStatistical.datura_impossible_to_purge,
      this._globalStatistical.datura_approval_waiting_for_approval,
      this._globalStatistical.datura_approval_purged,
      this._globalStatistical.datura_approval_review_purged
    ];
    this._chartStatusPurgedAproval.data.labels = [
      this._globalStatistical.datura_to_be_purged+" En attente d’épuration",
      this._globalStatistical.datura_purged+" Epurée",
      this._globalStatistical.datura_impossible_to_purge+" Epuration impossible",
      this._globalStatistical.datura_approval_waiting_for_approval+" En attente d'agréage",
      this._globalStatistical.datura_approval_purged+" Agrée",
      this._globalStatistical.datura_approval_review_purged+" Contre visite",
    ];
    this._chartStatusPurgedAproval.data.datasets[0].label ="Vue globale sur les status d’épuration/d’agréage de "+this._plot_infos_geometry.length+" parcelles",
    
    this._chartStatusPurgedAproval.update();
    this._chartStatus.update();
  }
  findElement(arr, propName, propValue) {
    for (var i = 0; i < arr.length; i++)
      if (arr[i][propName] == propValue)
        return arr[i];
  }

  downloadCSV() {
    ///////////////////////////////////////////////////////////
    // console.log(this._plot_infos_geometry);
    // for(var i = 0; i< this._plot_infos_geometry.length; i++) {
    //   this._plot_infos_geometry[i].farmer_name;
    //   this._plot_infos_geometry[i].plot_name;
    //   this._plot_infos_geometry[i].technician_first_name;
    //   this._plot_infos_geometry[i].technician_name;
    //   this._plot_infos_geometry[i].plot_area;
    //   // this._plot_infos_geometry[i].treatment[0].treatment_date_provisinnal_of_flight;
    // }
    var obj = this;
    var functionToCall = 'exportCSVDatura';
    var newData = { 'plot': this._plot_infos_geometry }
    console.log(newData);
    this.httpService.httpPostPromise(functionToCall, newData)
      .then((res) => {
        console.log(res.filename);
        var path = res.filename;
        return obj.http
          .get('assets/data/export_csv_datura/' + path, {
            //.get('assets/../../dist/asssets/data/missionPlanner_2018/'+path, {
            //.get('../dist/assets/data/missionPlanner_2018/'+path, {
            responseType: ResponseContentType.Blob
            // search: // query string if have
          })
          .map(res => {
            return {
              filename: path,
              data: res.blob()
            };
          })
          .subscribe(res => {
            console.log('start download:', res);
            var url = window.URL.createObjectURL(res.data);
            var a = document.createElement('a');
            document.body.appendChild(a);
            a.setAttribute('style', 'display: none');
            a.href = url;
            a.download = res.filename;
            a.click();
            window.URL.revokeObjectURL(url);
            a.remove(); // remove the element
          }, error => {
            console.log('download error:', JSON.stringify(error));
          }, () => {
            console.log('Completed file download.')
          });

      }, (error) => {
        console.error(error);
      });
    ///////////////////////////////////////////////////////////
  }

  radioChange(plot, databaseTableName, value) {
    var plot_id = plot.plot_id;
    var treatment_id = plot.treatment[0].treatment_id
    // alert('plot_id : '+ plot_id +', DatabaseTableName : '+ databaseTableName + ', value : '+ value);
    //send to DB
    var functionToCall = 'setPlotInformation';
    var newData = { 'plot_id': plot_id, 'table_name': databaseTableName, 'value': value, 'treatment_id': treatment_id }
    console.log(newData);
    var promise = new Promise((resolve, reject) => {
      this.httpService.httpPostPromise(functionToCall, newData)
        .then((res) => {
          console.log(res);
          resolve('Successful updates');
        }, (error) => {
          console.error(error);
          reject('Error from db : function radioChange()');
        });
    });
    console.log(plot);
    if (!value) {
      switch (databaseTableName) {
        case 'flight_authorizations_by_dgac':
          plot.plot_flight_authorizations_by_dgac = false;
        case 'assigned_to_a_tour':
        //   plot.plot_assigned_to_a_tour = false;
        case 'flight_made_on_plot':
          // plot.treatment[0].treatment_flight_made_on_plot = false;
        case 'image_received':
          plot.plot_image_received = false;
        case 'treated_ia_tpz_models':
          plot.plot_treated_ia_tpz_models = false;
        case 'quality_review':
          plot.plot_quality_review = false;
        case 'treated_delivered':
          plot.plot_treated_plot_delivered = false;
        case 'considered_by_farmer':
          plot.plot_considered_by_farmer = false;
      }
      var functionToCall = 'setPlotCascadeInformations';
      var plotDataRequest = { 'plot': plot }
      console.log(plotDataRequest);
      var promise = new Promise((resolve, reject) => {
        this.httpService.httpPostPromise(functionToCall, plotDataRequest)
          .then((plot) => {
            console.log(plot);
            resolve('Successful updates');
          }, (error) => {
            console.error(error);
            reject('Error from db : function radioChange()');
          });
      });
    }
  }

  changeDate(plot: any) {
    console.log(this._currentUserInfos.user_id);
    //assignation des variables
    var plot_id = plot.plot_id;
    var plot_name = plot.plot_name;
    var treatment_id = plot.treatment[0].treatment_id;
    var cooperative_email = plot.cooperative_email;
    var farmer_email = plot.farmer_email;
    var technician_email = plot.technician_email;
    //Update model and view 
    var plot = this.findElement(this._plot_infos_geometry, 'plot_id', plot_id);
    // plot.plot_date_provisinnal = this._plotDatePicker[plot_id];
    //vérification que le champs date ne soit pas vide
    if (this._plotDatePicker[plot_id]) {
      //format and change the harvest date in model
      var date = this.formatNgDatepicker(this._plotDatePicker[plot_id]);
      plot.treatment[0].treatment_date_harvest = date;
      this.displayDatepicker(plot_id);
      //send to DB
      var functionToCall = 'setHarvestDate';
      console.log(date);
      var newData = { 'treatment_id': treatment_id, 'provisional_date': date, 'plot_name': plot_name, 'cooperative_email': cooperative_email, 'farmer_email': farmer_email, 'technician_email': technician_email }
      this.httpService.httpPostPromise(functionToCall, newData)
        .then((plot_infos_geometry) => {
          console.log(plot_infos_geometry);
        }, (error) => {
          console.error(error);
        });

      //now format and change the provisionnal flight day (3 weeks before harvest)
      var flightDate = new Date(date);
      console.log(date);
      flightDate = this.removeDays(date, this._parameterNbDays);
      console.log(flightDate);
      date = this.formatJSDate(flightDate);
      plot.treatment[0].treatment_date_provisinnal_of_flight = date;
      //send to DB
      var functionToCall = 'setFlightDate';
      console.log(date);
      var newData = { 'treatment_id': treatment_id, 'provisional_date': date, 'plot_name': plot_name, 'cooperative_email': cooperative_email, 'farmer_email': farmer_email, 'technician_email': technician_email }
      this.httpService.httpPostPromise(functionToCall, newData)
        .then((plot_infos_geometry) => {
          console.log(plot_infos_geometry);
        }, (error) => {
          console.error(error);
        });
    } else {
      alert("Veuillez d'abord entrer une date dans le calendrier");
    }
  }

  //Format to yyyy-mm-dd from NgDatePicker format
  formatNgDatepicker(fulldate) {
    var month = fulldate.month;
    var date = fulldate.day;
    var year = fulldate.year;
    if (month < 10)
      month = "0" + month;
    if (date < 10)
      date = "0" + date;
    //TO DO : Change to date = day+"-"+month+"-"+year;
    return year + "-" + month + "-" + date;
  }

  //Format to yyyy-mm-dd from JS Date class format
  formatJSDate(fulldate) {
    var month = fulldate.getMonth() + 1;
    var date = fulldate.getDate();
    var year = fulldate.getFullYear();
    if (month < 10)
      month = "0" + month;
    if (date < 10)
      date = "0" + date;
    //TO DO : Change to date = day+"-"+month+"-"+year;
    return year + "-" + month + "-" + date;
  }

  removeDays(date, days) {
    var newDate = new Date(date);
    newDate.setDate(newDate.getDate() - days);
    return newDate;
  }

  //--------UI----------
  slideToggleContent(plotDivDescription) {
    $('#' + plotDivDescription + '-content').slideToggle(500, function () {
    });
  }

  //--------UI----------
  getAndPrintDataPlotFromDB(idOfCurentUser) {
    // console.log(idOfCurentUser);
    var functionToCall;
    if (idOfCurentUser.user_type == "a") functionToCall = 'getPlotByAdmin';
    if (idOfCurentUser.user_type == "c") functionToCall = 'getPlotByCooperative';
    if (idOfCurentUser.user_type == "t") functionToCall = 'getPlotByTechnician';
    if (idOfCurentUser.user_type == "f") functionToCall = 'getPlotByFarmer';
    // if(idOfCurentUser.user_type=="p") functionToCall = 'getPlotByPilot';

    var promise = new Promise((resolve, reject) => {
      this.httpService.httpPostPromise(functionToCall, idOfCurentUser)
        .then((plot_infos_geometry) => {
          if (plot_infos_geometry.length > 0) {
            this._plot_infos_geometry = plot_infos_geometry;
            this._plot_infos_geometryCopy = plot_infos_geometry;
            console.log(this._plot_infos_geometry);
            this.createDatePickerDisplayTools(plot_infos_geometry);

            this.creatStatusChart();
            this.creatPurgedAprovalChart(); 
            this.getSaticalStatus();
            
            resolve(plot_infos_geometry);
          }
        }, (error) => {
          console.log(error);
          reject('Eoor from db : getPlotByAdmin !');
        });
      // get parameters 
      functionToCall = 'getNbDaysBetweenHarvestAndFlightParameter';
      this.httpService.httpPostPromise(functionToCall, { 'id_user': this._currentUserInfos.user_id })
        .then((nbDaysBetweenHarvestAndFlightParameter) => {
          if (nbDaysBetweenHarvestAndFlightParameter.length > 0) {
            console.log(nbDaysBetweenHarvestAndFlightParameter);
            console.log(nbDaysBetweenHarvestAndFlightParameter[0].nb_days_between_harvest_and_flight);
            this._parameterNbDays = nbDaysBetweenHarvestAndFlightParameter[0].nb_days_between_harvest_and_flight;
            resolve(nbDaysBetweenHarvestAndFlightParameter);
          } else {
            this._parameterNbDays = 21;
          }
        }, (error) => {
          console.log(error);
          reject('Error from db : getNbDaysBetweenHarvestAndFlightParameter !');
        });

    });

    return promise;
  }

  createDatePickerDisplayTools(plots) {
    console.log('ok');
    console.log(plots);
    for (var i = 0; i < plots.length; i++) {
      this._isDatePickerDisplay[plots[i].plot_id] = true;
      //si des dates de récoltes sont prévu (donc  si un traritement est prévu) alors remplir le date picker
      if (plots[i].treatment[0]) {
        if (plots[i].treatment[0].treatment_date_harvest) {
          this._plotDatePicker[plots[i].plot_id] = this.transformNgbDatepickerFormat(plots[i].treatment[0].treatment_date_harvest);
        }
      }
      this.generatePlotDateTreatment(plots[i]);
    }
  }

  transformNgbDatepickerFormat(date) {
    return { year: parseInt(date.split('-')[0], 10), month: parseInt(date.split('-')[1], 10), day: parseInt(date.split('-')[2], 10) };
  }

  generatePlotDateTreatment(plot) {
    var date_treatment = <any>{};
    if (plot.plot_date_provisinnal) {
      var date = new Date(plot.plot_date_provisinnal);
      date_treatment.year = date.getFullYear();
      date_treatment.month = date.getMonth() + 1;
      date_treatment.day = date.getDay() + 1;
    }
    plot.plot_date_provisinnal != null ? plot.plot_date_treatment = date_treatment : plot.plot_date_treatment = null;

  }

  displayDatepicker(plot_id) {
    this._isDatePickerDisplay[plot_id] = !this._isDatePickerDisplay[plot_id];
  }

  search() {
    var _obj = this;
    var date_since = true;
    var date = null;
    var found_item = false;
    var isKeyword = _obj._filter.searchTerm;
    if (this._filter.date_since) {
      var month = _obj._filter.date_since.month;
      var day = _obj._filter.date_since.day;
      var year = _obj._filter.date_since.year;
      if (_obj._filter.date_since.month < 10)
        month = "0" + month;
      if (_obj._filter.date_since.day < 10)
        day = "0" + day;
      date = year + "" + month + "" + day;
    }
    if (!isKeyword) { //si pas de texte
      if (date) { //si une date (et pas de texte)
        this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
          if (tag.treatment.length > 0 && _obj._filter.date_since != "") { //si il y a une date dans le filtre
            return _obj.testFilterByDate(tag, date);
          }
        });
      }
      else if (!date) { //si pas de date (et pas de texte)
        this._plot_infos_geometry = this._plot_infos_geometryCopy;
      }
    } else if (_obj._filter.searchTerm) { //s'il y a du de texte
      if (date) { //si une date (et un texte)
        let term = (_obj._filter.searchTerm.toLowerCase());
        this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
          if (tag.treatment.length > 0 && _obj._filter.date_since != "") { //si il y a une date dans le filtre
            date_since = _obj.testFilterByDate(tag, date);
            found_item = _obj.testKeyword(tag, term);
            if (date_since && found_item)
              return true;
            else
              return false;
          }
        });
      }
      else { //si pas de date (et un texte)
        let term = (_obj._filter.searchTerm.toLowerCase());
        this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
          return _obj.testKeyword(tag, term);
        });
      }
    }
    this.getSaticalStatus();
  }

  testFilterByDate(tag, date) {
    if (tag.treatment[0].treatment_date_harvest != null) { // si l'objet contient une date
      if (this.filterByDate(tag.treatment[0].treatment_date_harvest, date, "today")) {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }

  filterByDate(date1, date2, unity) {
    var now = moment(date1);
    var dateBefore = moment(date2);
    switch (unity) {
      case "today":
        // console.log('days : ' + now.diff(dateBefore, 'days'));
        if (now.diff(dateBefore, 'days') < 0 || isNaN(now.diff(dateBefore, 'days'))) return false;
        else return true;
      case "yesterday":
        if (now.diff(dateBefore, 'days') != 1) return false;
        else return true;
      case "this_week":
        if (now.diff(dateBefore, 'weeks') != 0) return false;
        else return true;
      case "this_month":
        if (now.diff(dateBefore, 'months') != 0) return false;
        else return true;
      case "this_year":
        if (now.diff(dateBefore, 'years') != 0) return false;
        else return true;
      default:
        return true;
    }
  }

  testKeyword(tag, term) {
    if (tag.plot_name != null) {
      if ((tag.plot_name.toLowerCase()).indexOf(term) >= 0) { return true }
    }
    if (tag.cooperative_adherent != null) {
      if ((tag.cooperative_adherent.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.cooperative_city != null) {
      if ((tag.cooperative_city.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.cooperative_country != null) {
      if ((tag.cooperative_country.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.farmer_email != null) {
      if ((tag.farmer_email.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.farmer_first_name != null) {
      if ((tag.farmer_first_name.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.farmer_name != null) {
      if ((tag.farmer_name.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.farmer_phone != null) {
      if ((tag.farmer_phone.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
    if (tag.plot_comment != null) {
      if ((tag.plot_comment.toLowerCase()).toString().indexOf(term) >= 0) { return true }
    }
  }
}
