import * as licenseTxt from 'raw-loader!./license/luciadria_development.txt';
import * as License from 'luciad/util/License';
import { DeviceDetector } from '../../_class/DeviceDetector';
import { NetworkConnectionDetector } from '../../_class/NetworkConnectionDetector';
License.setLicenseText(licenseTxt);

import { AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone } from '@angular/core';
import 'rxjs/add/operator/toPromise';
import * as WebGLMap from 'luciad/view/WebGLMap';
import * as Map from "luciad/view/Map";
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
import { LayerFactory } from './LayerFactory';
import { GoogleMaps } from './GoogleMaps';
import * as  ShapeFactory from 'luciad/shape/ShapeFactory';
import * as  LayerGroup from 'luciad/view/LayerGroup';
import * as  LayerTreeControl from 'samples/common/control/LayerTreeControl';
import * as  LayerConfigUtil from 'samples/common/LayerConfigUtil';

/* Start Import file for create and edit feature */
import * as  Feature from 'luciad/model/feature/Feature';
import * as  FeatureModel from 'luciad/model/feature/FeatureModel';
import * as  BasicCreateController from 'luciad/view/controller/BasicCreateController';
import * as  EditController from 'luciad/view/controller/EditController';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  RestStore from 'samples/common/store/RestStore';
import * as  ShapeType from 'luciad/shape/ShapeType';
import * as  MemoryStore from 'luciad/model/store/MemoryStore';
import * as templateSample from "samples/template/sample";
import * as  domConstruct from "luciad/dojo/dom-construct";
import * as  dConstruct from "luciad/dojo/dom-construct";

/* Start Import file for create clustering access points feature */
import * as  ClusteringTransformer from 'luciad/view/feature/transformation/ClusteringTransformer';
import * as  ClusteringPainterWrapper from "samples/clustering/ClusteringPainterWrapper";
import * as ClusterIconStyleUtil from "samples/clustering/ClusterIconStyleUtil";
import * as  IconFactory from "samples/common/IconFactory";
//import * as variable from 'variableName';  
// import {ClusterIconStyleUtil,ClusteringPainterWrapper} from 'variableName';  

import * as  BasicFeaturePainter from 'luciad/view/feature/BasicFeaturePainter';

import { PlotDataLoader } from './PlotDataLoader';
import { Localisator } from './Localisator';
import { OptimizationOfATour } from './OptimizationOfATour';
import { BingMapsDataLoader } from '../../_class/BingMapsDataLoader';
import * as  Promise from "luciad/util/Promise";
import * as LayerType from 'luciad/view/LayerType';
import * as ShapePainterContour from "samples/shapePainter/ShapePainterContour";
import * as ShapePainterObstacle from "samples/shapePainter/ShapePainterObstacle";
import * as  ShapePainterOrdrePoint from 'luciad/shape/ShapePainterOrdrePoint';
import * as  ShapePainterContourOptimisation from 'luciad/shape/ShapePainterContour';
import * as  ShapePainterCircle from 'luciad/shape/ShapePainterCircle';
import * as  PaintRepresentation from "luciad/view/PaintRepresentation";
import * as GestureEventType from "luciad/view/input/GestureEventType";
import * as TransformationFactory from "luciad/transformation/TransformationFactory";

/* Start Import file for create and validate a form */
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { Router } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { SelectOptionService } from "../../shared/elements/select-option.service";
import { IOption } from "ng-select";

import swal from 'sweetalert2';
import { NotificationsService } from "angular2-notifications";
import * as $ from 'jquery';
import { } from '@types/googlemaps';
import { FireShotAPI } from './FireShotAPI';
@Component({
  selector: 'app-my-riamap',
  templateUrl: './my-riamap.component.html',
  styleUrls: ['./my-riamap.component.css'],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class MyRiamapComponent implements AfterViewInit, OnDestroy {
  @ViewChild('gmap') gmapElement: any;
  map: google.maps.Map;


  @ViewChild('map') mapElem: ElementRef;
  // Roadmap mapElement
  @ViewChild('roadmap') roadmapElem: ElementRef;

  /*  Notify */
  options: any = {
    position: ["bottom", "right"],
  };
  _coordinateType = null;
  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';

  title: string;
  msg: string;
  /*Tow opt algogithm*/

  _plotsInfoAndAccessPoint = []; // Pour to opt 
  _plotsInfoAndAccessPointOrdred = []; // Pour to opt 
  _featuresArraySelectedMemory = [];

  /*End Tow opt algogithm*/
  /*  End    */
  _map: WebGLMap;
  // Roadmap variables declarations
  roadmap: WebGLMap;
  rdmap_access_point: FeatureLayer;
  rdmap_plot_layer: FeatureLayer;
  rd_featureLayerTrajetOptimal: FeatureLayer;
  rd_featureLayerOrdrePoint: FeatureLayer;
  rdmap_path: FeatureLayer;
  roadmap_source_data: any;
  roadmap_table_rows: any;
  roadmap_table_rows_dist = { p1: null, p2: null, p3: null };
  roadmap_table_rows_duration = { p1: null, p2: null, p3: null };
  roadmap_itinerary_google_maps = {
    lat_current: null,
    long_current: null,
    lat_destination: null,
    long_destination: null,
    conveyance: 'data=!3m1!4b1!4m7!4m6!1m0!1m3!2m2!1d1.4250958!2d43.5794836!3e0',
    link_google_maps: null
  };
  roadmap_selected_row = 0;
  _sms = {
    type: 0,
    message: "",
    plot_id: null,
    to_farmer: true,
    to_technician: false,
    to_cooperative: false,
  }
  roadmap_columns: any[] = [
    { prop: 'id parcelle' },
    { name: 'Cooperative' },
    { name: 'Parcelle' },
    { name: 'Agriculteur' },
    { name: 'Téléphone' },
    { name: 'Techncien' },
    { name: 'Téléphone' }

  ];


  _printLayerControl: boolean = false;
  _featureLayer: FeatureLayer;
  _featureLayerTrajetOptimal: FeatureLayer;
  _featureLayerOrdrePoint: FeatureLayer;

  _featureLayerRepere: FeatureLayer;
  _featureLayerPlotsDB: FeatureLayer;
  _featureLayerObstaclesDB: FeatureLayer;
  _featureLayerBingMap: FeatureLayer;
  _featureLayerAccessPointDB: FeatureLayer;
  _featureLayerPissosDB: FeatureLayer;
  _featureLayerStartEndPoint: FeatureLayer;
  _featureLayerCircle: FeatureLayer;
  _circleSelect = {
    _radius: null,
    _erase: "true",
    _print: false,
  };
  _plotDataLoader: any;
  _localisator: any;
  _plot_infos_geometry = [];
  _tour_plot_infos_geometry = [];
  _plot_infos_geometryCopy = [];
  _currentUserInfos: any; //--------------!!!!
  _idOfUsersJSON_current: any; //--------------!!!! // = _idOfUsers  these variable is used after the user chose a current user to filter data in the carte 
  _usersFarmerByIdTech: any;//--------------!!!!
  _currentUserEmailAndToken: any; //--------------!!!!
  _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id": 0, "user_type": "t" }; //--------------!!!! // use to load a binding datas of a curent user or to filtering data 
  _errorInputs = { "name": false, "id_farmer": false, "electricline": false, "irrigationsystem": false }; // use to load a binding datas of a curent user or to filtering data 
  _farmer_selected = 0;
  // _model :{} ; //= {id_farmer:1,name :'',comment :'',electricline :'',irrigationsystem:'',geom :{}};
  _model = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    id_farmer: null,
    name: '',
    comment: '',
    electricline: '',
    irrigationsystem: '',
    geom: {},
    accesspoint: {},
    obstacles: {}
  };
  _tourModel = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    tourName: null,
    teamName: null,
    tourDate: null,
    pilots: [],
    drones: [],
    paths: [],
    dists: [],
    total_dist: 0,
    total_duration: 0,
    durations: [],
    area: 0,
    plot_id: { id: [], treatment: [] },
    start_point: null,
    end_point: null
  };
  _tourSummary = {
    selectedArea: 0,
    plotNumber: 0,
    plotNames: [],
    plotNamesOrdred: [],
    pathDistance: 0,
    pathDuration: 0
  };
  LIST_TREATMENTS: any = [];
  _tourExport = {
    team_id: null,
    tour_date: null,
    pilot_id: null,
    tour_id: null,
    type_filtre: null
  };
  selecteTeam = [{ value: 1, label: 'Equipe 1' }, { value: 2, label: 'Equipe 2' }, { value: 3, label: 'Equipe 3' }, { value: 4, label: 'Equipe 4' }];
  selectedPilot = [1, 2];
  pilot = [{ value: 1, label: 'ROMERO Stephane' }, { value: 2, label: 'MARC Dennys' }, { value: 3, label: 'Gregory' }, { value: 4, label: 'Opérateur 4' }] /*this.selectOptionService.getCountries()*/;
  selectedDrone = [1, 2];
  drone = [{ value: 1, label: 'Fox 1' }, { value: 2, label: 'Fox 2' }];
  tours = [];
  glLayer: any;
  _polt: number = 1;
  _startEndPoint: number = 1;
  EVENT_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(155, 180, 222, 0.8)",
      strokeWidth: 1
    })
  };

  EVENT_SELECTED_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(192, 217, 42, 0.8)",
      strokeWidth: 1.5
    })
  };
  progress: number = 0;
  label: string;

  @Input()
  mapReference: string;

  searchTerm: any;

  constructor(private httpService: HttpService,
    public authenticationService: AuthenticationService,
    private router: Router,
    private http: Http,
    private servicePNotify: NotificationsService,
    public selectOptionService: SelectOptionService,
    private deviceDetector: DeviceDetector,
    private connectionDetector: NetworkConnectionDetector,
    private cdRef: ChangeDetectorRef,
    private _ngZone: NgZone) {

    if (this.authenticationService.isLoggedIn()) {
      this.setIdOfUsersUsigLocalSorage();
      this.getAllUsersFarmersByIdTech();
    } else {
      this.router.navigate(['/login']); //--------------!!!!
    }

    if (localStorage.getItem('farmer_id')) {
      this._model.id_farmer = localStorage.getItem('farmer_id');
    } else {
      this._model.id_farmer = "null";
    }
  }

  processWithinAngularZone() {
    this.label = 'inside';
    this.progress = 0;
    this._increaseProgress(() => console.log('Inside Done!'));
  }
  processOutsideOfAngularZone(idOfCurentUsers) {
    this.label = 'outside';
    this.progress = 0;
    this._ngZone.runOutsideAngular(() => {
      this._increaseProgress(() => {
        this.ngOnInitAfterView();
        // reenter the Angular zone and display done
        this._ngZone.run(() => {
          //REMOVE LOADER NODE

          //REMOVE LOADER NODE
          console.log('Outside Done!');
        });
      });
    });
  }
  _increaseProgress(doneCallback: () => void) {
    this.progress += 1;
    this.cdRef.detectChanges();
    console.log(`Current progress: ${this.progress}%`);

    if (this.progress < 100) {
      window.setTimeout(() => this._increaseProgress(doneCallback), 10);
    } else {
      doneCallback();
    }
  }
  setFarmerIdLocalStorage(farmer_id) {
    localStorage.setItem('farmer_id', farmer_id);
  }

  ngOnInit() {

  }
  ngOnInitAfterView() {
    var _obj = this;
    // if (!localStorage.getItem('mapReference2D_3D')) {
    //   localStorage.setItem('mapReference2D_3D', 'EPSG:3857'); // EPSG:4326=2D and EPSG:4978=3D
    // }
    //idOfUsers il faut initialiser la properete idOfUsers en utilisant les id d'utilisateur connecter 
    var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); // 2D "EPSG:900913"
    this._map = new Map(this.mapElem.nativeElement, { reference: REF_EPSG3857 });

    BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {
      _obj._map.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");
      console.log(data);
    });

    this.addAllLayer();
    this.glLayer = GoogleMaps.startup(this._map);
    //Add layer controller to the application
    this.addMapLayer().then((data) => {
      console.log(data);
    }).catch((error) => {
      console.log(error);
    });
    this.activeSelectionChanged(this);
    this.loadDataMap(this._idOfUsers);
    this.roadmap_init();
    this.fitOnFranceOnLoad(this.roadmap);
    this.getGeolocation();
    $(function () {
      // Toggle info panel
      $("#showinfo").click(function () {
        $('#showinfo').toggleClass('active');
        $("#infopanel").fadeToggle();
      });
    });
    $(function () {
      // Toggle info panel
      $("#showinfoRoadMap").click(function () {
        $('#showinfoRoadMap').toggleClass('active');
        $("#infopanelRoadMap").fadeToggle();
      });
    });
  }
  ngAfterViewInit() {
    this.processOutsideOfAngularZone(this._idOfUsers);
  }

  //Saving state for offline use 
  save_state() {

  }
  // print test 
  downloadPDF() {

    //   html2canvas(document.body,{
    //     useCORS: true,
    //     width: 750,
    //      height: 1050,
    //      allowTaint : true,
    //      taintTest: false
    //     }).then(function(canvas){cp(canvas);});
    //   var cp=function(canvas) {
    //     $(".gm-style>div:first>div").css({
    //       left: 0,
    //       top: 0,
    //       "transform": $(".gm-style>div:first>div").css("transform")
    //     });
    //     document.body.appendChild(canvas);  
    // var imgData = canvas.toDataURL('image/png');
    // var imgdata =imgData.replace(/^data:image\/(png|jpg);base64,/,"") ;

    // var doc = new jsPDF('l', 'pt','a3');
    // var width = doc.internal.pageSize.width;
    // var height = doc.internal.pageSize.height;
    //  doc.addImage(imgdata, 'JPEG', 0,0,width,height);
    // //  window.resizeBy(250, 250); 
    // // window.focus();
    //  doc.save("pdf.pdf");
    //   }
  }

  fitOnFranceOnLoad(map) {
    var viewSize = map.viewSize;
    var b;
    if (viewSize[0] === 0 || viewSize[1] === 0) {
      b = ShapeFactory.createBounds(ReferenceProvider.getReference("CRS:84"), [1.10, 0.05, 44.19, 0.15]);
      map.resize();
      map.mapNavigator.fit({ bounds: b, animate: true });
    }
  }
  // ROADMAP_ CODE START 
  roadmap_init() {
    var _obj = this;
    this.roadmap = new WebGLMap(
      this.roadmapElem.nativeElement,
      { reference: ReferenceProvider.getReference(localStorage.getItem('mapReference2D_3D')) }
    );

    BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {
      _obj.roadmap.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");

    });

    // var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); // 2D "EPSG:900913"
    // this.roadmap = new Map( this.mapElem.nativeElement, {reference: REF_EPSG3857} );

    //  GoogleMaps.startup(this.roadmap);
    this.rdmap_path = this.createFeatureLayer("Trajet Optimal");

    var painteAccessPoints = new ShapePainterOrdrePoint();
    this.rdmap_access_point = this.createFeatureLayerWithPainter("Access points", painteAccessPoints);

    this.rdmap_plot_layer = this.createFeatureLayerWithPainter("Parcelles", new ShapePainterContour());
    this.rd_featureLayerOrdrePoint = this.createFeatureLayerWithPainter("L'ordre de la tournée", painteAccessPoints);
    this.rd_featureLayerTrajetOptimal = this.createFeatureLayer("Trajets optimals");
    // this._featureLayerPissosDB = this.createFeatureLayer("Pissos");
    // this.rdmap_plot_layer = this.createFeatureLayer("Parcelles");

    _obj.roadmap.layerTree.addChild(this.rdmap_path);
    _obj.roadmap.layerTree.addChild(this.rdmap_access_point);
    _obj.roadmap.layerTree.addChild(this.rdmap_plot_layer);
    _obj.roadmap.layerTree.addChild(this.rd_featureLayerOrdrePoint);
    _obj.roadmap.layerTree.addChild(this.rd_featureLayerTrajetOptimal);
    // _obj.roadmap.layerTree.addChild(this._featureLayerPissosDB);

    this.roadmap.on('MapChange', function () {
      _obj.rd_featureLayerOrdrePoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj.roadmap.mapScale[0] > 1 / 1000000));
    });
  }

  currentPlot(indx) {

    if (typeof this.roadmap_source_data.plot_id != "undefined") {

      if (indx < 0) {
        this.roadmap_selected_row += indx;
        if (this.roadmap_selected_row < 1) this.roadmap_selected_row = 0;
        this.zoomOnRoadMapPlot(parseInt(this.roadmap_source_data.plot_id[this.roadmap_selected_row]));
        if (this.roadmap_selected_row >= 1) {
          this.roadmap_table_rows = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1];

          this.roadmap_table_rows_dist.p1 = this.roadmap_source_data.dist[this.roadmap_selected_row - 1];
          this.roadmap_table_rows_dist.p2 = this.roadmap_source_data.dist[this.roadmap_selected_row];
          this.roadmap_table_rows_dist.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row].plot_name;


          this.roadmap_table_rows_duration.p1 = this.roadmap_source_data.duration[this.roadmap_selected_row - 1];
          this.roadmap_table_rows_duration.p2 = this.roadmap_source_data.duration[this.roadmap_selected_row];
          this.roadmap_table_rows_duration.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1].plot_name;
          this.smsTypeChange();

        }

      }
      if (indx > 0) {
        if (this.roadmap_selected_row == -1) this.roadmap_selected_row += indx + 1;
        this.roadmap_selected_row += indx;
        if (this.roadmap_selected_row > this.roadmap_source_data.plot_id.length - 2) this.roadmap_selected_row = this.roadmap_source_data.plot_id.length - 2;
        this.zoomOnRoadMapPlot(parseInt(this.roadmap_source_data.plot_id[this.roadmap_selected_row]));
        if (this.roadmap_selected_row >= 1) {
          this.roadmap_table_rows = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1];

          this.roadmap_table_rows_dist.p1 = this.roadmap_source_data.dist[this.roadmap_selected_row - 1];
          this.roadmap_table_rows_dist.p2 = this.roadmap_source_data.dist[this.roadmap_selected_row];
          if (this.roadmap_selected_row == this.roadmap_source_data.plot_info.length) {
            this.roadmap_table_rows_dist.p3 = "Point d'arrivée";
          } else {
            this.roadmap_table_rows_dist.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row].plot_name;
          }

          this.roadmap_table_rows_duration.p1 = this.roadmap_source_data.duration[this.roadmap_selected_row - 1];
          this.roadmap_table_rows_duration.p2 = this.roadmap_source_data.duration[this.roadmap_selected_row];
          this.roadmap_table_rows_duration.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1].plot_name;

          console.log(this.roadmap_table_rows_duration);
          this.smsTypeChange();
        }
      }
    }
  }

  printRoadMap() {
    window.print();
  }

  optimisationRoadMap() {
    var _plotsInfoAndAccessPointOrdred = [];

    _plotsInfoAndAccessPointOrdred.push({ "plot_lon_access_point": this.roadmap_source_data.tour.lat_start_point, "plot_lat_access_point": this.roadmap_source_data.tour.long_start_point, "plot_id": 0, "plot_name": "point de départ" });

    for (var i = 0; i < this.roadmap_source_data.plot_info.length; i++) {
      _plotsInfoAndAccessPointOrdred.push(this.roadmap_source_data.plot_info[i]);
    }

    _plotsInfoAndAccessPointOrdred.push({ "plot_lon_access_point": this.roadmap_source_data.tour.lat_end_point, "plot_lat_access_point": this.roadmap_source_data.tour.long_end_point, "plot_id": 0, "plot_name": "point d'arrivée" });

    console.log(_plotsInfoAndAccessPointOrdred);
    this.addNotify({ title: 'Chargement de feuille de routes (^_^)', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('getRoadPathBetween2point', { plotInfosAndAccessPoints: _plotsInfoAndAccessPointOrdred })
      .then((data) => {
        console.log(data);
        this.printResultOfRoadMap(data.path, _plotsInfoAndAccessPointOrdred);
        this.addNotify({ title: 'Chargement de feuille de routes (^_^)', msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Chargement de feuille de routes', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }
  printResultOfRoadMap(path, _plotsInfoAndAccessPointOrdred) {

    this._tourSummary.pathDistance = 0;
    this._tourSummary.pathDuration = 0;
    this._tourModel.dists = [];
    this._tourModel.durations = [];

    var distanceDureeFinale = [];
    var decodedPath1 = [];
    var distTraget = 0;
    var durationTraget = 0;

    $("#contentdivRodMap").html('<div id="syntheseInitaile" style="background-color : #aeff00; width:100%;"></div><div id="syntheseFinale" style="background-color : #2c3e50; width:100%;"></div><div id="gain" style="background-color : #9fc54d; width:100%;">Gain</div>');


    for (var i = 0; i < path.length; i++) {
      path[i] = JSON.parse(path[i]);


      var strDiv = "detailles" + i;
      document.getElementById('contentdivRodMap').innerHTML += "<h5 style='color : rgb(254, 254, 254) ;font-size: 12px;' (click)='displayDiv(" + strDiv + ")'>Trajet de " + this._tourSummary.plotNamesOrdred[i] + " à " + this._tourSummary.plotNamesOrdred[i + 1] + "<span style='color : #9fc54d; font-size: 90%'>   " + path[i].routes[0].legs[0].duration.text + "(" + path[i].routes[0].legs[0].distance.text + ")</span></h5> <div id ='" + strDiv + "' class='madiv' style='color :rgb(255, 255, 255);' display='none' ></div>";

      for (var j = 0; j < path[i].routes[0].legs[0].steps.length; j++) {

        document.getElementById(strDiv).innerHTML += "<br>" + path[i].routes[0].legs[0].steps[j].html_instructions;
        document.getElementById(strDiv).innerHTML += "<br><span style='color : #9fc54d; font-size: 80%'>" + path[i].routes[0].legs[0].steps[j].duration.text + "(" + path[i].routes[0].legs[0].steps[j].distance.text + ")</span>";

      }
      this._tourModel.dists.push(path[i].routes[0].legs[0].distance.value / 1000);
      this._tourModel.durations.push(path[i].routes[0].legs[0].duration.value / 3600);
      this._tourSummary.pathDistance += path[i].routes[0].legs[0].distance.value;
      this._tourSummary.pathDuration += path[i].routes[0].legs[0].duration.value;

      decodedPath1[i] = new Array();
      decodedPath1[i] = google.maps.geometry.encoding.decodePath(path[i].routes[0].overview_polyline.points);
      console.log(decodedPath1[i]);
    }

    document.getElementById('syntheseFinale').innerHTML += "Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration / 3600 + "H";
    $("#syntheseFinale").html("Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration / 3600 + "H");

    this.removeFeatureFromLayer(this.rd_featureLayerTrajetOptimal);
    this.removeFeatureFromLayer(this.rd_featureLayerOrdrePoint);

    for (var i = 0; i < decodedPath1.length; i++) {
      this.creatAndAddPolylineForTwoOptRoadMap(decodedPath1[i], this.rd_featureLayerTrajetOptimal.model);
    }

    this.createAndAddPointForTwoOptRoadMap(_plotsInfoAndAccessPointOrdred);

  }

  smsTypeChange() {
    console.log(this._sms);
    console.log(this.roadmap_table_rows);
    if (this.roadmap_selected_row >= 1) {
      this._sms.plot_id = this.roadmap_table_rows.plot_id;
      if (this._sms.type == 0) this._sms.message = "A propos de la parcelle  " + this.roadmap_table_rows.plot_name + " >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 1) this._sms.message = "Information >> Date prévue pour le traitement de la parcelle " + this.roadmap_table_rows.plot_name + " est le " + this.roadmap_source_data.tour.date + ". >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 2) this._sms.message = "Information >> Traitement de la parcelle  " + this.roadmap_table_rows.plot_name + " débutée(traitement commencé par pilote) >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 3) this._sms.message = "Information >> Traitmement de la parcelle " + this.roadmap_table_rows.plot_name + " est terminé. >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;

    }
  }

  sendSMS() {

    console.log(this._sms);
    this.addNotify({ title: 'Envoie de message ', msg: 'envoie en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('sms', { sms: this._sms })
      .then((data) => {
        console.log(data);
        this.addNotify({ title: 'Envoie de message  (^_^)', msg: 'Le message à été envoyé avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Envoie de message', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }

  verifyThenSendSMS() {
    var deviceInformation = this.deviceDetector.getDeviceInformations();
    if (!this.connectionDetector.isNetworkConnected()) {
      /*switch (deviceInformation.device) {
        case 'window':
          // Process for windows
          // Stockage SQLlite
          break;
        case 'android':
        case 'iphone':
        case 'ipad':
          // Process for android, iPhone and iPad
          if(false {Test 2G}) {
            // Stockage SQLlite
          }
          break;
        default: 
          console.log("default device");
      }    */
    } else {
      this.sendSMS();
    }
  }

  removeAllFeatursRoadMap() {
    for (var i = this.rdmap_plot_layer.model.store._data.length - 1; i >= 0; i--) {
      this.rdmap_plot_layer.model.remove(this.rdmap_plot_layer.model.store._data[i].id);
    }

  }
  //ROADMAP DATA LOAD
  loadRoadMapData(tourId) {
    console.log(tourId);
    this.addNotify({ title: 'Chargement de feuille de routes (^_^)', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('getTourById', { tour_id: tourId })
      .then((data) => {

        this.roadmap_source_data = data;
        this.removeAllFeatursRoadMap();
        this.roadmap_selected_row = 0;
        this.printPolygoneContour(this.roadmap_source_data.plot_info);
        this.optimisationRoadMap();
        console.log(this.roadmap_table_rows);

        console.log("Roadmap Source data >> : ");
        console.log(this.roadmap_source_data);
        this.addNotify({
          title: 'Chargement de feuille de routes (^_^)',
          msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !',
          type: 'success'
        });
      }, (error) => {
        console.error(error);
        this.addNotify(
          {
            title: 'Chargement de feuille de routes',
            msg: 'problème vient de serveur ! rafraichir la page :(',
            type: 'error'
          });
      });
  }

  zoomOnRoadMapPlot(plot_id) {
    for (var i = this.rdmap_plot_layer.model.store._data.length - 1; i >= 0; i--) {
      if (this.rdmap_plot_layer.model.store._data[i].properties.plot_id == plot_id) {
        var shape_id_poly = this.rdmap_plot_layer.model.store._data[i].id;
        this.roadmap.mapNavigator.fit(this.rdmap_plot_layer.model.get(shape_id_poly).shape.bounds);
      }
    }
  }

  errorGeolocation(err) {
    console.warn(`ERROR(${err.code}): ${err.message}`);
  }

  successGeolocation(pos) {
    var crd = pos.coords;

    console.log('Votre position actuelle est :');
    console.log(`Latitude : ${crd.latitude}`);
    console.log(`Longitude: ${crd.longitude}`);
    console.log(`Plus ou moins ${crd.accuracy} mètres.`);
    this.roadmap_itinerary_google_maps.lat_current = crd.latitude;
    this.roadmap_itinerary_google_maps.long_current = crd.longitude;
    console.log(this.roadmap_itinerary_google_maps);
  }
  getGeolocation() {
    var _obj = this;
    var options = {
      enableHighAccuracy: true,
      timeout: 5000,
      maximumAge: 0
    };

    if (navigator.geolocation) {
      // L'API est disponible
      navigator.geolocation.getCurrentPosition(function (pos) {
        var crd = pos.coords;
        // console.log('Votre position actuelle est :');
        // console.log(`Latitude : ${crd.latitude}`);
        // console.log(`Longitude: ${crd.longitude}`);
        // console.log(`Plus ou moins ${crd.accuracy} mètres.`);
        _obj.roadmap_itinerary_google_maps.lat_current = crd.latitude;
        _obj.roadmap_itinerary_google_maps.long_current = crd.longitude;
        console.log(_obj.roadmap_itinerary_google_maps);
      }/*this.successGeolocation*/, this.errorGeolocation, options);
    } else {
      // Pas de support, proposer une alternative ?
      console.log("Pas de support, proposer une alternative ?");
    }
  }
  getItinerary_google_maps(lat_destination, long_destination) {

    this.roadmap_itinerary_google_maps.lat_destination = lat_destination;
    this.roadmap_itinerary_google_maps.long_destination = long_destination;
    this.roadmap_itinerary_google_maps.link_google_maps = "https://www.google.fr/maps/dir/" + this.roadmap_itinerary_google_maps.lat_current + ',' + this.roadmap_itinerary_google_maps.long_current + '/' + this.roadmap_itinerary_google_maps.lat_destination + ',' + this.roadmap_itinerary_google_maps.long_destination + '/' + this.roadmap_itinerary_google_maps.conveyance;

    console.log(this.roadmap_itinerary_google_maps);
    window.open(this.roadmap_itinerary_google_maps.link_google_maps);

  }

  changePlotStatus(plot_id, statut) {

    this.httpService.httpPostPromise('changePlotStatus', { plot_id: plot_id, statut: statut })
      .then((data) => {
        console.log(data);
        this.roadmap_table_rows.statut = statut;
        this.addNotify({ title: 'Modification de l\'état de la parcelle  (^_^)', msg: 'L\'état à été modifié avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Modification de l\'état de la parcelle ', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }
  //MODAL for roadmap : init and load 
  //Table code
  onSelect({ selected }) { }
  onActivate(event) { }

  printPolygoneContour(plot_infos_geometry) {

    // console.log(plot_infos_geometry[0]);


    var ref = ReferenceProvider.getReference("EPSG:4326");
    // console.log(ref);

    for (var i = 0; i < plot_infos_geometry.length; i++) {

      var poly = ShapeFactory.createPolygon(ref, []);
      var access_pointDB = JSON.parse(plot_infos_geometry[i].plot_access_point);
      var access_point = ShapeFactory.createPoint(ref, access_pointDB.coordinates);

      var polyDB = JSON.parse(plot_infos_geometry[i].plot_geometry).coordinates[0];
      for (var j = 0; j < polyDB.length; j++) {
        // console.log(polyDB[j][0]);
        // var marker = ShapeFactory.createPoint(ref,[polyDB[j][0],polyDB[j][1],polyDB[j][2]]);
        //var marker = ShapeFactory.createPoint(ref,[polyDB[j][0],polyDB[j][1],polyDB[j][2]]);
        var marker = ShapeFactory.createPoint(ref, [polyDB[j][0], polyDB[j][1], polyDB[j][2]]);
        poly.insertPoint(j, marker);
      }

      var plot_properties = {
        farmer_id: plot_infos_geometry[i].farmer_id,
        farmer_first_name: plot_infos_geometry[i].farmer_first_name,
        farmer_name: plot_infos_geometry[i].farmer_name,
        farmer_phone: plot_infos_geometry[i].farmer_phone,

        technician_id: plot_infos_geometry[i].technician_id,
        technician_first_name: plot_infos_geometry[i].technician_first_name,
        technician_name: plot_infos_geometry[i].technician_name,

        plot_id: plot_infos_geometry[i].plot_id,
        plot_name: plot_infos_geometry[i].plot_name,
        plot_area: plot_infos_geometry[i].plot_area,
        plot_lat_access_point: access_point[0],
        plot_lon_access_point: access_point[1],
        plot_power_line: plot_infos_geometry[i].plot_power_line,
        plot_irrigation: plot_infos_geometry[i].plot_irrigation,
        plot_comment: plot_infos_geometry[i].plot_comment,

        cooperative_id: plot_infos_geometry[i].cooperative_id,
        cooperative_name: plot_infos_geometry[i].cooperative_name,

        cooperative_adherent_id: plot_infos_geometry[i].cooperative_id,
        cooperative_adherent_name: plot_infos_geometry[i].cooperative_adherent,

      };
      var markerFeaturePlot = new Feature(poly);
      var markerFeatureAccessPoint = new Feature(access_point);
      markerFeaturePlot.properties = plot_properties;
      markerFeatureAccessPoint.properties = plot_properties;
      //Décommenter pour faire apparaitre le tableauDePoints
      var shape_id = this.rdmap_plot_layer.model.add(markerFeaturePlot);
      // var shape_id = this._featureLayerAccessPointDB.model.add(markerFeatureAccessPoint);
      // return shape_id;

      // ----- Obstacles
      var obstaclesDB = JSON.parse(plot_infos_geometry[i].plot_obstacles);

      if (obstaclesDB) {
        obstaclesDB = obstaclesDB.coordinates;
        console.log(obstaclesDB);
        for (var j = 0; j < obstaclesDB.length; j++) {
          var obstacleDB = obstaclesDB[j];
          console.log(obstacleDB);
          var obstacle = ShapeFactory.createPolygon(ref, []);
          for (var k = 0; k < obstacleDB.length; k++) {
            var marker = ShapeFactory.createPoint(ref, [obstacleDB[k][0], obstacleDB[k][1], obstacleDB[k][2]]);
            obstacle.insertPoint(k, marker);
          }
          console.log(obstacle);

          var markerFeaturePlot = new Feature(obstacle);
          markerFeaturePlot.properties = plot_properties;
          //Décommenter pour faire apparaitre le tableauDePoints
          // var shape_id = this._featureLayerObstaclesDB.model.add(markerFeaturePlot);
        }
      }

    }
    this.roadmap.mapNavigator.fit({ bounds: this.rdmap_plot_layer.bounds, animate: true });
  }
  generate() {
    // roadmap_screenJs.generate();
  }
  saves() {
    console.log(FireShotAPI);
    //FireShotAPI.savePage(false,'div.ria-map','test.png');
    FireShotAPI.editPage(true, 'div.ria-map', 'test.png');
  }

  //ROADMAP CODE END
  map2D_3D(ref) {
    localStorage.setItem('mapReference2D_3D', ref);
    location.reload();
  }
  onSelectionChange() {
    this._localisator.selectionChanged(this._coordinateType, true);
  }

  change_navigator_view() {
    if (this._coordinateType == "DMS") {
      this._localisator.selectionChanged("DD", false);
    }
    this._localisator.change_navigator_view(this._map.mapNavigator, this._featureLayerRepere.model);
  }

  //Centre la carte sur une adresse
  geolocalise() {
    this._localisator.geolocalise(this._map.mapNavigator);
  }

  addAllLayer() {
    var _obj = this;
    // this._featureLayer = this.createFeatureLayer("Nouvelle parcelle");
    this._featureLayerRepere = this.createFeatureLayer("Repère");

    this.createFeatureLayerWithClustering("Regroupement");
    var painterContour = new ShapePainterContour();
    var painterObstacle = new ShapePainterObstacle();
    var painterOrdrePoint = new ShapePainterOrdrePoint();

    this._featureLayerPlotsDB = this.createFeatureLayerWithPainter("Parcelles", new ShapePainterContourOptimisation());
    this._featureLayerObstaclesDB = this.createFeatureLayerWithPainter("Obstacles", painterObstacle);
    this._featureLayerStartEndPoint = this.createFeatureLayerWithPainter("Point de départ && point d'arrivée", painterOrdrePoint);
    this._featureLayerOrdrePoint = this.createFeatureLayerWithPainter("L'ordre de la tournée", painterOrdrePoint);
    // this._featureModelTrajetOptimal = this.createFeatureLayerWithPainter("Trajets optimals");
    this._featureLayerCircle = this.createFeatureLayerWithPainter("Cercle", new ShapePainterCircle());
    this._featureLayerTrajetOptimal = this.createFeatureLayer("Trajets optimals");
    // console.log(BingMapsDataLoader.createLayer("AerialWithLabels")) ;
    // console.log(this._featureLayerBingMap);
    // this._map.layerTree.addChild(LayerFactory.createBackgroundLayer());
    this._map.layerTree.addChild(LayerFactory.createLonLatGridLayer());
    // this._map.layerTree.addChild(this._featureLayer);
    this._map.layerTree.addChild(this._featureLayerRepere);
    this._map.layerTree.addChild(this._featureLayerPlotsDB);
    this._map.layerTree.addChild(this._featureLayerObstaclesDB);
    this._map.layerTree.addChild(this._featureLayerAccessPointDB);
    this._map.layerTree.addChild(this._featureLayerOrdrePoint);
    this._map.layerTree.addChild(this._featureLayerTrajetOptimal);
    this._map.layerTree.addChild(this._featureLayerTrajetOptimal);
    this._map.layerTree.addChild(this._featureLayerStartEndPoint);
    this._map.layerTree.addChild(this._featureLayerCircle);
    // this._map.layerTree.addChild(this._featureLayerBingMap);


    this._map.on('MapChange', function () {
      _obj._featureLayerPlotsDB.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 10000));
      _obj._featureLayerOrdrePoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 1000000));
      _obj._featureLayerStartEndPoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 1004000));

    });

  }
  loadDataMap(idOfCurentUsers) {
    var obj = this;
    // this.addBalloonForm(this);
    //this._plotDataLoader = new PlotDataLoader ;
    this._localisator = new Localisator();

    this._plotDataLoader = new PlotDataLoader(this._map,
      this.httpService,
      this._featureLayerPlotsDB,
      this._featureLayerObstaclesDB,
      this._featureLayerAccessPointDB,
      this._plot_infos_geometry);

    this._plotDataLoader.getAndPrintDataPlotFromDB(idOfCurentUsers).then((data) => {
      obj._plot_infos_geometry = data;
      obj._plot_infos_geometryCopy = data;
      setTimeout(function () {
        var node = document.getElementById("loader");
        if (node) {
          if (node.parentNode) {
            node.parentNode.removeChild(node);
          }
        }
      }, 1000);
    });
  }

  getDataPlotFromDB(idOfCurentUser) {

    console.log(idOfCurentUser);
    var functionToCall;
    if (idOfCurentUser.user_type == "a") functionToCall = 'getPlotByAdmin';
    if (idOfCurentUser.user_type == "c") functionToCall = 'getPlotByCooperative';
    if (idOfCurentUser.user_type == "t") functionToCall = 'getPlotByTechnician';
    if (idOfCurentUser.user_type == "f") functionToCall = 'getPlotByFarmer';
    // if(idOfCurentUser.user_type=="p") functionToCall = 'getPlotByPilot';

    var plots_table = [];
    this.httpService.httpPostPromise(functionToCall, idOfCurentUser)
      .then((plot_infos_geometry) => {
        this._plot_infos_geometry = plot_infos_geometry;
        this._plot_infos_geometryCopy = plot_infos_geometry;
      }, (error) => {
        console.log(error);
      });
  }


  addMapLayer(): Promise<any> {
    var promise = new Promise((resolve, reject) => {
      if (new LayerTreeControl(this._map, { domId: "controlcontainer", title: "CALQUES" })) {
        resolve("hello i'm the promise result");
      } else {
        reject("I'm bad response of the promise");
      }
    });
    return promise;
  }

  openMyModal(event) {
    document.querySelector("#" + event).classList.add('md-show');
  }

  closeMyModalByDivId(event) {
    document.querySelector("#" + event).classList.remove('md-show');
  }

  closeMyModal(event) {
    ((event.target.parentElement.parentElement).parentElement).classList.remove('md-show');
  }
  addBalloonForm(oo) { }

  deletStartEndPoint() {

    for (var i = this._featureLayerStartEndPoint.model.store._data.length - 1; i >= 0; i--) {
      this._featureLayerStartEndPoint.model.remove(this._featureLayerStartEndPoint.model.store._data[i].id);
    }
    document.getElementById("start_end_point").removeAttribute('disabled');
  }

  deletePlotFromDB(plot_id) {
    // this._idOfUsersJSON_current.f= this._model.id_farmer ;
    // this.updateDataMap(JSON.stringify(this._idOfUsersJSON_current) );
    var del;
    var _obj = this;
    Promise.resolve().then(function () {
      del = _obj.deleteSwal(_obj._idOfUsers, plot_id);
    }).then(function () {
      // _obj._featureLayerAccessPointDB.model.on("ModelChanged", function(event) {
      // if(_obj._idOfUsersJSON_current){
      //    _obj.updateDataMap(JSON.stringify(this._idOfUsersJSON_current)); //chargement des donnés avec le filtrage  
      //  }else{
      //   _obj.resetDataMap();//chargement des donnés sans le filtrage
      //  } 
      // });   
    });


  }

  //--------UI----------
  slideToggleContent(plotDivDescription) {
    $('#' + plotDivDescription + '-content').slideToggle(500, function () {
    });
  }
  //--------UI----------
  search(): void {
    console.log(this.searchTerm);
    if (this.searchTerm == "") {
      this._plot_infos_geometry = this._plot_infos_geometryCopy;
    } else {
      let term = (this.searchTerm.toLowerCase());
      console.log(term);

      this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
        if (tag.plot_name != null) {
          if ((tag.plot_name.toLowerCase()).indexOf(term) >= 0) { return tag.plot_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_adherent != null) {
          if ((tag.cooperative_adherent.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_adherent.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_city != null) {
          if ((tag.cooperative_city.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_city.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_country != null) {
          if ((tag.cooperative_country.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_country.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_email != null) {
          if ((tag.farmer_email.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_email.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_first_name != null) {
          if ((tag.farmer_first_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_first_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_name != null) {
          if ((tag.farmer_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_phone != null) {
          if ((tag.farmer_phone.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_phone.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.plot_comment != null) {
          if ((tag.plot_comment.toLowerCase()).toString().indexOf(term) >= 0) { return tag.plot_comment.toLowerCase().indexOf(term) >= 0; }
        }
      });
      console.log(this._plot_infos_geometry);
    }
  }

  deleteSwal(idOfCurentUser, plot_id) {

    console.log(idOfCurentUser);
    var functionToCall;
    // if(idOfCurentUser.user_type=="admin") functionToCall = 'getPlotByAdmin';
    // if(idOfCurentUser.user_type=="c") functionToCall = 'getPlotByCooperative';
    // if(idOfCurentUser.user_type=="a") functionToCall = 'getPlotByAdherent';
    // if(idOfCurentUser.user_type=="t") functionToCall = 'getPlotByTechnician';
    // if(idOfCurentUser.user_type=="f") functionToCall = 'getPlotByFarmer';
    var req = { "plot_id": plot_id };
    var _obj = this;
    swal({
      title: 'Êtes-vous sûr?',
      text: "Souhaitez-vous supprimer définitivement cette parcelle ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Supprimer !',
      cancelButtonText: 'Non, Annuler !',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      // alert('lahcen ya rbi tkhdam');
      _obj.httpService.httpPostPromise("deleteplot", req)
        .then((plot_infos_geometry) => {

          swal(
            'Supprimée!',
            'Votre parcelle a été supprimée.',
            'success'
          )

          _obj._plotDataLoader.removeAll();
          if (_obj._idOfUsersJSON_current) {
            _obj.updateDataMap(JSON.stringify(_obj._idOfUsersJSON_current)); //chargement des donnés avec le filtrage  
          } else {
            _obj.resetDataMap();//chargement des donnés sans le filtrage
          }
        }, (error) => {
          swal(
            'Annulé !',
            'Votre parcelle n\'a été supprimée,réessayez ultérieurement !',
            'error'
          )
          console.log(error);
        });

    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
          'Annulé',
          'Votre parcelle n\'a pas été supprimée :)',
          'error'
        )
      }
    }).catch(swal.noop);

  }

  zoomOnFeature(plot_id) {
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        var shape_id_poly = this._featureLayerPlotsDB.model.store._data[i].id;
        this._map.mapNavigator.fit(this._featureLayerPlotsDB.model.get(shape_id_poly).shape.bounds);
      }
    }

    $('html,body').animate({
      scrollTop: 1 != $("#search-bar").height() ? $("#search-bar").height() + 50 : 100
    }, 300);
  }
  //-------------------Form controler-------------------------
  addBalloonElementSubmiteListner() {

    var _obj = this;
    var validate = false;



    if (_obj._model.id_farmer == "null") {
      _obj._errorInputs.id_farmer = true;
      console.log(_obj._errorInputs.id_farmer);
      console.log(_obj._model.id_farmer);
    } else {

      _obj._errorInputs.id_farmer = false;
      console.log(_obj._model.id_farmer);
      console.log(_obj._errorInputs.id_farmer);
    }

    if (!_obj._model.name) {
      _obj._errorInputs.name = true;
    } else {
      _obj._errorInputs.name = false;
    }
    // if(!_obj._model.comment);
    if (!_obj._model.electricline) {
      _obj._errorInputs.electricline = true;
    } else {
      _obj._errorInputs.electricline = false;
    }

    if (!_obj._model.irrigationsystem) {
      _obj._errorInputs.irrigationsystem = true;
    } else {
      _obj._errorInputs.irrigationsystem = false;
    }

    if (_obj._model.id_farmer == "null" || !_obj._model.name || !_obj._model.electricline || !_obj._model.irrigationsystem) {
      validate = false;
    } else {
      validate = true;
    }
    if (validate) {
      _obj._model.id_farmer = _obj._model.id_farmer;
      _obj._model.name = _obj._model.name;
      _obj._model.comment = _obj._model.comment;
      _obj._model.electricline = _obj._model.electricline; // document.getElementById("myCheck").checked
      _obj._model.irrigationsystem = _obj._model.irrigationsystem;


      var plotGeometry = _obj._featureLayer.workingSet.get();
      var poly = 'POLYGON((';
      var accessPoint = 'POINT(';
      var obstacles = null;
      if (plotGeometry.length > 2) obstacles = 'POLYGON((';
      for (var i = 0; i < plotGeometry.length; i++) {
        if (i == 0) {
          for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
            poly += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
          }
          poly += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '))';
        } else if (i == 1) {

          accessPoint += plotGeometry[i].geometry[0] + ' ' + plotGeometry[i].geometry[1] + ')';

        } else {
          if (i != plotGeometry.length - 1) {

            for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
              obstacles += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
            }
            obstacles += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '),(';
          } else {

            for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
              obstacles += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
            }
            obstacles += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '))';
          }
        }

      }
      _obj._model.geom = poly;
      _obj._model.accesspoint = accessPoint;
      _obj._model.obstacles = obstacles;

      console.log(_obj._model);
      _obj.onSubmit(_obj._model);
    }
  }


  onSubmit(parcelleDatas) { // VERIFICATION 
    this.httpService.httpPostPromise('storeplot', parcelleDatas)
      .then((data) => {
        this.addNotify({ title: 'Ajout d\'une parcelle', msg: 'La parcelle a été créée avec succes :)', type: 'success' });
        this.reset_polt();
        this.resetModel();
        this.closeMyModalByDivId('effect-7');
        if (this._idOfUsersJSON_current) {
          this._idOfUsersJSON_current.f = this._model.id_farmer;
          this.updateDataMap(JSON.stringify(this._idOfUsersJSON_current));
        } else {
          this.resetDataMap();
        }
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Ajout d\'une parcelle', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }

  resetModel() {
    this._model = {
      client_id: 2,
      client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
      id_farmer: null,
      name: '',
      comment: '',
      electricline: '',
      irrigationsystem: '',
      geom: {},
      accesspoint: {},
      obstacles: {}
    };
  }
  //-------------------End Form controler-------------------------
  activeSelectionChanged(o): void {

    o._map.on("SelectionChanged", function (event) {
      console.log(o._map.selectedObjects[0]);
      console.log(o._map);

      // o._featuresArraySelectedMemory = [] ;
      // console.log(o._map.selectedObjects[0]);
      console.log(event);
      console.log(event.selectionChanges[0]);
      if (event.selectionChanges.length > 0) {
        var add = (event.selectionChanges[0].deselected.length == 0);
        var remove = (event.selectionChanges[0].deselected.length == 1); //TO DO : we must manage deselect several plots
        if (event.selectionChanges[0].layer == o._featureLayerPlotsDB && add || event.selectionChanges[0].layer == o._featureLayerPlotsDB && remove) {
          // alert('1');
          console.log(o._plotsInfoAndAccessPoint);
          o._plotsInfoAndAccessPoint = [];
          var selectedObjects = o._map.selectedObjects[0];
          console.log(selectedObjects);
          if (o.isExistStartEndPoints()) {
            if (add)
              o.updateStatisticsPlotsSelection(selectedObjects, { operation: "add", feature: null });
            else if (remove) {
              o.updateStatisticsPlotsSelection(selectedObjects, { operation: "remove", feature: event.selectionChanges[0].deselected[0] });
              o.removeFeatureFromLayer(o._featureLayerCircle);
            }
          }
        } else if (event.selectionChanges[0].layer == o._featureLayerCircle) {
          // alert('2');
          o._featureLayerCircle.workingSet.get()[0].properties = { isSelected: true };
          console.log(o._featureLayerCircle.workingSet.get()[0]);
          o.circleEditController(event);

        } else if (event.selectionChanges[0].selected.length == 0 && o._featureLayerCircle.workingSet.get()[0].properties.isSelected == true) {
          // alert('3');
          o._featureLayerCircle.workingSet.get()[0].properties = { isSelected: false };
          o.removeFeatureFromLayer(o._featureLayerCircle);
          o._circleSelect._print = false;
          o._circleSelect._radius = "Rayon :  10 Km";
          o.applySelectPlots(o._featuresArraySelectedMemory);
        }
      }
    });
  }

  //-------------------Selected by circle----------------------------

  circleEditController(event) {
    var o = this;
    var selectedFeature = event.selectionChanges[0].selected[0];
    o._map.controller = new EditController(event.selectionChanges[0].layer, selectedFeature, { finishOnSingleClick: true });
    o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
    o._map.controller.onGestureEvent = function (event) {
      // if (event.inputType === "mouse" && event.domEvent.button > 0) {
      //   return HandleEventResult.EVENT_IGNORED;
      // }

      switch (event.type) {
        case GestureEventType.DOWN:
          o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
          break;
        case GestureEventType.DRAG:
          o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
          o._circleSelect._radius = "Rayon : " + (Math.round((o._featureLayerCircle.workingSet.get()[0].shape.radius / 1000) * 100) / 100) + " Km";
          break;
        case GestureEventType.DRAG_END:
          //Do nothing
          break;
      }
      return EditController.prototype.onGestureEvent.apply(this, arguments);
    }
  }
  updateStatisticsPlotsSelection(selectedObjects, operation) {
    var _obj = this;
    var StartEndPoint = _obj._featureLayerStartEndPoint.workingSet.get();
    _obj._plotsInfoAndAccessPoint.push({ "plot_lon_access_point": StartEndPoint[0].geometry[1], "plot_lat_access_point": StartEndPoint[0].geometry[0], "plot_id": 0, "plot_name": "point de départ" });

    _obj._tourSummary.plotNumber = selectedObjects.selected.length;
    _obj._tourSummary.selectedArea = 0;
    _obj._tourSummary.plotNames = [];
    _obj._tourSummary.plotNames.push('Point de départ');

    for (var i = 0; i < selectedObjects.selected.length; i++) {
      _obj._plotsInfoAndAccessPoint.push(selectedObjects.selected[i].properties);
      _obj._tourSummary.selectedArea += parseFloat(selectedObjects.selected[i].properties.plot_area);
      _obj._tourSummary.plotNames.push(selectedObjects.selected[i].properties.plot_name);
      if (operation.operation == "add") _obj.addPlotInfoAndAccessPointIfNotExist(selectedObjects.selected[i]);
      else if (operation.operation == "remove") _obj.removePlotInfoAndAccessPointIfDeselected(operation.feature);
    }

    _obj._tourSummary.plotNames.push("Point d'arrivé");
    _obj._plotsInfoAndAccessPoint.push({ "plot_lon_access_point": StartEndPoint[1].geometry[1], "plot_lat_access_point": StartEndPoint[1].geometry[0], "plot_id": 0, "plot_name": "point d'arrivée" });
    console.log(_obj._plotsInfoAndAccessPoint);
  }

  isExistStartEndPoints() {
    if (this._featureLayerStartEndPoint.workingSet.get().length < 2) {
      alert("Veuillez définir le point de départ et le point d'arrivée !");
      return false;
    } else {
      return true;
    }
  }
  createCircle() {
    if (!(this._featureLayerCircle.workingSet.get().length > 0)) {
      if (this._circleSelect._erase == "true") {
        this._featuresArraySelectedMemory = [];
      }
      var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
      var marker = ShapeFactory.createCircleByCenterPoint(
        REF_CRS84,
        this.getLonLatPointAtMapCenter(this._map),
        10000
      );
      var circle = new Feature(marker);
      circle.properties = { isSelected: true };
      var shape_circle_id = this._featureLayerCircle.model.add(circle);
      this._map.selectObjects([{ objects: [circle], layer: this._featureLayerCircle }]);
      this._circleSelect._print = true;
    }
  }

  fillSelection(circleFeature, features) {
    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    if (this.isExistStartEndPoints()) {
      // console.log(this._plotsInfoAndAccessPoint);
      for (var i = 0; i < features.length; i++) {
        var shape = features[i].shape;
        //console.log("Point with id " + shape.id + " is in circle : "+circle.shape.contains2DPoint(ShapeFactory.createPoint(ref,[shape[0],shape[1],shape[2]])));
        if (circleFeature.shape.contains2DPoint(ShapeFactory.createPoint(REF_CRS84, [shape[0], shape[1], shape[2]]))) {
          if (features[i].properties.clusteredElements) {
            for (var j = 0; j < features[i].properties.clusteredElements.length; j++) {
              this.addPlotInfoAndAccessPointIfNotExist(this.getPlotFeature(features[i].properties.clusteredElements[j].properties.plot_id));
            }
          } else {
            // console.log(features[i]);
            this.addPlotInfoAndAccessPointIfNotExist(this.getPlotFeature(features[i].properties.plot_id));
          }
          //  console.log(featuresArray);
          this.applySelectPlots(this._featuresArraySelectedMemory);

        } else {

        }
      }
    }

    // selection = {objects: featuresArray, layer: featuresLayer};
  }
  addPlotInfoAndAccessPointIfNotExist(feature) {
    console.log(feature);
    if (!this._featuresArraySelectedMemory.includes(feature)) {
      this._featuresArraySelectedMemory.push(feature);
    }
  }
  removePlotInfoAndAccessPointIfDeselected(feature) {
    var indx = this._featuresArraySelectedMemory.indexOf(feature);
    // alert("indx " + indx);
    if (indx != -1) {
      this._featuresArraySelectedMemory.splice(indx, 1);
    }

  }

  getLonLatPointAtMapCenter(map) {
    var viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
    var mapPoint = map.viewToMapTransformation.transform(viewPointCenter);

    var lonLatReference = ReferenceProvider.getReference("CRS:84");
    var mapToLonLatTransformation = TransformationFactory.createTransformation(map.reference, lonLatReference);

    var lonLatPoint = mapToLonLatTransformation.transform(mapPoint);
    return lonLatPoint;
  }

  applySelectPlots(featuresArray) {
    // this._featuresArraySelectedMemory =[];
    this._map.selectObjects([{ objects: featuresArray, layer: this._featureLayerPlotsDB }]);
  }
  getPlotFeature(plot_id) {
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        // console.log("-----------this._featureLayerPlotsDB.model.store._data[i]-------");
        return this._featureLayerPlotsDB.model.store._data[i];
      }
    }
  }
  //-------------------En selected by cercle-------------------------

  linkCreateButton(domId): void {

    if (domId == 'createpoint') var shapeType = ShapeType.POINT;
    else if (domId == 'createpolygon') var shapeType = ShapeType.POLYGON;
    this._map.selectObjects([]);

    //#snippet controller
    var createController = new BasicCreateController(shapeType);
    // var createController = new BasicCreateController(shapeType, {}, {finishOnSingleClick: true});
    //#endsnippet controller
    var _obj = this;
    createController.onChooseLayer = function (map) {

      return _obj._featureLayer;

    }
    createController.onObjectCreated = function (oo) {

      BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
      _obj._polt++;
      // console.log(_obj._featureLayer.workingSet.get().length);
    };

    this._map.controller = createController;
    // });
  }
  //--------------------------------------Tour--------------------------------------------
  optimisation() {
    var distMatrix = OptimizationOfATour.matrixDistanceLatLog(this._plotsInfoAndAccessPoint);

    this._plotsInfoAndAccessPointOrdred = OptimizationOfATour.towOpt(distMatrix, this._plotsInfoAndAccessPoint);
    this._tourSummary.plotNamesOrdred = [];
    for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {
      this._tourSummary.plotNamesOrdred.push(this._plotsInfoAndAccessPointOrdred[i].plot_name);
    }
    this.addNotify({ title: 'Chargement de feuille de routes (^_^)', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('getRoadPathBetween2point', { plotInfosAndAccessPoints: this._plotsInfoAndAccessPointOrdred })
      .then((data) => {
        console.log(data);
        this.printResultOfTwoOpt(data.path);
        this.addNotify({ title: 'Chargement de feuille de routes (^_^)', msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Chargement de feuille de routes', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });
  }
  //-5-----------------------------Afficher la tournee sur la map et charger la feuille de route-----------------------------

  printResultOfTwoOpt(path) {

    this._tourSummary.pathDistance = 0;
    this._tourSummary.pathDuration = 0;
    this._tourModel.dists = [];
    this._tourModel.durations = [];

    var distanceDureeFinale = [];
    var decodedPath1 = [];
    var distTraget = 0;
    var durationTraget = 0;
    console.log(path);
    $("#contentdiv").html('<div id="syntheseInitaile" style="background-color : #aeff00; width:100%;"></div><div id="syntheseFinale" style="background-color : #2c3e50; width:100%;"></div><div id="gain" style="background-color : #9fc54d; width:100%;">Gain</div>');

    for (var i = 0; i < path.length; i++) {
      path[i] = JSON.parse(path[i]);
      console.log(path[i]);
      var strDiv = "detailles" + i;
      document.getElementById('contentdiv').innerHTML += "<h5 style='color : rgb(254, 254, 254) ;font-size: 12px;' (click)='displayDiv(" + strDiv + ")'>Trajet de " + this._tourSummary.plotNamesOrdred[i] + " à " + this._tourSummary.plotNamesOrdred[i + 1] + "<span style='color : #9fc54d; font-size: 90%'>   " + path[i].routes[0].legs[0].duration.text + "(" + path[i].routes[0].legs[0].distance.text + ")</span></h5> <div id ='" + strDiv + "' class='madiv' style='color :rgb(255, 255, 255);' display='none' ></div>";
      // nomParcellesOrdonnes[i][2] = i ; //Ordre  
      // nomParcellesOrdonnes[i][3] = (path[i].routes[0].legs[0].distance.value/1000).toFixed(4) ; //Distance
      // nomParcellesOrdonnes[i][4] = (path[i].routes[0].legs[0].duration.value/3600).toFixed(4) ; //Durée

      for (var j = 0; j < path[i].routes[0].legs[0].steps.length; j++) {

        document.getElementById(strDiv).innerHTML += "<br>" + path[i].routes[0].legs[0].steps[j].html_instructions;
        document.getElementById(strDiv).innerHTML += "<br><span style='color : #9fc54d; font-size: 80%'>" + path[i].routes[0].legs[0].steps[j].duration.text + "(" + path[i].routes[0].legs[0].steps[j].distance.text + ")</span>";

      }
      this._tourModel.dists.push(path[i].routes[0].legs[0].distance.value / 1000);
      this._tourModel.durations.push(path[i].routes[0].legs[0].duration.value / 3600);
      this._tourSummary.pathDistance += path[i].routes[0].legs[0].distance.value;
      this._tourSummary.pathDuration += path[i].routes[0].legs[0].duration.value;

      decodedPath1[i] = new Array();
      decodedPath1[i] = google.maps.geometry.encoding.decodePath(path[i].routes[0].overview_polyline.points);
      console.log(decodedPath1[i]);
    }

    document.getElementById('syntheseFinale').innerHTML += "Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration / 3600 + "H";
    $("#syntheseFinale").html("Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration / 3600 + "H");
    // distanceDureeFinale.push(distTraget/1000,durationTraget/3600);

    // nomParcellesOrdonnesExportCsv = nomParcellesOrdonnes;   
    //  if (finInit==1) {
    //   // document.getElementById('syntheseInitaile').innerHTML+="Distance initiale :"+distTraget/1000+"km<br>La durée initiale :"+durationTraget/3600+"H";
    //    // initialize(decodedPath1); 
    //     $("#syntheseInitaile").html("Distance initiale :"+distTraget/1000+"km<br>La durée initiale :"+durationTraget/3600+"H");
    //    alert("Calcule des données statistiques");
    //  }  

    // // vider et supprimer les premiers path dans le MemoryStore (Trajet qui est polyline et dans points d'acces)
    this.removeFeatureFromLayer(this._featureLayerTrajetOptimal);
    this.removeFeatureFromLayer(this._featureLayerOrdrePoint);

    for (var i = 0; i < decodedPath1.length; i++) {
      this.creatAndAddPolylineForTwoOpt(decodedPath1[i], this._featureLayerTrajetOptimal.model);
    }

    this.createAndAddPointForTwoOpt(false);

    // var nomParcellesOrdonnesTmp ="";
    // for(var i=0 ;i<nomParcellesOrdonnes.length;i++){
    //     nomParcellesOrdonnesTmp +=nomParcellesOrdonnes[i][0]+"<br>";
    // }
    // $("#parcellesOrdonnes").html("<h3 style='color : #ffffff; font-size: 18px'>Les parcelles ordonnées sont: </h3>  <br> "+nomParcellesOrdonnesTmp);   

  }


  displayDiv(idDiv) {

    if ($(idDiv).attr("display") == "none") {

      $(idDiv).fadeIn("slow", "swing");
      $(idDiv).attr("display", "block");
    } else {
      $(idDiv).fadeOut("slow", "swing");
      $(idDiv).attr("display", "none");
    }
  }

  submitTour() {
    this._tourModel.pilots = this.selectedPilot;
    this._tourModel.drones = this.selectedDrone;
    this._tourModel.area = this._tourSummary.selectedArea;
    this._tourModel.total_dist = this._tourSummary.pathDistance / 1000;
    this._tourModel.total_duration = this._tourSummary.pathDuration / 3600;
    var indx = this._plotsInfoAndAccessPointOrdred.length - 1;
    this._tourModel.start_point = 'POINT(' + this._plotsInfoAndAccessPointOrdred[0].plot_lat_access_point + ' ' + this._plotsInfoAndAccessPointOrdred[0].plot_lon_access_point + ')';
    this._tourModel.end_point = 'POINT(' + this._plotsInfoAndAccessPointOrdred[indx].plot_lat_access_point + ' ' + this._plotsInfoAndAccessPointOrdred[indx].plot_lon_access_point + ')';

  
    console.log(this._plotsInfoAndAccessPointOrdred.length);
    console.log(this._tourModel);
    console.log(this.selectedPilot);
    console.log(this._featureLayerTrajetOptimal);

    this.httpService.httpPostPromise('storeTour', this._tourModel)
        .then((data) => {
          console.log(data.state);
          this.addNotify({ title: 'Sauvegarder la tournée (^_^)', msg: 'La tournée ' + this._tourModel.tourName + ' a été sauvegarder avec succès !', type: 'success' });
  
          if (this._idOfUsersJSON_current) {
            this.updateDataMap(JSON.stringify(this._idOfUsersJSON_current));
          } else {
            this.resetDataMap();
          }
        }, (error) => {
          console.error(error);
          this.addNotify({ title: 'Sauvegarder la tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
      }); 
  }
  get_tour_plot_infos_geometry() {
    this._tourModel.plot_id.id = [];
    this._tourModel.plot_id.treatment = [];
    for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {
      this._tourModel.plot_id.id.push(this._plotsInfoAndAccessPointOrdred[i].plot_id);
    }
    this._tour_plot_infos_geometry = [];
    for (var i = 0; i < this._tourModel.plot_id.id.length; i++) {
      if (this._tourModel.plot_id.id[i] != 0)
        this._tour_plot_infos_geometry.push(this.getPlotInfoGeometry(this._tourModel.plot_id.id[i]));
    }
    for (var i = this._tour_plot_infos_geometry.length - 1; i >= 0; i--) {
      var lastTreatmentId = null;
      for (var j = 0; j < this._tour_plot_infos_geometry[i].treatment.length; j++) {
        if (j == 0 && this._tour_plot_infos_geometry[i].treatment[j].treatment_status == "commande"){
          lastTreatmentId = this._tour_plot_infos_geometry[i].treatment[j].treatment_id;
        }else if (j != 0 && this._tour_plot_infos_geometry[i].treatment[j].treatment_status == "commande") {
          if (lastTreatmentId < this._tour_plot_infos_geometry[i].treatment[j].treatment_id || lastTreatmentId==null){
            lastTreatmentId = this._tour_plot_infos_geometry[i].treatment[j].treatment_id;
          }
        }
      } 
      if (lastTreatmentId) {
        this._tourModel.plot_id.treatment.push(lastTreatmentId);
      }
    }
  }
  checkUncheckTreatmentTour(treatment_id) {
    for (var i = this._tourModel.plot_id.treatment.length - 1; i >= 0; i--) {
      if (this._tourModel.plot_id.treatment[i] == treatment_id) {
        return true;
      }
    }
    return false;
  }
  updatePlotTableTreatment(plot_id, treatment_id) {
    console.log("plot_id: " + plot_id + "__treatment_id: " + treatment_id);
    var checkBox = document.getElementById('treatment-tour-' + treatment_id);
    if ((<HTMLInputElement>checkBox).checked) {
      for (var i = 0; i < this._tourModel.plot_id.id.length; i++) {
        if (this._tourModel.plot_id.id[i] == plot_id) {
          this._tourModel.plot_id.treatment.push(treatment_id);
        }
      }
    } else {
      var indx = this._tourModel.plot_id.treatment.map(function (e) { return e; }).indexOf(treatment_id);
      this._tourModel.plot_id.treatment.splice(indx, 1);
    }
    console.log(this._tourModel);
  }

  /**
   * Returns the plot at the given ID.
   * @param aId  plot id
   */
  getPlotInfoGeometry(aId) {
    var _plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
      return tag.plot_id == aId;
    });
    return _plot_infos_geometry[0];
  }
  setLIST_TREATMENTS(plot_id) {
    this.LIST_TREATMENTS = [];
    this.LIST_TREATMENTS.push(this.getPlotInfoGeometry(plot_id));
    for (var i = 0; i < this.LIST_TREATMENTS.length; i++) {
      var treatment = this.LIST_TREATMENTS[i].treatment;
      this.LIST_TREATMENTS[i].treatment = [];
      for (var j = 0; j < treatment.length; j++) {
        if (treatment[j].treatment_status == "commande" || treatment[j].treatment_status == "en-cours") {
          this.LIST_TREATMENTS[i].treatment.push(treatment[j]);
        }
      }
    }
  }
  getTreatmentLength(treatements) {
    var _length = 0;
    for (var i = 0; i < treatements.length; i++) {
      if (treatements[i].treatment_status == "commande" || treatements[i].treatment_status == "en-cours") {
        _length++;
      }
    }
    return _length;
  }
  exportTour(tour_id) {

    this.addNotify({ title: 'Exportation de la tournée (^_^)', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('exportCSVTour', { tour_id: tour_id })
      .then((data) => {
        console.log(data);
        this.downloadTour(data.filename);
        this.addNotify({ title: 'Exportation de la tournée (^_^)', msg: 'Veuillez télécharger votre tournée.', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Exportation de la tournée', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });
  }

  downloadTour(path) {
    return this.http
      .get('assets/data/tournees_2018/' + path, {
        responseType: ResponseContentType.Blob
      })
      .map(res => {
        return {
          filename: path,
          data: res.blob()
        };
      })
      .subscribe(res => {
        console.log('start download:', res);
        var url = window.URL.createObjectURL(res.data);
        var a = document.createElement('a');
        document.body.appendChild(a);
        a.setAttribute('style', 'display: none');
        a.href = url;
        a.download = res.filename;
        a.click();
        window.URL.revokeObjectURL(url);
        a.remove(); // remove the element
      }, error => {
        console.log('download error:', JSON.stringify(error));
      }, () => {
        console.log('Completed file download.')
      });
  }
  getTourByTeam(team_id) {
    this._tourExport.type_filtre = 't';
    this.httpService.httpPostPromise('getTourByTeam', { team_id: this._tourExport.team_id })
      .then((data) => {
        this.tours = data;
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
      });
  }

  getTourByPilot(pilot_id) {
    this._tourExport.type_filtre = 'p';
    this.httpService.httpPostPromise('getTourByPilot', { pilot_id: this._tourExport.pilot_id })
      .then((data) => {
        this.tours = data;
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
      });
  }

  getTourById(tour_id) {
    this.httpService.httpPostPromise('getTourById', { tour_id: this._tourExport.tour_id })
      .then((data) => {
        console.log(data);
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
      });
  }

  updateTour(tour_id) {
    console.log(tour_id);
  }
  deleteTour(tour_id) {
    console.log(tour_id);
    this.deleteTourSwal(this._idOfUsers, tour_id);
  }


  deleteTourSwal(idOfCurentUser, tour_id) {

    this.closeMyModalByDivId('retrieveTourForRoadMap');
    console.log(idOfCurentUser);
    var functionToCall;
    // if(idOfCurentUser.user_type=="admin") functionToCall = 'getPlotByAdmin';
    // if(idOfCurentUser.user_type=="c") functionToCall = 'getPlotByCooperative';
    // if(idOfCurentUser.user_type=="a") functionToCall = 'getPlotByAdherent';
    // if(idOfCurentUser.user_type=="t") functionToCall = 'getPlotByTechnician';
    // if(idOfCurentUser.user_type=="f") functionToCall = 'getPlotByFarmer';
    var req = { "tour_id": tour_id };
    var _obj = this;
    swal({
      title: 'Êtes-vous sûr?',
      text: "Souhaitez-vous supprimer définitivement cette tournée ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Supprimer !',
      cancelButtonText: 'Non, Annuler !',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      // alert('lahcen ya rbi tkhdam');
      _obj.httpService.httpPostPromise("deleteTour", req)
        .then((plot_infos_geometry) => {

          swal(
            'Supprimée!',
            'Votre tournée a été supprimée.',
            'success'
          )
          if (_obj._tourExport.type_filtre == 'p') {
            _obj.getTourByPilot(_obj._tourExport.pilot_id);
          } else if (_obj._tourExport.type_filtre == 't') {
            _obj.getTourByTeam(_obj._tourExport.team_id);
          } else if (_obj._tourExport.type_filtre == 'date') {
            // TO DO 
          }
          _obj.openMyModal('retrieveTourForRoadMap');
        }, (error) => {
          swal(
            'Annulé !',
            'Votre tournée n\'a pas été supprimée,réessayez ultérieurement !',
            'error'
          )
          _obj.openMyModal('retrieveTourForRoadMap');
          console.log(error);
        });

    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
          'Annulé',
          'Votre tournée n\'a pas été supprimée :)',
          'error'
        )
        _obj.openMyModal('retrieveTourForRoadMap');
      }
    }).catch(swal.noop);

  }
  //--------------------------------------Tour--------------------------------------------

  removeFeatureFromLayer(layer) {
    for (var i = layer.model.store._data.length - 1; i >= 0; i--) {
      layer.model.remove(layer.model.store._data[i].id);
    }
  }

  createAndAddPointForTwoOpt(formHistorique) {

    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {

      var myPoint = ShapeFactory.createPoint(REF_CRS84, [this._plotsInfoAndAccessPointOrdred[i].plot_lat_access_point, this._plotsInfoAndAccessPointOrdred[i].plot_lon_access_point]);
      var markerFeature = new Feature(myPoint);

      if (!formHistorique) {

        if (i == 0) var properties = { order: "PDE" };
        else if (i == this._plotsInfoAndAccessPointOrdred.length - 1) var properties = { order: "PDA" };
        else var properties = { order: '<h4 class="sub-title" style="color: #a9bc14;" align="center">' + i + '</h4>' + this._plotsInfoAndAccessPointOrdred[i].plot_name };

      } else {

        // $("#btn_exporter_tour_csv").prop("disabled",false); 

        // if(i==0) var pro = {ordre :"Point de départ"};
        // else if(i==ordrePoint.length-1) var pro = {ordre :"Point d'arrivée"};
        // else var pro = {ordre :"<a href='#'><p align='center' style='font-size: 20px;'>"+i+"</p></a>"+nomParcellesOrdonnes[i][0] };

      }
      console.log(properties);
      console.log(this._featureLayerOrdrePoint);
      markerFeature.properties = properties;
      this._featureLayerOrdrePoint.model.add(markerFeature);
    }
  }

  createAndAddPointForTwoOptRoadMap(_plotsInfoAndAccessPointOrdred) {

    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    for (var i = 0; i < _plotsInfoAndAccessPointOrdred.length; i++) {

      var myPoint = ShapeFactory.createPoint(REF_CRS84, [_plotsInfoAndAccessPointOrdred[i].plot_lat_access_point, _plotsInfoAndAccessPointOrdred[i].plot_lon_access_point]);
      var markerFeature = new Feature(myPoint);

      var properties = { order: '<h4 class="sub-title" style="color: #a9bc14;" align="center">' + i + '</h4>' + _plotsInfoAndAccessPointOrdred[i].plot_name };

      console.log(this.rd_featureLayerOrdrePoint);
      markerFeature.properties = properties;
      this.rd_featureLayerOrdrePoint.model.add(markerFeature);
    }

    this.roadmap.mapNavigator.fit({ bounds: this.rd_featureLayerOrdrePoint.bounds, animate: false });
  }

  creatAndAddPolylineForTwoOptRoadMap(tableauDePoints, model) {
    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    var ligne = '(';
    var poly = ShapeFactory.createPolyline(REF_CRS84, []);

    for (var i = 0; i < tableauDePoints.length; i++) {
      var marker = ShapeFactory.createPoint(REF_CRS84, [parseFloat(tableauDePoints[i].lng()), parseFloat(tableauDePoints[i].lat())]);
      poly.insertPoint(i, marker);

      if (i == tableauDePoints.length - 1) ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ')';
      else ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ',';
    }
    this._tourModel.paths.push(ligne);
    var markerFeature = new Feature(poly);
    var shape_id = model.add(markerFeature);
    this._map.mapNavigator.fit({ bounds: this.rd_featureLayerTrajetOptimal.bounds, animate: false });
    return shape_id;
  }

  creatAndAddPolylineForTwoOpt(tableauDePoints, model) {
    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    var ligne = '(';
    var poly = ShapeFactory.createPolyline(REF_CRS84, []);

    for (var i = 0; i < tableauDePoints.length; i++) {
      var marker = ShapeFactory.createPoint(REF_CRS84, [parseFloat(tableauDePoints[i].lng()), parseFloat(tableauDePoints[i].lat())]);
      poly.insertPoint(i, marker);

      if (i == tableauDePoints.length - 1) ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ')';
      else ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ',';
    }
    this._tourModel.paths.push(ligne);
    var markerFeature = new Feature(poly);
    var shape_id = model.add(markerFeature);
    this._map.mapNavigator.fit({ bounds: this._featureLayerTrajetOptimal.bounds, animate: false });
    return shape_id;
  }


  linkCreateButtonStartEndPoint(domId): void {
    var _obj = this;
    if (domId == 'start_end_point') var shapeType = ShapeType.POINT;

    // this._map.selectObjects([]);
    if (_obj._featureLayerStartEndPoint.workingSet.get().length != 2) {
      //#snippet controller
      var defaultProperties = {};
      if (_obj._featureLayerStartEndPoint.workingSet.get().length == 0) defaultProperties = { order: 'Point de départ' };
      else defaultProperties = { order: 'Point de d\'arrivée' };
      var createController = new BasicCreateController(shapeType, defaultProperties, { finishOnSingleClick: true });

      createController.onChooseLayer = function (map) {

        return _obj._featureLayerStartEndPoint;

      }
      createController.onObjectCreated = function (oo) {

        BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
        _obj._startEndPoint++;
      };

      this._map.controller = createController;
      // });
    } else {
      document.getElementById("start_end_point").setAttribute("disabled", "disabled");
    }

  }

  reset_polt() {

    var sizeWSet = this._featureLayer.workingSet.get().length;
    var features = this._featureLayer.workingSet.get();
    console.log(features);
    for (var i = 0; i < sizeWSet; i++) {
      this._featureLayer.workingSet.remove(features[i].id);
    }
    this._map.hideBalloon();
    this._polt = 1;
  }

  _fetchSelectedObject(map) {
    var objects = map.selectedObjects;
    // console.log(objects);
    for (var idx = 0; idx < objects.length; idx++) {
      if (objects[idx].selected.length > 0 && objects[idx].layer.editable) {
        return {
          layer: objects[idx].layer,
          feature: objects[idx].selected[0]
        };
      }
    }
  }



  createFeatureLayer(label) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: true,
      label: label
    });
  }

  createFeatureLayerWithPainter(label, shapePainter) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: false,
      label: label,
      painter: shapePainter
    });
  }


  verifieExistance(tabId, id) {
    var val = 0;
    for (var i = 0; i < tabId.length; i++) {
      if (tabId[i] == id) { return 1; }
    }
    return val;
  }

  updateDataMap(idOfUsers) {

    this._idOfUsersJSON_current = JSON.parse(idOfUsers);
    this.setIdOfUsers(this._idOfUsersJSON_current);  // set this._idOfUsers
    this.removeAllShapesForAllLayers();
    //this.removeAllLayer();
    //this.addAllLayer();
    this.loadDataMap(this._idOfUsers);

  }

  resetDataMap() {
    this.setIdOfUsersUsigLocalSorage();
    this.removeAllShapesForAllLayers();
    // this.removeAllLayer();
    //this.addAllLayer();
    this.loadDataMap(this._idOfUsers);
  }

  getAllUsersFarmersByIdTech() {

    this.httpService.httpPostPromise('getAllUsersFarmersByIdTech', { id_technician: this._currentUserInfos.tchnicians_id })
      .then((data) => {
        this._usersFarmerByIdTech = data;
        console.log(this._usersFarmerByIdTech);
        // alert('yes yes yes yes ');
      }, (error) => {
        // this.addNotify({title:'Arbre des coopératives', msg: 'problème vient de serveur ! rafraichir la page :(', type:'error'});
      });
  }
  setIdOfUsersUsigLocalSorage() {
    this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));


    switch (this._currentUserInfos.right) {
      case 1:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "a";
        break;
      case 2:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "c";

        break;
      case 3:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "t";
        break;
      case 4:
        this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
        this._idOfUsers.user_type = "f";

        break;
      // case '5':
      //         this._idOfUsers.cooperative_id = 0; 
      //         this._idOfUsers.adherent_id = 0 ;
      //         this._idOfUsers.technician_id = 0 ; 
      //         this._idOfUsers.farmer_id = 0 ;
      //         this._idOfUsers.user_type = "p"  ;

      //     break;
    }
  }
  setIdOfUsers(idOfUsersJSON) {

    this._idOfUsers.cooperative_id = idOfUsersJSON.c
    // this._idOfUsers.adherent_id = idOfUsersJSON.a ;
    this._idOfUsers.technician_id = idOfUsersJSON.t;
    this._idOfUsers.farmer_id = idOfUsersJSON.f;
    this._idOfUsers.user_type = idOfUsersJSON.s;
  }
  createFeatureLayerWithClustering(label) {
    var _obj = this;
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    var featureStore = new MemoryStore();
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    var armedEventsPainter = new BasicFeaturePainter();

    armedEventsPainter.getDetailLevelScales = function () {
      return [1 / 2000000];
    };

    armedEventsPainter.paintLabel = function (labelcanvas, feature, shape, layer, map, paintState) {
      if (paintState.level === 1) {
        // labelcanvas.drawLabel(labelForArmedEvent(feature), shape.focusPoint, {
        //   positions: PointLabelPosition.NORTH
        // });
      }
    };

    armedEventsPainter.paintBody = function (geocanvas, feature, shape, layer, map, paintState) {
      if (paintState.selected) {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_SELECTED_STYLE);
      } else {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_STYLE);
      }
    };

    var clusterPainter = new ClusteringPainterWrapper(armedEventsPainter);
    clusterPainter.paintClusterBody = function (geocanvas, feature, shape, layer, map, paintState) {
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getOuterStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getInnerStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getTextStyle(feature));
      if (paintState.selected) {
        // Paint clustered elements when selecting a cluster
        var clusteredFeatures = ClusteringTransformer.clusteredFeatures(feature);
        for (var i = 0; i < clusteredFeatures.length; i++) {
          var clusteredFeature = clusteredFeatures[i];
          armedEventsPainter.paintBody(geocanvas, clusteredFeature, clusteredFeature.shape, layer, map, paintState);
        }
      }
    };

    var j = 0;
    clusterPainter.paintClusterLabel = function (labelCanvas, feature, shape, layer, map, state) {
      //don't paint the default cluster label
      // console.log(clusterPainter);
      //  _obj._map.mapNavigator.pan({targetLocation: targetViewPoint, animate: {duration: 250}}); 
      // map.mapNavigator.fit(targetViewPoint);

      layer.balloonContentProvider = function (o) { //============> Start============>
        console.log(o);
        var _tempModelPoint = ShapeFactory.createPoint(o.geometry._reference, [o.geometry[0], o.geometry[1]]);
        this._tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
        var _tempMapPoint = ShapeFactory.createPoint(map.reference, [0, 0]);
        var _transformation = TransformationFactory.createTransformation(o.geometry._reference, map.reference);
        _transformation.transform(_tempModelPoint, _tempMapPoint);
        map.mapToViewTransformation.transform(_tempMapPoint, this._tempViewPoint);
        this.viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var centerOfView = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var xCenter = (map.viewSize[0] / 2) - this._tempViewPoint[0];
        var yCenter = (map.viewSize[1] / 2) - this._tempViewPoint[1];
        var offsetFromCenterOfView = centerOfView.copy();
        offsetFromCenterOfView.translate(xCenter, yCenter + 100);
        map.mapNavigator.pan({ targetLocation: centerOfView, toViewLocation: offsetFromCenterOfView, animate: { duration: 200 } })

        var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
        var targetViewPoint = ShapeFactory.createPoint(REF_CRS84, [o._shape._coords[0], o._shape._coords[1] - 1]);
        // _obj._map.mapNavigator.pan({targetLocation: targetViewPoint, animate: {duration: 250}}); 
        var plots;
        var plots_count = 0;
        var plot_area = 0;
        var tabIdFarmer = [];
        var tabIdTech = [];
        var tabIdCoop = [];
        var tabIdAdhe = [];

        console.log(o.properties);
        var plot_properties = o.properties, node;
        node = domConstruct.toDom('<div class="card-body-ballon"> </div>');

        console.log(plot_properties);
        if (!plot_properties.clusteredElements) {
          plots = plot_properties; // Feature with properties
          console.log(plots);
          // alert('1') ;
        } else {
          // alert("2") ;
          plots = plot_properties.clusteredElements;
          console.log(plots);
        }

        if (!plot_properties.clusteredElements) {         //========Node for single plot=====> Start 

          plots_count++;
          plot_area += parseFloat(plots.plot_area);
          var nodeSinglePlot = domConstruct.toDom('\
                                                        <div class="row">\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title" style="color: #a9bc14;">Information sur la parcelle</h4>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nom parcelle : '+ plots.plot_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nom agriculteur : '+ plots.farmer_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Prenom agriculteur : '+ plots.farmer_first_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Téléphone : '+ plots.farmer_phone + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Adhérent : '+ plots.cooperative_adherent_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nombre de parcelles : '+ plots_count + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Superficie Totale : '+ plot_area.toFixed(2).toString() + ' Ha</p>\
                                                          </div>\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title" style="color: #a9bc14;">Statistique</h4>\
                                                            <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                          </div>\
                                                        </div>\
                                                   ');
          domConstruct.place(nodeSinglePlot, node);    //========>End
        } else {                          //========Node for multiples plots=====> Start 


          plots_count += plot_properties.clusteredElements.length;

          // var nodeRow = domConstruct.toDom('\
          //                                        <div class="row">\
          //                                        </div>\
          //                                     ');
          var nodeRow = domConstruct.create("div", null, node, "last");
          nodeRow.setAttribute("class", "row");

          var nodeSelects = domConstruct.create("div", null, nodeRow, 'last');
          nodeSelects.setAttribute("class", "col-sm-12 col-xl-6 m-b-30-ballon");

          var nodeTitle = domConstruct.toDom('\
                                                <h4 class="sub-title" style="color: #a9bc14;">Filtre</h4>\
                                          ');

          domConstruct.place(nodeTitle, nodeSelects);


          var selectFarmer = domConstruct.create("select", null);
          selectFarmer.setAttribute("class", "form-control form-control-info");
          selectFarmer.setAttribute("name", "farmerSelect");
          selectFarmer.setAttribute("style", "margin-bottom: 10px;");
          selectFarmer.addEventListener("change", function () { _obj.updateDataMap(selectFarmer.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des agriculteurs</option>'), selectFarmer);

          var selectTechnician = domConstruct.create("select", null);
          selectTechnician.setAttribute("class", "form-control form-control-info");
          selectTechnician.setAttribute("name", "technicianSelect");
          selectTechnician.setAttribute("style", "margin-bottom: 10px;");
          selectTechnician.addEventListener("change", function () { _obj.updateDataMap(selectTechnician.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des techniciens</option>'), selectTechnician);

          var selectCooperative = domConstruct.create("select", null);
          selectCooperative.setAttribute("class", "form-control form-control-info");
          selectCooperative.setAttribute("name", "cooperativeSelect");
          selectCooperative.setAttribute("style", "margin-bottom: 10px;");
          selectCooperative.addEventListener("change", function () { _obj.updateDataMap(selectCooperative.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des cooperatives</option>'), selectCooperative);

          var selectAdherent = domConstruct.create("select", null);
          selectAdherent.setAttribute("class", "form-control form-control-info");
          selectAdherent.setAttribute("name", "cooperativeSelect");
          selectAdherent.setAttribute("style", "margin-bottom: 10px;");
          selectAdherent.addEventListener("change", function () { _obj.updateDataMap(selectAdherent.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des adhérents</option>'), selectAdherent);


          if (_obj._currentUserInfos.right == 1/*ADMIN*/) {

            domConstruct.place(selectCooperative, nodeSelects);
            domConstruct.place(selectAdherent, nodeSelects);
            domConstruct.place(selectTechnician, nodeSelects);
            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 2/*COOPERATIVE*/) {

            domConstruct.place(selectAdherent, nodeSelects);
            domConstruct.place(selectTechnician, nodeSelects);
            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 3/*TECHNICIAN*/) {

            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 4/*FARMER*/) {

          }



          for (var i = 0; i < plots.length; i++) {

            plot_area += parseFloat(plots[i].properties.plot_area);

            console.log(plots[i].properties.farmer_id);

            if (!_obj.verifieExistance(tabIdFarmer, plots[i].properties.farmer_id)) {
              tabIdFarmer[i] = plots[i].properties.farmer_id;
              var hrefAgriParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"f"}';
              var b = dConstruct.create("option", { innerHTML: plots[i].properties.farmer_name + " " + plots[i].properties.farmer_first_name + "</a>" }, selectFarmer, "last");
              b.setAttribute("value", hrefAgriParcelle);
            }
            if (!_obj.verifieExistance(tabIdTech, plots[i].properties.technician_id)) {
              tabIdTech[i] = plots[i].properties.technician_id;
              var hrefTecParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"t"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.technician_name + " " + plots[i].properties.technician_first_name }, selectTechnician, "last");
              c.setAttribute("value", hrefTecParcelle);
            }
            if (!_obj.verifieExistance(tabIdCoop, plots[i].properties.cooperative_id)) {
              tabIdCoop[i] = plots[i].properties.cooperative_id;
              var hrefCoopParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_name }, selectCooperative, "last");
              c.setAttribute("value", hrefCoopParcelle);
            }

            if (!_obj.verifieExistance(tabIdAdhe, plots[i].properties.cooperative_adherent_id)) {
              tabIdAdhe[i] = plots[i].properties.cooperative_adherent_id;
              var hrefAdheParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_adherent_name }, selectAdherent, "last");
              c.setAttribute("value", hrefAdheParcelle);

            }

          }
          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : ' + plots.length + '</p>'), nodeSelects);
          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie Totale : ' + plot_area.toFixed(2).toString() + ' Ha</p>'), nodeSelects);
          var domAllPlots = domConstruct.toDom('<p  style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Voir Toutes les parcelles  </p>');
          domAllPlots.addEventListener("click", function () { _obj.resetDataMap(); });
          domConstruct.place(domAllPlots, nodeSelects);
          console.log(plot_area);
          var nodeStatistique = domConstruct.toDom('\
                                                    <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                      <h4 class="sub-title" style="color: #a9bc14;">Statistiques</h4>\
                                                      <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                    </div>\
                                                  ');
          domConstruct.place(nodeStatistique, nodeRow);
          domConstruct.place(nodeRow, node);
        }    //========Node for multiples plots=====> End
        // var divFooter =  domConstruct.toDom("<br><h1> refNode </h1>");
        // domConstruct.create(node,{},divFooter);
        // domConstruct.place(divFooter,node);

        return node;
      } //============>End ============>


    };

    var clusterParam1 = ClusteringTransformer.create({
      defaultParameters: {
        clusterSize: 150
      }
    });

    var clusterParam2 = ClusteringTransformer.create({
      defaultParameters: {
        noClustering: "disable"
      }
    });

    this._featureLayerAccessPointDB = new FeatureLayer(featureModel, {
      label: label,
      selectable: true,
      editable: true,
      painter: clusterPainter,
      transformer: clusterParam1
    }
    );
  }

  removeAllLayer() {
    this._map.layerTree.removeAllChildren();
  }

  removeAllShapesForAllLayers() {
    this._plotDataLoader.removeAll();
  }

  ngOnDestroy() {
    // if (this._map) {
    //   this._map.destroy();
    // }
    // this.ngAfterViewInit();
    // //document.getElementById("controlcontainer").innerHTML="";
  }
  addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.options = {
      position: [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch (options.type) {
      case 'success':
        this.servicePNotify.success(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg,
          options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
    }
  }
}
