import * as licenseTxt from 'raw-loader!./license/luciadria_development.txt';
import * as License from 'luciad/util/License';
import { DeviceDetector } from '../../_class/DeviceDetector';
import { NetworkConnectionDetector } from '../../_class/NetworkConnectionDetector';
License.setLicenseText(licenseTxt);

import { AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone } from '@angular/core';
import 'rxjs/add/operator/toPromise';
import * as WebGLMap from 'luciad/view/WebGLMap';
import * as Map from "luciad/view/Map";
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
import { LayerFactory } from './LayerFactory';
import { GoogleMaps } from './GoogleMaps';
import * as  ShapeFactory from 'luciad/shape/ShapeFactory';
import * as  LayerGroup from 'luciad/view/LayerGroup';
import * as  LayerTreeControl from 'samples/common/control/LayerTreeControl';
import * as  LayerConfigUtil from 'samples/common/LayerConfigUtil';

/* Start Import file for create and edit feature */
import * as  Feature from 'luciad/model/feature/Feature';
import * as  FeatureModel from 'luciad/model/feature/FeatureModel';
import * as  BasicCreateController from 'luciad/view/controller/BasicCreateController';
import * as  EditController from 'luciad/view/controller/EditController';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  RestStore from 'samples/common/store/RestStore';
import * as  ShapeType from 'luciad/shape/ShapeType';
import * as  MemoryStore from 'luciad/model/store/MemoryStore';
import * as templateSample from "samples/template/sample";
import * as  domConstruct from "luciad/dojo/dom-construct";
import * as  dConstruct from "luciad/dojo/dom-construct";

/* Start Import file for create clustering access points feature */
import * as  ClusteringTransformer from 'luciad/view/feature/transformation/ClusteringTransformer';
import * as  ClusteringPainterWrapper from "samples/clustering/ClusteringPainterWrapper";
import * as ClusterIconStyleUtil from "samples/clustering/ClusterIconStyleUtil";
import * as  IconFactory from "samples/common/IconFactory";
//import * as variable from 'variableName';  
// import {ClusterIconStyleUtil,ClusteringPainterWrapper} from 'variableName';  

import * as  BasicFeaturePainter from 'luciad/view/feature/BasicFeaturePainter';

import { PlotDataLoader } from './PlotDataLoader';
import { Localisator } from './Localisator';
import { OptimizationOfATour } from './OptimizationOfATour';
import { BingMapsDataLoader } from '../../_class/BingMapsDataLoader';
import * as  Promise from "luciad/util/Promise";
import * as LayerType from 'luciad/view/LayerType';
import * as ShapePainterContour from "samples/shapePainter/ShapePainterContour";
import * as ShapePainterObstacle from "samples/shapePainter/ShapePainterObstacle";
import * as  ShapePainterOrdrePoint from 'luciad/shape/ShapePainterOrdrePoint';
import * as  ShapePainterContourOptimisation from 'luciad/shape/ShapePainterContour';
import * as  ShapePainterCircle from 'luciad/shape/ShapePainterCircle';
import * as  PaintRepresentation from "luciad/view/PaintRepresentation";
import * as GestureEventType from "luciad/view/input/GestureEventType";
import * as TransformationFactory from "luciad/transformation/TransformationFactory";
import * as ZoomControl from "samples/common/navigation/ZoomControl";
import * as PanControl from "samples/common/navigation/PanControl";

/* Start Import file for create and validate a form */
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { Router } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { SelectOptionService } from "../../shared/elements/select-option.service";
import { IOption } from "ng-select";
import { NgbDatepickerConfig, NgbDateParserFormatter } from '@ng-bootstrap/ng-bootstrap';
import { NgbDateCustomParserFormatter } from "../../_class/ngb-date-custom-parser-formatter";

import swal from 'sweetalert2';
import { NotificationsService } from "angular2-notifications";
import * as $ from 'jquery';
import { } from '@types/googlemaps';

@Component({
    selector: 'app-new-tour',
    templateUrl: './new-tour.component.html',
    styleUrls: ['./new-tour.component.css'],
    providers: [{ provide: NgbDateParserFormatter, useClass: NgbDateCustomParserFormatter }],
    animations: [fadeInOutTranslate],
    encapsulation: ViewEncapsulation.None
})
export class NewTourComponent implements AfterViewInit, OnDestroy {

    @ViewChild('map') mapElem: ElementRef;
    /*  Notify */
    options: any = {
        position: ["bottom", "right"],
    };
    _coordinateType = null;
    position1: string = 'bottom';
    position2: string = 'right';
    timeOut: number = 6000;
    showProgressBar: boolean = true;
    pauseOnHover: boolean = true;
    lastOnBottom: boolean = true;
    clickToClose: boolean = true;
    maxLength: number = 0;
    maxStack: number = 8;
    preventDuplicates: boolean = false;
    preventLastDuplicates: boolean = false;
    theClass: string;
    rtl: boolean = false;
    animate: string = 'fromRight';
    icons: string;
    subType: string = 'success';

    title: string;
    msg: string;
    /*Tow opt algogithm*/

    _plotsInfoAndAccessPoint = []; // Pour to opt 
    _plotsInfoAndAccessPointOrdred = []; // Pour to opt 
    _featuresArraySelectedMemory = [];

    /*End Tow opt algogithm*/
    /*  End    */
    _map: WebGLMap;
    // Roadmap variables declarations
    roadmap: WebGLMap;
    rdmap_access_point: FeatureLayer;
    rdmap_plot_layer: FeatureLayer;
    rd_featureLayerTrajetOptimal: FeatureLayer;
    rd_featureLayerOrdrePoint: FeatureLayer;
    rdmap_path: FeatureLayer;
    roadmap_source_data: any;
    roadmap_table_rows: any;
    roadmap_table_rows_dist = { p1: null, p2: null, p3: null };
    roadmap_table_rows_duration = { p1: null, p2: null, p3: null };
    roadmap_itinerary_google_maps = {
        lat_current: null,
        long_current: null,
        lat_destination: null,
        long_destination: null,
        conveyance: 'data=!3m1!4b1!4m7!4m6!1m0!1m3!2m2!1d1.4250958!2d43.5794836!3e0',
        link_google_maps: null
    };
    errorGeolocation: any;
    roadmap_selected_row = 0;
    _sms = {
        type: 0,
        message: "",
        plot_id: null,
        to_farmer: true,
        to_technician: false,
        to_cooperative: false,
    }
    roadmap_columns: any[] = [
        { prop: 'id parcelle' },
        { name: 'Cooperative' },
        { name: 'Parcelle' },
        { name: 'Agriculteur' },
        { name: 'Téléphone' },
        { name: 'Techncien' },
        { name: 'Téléphone' }

    ];

    _printLayerControl: boolean = false;
    _featureLayer: FeatureLayer;
    _featureLayerTrajetOptimal: FeatureLayer;
    _featureLayerOrdrePoint: FeatureLayer;

    _featureLayerRepere: FeatureLayer;
    _featureLayerPlotsDB: FeatureLayer;
    _featureLayerObstaclesDB: FeatureLayer;
    _featureLayerBingMap: FeatureLayer;
    _featureLayerAccessPointDB: FeatureLayer;
    _featureLayerPissosDB: FeatureLayer;
    _featureLayerStartEndPoint: FeatureLayer;
    _featureLayerStartEndPointTmp: FeatureLayer;
    _featureLayerCircle: FeatureLayer;
    _circleSelect = {
        _radius: null,
        _erase: "true",
        _print: false,
    };
    _plotDataLoader: any;
    _localisator: any;
    _plot_infos_geometry = [];
    _tour_plot_infos_geometry = [];
    _plot_infos_geometryCopy = [];
    _currentUserInfos: any; //--------------!!!!
    _idOfUsersJSON_current: any; //--------------!!!! // = _idOfUsers  these variable is used after the user chose a current user to filter data in the carte 
    _usersFarmerByIdTech: any;//--------------!!!!
    _currentUserEmailAndToken: any; //--------------!!!!
    _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id": 0, "user_type": "t" }; //--------------!!!! // use to load a binding datas of a curent user or to filtering data 
    _errorInputs = { "name": false, "id_farmer": false, "electricline": false, "irrigationsystem": false }; // use to load a binding datas of a curent user or to filtering data 
    _farmer_selected = 0;
    // _model :{} ; //= {id_farmer:1,name :'',comment :'',electricline :'',irrigationsystem:'',geom :{}};
    _model = {
        client_id: 2,
        client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
        id_farmer: null,
        name: '',
        comment: '',
        electricline: '',
        irrigationsystem: '',
        geom: {},
        accesspoint: {},
        obstacles: {}
    };
    _tourModel = {
        client_id: 2,
        client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
        tourName: null,
        teamName: null,
        tourDate: null,
        pilots: [],
        drones: [],
        paths: [],
        dists: [],
        total_dist: 0,
        total_duration: 0,
        durations: [],
        area: 0,
        plot_id: { id: [], treatment: [] },
        start_point: null,
        end_point: null
    };
    tourDate = {
        day: "",
        mouth: "",
        year: "",
    };
    _tourSummary = {
        selectedArea: 0,
        plotNumber: 0,
        plotNames: [],
        plotNamesOrdred: [],
        pathDistance: 0,
        pathDuration: 0
    };
    LIST_TREATMENTS: any = [];
    _tourExport = {
        team_id: null,
        tour_date: null,
        pilot_id: null,
        tour_id: null,
        type_filtre: null
    };
    selecteTeam = [];
    selecteTeamCopy = [];

    selectedPilot = [];
    selectePilotCopy = [];
    _pilot_selcted = null;
    pilot = [];
    selectedDrone = [];
    _drone_selcted = null;
    drone = [{ value: 1, label: 'Fox 1' }, { value: 2, label: 'Fox 2' }];

    tours = [];
    glLayer: any;
    _polt: number = 1;
    _startEndPoint: number = 1;
    EVENT_STYLE = {
        draped: true,
        width: "16px",
        height: "16px",
        image: IconFactory.circle({
            width: 16,
            height: 16,
            fill: "rgba(0, 78, 146, 0.8)",
            stroke: "rgba(155, 180, 222, 0.8)",
            strokeWidth: 1
        })
    };

    EVENT_SELECTED_STYLE = {
        draped: true,
        width: "16px",
        height: "16px",
        image: IconFactory.circle({
            width: 16,
            height: 16,
            fill: "rgba(0, 78, 146, 0.8)",
            stroke: "rgba(192, 217, 42, 0.8)",
            strokeWidth: 1.5
        })
    };
    progress: number = 0;
    label: string;
    isCollapsed = {
        adr: false,
        cd: true,
        dms: true
    }
    currentPoint = {
        step: "2/7",
        label: "point de départ"
    }
    _geolocalise = {
        _googleGeolocationAdress: {
            adress: "",
            error: {
                msg: "",
                state: false,
            }
        },
        cd: {
            lat: 0,
            long: 0
        },
        dms: {
            lat: {
                north_south_selector: "N",
                lat_d: 0,
                lat_m: 0,
                lat_s: 0,
            },
            long: {
                east_west_selector: "E",
                lon_d: 0,
                lon_m: 0,
                lon_s: 0,
            }
        }
    }
    @Input()
    mapReference: string;

    searchTerm: any;
    constructor(private httpService: HttpService,
        public authenticationService: AuthenticationService,
        private router: Router,
        private http: Http,
        private servicePNotify: NotificationsService,
        public selectOptionService: SelectOptionService,
        private deviceDetector: DeviceDetector,
        private connectionDetector: NetworkConnectionDetector,
        private cdRef: ChangeDetectorRef,
        private _ngZone: NgZone) {
        if (this.authenticationService.isLoggedIn()) {
            this.setIdOfUsersUsigLocalSorage();
            this.getAllTeams();
        } else {
            this.router.navigate(['/login']); //--------------!!!!
        }

        if (localStorage.getItem('farmer_id')) {
            this._model.id_farmer = localStorage.getItem('farmer_id');
        } else {
            this._model.id_farmer = "null";
        }
    }
    setIdOfUsersUsigLocalSorage() {
        this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));


        switch (this._currentUserInfos.right) {
            case 1:
                this._idOfUsers.cooperative_id = 0;
                this._idOfUsers.technician_id = 0;
                this._idOfUsers.farmer_id = 0;
                this._idOfUsers.user_type = "a";
                break;
            case 2:
                this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                this._idOfUsers.technician_id = 0;
                this._idOfUsers.farmer_id = 0;
                this._idOfUsers.user_type = "c";

                break;
            case 3:
                this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
                this._idOfUsers.farmer_id = 0;
                this._idOfUsers.user_type = "t";
                break;
            case 4:
                this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
                this._idOfUsers.technician_id = 0;
                this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
                this._idOfUsers.user_type = "f";

                break;
            // case '5':
            //         this._idOfUsers.cooperative_id = 0; 
            //         this._idOfUsers.adherent_id = 0 ;
            //         this._idOfUsers.technician_id = 0 ; 
            //         this._idOfUsers.farmer_id = 0 ;
            //         this._idOfUsers.user_type = "p"  ;

            //     break;
        }
    }
    getAllTeams() {
        this.httpService.httpPostPromise('getTeams', {})
            .then((data) => {
                console.log(data);
                this.selecteTeam = data;
                this.selecteTeamCopy = data;
            }, (error) => {
                console.error(error);
            });
    }
    ngOnInit() {

        $('#asy-sidebarCollapse').on('click', function () {
            $('#asy-sidebar').toggleClass('active');
        });
        $('#asy-sidebarCollapse2').on('click', function () {
            $('#asy-sidebar').toggleClass('active');
        });

    }
    ngOnDestroy() {
        // if (this._map) {
        //   this._map.destroy();
        // }
        // this.ngAfterViewInit();
        // //document.getElementById("controlcontainer").innerHTML="";
    }
    ngAfterViewInit() {
        this.processOutsideOfAngularZone(this._idOfUsers);
    }
    processOutsideOfAngularZone(idOfCurentUsers) {
        this.label = 'outside';
        this.progress = 0;
        this._ngZone.runOutsideAngular(() => {
            this._increaseProgress(() => {
                this.ngOnInitAfterView();
                // reenter the Angular zone and display done
                this._ngZone.run(() => {
                    //REMOVE LOADER NODE

                    //REMOVE LOADER NODE
                    console.log('Outside Done!');
                });
            });
        });
    }
    _increaseProgress(doneCallback: () => void) {
        this.progress += 1;
        this.cdRef.detectChanges();
        console.log(`Current progress: ${this.progress}%`);

        if (this.progress < 100) {
            window.setTimeout(() => this._increaseProgress(doneCallback), 10);
        } else {
            doneCallback();
        }
    }
    ngOnInitAfterView() {
        var _obj = this;

        //idOfUsers il faut initialiser la properete idOfUsers en utilisant les id d'utilisateur connecter 
        var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); // 2D "EPSG:900913"
        this._map = new Map(this.mapElem.nativeElement, { reference: REF_EPSG3857 });

        BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {
            _obj._map.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");
        });


        // this.glLayer = GoogleMaps.startup(this._map);
        //Add layer controller to the application
        new LayerTreeControl(this._map, { domId: "controlcontainer", title: "CALQUES" });
        this._map.minMapScale = 1 / 110000000;
        new PanControl(this._map);
        new ZoomControl(this._map, { touch: false });

        this.addAllLayer();

        this.activeSelectionChanged(this);
        this.loadDataMap(this._idOfUsers);
        // this.fitOnFranceOnLoad(this.roadmap);
        // this.getGeolocation();

    }
    loadDataMap(idOfCurentUsers) {
        var obj = this;
        // this.addBalloonForm(this);
        //this._plotDataLoader = new PlotDataLoader ;
        this._localisator = new Localisator();

        this._plotDataLoader = new PlotDataLoader(this._map,
            this.httpService,
            this._featureLayerPlotsDB,
            this._featureLayerObstaclesDB,
            this._featureLayerAccessPointDB,
            this._plot_infos_geometry);

        this._plotDataLoader.getAndPrintDataPlotFromDB(idOfCurentUsers).then((data) => {
            obj._plot_infos_geometry = data;
            obj._plot_infos_geometryCopy = data;
            setTimeout(function () {
                var node = document.getElementById("loader");
                if (node) {
                    if (node.parentNode) {
                        node.parentNode.removeChild(node);
                    }
                }
            }, 1000);
        });
    }
    getGeolocation() {
        var _obj = this;
        var options = {
            enableHighAccuracy: true,
            timeout: 5000,
            maximumAge: 0
        };

        if (navigator.geolocation) {
            // L'API est disponible
            navigator.geolocation.getCurrentPosition(function (pos) {
                var crd = pos.coords;
                // console.log('Votre position actuelle est :');
                // console.log(`Latitude : ${crd.latitude}`);
                // console.log(`Longitude: ${crd.longitude}`);
                // console.log(`Plus ou moins ${crd.accuracy} mètres.`);
                _obj.roadmap_itinerary_google_maps.lat_current = crd.latitude;
                _obj.roadmap_itinerary_google_maps.long_current = crd.longitude;
                console.log(_obj.roadmap_itinerary_google_maps);
            }/*this.successGeolocation*/, this.errorGeolocation, options);
        } else {
            // Pas de support, proposer une alternative ?
            console.log("Pas de support, proposer une alternative ?");
        }
    }
    convertLatLongToDMS(coordinateType) {
        console.log('raha khdama');
        if (coordinateType === "DD") {
            this.isCollapsed.cd = !this.isCollapsed.cd;
            this.isCollapsed.adr = true;
            this.isCollapsed.dms = true;
        } else if (coordinateType === "DMS") {
            this.isCollapsed.dms = !this.isCollapsed.dms;
            this.isCollapsed.cd = true;
            this.isCollapsed.adr = true;
        }
        // this._localisator.selectionChanged(coordinateType, true);
    }

    locaisationLatLongAndDMS(localisationType, option) {
        var _obj = this;
        if (localisationType === "DMS") {
            this._localisator.selectionChanged("DD", false);
        }
        return new Promise(function (resolve, reject) {
            _obj._localisator.change_navigator_view(_obj._map.mapNavigator, _obj._featureLayerRepere.model).then(lat_long => {
                if (option.eventType === "createStartEndPoint") {
                    _obj.addStartEndPointByLocation(lat_long);
                }
                resolve(true);
            });
        });
    }
    //Centre la carte sur une adress
    geolocalise(option) {
        var _obj = this;
        return new Promise(function (resolve, reject) {
            _obj._localisator.geolocalise(_obj._map.mapNavigator, _obj._geolocalise._googleGeolocationAdress.adress).then(result => {
                console.log(result);
                if (option.eventType === "createStartEndPoint") {
                    _obj.addStartEndPointByLocation(result);
                }
                _obj._geolocalise._googleGeolocationAdress.error.state = false;
                _obj._geolocalise._googleGeolocationAdress.error.msg = "";
                resolve(true);
            }).catch(error => {
                console.log(error);
                _obj._geolocalise._googleGeolocationAdress.error.state = true;
                _obj._geolocalise._googleGeolocationAdress.error.msg = error.msg;
                reject(false);
            });
        });
    }
    addStartEndPointByLocation(lat_long) {
        var _obj = this;
        var defaultProperties;
        if (_obj._featureLayerStartEndPoint.workingSet.get().length <= 2) {
            if (_obj._featureLayerStartEndPoint.workingSet.get().length == 0 && _obj.currentPoint.step === "2/7") {
                // create start point
                defaultProperties = { order: 'Point de départ' };
                var myPoint = ShapeFactory.createPoint(ReferenceProvider.getReference("EPSG:4326"), [lat_long[1], lat_long[0]]);
                var markerFeature = new Feature(myPoint);
                markerFeature.properties = defaultProperties;
                this._featureLayerStartEndPoint.model.add(markerFeature);
                _obj._startEndPoint++;

            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 1 && _obj.currentPoint.step === "2/7") {
                // to do update start point
                var feature = _obj._featureLayerStartEndPoint.workingSet.get()[0];
                var myPoint = ShapeFactory.createPoint(ReferenceProvider.getReference("EPSG:4326"), [lat_long[1], lat_long[0]]);
                feature.shape = myPoint;
                this._featureLayerStartEndPoint.model.put(feature, {});

            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 1 && _obj.currentPoint.step === "3/7") {
                // create end point
                defaultProperties = { order: 'Point de d\'arrivée' };
                var myPoint = ShapeFactory.createPoint(ReferenceProvider.getReference("EPSG:4326"), [lat_long[1], lat_long[0]]);
                var markerFeature = new Feature(myPoint);
                markerFeature.properties = defaultProperties;
                this._featureLayerStartEndPoint.model.add(markerFeature);
                _obj._startEndPoint++;

            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 2 && _obj.currentPoint.step === "3/7") {
                // to do update send point
                var feature = _obj._featureLayerStartEndPoint.workingSet.get()[1];
                var myPoint = ShapeFactory.createPoint(ReferenceProvider.getReference("EPSG:4326"), [lat_long[1], lat_long[0]]);
                feature.shape = myPoint;
                this._featureLayerStartEndPoint.model.put(feature, {});
            }
        }
    }
    linkCreateButtonStartEndPoint(domId): void {
        var _obj = this;
        if (domId == 'start_end_point') var shapeType = ShapeType.POINT;

        // this._map.selectObjects([]);
        if (_obj._featureLayerStartEndPoint.workingSet.get().length <= 2) {
            //#snippet controller
            var defaultProperties = {};
            var createController;
            if (_obj._featureLayerStartEndPoint.workingSet.get().length == 0 && _obj.currentPoint.step === "2/7") {
                defaultProperties = { order: 'Point de départ' };
                createController = new BasicCreateController(shapeType, defaultProperties, { finishOnSingleClick: true });
                createController.onChooseLayer = function (map) {
                    return _obj._featureLayerStartEndPoint;
                }
                createController.onObjectCreated = function (oo) {
                    BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
                    console.log("Create start point");
                };
            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 1 && _obj.currentPoint.step === "2/7") {
                _obj._map.layerTree.addChild(_obj._featureLayerStartEndPointTmp);
                defaultProperties = { order: 'Point de départ' };
                createController = new BasicCreateController(shapeType, defaultProperties, { finishOnSingleClick: true });
                createController.onChooseLayer = function (map) {
                    return _obj._featureLayerStartEndPointTmp;
                }
                createController.onObjectCreated = function (aMapView, aLayer, aObject) {
                    BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
                    console.log("update start point ");
                    console.log(aObject);

                    var feature = _obj._featureLayerStartEndPoint.workingSet.get()[0];
                    feature.shape = aObject.shape;
                    _obj._featureLayerStartEndPoint.model.put(feature, {});
                    _obj.removeFeatureFromLayer(_obj._featureLayerStartEndPointTmp);
                    _obj._map.layerTree.removeChild(_obj._featureLayerStartEndPointTmp);
                };

            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 1 && _obj.currentPoint.step === "3/7") {
                defaultProperties = { order: 'Point de d\'arrivée' };
                createController = new BasicCreateController(shapeType, defaultProperties, { finishOnSingleClick: true });
                createController.onChooseLayer = function (map) {
                    return _obj._featureLayerStartEndPoint;
                }
                createController.onObjectCreated = function (oo) {
                    BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
                    console.log("Create end point");
                };
            } else if (_obj._featureLayerStartEndPoint.workingSet.get().length == 2 && _obj.currentPoint.step === "3/7") {
                _obj._map.layerTree.addChild(_obj._featureLayerStartEndPointTmp);
                defaultProperties = { order: 'Point de d\'arrivée' };
                createController = new BasicCreateController(shapeType, defaultProperties, { finishOnSingleClick: true });
                createController.onChooseLayer = function (map) {
                    return _obj._featureLayerStartEndPointTmp;
                }
                createController.onObjectCreated = function (aMapView, aLayer, aObject) {
                    BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
                    console.log("update end point ");
                    console.log(aObject);
                    var feature = _obj._featureLayerStartEndPoint.workingSet.get()[1];
                    feature.shape = aObject.shape;
                    _obj._featureLayerStartEndPoint.model.put(feature, {});
                    _obj.removeFeatureFromLayer(_obj._featureLayerStartEndPointTmp);
                    _obj._map.layerTree.removeChild(_obj._featureLayerStartEndPointTmp);
                };
            }
            this._map.controller = createController;
            // });
        } else {
            //   document.getElementById("start_end_point").setAttribute("disabled", "disabled");
        }

    }
    //Centre la carte sur une adress
    runScriptWhenEnterKeyIsPressed(e, action) {
        //See notes about 'which' and 'key'
        if (e.keyCode == 13) {
            this.geolocalise(action);
            return false;
        } else {
            return true;
        }
    }
    addAllLayer() {
        var _obj = this;

        this._featureLayerRepere = this.createFeatureLayer("Repère");

        this.createFeatureLayerWithClustering("Regroupement");
        var painterContour = new ShapePainterContour();
        var painterObstacle = new ShapePainterObstacle();
        var painterOrdrePoint = new ShapePainterOrdrePoint();

        this._featureLayerPlotsDB = this.createFeatureLayerWithPainter("Parcelles", new ShapePainterContourOptimisation());
        this._featureLayerObstaclesDB = this.createFeatureLayerWithPainter("Obstacles", painterObstacle);
        this._featureLayerStartEndPoint = this.createFeatureLayerWithPainter("Point de départ && point d'arrivée", painterOrdrePoint);
        this._featureLayerStartEndPointTmp = this.createFeatureLayerWithPainter("Point de départ && point d'arrivée tmp", painterOrdrePoint);
        this._featureLayerOrdrePoint = this.createFeatureLayerWithPainter("L'ordre de la tournée", painterOrdrePoint);
        // this._featureModelTrajetOptimal = this.createFeatureLayerWithPainter("Trajets optimals");
        this._featureLayerCircle = this.createFeatureLayerWithPainter("Cercle", new ShapePainterCircle());
        this._featureLayerTrajetOptimal = this.createFeatureLayer("Trajets optimals");

        this._map.layerTree.addChild(LayerFactory.createLonLatGridLayer());

        this._map.layerTree.addChild(this._featureLayerRepere);
        this._map.layerTree.addChild(this._featureLayerPlotsDB);
        this._map.layerTree.addChild(this._featureLayerObstaclesDB);
        this._map.layerTree.addChild(this._featureLayerAccessPointDB);
        this._map.layerTree.addChild(this._featureLayerOrdrePoint);
        this._map.layerTree.addChild(this._featureLayerTrajetOptimal);
        this._map.layerTree.addChild(this._featureLayerTrajetOptimal);
        this._map.layerTree.addChild(this._featureLayerStartEndPoint);
        this._map.layerTree.addChild(this._featureLayerCircle);

        this._map.on('MapChange', function () {
            _obj._featureLayerPlotsDB.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 10000));
            _obj._featureLayerOrdrePoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 1000000));
            _obj._featureLayerStartEndPoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj._map.mapScale[0] > 1 / 1004000));

        });
        console.log('----------------------------------------------lahcen-----------------------------------');

    }
    createFeatureLayer(label) {
        //#snippet simplefeaturemodel
        var featureModelReference = ReferenceProvider.getReference("CRS:84");
        //var featureURL = "/createandedit";
        // var codec = new CustomJsonCodec();
        var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
        //#endsnippet simplefeaturemodel

        //#snippet simplefeaturemodel
        var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
        //#endsnippet simplefeaturemodel

        return new FeatureLayer(featureModel, {
            selectable: true,
            editable: true,
            label: label
        });
    }

    createFeatureLayerWithPainter(label, shapePainter) {
        //#snippet simplefeaturemodel
        var featureModelReference = ReferenceProvider.getReference("CRS:84");
        //var featureURL = "/createandedit";
        // var codec = new CustomJsonCodec();
        var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
        //#endsnippet simplefeaturemodel

        //#snippet simplefeaturemodel
        var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
        //#endsnippet simplefeaturemodel

        return new FeatureLayer(featureModel, {
            selectable: true,
            editable: false,
            label: label,
            painter: shapePainter
        });
    }
    createFeatureLayerWithClustering(label) {
        var _obj = this;
        var featureModelReference = ReferenceProvider.getReference("CRS:84");
        var featureStore = new MemoryStore();
        var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
        var armedEventsPainter = new BasicFeaturePainter();

        armedEventsPainter.getDetailLevelScales = function () {
            return [1 / 2000000];
        };

        armedEventsPainter.paintLabel = function (labelcanvas, feature, shape, layer, map, paintState) {
            if (paintState.level === 1) {
                // labelcanvas.drawLabel(labelForArmedEvent(feature), shape.focusPoint, {
                //   positions: PointLabelPosition.NORTH
                // });
            }
        };

        armedEventsPainter.paintBody = function (geocanvas, feature, shape, layer, map, paintState) {
            if (paintState.selected) {
                geocanvas.drawIcon(shape.focusPoint, this.EVENT_SELECTED_STYLE);
            } else {
                geocanvas.drawIcon(shape.focusPoint, this.EVENT_STYLE);
            }
        };

        var clusterPainter = new ClusteringPainterWrapper(armedEventsPainter);
        clusterPainter.paintClusterBody = function (geocanvas, feature, shape, layer, map, paintState) {
            geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getOuterStyle(feature, paintState.selected));
            geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getInnerStyle(feature, paintState.selected));
            geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getTextStyle(feature));
            if (paintState.selected) {
                // Paint clustered elements when selecting a cluster
                var clusteredFeatures = ClusteringTransformer.clusteredFeatures(feature);
                for (var i = 0; i < clusteredFeatures.length; i++) {
                    var clusteredFeature = clusteredFeatures[i];
                    armedEventsPainter.paintBody(geocanvas, clusteredFeature, clusteredFeature.shape, layer, map, paintState);
                }
            }
        };

        var j = 0;
        clusterPainter.paintClusterLabel = function (labelCanvas, feature, shape, layer, map, state) {
            //don't paint the default cluster label
            // console.log(clusterPainter);
            //  _obj._map.mapNavigator.pan({targetLocation: targetViewPoint, animate: {duration: 250}}); 
            // map.mapNavigator.fit(targetViewPoint);

            layer.balloonContentProvider = function (o) { //============> Start============>
                console.log(o);
                var _tempModelPoint = ShapeFactory.createPoint(o.geometry._reference, [o.geometry[0], o.geometry[1]]);
                this._tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
                var _tempMapPoint = ShapeFactory.createPoint(map.reference, [0, 0]);
                var _transformation = TransformationFactory.createTransformation(o.geometry._reference, map.reference);
                _transformation.transform(_tempModelPoint, _tempMapPoint);
                map.mapToViewTransformation.transform(_tempMapPoint, this._tempViewPoint);
                this.viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
                var centerOfView = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
                var xCenter = (map.viewSize[0] / 2) - this._tempViewPoint[0];
                var yCenter = (map.viewSize[1] / 2) - this._tempViewPoint[1];
                var offsetFromCenterOfView = centerOfView.copy();
                offsetFromCenterOfView.translate(xCenter, yCenter + 100);
                map.mapNavigator.pan({ targetLocation: centerOfView, toViewLocation: offsetFromCenterOfView, animate: { duration: 200 } })

                var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
                var targetViewPoint = ShapeFactory.createPoint(REF_CRS84, [o._shape._coords[0], o._shape._coords[1] - 1]);
                // _obj._map.mapNavigator.pan({targetLocation: targetViewPoint, animate: {duration: 250}}); 
                var plots;
                var plots_count = 0;
                var plot_area = 0;
                var tabIdFarmer = [];
                var tabIdTech = [];
                var tabIdCoop = [];
                var tabIdAdhe = [];

                console.log(o.properties);
                var plot_properties = o.properties, node;
                node = domConstruct.toDom('<div class="card-body-ballon"> </div>');

                console.log(plot_properties);
                if (!plot_properties.clusteredElements) {
                    plots = plot_properties; // Feature with properties
                    console.log(plots);
                    // alert('1') ;
                } else {
                    // alert("2") ;
                    plots = plot_properties.clusteredElements;
                    console.log(plots);
                }

                if (!plot_properties.clusteredElements) {         //========Node for single plot=====> Start 

                    plots_count++;
                    plot_area += parseFloat(plots.plot_area);
                    var nodeSinglePlot = domConstruct.toDom('\
                                                            <div class="row">\
                                                              <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                                <h4 class="sub-title" style="color: #a9bc14;">Information sur la parcelle</h4>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nom parcelle : '+ plots.plot_name + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nom agriculteur : '+ plots.farmer_name + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Prenom agriculteur : '+ plots.farmer_first_name + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Téléphone : '+ plots.farmer_phone + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Adhérent : '+ plots.cooperative_adherent_name + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Nombre de parcelles : '+ plots_count + '</p>\
                                                                <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;" >Superficie Totale : '+ plot_area.toFixed(2).toString() + ' Ha</p>\
                                                              </div>\
                                                              <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                                <h4 class="sub-title" style="color: #a9bc14;">Statistique</h4>\
                                                                <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                              </div>\
                                                            </div>\
                                                       ');
                    domConstruct.place(nodeSinglePlot, node);    //========>End
                } else {                          //========Node for multiples plots=====> Start 


                    plots_count += plot_properties.clusteredElements.length;

                    // var nodeRow = domConstruct.toDom('\
                    //                                        <div class="row">\
                    //                                        </div>\
                    //                                     ');
                    var nodeRow = domConstruct.create("div", null, node, "last");
                    nodeRow.setAttribute("class", "row");

                    var nodeSelects = domConstruct.create("div", null, nodeRow, 'last');
                    nodeSelects.setAttribute("class", "col-sm-12 col-xl-6 m-b-30-ballon");

                    var nodeTitle = domConstruct.toDom('\
                                                    <h4 class="sub-title" style="color: #a9bc14;">Filtre</h4>\
                                              ');

                    domConstruct.place(nodeTitle, nodeSelects);


                    var selectFarmer = domConstruct.create("select", null);
                    selectFarmer.setAttribute("class", "form-control form-control-info");
                    selectFarmer.setAttribute("name", "farmerSelect");
                    selectFarmer.setAttribute("style", "margin-bottom: 10px;");
                    selectFarmer.addEventListener("change", function () { _obj.updateDataMap(selectFarmer.value); });
                    domConstruct.place(domConstruct.toDom('<option value="0">Liste des agriculteurs</option>'), selectFarmer);

                    var selectTechnician = domConstruct.create("select", null);
                    selectTechnician.setAttribute("class", "form-control form-control-info");
                    selectTechnician.setAttribute("name", "technicianSelect");
                    selectTechnician.setAttribute("style", "margin-bottom: 10px;");
                    selectTechnician.addEventListener("change", function () { _obj.updateDataMap(selectTechnician.value); });
                    domConstruct.place(domConstruct.toDom('<option value="0">Liste des techniciens</option>'), selectTechnician);

                    var selectCooperative = domConstruct.create("select", null);
                    selectCooperative.setAttribute("class", "form-control form-control-info");
                    selectCooperative.setAttribute("name", "cooperativeSelect");
                    selectCooperative.setAttribute("style", "margin-bottom: 10px;");
                    selectCooperative.addEventListener("change", function () { _obj.updateDataMap(selectCooperative.value); });
                    domConstruct.place(domConstruct.toDom('<option value="0">Liste des cooperatives</option>'), selectCooperative);

                    var selectAdherent = domConstruct.create("select", null);
                    selectAdherent.setAttribute("class", "form-control form-control-info");
                    selectAdherent.setAttribute("name", "cooperativeSelect");
                    selectAdherent.setAttribute("style", "margin-bottom: 10px;");
                    selectAdherent.addEventListener("change", function () { _obj.updateDataMap(selectAdherent.value); });
                    domConstruct.place(domConstruct.toDom('<option value="0">Liste des adhérents</option>'), selectAdherent);


                    if (_obj._currentUserInfos.right == 1/*ADMIN*/) {

                        domConstruct.place(selectCooperative, nodeSelects);
                        domConstruct.place(selectAdherent, nodeSelects);
                        domConstruct.place(selectTechnician, nodeSelects);
                        domConstruct.place(selectFarmer, nodeSelects);

                    } else if (_obj._currentUserInfos.right == 2/*COOPERATIVE*/) {

                        domConstruct.place(selectAdherent, nodeSelects);
                        domConstruct.place(selectTechnician, nodeSelects);
                        domConstruct.place(selectFarmer, nodeSelects);

                    } else if (_obj._currentUserInfos.right == 3/*TECHNICIAN*/) {

                        domConstruct.place(selectFarmer, nodeSelects);

                    } else if (_obj._currentUserInfos.right == 4/*FARMER*/) {

                    }



                    for (var i = 0; i < plots.length; i++) {

                        plot_area += parseFloat(plots[i].properties.plot_area);

                        console.log(plots[i].properties.farmer_id);

                        if (!_obj.verifieExistance(tabIdFarmer, plots[i].properties.farmer_id)) {
                            tabIdFarmer[i] = plots[i].properties.farmer_id;
                            var hrefAgriParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"f"}';
                            var b = dConstruct.create("option", { innerHTML: plots[i].properties.farmer_name + " " + plots[i].properties.farmer_first_name + "</a>" }, selectFarmer, "last");
                            b.setAttribute("value", hrefAgriParcelle);
                        }
                        if (!_obj.verifieExistance(tabIdTech, plots[i].properties.technician_id)) {
                            tabIdTech[i] = plots[i].properties.technician_id;
                            var hrefTecParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"t"}';
                            var c = dConstruct.create("option", { innerHTML: plots[i].properties.technician_name + " " + plots[i].properties.technician_first_name }, selectTechnician, "last");
                            c.setAttribute("value", hrefTecParcelle);
                        }
                        if (!_obj.verifieExistance(tabIdCoop, plots[i].properties.cooperative_id)) {
                            tabIdCoop[i] = plots[i].properties.cooperative_id;
                            var hrefCoopParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
                            var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_name }, selectCooperative, "last");
                            c.setAttribute("value", hrefCoopParcelle);
                        }

                        if (!_obj.verifieExistance(tabIdAdhe, plots[i].properties.cooperative_adherent_id)) {
                            tabIdAdhe[i] = plots[i].properties.cooperative_adherent_id;
                            var hrefAdheParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
                            var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_adherent_name }, selectAdherent, "last");
                            c.setAttribute("value", hrefAdheParcelle);

                        }

                    }
                    domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : ' + plots.length + '</p>'), nodeSelects);
                    domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie Totale : ' + plot_area.toFixed(2).toString() + ' Ha</p>'), nodeSelects);
                    var domAllPlots = domConstruct.toDom('<p  style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Voir Toutes les parcelles  </p>');
                    domAllPlots.addEventListener("click", function () { _obj.resetDataMap(); });
                    domConstruct.place(domAllPlots, nodeSelects);
                    console.log(plot_area);
                    var nodeStatistique = domConstruct.toDom('\
                                                        <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                          <h4 class="sub-title" style="color: #a9bc14;">Statistiques</h4>\
                                                          <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                        </div>\
                                                      ');
                    domConstruct.place(nodeStatistique, nodeRow);
                    domConstruct.place(nodeRow, node);
                }    //========Node for multiples plots=====> End
                // var divFooter =  domConstruct.toDom("<br><h1> refNode </h1>");
                // domConstruct.create(node,{},divFooter);
                // domConstruct.place(divFooter,node);

                return node;
            } //============>End ============>


        };

        var clusterParam1 = ClusteringTransformer.create({
            defaultParameters: {
                clusterSize: 150
            }
        });

        var clusterParam2 = ClusteringTransformer.create({
            defaultParameters: {
                noClustering: "disable"
            }
        });

        this._featureLayerAccessPointDB = new FeatureLayer(featureModel, {
            label: label,
            selectable: true,
            editable: true,
            painter: clusterPainter,
            transformer: clusterParam1
        }
        );
    }
    verifieExistance(tabId, id) {
        var val = 0;
        for (var i = 0; i < tabId.length; i++) {
            if (tabId[i] == id) { return 1; }
        }
        return val;
    }
    updateDataMap(idOfUsers) {

        this._idOfUsersJSON_current = JSON.parse(idOfUsers);
        // this.setIdOfUsers(this._idOfUsersJSON_current);  // set this._idOfUsers
        // this.removeAllShapesForAllLayers();
        // this.removeAllLayer();
        // this.addAllLayer();
        this.loadDataMap(this._idOfUsers);

    }

    resetDataMap() {
        this.setIdOfUsersUsigLocalSorage();
        this.removeAllShapesForAllLayers();
        this.loadDataMap(this._idOfUsers);
    }
    removeAllShapesForAllLayers() {
        this._plotDataLoader.removeAll();
    }
    activePanel(panelId) {

        $(".tab-pane").removeClass("active in show");
        $("[data-toggle='pill']").removeClass('is-active'); // fill of icon 
        $("#" + panelId + "-tab").addClass('is-active');
        $("#" + panelId).addClass('active in show');

        if (panelId == "scroll-tab-2") {

            $(".asy-titel__tab").css("display", "none");
            // $("#scroll-tab-3-tab").removeClass("active-pointer-events");

        } else if (panelId == "scroll-tab-3") {
            $(".asy-titel__tab").css("display", "none");

            // $("#scroll-tab-4-tab").removeClass("active-pointer-events");
        } else if (panelId == "scroll-tab-4") {

        }
    }
    closeMyModalByDivId(event) {
        document.querySelector("#" + event).classList.remove('md-show');
    }
    openMyModal(event) {
        document.querySelector("#" + event).classList.add('md-show');
    }

    deletStartEndPoint() {
        for (var i = this._featureLayerStartEndPoint.model.store._data.length - 1; i >= 0; i--) {
            this._featureLayerStartEndPoint.model.remove(this._featureLayerStartEndPoint.model.store._data[i].id);
        }
        this.currentPoint.label = "point de départ";
        this.currentPoint.step = "2/7";
    }

    validateStatrEndPoint() {
        var nbrPoints = this._featureLayerStartEndPoint.model.store._data.length
        if (nbrPoints < 2) {
            if (nbrPoints == 0) {

            } else if (nbrPoints == 1) {
                this.currentPoint.step = "3/7";
                this.currentPoint.label = "point de d\'arrivée";
            }
        } else {
            this.activePanel('scroll-tab-2');
            this.createCircle();
        }
    }
    validatePlotsSelected() {
        if (this._tourSummary.plotNumber == 0) {

        } else {
            this.optimisation();
            this.activePanel('scroll-tab-3');
        }
    }
    validateCalculetedTour() {
        if (this._tourSummary.pathDistance != 0 && this._tourSummary.pathDuration != 0) {
            this.activePanel('scroll-tab-4');
        } else {

        }
    }
    validateTourInfo() {
        console.log(this._tourModel);
        if (this.selectedPilot.length > 0 && this.selectedDrone.length > 0 && this._tourModel.teamName != "null" && this._tourModel.teamName != null && this._tourModel.tourName != "null" && this._tourModel.tourName != null) {
            this.settourDate();
            this.getPilotSelected();
            this.activePanel('scroll-tab-5');
        } else {

        }
    }
    settourDate() {
        var month = this._tourModel.tourDate.month;
        var day = this._tourModel.tourDate.day;
        var year = this._tourModel.tourDate.year;
        if (month < 10)
            month = "0" + month;
        if (day < 10)
            day = "0" + day;
        var date = year + "/" + month + "/" + day;
        console.log(date);
        var ladate = new Date(date);
        console.log(ladate);
        var tab_mois = new Array("Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre");
        this.tourDate.mouth = tab_mois[ladate.getMonth()];
        this.tourDate.year = "" + ladate.getFullYear();
        this.tourDate.day = "" + ladate.getDay();
    }
    validateTourZoon() {
        console.log(this._geolocalise);
        var _obj = this;
        if (!_obj.isCollapsed.adr) {
            _obj.geolocalise({ eventType: 'geolocation' }).then(data => {
                if (data) {
                    _obj._geolocalise._googleGeolocationAdress.adress = "";
                    _obj._geolocalise._googleGeolocationAdress.error.state = false;
                    $('#infopanel').css("min-width", "310px");
                    _obj.activePanel('scroll-tab-1');
                } else if (!data) {

                }
            });
        } else if (!_obj.isCollapsed.cd) {
            this.locaisationLatLongAndDMS('DD', { eventType: 'geolocation' }).then(data => {
                if (data) {
                    $('#infopanel').css("min-width", "310px");
                    _obj.activePanel('scroll-tab-1');
                }
            });
        } else if (!_obj.isCollapsed.dms) {
            this.locaisationLatLongAndDMS('DMS', { eventType: 'geolocation' }).then(data => {
                if (data) {
                    $('#infopanel').css("min-width", "310px");
                    _obj.activePanel('scroll-tab-1');
                }
            });
        }
    }
    afterStoreTour() {
        this.resetTourModel();
        this.removeFeatureFromLayer(this._featureLayerTrajetOptimal);
        this.removeFeatureFromLayer(this._featureLayerOrdrePoint);
        this.openMyModal('afterCreateTour');
        this.resetDataMap();
        this.deletStartEndPoint();

        $('#infopanel').css("min-width", "0px");
        this.activePanel('scroll-tab-0');
    }
    getPilotByTeam(team_id) {
        if (team_id != "null" && team_id != null) {
            this.httpService.httpPostPromise('getPilotsByTeam', {team_id:team_id})
                .then((data) => {
                    console.log(data);
                    this.pilot = data;
                    this._pilot_selcted =null;
                    $("#pilot_select").prop('disabled', false);
                }, (error) => {
                    console.error(error);
                    $("#pilot_select").prop('disabled', 'disabled');
                });
            }else {
                $("#pilot_select").prop('disabled', 'disabled');
            }
        }
        changeDronSelected() {
            this.selectedDrone = [];
            if (this._drone_selcted != null && this._drone_selcted != "Nom drone")
                this.selectedDrone.push(parseInt(this._drone_selcted));
            console.log(this.selectedDrone);
        }
        getPilotSelected() {
            var _obj = this;
            if (this.selectedPilot.length > 0) {
                var pilotname = this.pilot.filter(function (tag) {
                    if (tag.pilot_id == _obj.selectedPilot[0]) return true;
                });
                return pilotname[0].pilot_first_name+" "+pilotname[0].pilot_name;
            } else return "";
        }
        getDroneSelected() {
            var _obj = this;
            if (this.selectedDrone.length > 0) {
                var dronename = this.drone.filter(function (tag) {
                    if (tag.value == _obj.selectedDrone[0]) return true;
                });
                return dronename[0].label;
            } else return "";
        }
        getTeamSelected() {
            var _obj = this;
            if (this._tourModel.teamName != "" && this._tourModel.teamName != null && this._tourModel.teamName != "Nom de l'équipe") {
                var teamtname = this.selecteTeam.filter(function (tag) {
                    if (tag.team_id == parseInt(_obj._tourModel.teamName)) return true;
                });
                return teamtname[0].team_name;
            } else return "";
        }

        changePilotSelected() {
            console.log(this._pilot_selcted)
            this.selectedPilot = [];
            if (this._pilot_selcted != null && this._pilot_selcted != "Nom pilote")
                this.selectedPilot.push(parseInt(this._pilot_selcted));
            console.log(this.selectedPilot);
        }


        //-------------------End Form controler-------------------------
        activeSelectionChanged(o): void {

            o._map.on("SelectionChanged", function (event) {
                console.log(o._map.selectedObjects[0]);
                console.log(o._map);

                // o._featuresArraySelectedMemory = [] ;
                // console.log(o._map.selectedObjects[0]);
                console.log(event);
                console.log(event.selectionChanges[0]);
                if (event.selectionChanges.length > 0) {
                    var add = (event.selectionChanges[0].deselected.length == 0);
                    var remove = (event.selectionChanges[0].deselected.length == 1); //TO DO : we must manage deselect several plots
                    if (event.selectionChanges[0].layer == o._featureLayerPlotsDB && add || event.selectionChanges[0].layer == o._featureLayerPlotsDB && remove) {
                        // alert('1');
                        console.log(o._plotsInfoAndAccessPoint);
                        o._plotsInfoAndAccessPoint = [];
                        var selectedObjects = o._map.selectedObjects[0];
                        console.log(selectedObjects);
                        console.log(add);
                        console.log(remove);
                        if (o.isExistStartEndPoints()) {
                            console.log(selectedObjects);
                            if (add)
                                o.updateStatisticsPlotsSelection(selectedObjects, { operation: "add", feature: null });
                            else if (remove) {
                                o.updateStatisticsPlotsSelection(selectedObjects, { operation: "remove", feature: event.selectionChanges[0].deselected[0] });
                                o.removeFeatureFromLayer(o._featureLayerCircle);
                            }
                        }
                    } else if (event.selectionChanges[0].layer == o._featureLayerCircle) {
                        // alert('2');
                        o._featureLayerCircle.workingSet.get()[0].properties = { isSelected: true };
                        console.log(o._featureLayerCircle.workingSet.get()[0]);
                        o.circleEditController(event);

                    } else if (event.selectionChanges[0].selected.length == 0 && o._featureLayerCircle.workingSet.get()[0].properties.isSelected == true) {
                        // alert('3');
                        o._featureLayerCircle.workingSet.get()[0].properties = { isSelected: false };
                        o.removeFeatureFromLayer(o._featureLayerCircle);
                        o._circleSelect._print = false;
                        o.applySelectPlots(o._featuresArraySelectedMemory);
                    }
                }
            });
        }
        //-------------------Selected by circle----------------------------

        circleEditController(event) {
            var o = this;
            var selectedFeature = event.selectionChanges[0].selected[0];
            o._map.controller = new EditController(event.selectionChanges[0].layer, selectedFeature, { finishOnSingleClick: true });
            o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
            o._map.controller.onGestureEvent = function (event) {
                // if (event.inputType === "mouse" && event.domEvent.button > 0) {
                //   return HandleEventResult.EVENT_IGNORED;
                // }

                switch (event.type) {
                    case GestureEventType.DOWN:
                        o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
                        break;
                    case GestureEventType.DRAG:
                        o.fillSelection(o._featureLayerCircle.workingSet.get()[0], o._featureLayerAccessPointDB.workingSet.get());
                        o._circleSelect._radius = "Rayon : " + (Math.round((o._featureLayerCircle.workingSet.get()[0].shape.radius / 1000) * 100) / 100) + " Km";
                        break;
                    case GestureEventType.DRAG_END:
                        //Do nothing
                        break;
                }
                return EditController.prototype.onGestureEvent.apply(this, arguments);
            }
        }
        updateStatisticsPlotsSelection(selectedObjects, operation) {
            if (typeof selectedObjects !== "undefined") {
                var _obj = this;
                var StartEndPoint = _obj._featureLayerStartEndPoint.workingSet.get();
                _obj._plotsInfoAndAccessPoint.push({ "plot_lon_access_point": StartEndPoint[0].geometry[1], "plot_lat_access_point": StartEndPoint[0].geometry[0], "plot_id": 0, "plot_name": "point de départ" });

                _obj._tourSummary.plotNumber = selectedObjects.selected.length;
                _obj._tourSummary.selectedArea = 0;
                _obj._tourSummary.plotNames = [];
                _obj._tourSummary.plotNames.push('Point de départ');

                for (var i = 0; i < selectedObjects.selected.length; i++) {
                    _obj._plotsInfoAndAccessPoint.push(selectedObjects.selected[i].properties);
                    _obj._tourSummary.selectedArea += parseFloat(selectedObjects.selected[i].properties.plot_area);
                    _obj._tourSummary.plotNames.push(selectedObjects.selected[i].properties.plot_name);
                    if (operation.operation == "add") _obj.addPlotInfoAndAccessPointIfNotExist(selectedObjects.selected[i]);
                    else if (operation.operation == "remove") _obj.removePlotInfoAndAccessPointIfDeselected(operation.feature);
                }
                _obj._tourSummary.selectedArea = parseFloat(_obj._tourSummary.selectedArea.toFixed(2));

                _obj._tourSummary.plotNames.push("Point d'arrivé");
                _obj._plotsInfoAndAccessPoint.push({ "plot_lon_access_point": StartEndPoint[1].geometry[1], "plot_lat_access_point": StartEndPoint[1].geometry[0], "plot_id": 0, "plot_name": "point d'arrivée" });
                console.log(_obj._plotsInfoAndAccessPoint);
            }
        }

        isExistStartEndPoints() {
            if (this._featureLayerStartEndPoint.workingSet.get().length < 2) {
                alert("Veuillez définir le point de départ et le point d'arrivée !");
                return false;
            } else {
                return true;
            }
        }
        createCircle() {
            if (!(this._featureLayerCircle.workingSet.get().length > 0)) {
                if (this._circleSelect._erase == "true") {
                    this._featuresArraySelectedMemory = [];
                }
                var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
                var marker = ShapeFactory.createCircleByCenterPoint(
                    REF_CRS84,
                    this.getLonLatPointAtMapCenter(this._map),
                    10000
                );
                var circle = new Feature(marker);
                circle.properties = { isSelected: true };
                var shape_circle_id = this._featureLayerCircle.model.add(circle);
                this._map.selectObjects([{ objects: [circle], layer: this._featureLayerCircle }]);
                this._circleSelect._print = true;
                this._circleSelect._radius = "Rayon :  10 Km";
            }
        }

        fillSelection(circleFeature, features) {
            var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
            if (this.isExistStartEndPoints()) {
                // console.log(this._plotsInfoAndAccessPoint);
                for (var i = 0; i < features.length; i++) {
                    var shape = features[i].shape;
                    //console.log("Point with id " + shape.id + " is in circle : "+circle.shape.contains2DPoint(ShapeFactory.createPoint(ref,[shape[0],shape[1],shape[2]])));
                    if (circleFeature.shape.contains2DPoint(ShapeFactory.createPoint(REF_CRS84, [shape[0], shape[1], shape[2]]))) {
                        if (features[i].properties.clusteredElements) {
                            for (var j = 0; j < features[i].properties.clusteredElements.length; j++) {
                                this.addPlotInfoAndAccessPointIfNotExist(this.getPlotFeature(features[i].properties.clusteredElements[j].properties.plot_id));
                            }
                        } else {
                            // console.log(features[i]);
                            this.addPlotInfoAndAccessPointIfNotExist(this.getPlotFeature(features[i].properties.plot_id));
                        }
                        //  console.log(featuresArray);
                        this.applySelectPlots(this._featuresArraySelectedMemory);

                    } else {

                    }
                }
            }

            // selection = {objects: featuresArray, layer: featuresLayer};
        }
        addPlotInfoAndAccessPointIfNotExist(feature) {
            console.log(feature);
            if (!this._featuresArraySelectedMemory.includes(feature)) {
                this._featuresArraySelectedMemory.push(feature);
            }
        }
        removePlotInfoAndAccessPointIfDeselected(feature) {
            var indx = this._featuresArraySelectedMemory.indexOf(feature);
            // alert("indx " + indx);
            if (indx != -1) {
                this._featuresArraySelectedMemory.splice(indx, 1);
            }

        }

        getLonLatPointAtMapCenter(map) {
            var viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
            var mapPoint = map.viewToMapTransformation.transform(viewPointCenter);

            var lonLatReference = ReferenceProvider.getReference("CRS:84");
            var mapToLonLatTransformation = TransformationFactory.createTransformation(map.reference, lonLatReference);

            var lonLatPoint = mapToLonLatTransformation.transform(mapPoint);
            return lonLatPoint;
        }

        applySelectPlots(featuresArray) {
            // this._featuresArraySelectedMemory =[];
            this._map.selectObjects([{ objects: featuresArray, layer: this._featureLayerPlotsDB }]);
        }
        getPlotFeature(plot_id) {
            for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
                if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
                    // console.log("-----------this._featureLayerPlotsDB.model.store._data[i]-------");
                    return this._featureLayerPlotsDB.model.store._data[i];
                }
            }
        }
        //-------------------En selected by cercle-------------------------

        //--------------------------------------Tour--------------------------------------------
        optimisation() {
            var distMatrix = OptimizationOfATour.matrixDistanceLatLog(this._plotsInfoAndAccessPoint);

            this._plotsInfoAndAccessPointOrdred = OptimizationOfATour.towOpt(distMatrix, this._plotsInfoAndAccessPoint);
            this._tourSummary.plotNamesOrdred = [];
            for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {
                this._tourSummary.plotNamesOrdred.push(this._plotsInfoAndAccessPointOrdred[i].plot_name);
            }
            this.addNotify({ title: 'Chargement de feuille de routes ', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
            this.httpService.httpPostPromise('getRoadPathBetween2point', { plotInfosAndAccessPoints: this._plotsInfoAndAccessPointOrdred })
                .then((data) => {
                    console.log(data);
                    this.printResultOfTwoOpt(data.path);
                    this.addNotify({ title: 'Chargement de feuille de routes ', msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !', type: 'success' });
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Chargement de feuille de routes', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
                });
        }
        removeFeatureFromLayer(layer) {
            for (var i = layer.model.store._data.length - 1; i >= 0; i--) {
                layer.model.remove(layer.model.store._data[i].id);
            }
        }
        creatAndAddPolylineForTwoOpt(tableauDePoints, model) {
            var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
            var ligne = '(';
            var poly = ShapeFactory.createPolyline(REF_CRS84, []);

            for (var i = 0; i < tableauDePoints.length; i++) {
                var marker = ShapeFactory.createPoint(REF_CRS84, [parseFloat(tableauDePoints[i].lng()), parseFloat(tableauDePoints[i].lat())]);
                poly.insertPoint(i, marker);

                if (i == tableauDePoints.length - 1) ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ')';
                else ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ',';
            }
            this._tourModel.paths.push(ligne);
            var markerFeature = new Feature(poly);
            var shape_id = model.add(markerFeature);
            this._map.mapNavigator.fit({ bounds: this._featureLayerTrajetOptimal.bounds, animate: false });
            return shape_id;
        }
        createAndAddPointForTwoOpt(formHistorique) {

            var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
            for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {

                var myPoint = ShapeFactory.createPoint(REF_CRS84, [this._plotsInfoAndAccessPointOrdred[i].plot_lat_access_point, this._plotsInfoAndAccessPointOrdred[i].plot_lon_access_point]);
                var markerFeature = new Feature(myPoint);

                if (!formHistorique) {

                    if (i == 0) var properties = { order: "PDE" };
                    else if (i == this._plotsInfoAndAccessPointOrdred.length - 1) var properties = { order: "PDA" };
                    else var properties = { order: '<h4 class="sub-title" style="color: #a9bc14;" align="center">' + i + '</h4>' + this._plotsInfoAndAccessPointOrdred[i].plot_name };

                } else {

                    // $("#btn_exporter_tour_csv").prop("disabled",false); 

                    // if(i==0) var pro = {ordre :"Point de départ"};
                    // else if(i==ordrePoint.length-1) var pro = {ordre :"Point d'arrivée"};
                    // else var pro = {ordre :"<a href='#'><p align='center' style='font-size: 20px;'>"+i+"</p></a>"+nomParcellesOrdonnes[i][0] };

                }
                console.log(properties);
                console.log(this._featureLayerOrdrePoint);
                markerFeature.properties = properties;
                this._featureLayerOrdrePoint.model.add(markerFeature);
            }
        }
        //-5-----------------------------Afficher la tournee sur la map et charger la feuille de route-----------------------------

        printResultOfTwoOpt(path) {
            var _obj = this;
            this._tourSummary.pathDistance = 0;
            this._tourSummary.pathDuration = 0;
            this._tourModel.dists = [];
            this._tourModel.durations = [];

            var distanceDureeFinale = [];
            var decodedPath1 = [];
            var distTraget = 0;
            var durationTraget = 0;
            console.log(path);
            // $("#contentdiv").html('<div id="syntheseInitaile" style="background-color : #aeff00; width:100%;"></div><div id="syntheseFinale" style="background-color : #2c3e50; width:100%;"></div><div id="gain" style="background-color : #9fc54d; width:100%;">Gain</div>');

            for (var i = 0; i < path.length; i++) {
                path[i] = JSON.parse(path[i]);
                console.log(path[i]);
                var strDiv = "detailles" + i;
                var titlelDiv = "title" + i;
                document.getElementById('contentdiv').innerHTML += "<div id='" + titlelDiv + "' class='ays-label-steps' >Trajet de " + this._tourSummary.plotNamesOrdred[i] + " à " + this._tourSummary.plotNamesOrdred[i + 1] + "<span style='color : #9fc54d; font-size: 90% ;margin-right:3px;'>" + path[i].routes[0].legs[0].duration.text + "(" + path[i].routes[0].legs[0].distance.text + ")</span></div> <div id ='" + strDiv + "' class='ays-div-steps' ></div>";
                // nomParcellesOrdonnes[i][2] = i ; //Ordre  
                // nomParcellesOrdonnes[i][3] = (path[i].routes[0].legs[0].distance.value/1000).toFixed(4) ; //Distance
                // nomParcellesOrdonnes[i][4] = (path[i].routes[0].legs[0].duration.value/3600).toFixed(4) ; //Durée

                // var el = document.getElementById(titlelDiv);
                $("#" + titlelDiv).click(function () {
                    _obj.displayDiv(strDiv);
                });
                // el.addEventListener("click", function () { _obj.displayDiv(strDiv); });
                for (var j = 0; j < path[i].routes[0].legs[0].steps.length; j++) {

                    document.getElementById(strDiv).innerHTML += "<br>" + path[i].routes[0].legs[0].steps[j].html_instructions;
                    document.getElementById(strDiv).innerHTML += "<br><span style='color : #9fc54d; font-size: 80%'>" + path[i].routes[0].legs[0].steps[j].duration.text + "(" + path[i].routes[0].legs[0].steps[j].distance.text + ")</span>";

                }
                this._tourModel.dists.push(path[i].routes[0].legs[0].distance.value / 1000);
                this._tourModel.durations.push(path[i].routes[0].legs[0].duration.value / 3600);
                this._tourSummary.pathDistance += path[i].routes[0].legs[0].distance.value;
                this._tourSummary.pathDuration += path[i].routes[0].legs[0].duration.value;

                decodedPath1[i] = new Array();
                decodedPath1[i] = google.maps.geometry.encoding.decodePath(path[i].routes[0].overview_polyline.points);
                console.log(decodedPath1[i]);
            }
            this._tourSummary.pathDuration = parseFloat((this._tourSummary.pathDuration / 3600).toFixed(2));
            this._tourSummary.pathDistance = parseFloat((this._tourSummary.pathDistance / 1000).toFixed(2));
            // document.getElementById('syntheseFinale').innerHTML += "Distance finale : " + this._tourSummary.pathDistance + "km<br>La durée finale :" + this._tourSummary.pathDuration + "H";
            $("#syntheseFinale").html("Distance finale :" + this._tourSummary.pathDistance + "km<br>La durée finale : " + this._tourSummary.pathDuration + "H");
            // distanceDureeFinale.push(distTraget/1000,durationTraget/3600);

            // nomParcellesOrdonnesExportCsv = nomParcellesOrdonnes;   
            //  if (finInit==1) {
            //   // document.getElementById('syntheseInitaile').innerHTML+="Distance initiale :"+distTraget/1000+"km<br>La durée initiale :"+durationTraget/3600+"H";
            //    // initialize(decodedPath1); 
            //     $("#syntheseInitaile").html("Distance initiale :"+distTraget/1000+"km<br>La durée initiale :"+durationTraget/3600+"H");
            //    alert("Calcule des données statistiques");
            //  }  
            // // vider et supprimer les premiers path dans le MemoryStore (Trajet qui est polyline et dans points d'acces)
            this.removeFeatureFromLayer(this._featureLayerTrajetOptimal);
            this.removeFeatureFromLayer(this._featureLayerOrdrePoint);

            for (var i = 0; i < decodedPath1.length; i++) {
                this.creatAndAddPolylineForTwoOpt(decodedPath1[i], this._featureLayerTrajetOptimal.model);
            }

            this.createAndAddPointForTwoOpt(false);

            // var nomParcellesOrdonnesTmp ="";
            // for(var i=0 ;i<nomParcellesOrdonnes.length;i++){
            //     nomParcellesOrdonnesTmp +=nomParcellesOrdonnes[i][0]+"<br>";
            // }
            // $("#parcellesOrdonnes").html("<h3 style='color : #ffffff; font-size: 18px'>Les parcelles ordonnées sont: </h3>  <br> "+nomParcellesOrdonnesTmp);   

        }

        collapsed() {

        }
        displayDiv(idDiv) {
            console.log("wlah hta khdama");
            $("#" + idDiv).fadeToggle();
        }

        submitTour() {
            this._tourModel.pilots = this.selectedPilot;
            this._tourModel.drones = this.selectedDrone;
            this._tourModel.area = this._tourSummary.selectedArea;
            this._tourModel.total_dist = this._tourSummary.pathDistance / 1000;
            this._tourModel.total_duration = this._tourSummary.pathDuration / 3600;
            var indx = this._plotsInfoAndAccessPointOrdred.length - 1;
            this._tourModel.start_point = 'POINT(' + this._plotsInfoAndAccessPointOrdred[0].plot_lat_access_point + ' ' + this._plotsInfoAndAccessPointOrdred[0].plot_lon_access_point + ')';
            this._tourModel.end_point = 'POINT(' + this._plotsInfoAndAccessPointOrdred[indx].plot_lat_access_point + ' ' + this._plotsInfoAndAccessPointOrdred[indx].plot_lon_access_point + ')';

            this.get_tour_plot_infos_geometry();
            console.log(this._plotsInfoAndAccessPointOrdred.length);
            console.log(this._tourModel);
            console.log(this.selectedPilot);
            console.log(this._featureLayerTrajetOptimal);

            var month = this._tourModel.tourDate.month;
            var day = this._tourModel.tourDate.day;
            var year = this._tourModel.tourDate.year;
            if (this._tourModel.tourDate.month < 10)
                month = "0" + month;
            if (this._tourModel.tourDate.day < 10)
                day = "0" + day;
            var date = year + "" + month + "" + day;
            this._tourModel.tourDate = date;

            this.httpService.httpPostPromise('storeTour', this._tourModel)
                .then((data) => {
                    console.log(data);
                    this._tourExport.tour_id = data.tour_id;
                    console.log(this._tourExport.tour_id);
                    this.afterStoreTour();
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Sauvegarder la tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
                });
        }
        resetTourModel() {
            this._tourModel.tourName = null
            this._tourModel.teamName = null;
            this._tourModel.tourDate = null;
            this._tourModel.pilots = [];
            this._tourModel.drones = [];
            this._tourModel.paths = [];
            this._tourModel.dists = [];
            this._tourModel.total_dist = 0;
            this._tourModel.total_duration = 0;
            this._tourModel.durations = [];
            this._tourModel.area = 0;
            this._tourModel.plot_id = { id: [], treatment: [] };
            this._tourModel.start_point = null;
            this._tourModel.end_point = null;

            this._tourSummary.pathDistance = 0;
            this._tourSummary.pathDuration = 0;
            this._tourSummary.plotNames = [];
            this._tourSummary.plotNamesOrdred = [];
            this._tourSummary.plotNumber = 0;
            this._tourSummary.selectedArea = 0;

            this.selectedPilot = [];
            this.selectedDrone = [];
        }
        get_tour_plot_infos_geometry() {
            this._tourModel.plot_id.id = [];
            this._tourModel.plot_id.treatment = [];
            for (var i = 0; i < this._plotsInfoAndAccessPointOrdred.length; i++) {
                this._tourModel.plot_id.id.push(this._plotsInfoAndAccessPointOrdred[i].plot_id);
            }
            this._tour_plot_infos_geometry = [];
            for (var i = 0; i < this._tourModel.plot_id.id.length; i++) {
                if (this._tourModel.plot_id.id[i] != 0)
                    this._tour_plot_infos_geometry.push(this.getPlotInfoGeometry(this._tourModel.plot_id.id[i]));
            }
            for (var i = this._tour_plot_infos_geometry.length - 1; i >= 0; i--) {
                var lastTreatmentId = null;
                for (var j = 0; j < this._tour_plot_infos_geometry[i].treatment.length; j++) {
                    if (j == 0 && this._tour_plot_infos_geometry[i].treatment[j].treatment_status == "commande") {
                        lastTreatmentId = this._tour_plot_infos_geometry[i].treatment[j].treatment_id;
                    } else if (j != 0 && this._tour_plot_infos_geometry[i].treatment[j].treatment_status == "commande") {
                        if (lastTreatmentId < this._tour_plot_infos_geometry[i].treatment[j].treatment_id || lastTreatmentId == null) {
                            lastTreatmentId = this._tour_plot_infos_geometry[i].treatment[j].treatment_id;
                        }
                    }
                }
                if (lastTreatmentId) {
                    this._tourModel.plot_id.treatment.push(lastTreatmentId);
                }
            }
        }
        checkUncheckTreatmentTour(treatment_id) {
            for (var i = this._tourModel.plot_id.treatment.length - 1; i >= 0; i--) {
                if (this._tourModel.plot_id.treatment[i] == treatment_id) {
                    return true;
                }
            }
            return false;
        }
        updatePlotTableTreatment(plot_id, treatment_id) {
            console.log("plot_id: " + plot_id + "__treatment_id: " + treatment_id);
            var checkBox = document.getElementById('treatment-tour-' + treatment_id);
            if ((<HTMLInputElement>checkBox).checked) {
                for (var i = 0; i < this._tourModel.plot_id.id.length; i++) {
                    if (this._tourModel.plot_id.id[i] == plot_id) {
                        this._tourModel.plot_id.treatment.push(treatment_id);
                    }
                }
            } else {
                var indx = this._tourModel.plot_id.treatment.map(function (e) { return e; }).indexOf(treatment_id);
                this._tourModel.plot_id.treatment.splice(indx, 1);
            }
            console.log(this._tourModel);
        }

        /**
         * Returns the plot at the given ID.
         * @param aId  plot id
         */
        getPlotInfoGeometry(aId) {
            var _plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
                return tag.plot_id == aId;
            });
            return _plot_infos_geometry[0];
        }
        setLIST_TREATMENTS(plot_id) {
            this.LIST_TREATMENTS = [];
            this.LIST_TREATMENTS.push(this.getPlotInfoGeometry(plot_id));
            for (var i = 0; i < this.LIST_TREATMENTS.length; i++) {
                var treatment = this.LIST_TREATMENTS[i].treatment;
                this.LIST_TREATMENTS[i].treatment = [];
                for (var j = 0; j < treatment.length; j++) {
                    if (treatment[j].treatment_status == "commande" || treatment[j].treatment_status == "en-cours") {
                        this.LIST_TREATMENTS[i].treatment.push(treatment[j]);
                    }
                }
            }
        }
        getTreatmentLength(treatements) {
            var _length = 0;
            for (var i = 0; i < treatements.length; i++) {
                if (treatements[i].treatment_status == "commande" || treatements[i].treatment_status == "en-cours") {
                    _length++;
                }
            }
            return _length;
        }
        exportTour(tour_id) {

            this.addNotify({ title: 'Exportation de la tournée ', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
            this.httpService.httpPostPromise('exportCSVTour', { tour_id: tour_id })
                .then((data) => {
                    console.log(data);
                    this.downloadTour(data.filename);
                    this.addNotify({ title: 'Exportation de la tournée ', msg: 'Veuillez télécharger votre tournée.', type: 'success' });
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Exportation de la tournée', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
                });
        }

        downloadTour(path) {
            return this.http
                .get('assets/data/tournees_2018/' + path, {
                    responseType: ResponseContentType.Blob
                })
                .map(res => {
                    return {
                        filename: path,
                        data: res.blob()
                    };
                })
                .subscribe(res => {
                    console.log('start download:', res);
                    var url = window.URL.createObjectURL(res.data);
                    var a = document.createElement('a');
                    document.body.appendChild(a);
                    a.setAttribute('style', 'display: none');
                    a.href = url;
                    a.download = res.filename;
                    a.click();
                    window.URL.revokeObjectURL(url);
                    a.remove(); // remove the element
                }, error => {
                    console.log('download error:', JSON.stringify(error));
                }, () => {
                    console.log('Completed file download.')
                });
        }
        getTourByTeam(team_id) {
            this._tourExport.type_filtre = 't';
            this.httpService.httpPostPromise('getTourByTeam', { team_id: this._tourExport.team_id })
                .then((data) => {
                    this.tours = data;
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
                });
        }

        getTourByPilot(pilot_id) {
            this._tourExport.type_filtre = 'p';
            this.httpService.httpPostPromise('getTourByPilot', { pilot_id: this._tourExport.pilot_id })
                .then((data) => {
                    this.tours = data;
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
                });
        }

        getTourById(tour_id) {
            this.httpService.httpPostPromise('getTourById', { tour_id: this._tourExport.tour_id })
                .then((data) => {
                    console.log(data);
                }, (error) => {
                    console.error(error);
                    this.addNotify({ title: 'Récuperer la liste des tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
                });
        }

        updateTour(tour_id) {
            console.log(tour_id);
        }
        deleteTour(tour_id) {
            console.log(tour_id);
            // this.deleteTourSwal(this._idOfUsers, tour_id);
        }
        showList() {
            document.getElementById("listtoshow").style.display = "block";
        }
        hideList() {
            document.getElementById("listtoshow").style.display = "none";
        }
        addNotify(options) {
            //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
            this.servicePNotify.remove();
            this.options = {
                position: [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
                maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
                timeOut: options.timeOut ? options.timeOut : this.timeOut,
                showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
                pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
                lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
                clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
                maxLength: options.maxLength ? options.maxLength : this.maxLength,
                preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
                preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
                theClass: options.theClass ? options.theClass : this.theClass,
                rtl: ('rtl' in options) ? options.rtl : this.rtl,
                animate: options.animate ? options.animate : this.animate,
                icons: options.icons ? options.icons : this.icons
            }
            switch (options.type) {
                case 'success':
                    this.servicePNotify.success(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                case 'error':
                    this.servicePNotify.error(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                case 'alert':
                    this.servicePNotify.error(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                case 'warn':
                    this.servicePNotify.error(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                case 'info':
                    this.servicePNotify.info(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                case 'create':
                    this.servicePNotify.create(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg,
                        options.type ? options.type : this.subType
                    );
                    break;
                case 'html':
                    this.servicePNotify.html(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
                default:
                    this.servicePNotify.alert(
                        options.title ? options.title : this.title,
                        options.msg ? options.msg : this.msg
                    );
                    break;
            }
        }

    }
