import * as  ShapeFactory  from 'luciad/shape/ShapeFactory';
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  Feature from 'luciad/model/feature/Feature';
import * as Map from "luciad/view/Map";
import * as $ from 'jquery';

export class Localisator {

	constructor() {
		$(".DMS").hide();
		$(".DD").hide();
		$(".btn_recherche_coordonnee").hide();
		$(".geolocation").hide();
		$("#br_ini").hide();
		//$('input:radio[name=coordinates_type]').filter('[value=DD]').prop('checked', true);
	}

	selectionChanged(coordinate_type, visualisation) {
		if(coordinate_type == "DMS") {
	      //Récupération des valeurs dans les champs html
	      var longitude = $("#lon_dd").val();
	      var lonDMS = this.convertDDToDMS(longitude);
	      var latitude = $("#lat_dd").val();
	      var latDMS = this.convertDDToDMS(latitude);
	      if (latitude && longitude) {
	      	if(longitude>=0){
		        $("#lon_dd").val(longitude);
		        $("#lon_d").val(lonDMS[0]);
		        $("#lon_m").val(lonDMS[1]);
		        $("#lon_s").val(lonDMS[2]);
		        $('#north_south_selector option[value="O"]').attr('selected', 'true');
		     }else{
		        $("#lon_dd").val(-longitude);
		        $("#lon_d").val(-lonDMS[0]);
		        $("#lon_m").val(-lonDMS[1]);
		        $("#lon_s").val(-lonDMS[2]);
		        $('#north_south_selector option[value="E"]').attr('selected', 'true');
		    }

		    if(latitude>=0){      
		        $("#lat_dd").val(latitude) ;
		        //Remplissage des champs
		        $("#lat_d").val(latDMS[0]);
		        $("#lat_m").val(latDMS[1]);
		        $("#lat_s").val(latDMS[2]);
		        $('#east_west_selector option[value="N"]').attr('selected', 'true');
		    } else {
		        $("#lat_dd").val(-latitude) ;
		        //Remplissage des champs
		        $("#lat_d").val(-latDMS[0]);
		        $("#lat_m").val(-latDMS[1]);
		        $("#lat_s").val(-latDMS[2]);
		        $('#east_west_selector option[value="S"]').attr('selected', 'true');      
		    }
	      }
	      
	    }else{
	      var lat_d = $("#lat_d").val();
	      var lat_m = $("#lat_m").val();
	      var lat_s = $("#lat_s").val();
	      if($("#east_west_selector").val()=='O'){
	      	var lat_DD = this.convertDMSToDD(lat_d,lat_m,lat_s);
	      }else{
	        var lat_DD = this.convertDMSToDD(-lat_d,-lat_m,-lat_s);
	      }

	      var lon_d = $("#lon_d").val();
	      var lon_m = $("#lon_m").val();
	      var lon_s = $("#lon_s").val();
	      if($("#north_south_selector").val()=='N'){
	        var lon_DD = this.convertDMSToDD(lon_d,lon_m,lon_s);
	      }else{
	        var lon_DD = this.convertDMSToDD(-lon_d,-lon_m,-lon_s);
	      }
	      //inversion de la visibilité des champs (DMS to DD)
	      
	      //Remplissage des champs
	      $("#lon_dd").val(lon_DD.toFixed(5));
	      $("#lat_dd").val(lat_DD.toFixed(5));
	    }
	    if(visualisation) {
	      	this.change_view(coordinate_type);
	     }
	    
	}
	 
	change_view(selected_view) {
		$("#br_ini").show();
		if(selected_view == "DMS") {
			$(".btn_recherche_coordonnee").show();
			$("#search-by-coordonnees").show();
			$(".DMS").show();
			$(".DD").hide();
	      	$(".geolocation").hide();
	    }
    	else if (selected_view == "DD") {
			$(".btn_recherche_coordonnee").show();
			$("#search-by-coordonnees").show();
			$(".DMS").hide();
			$(".DD").show();
	      	$(".geolocation").hide();
    	} else {
			$(".btn_recherche_coordonnee").hide();
			$(".DMS").hide();
				$(".DD").hide();
				$("#search-by-adress").show();
	      	$(".geolocation").show();
    	}
	}
	 
	change_navigator_view(mapNavigator, model) {

    var lat = $('#lat_dd');
    var lon = $('#lon_dd');
    //console.log(lat.val());
    var point = ShapeFactory.createPoint(ReferenceProvider.getReference("CRS:84"),[parseFloat(lon.val()),parseFloat(lat.val())]);;
    mapNavigator.fit(point);
    mapNavigator.zoomTo(1/4000);
    var markerFeatureAccessPoint = new Feature(point);
    //Décommenter pour faire apparaitre le tableauDePoints
    var shape_id = model.add(markerFeatureAccessPoint);
    var model_repere = model;
    setTimeout(function() {
      model_repere.remove(shape_id);
    }, 7500);
  }

  //Centre la carte sur une adresse
  //Google map est importé en script dans la page index.html
  geolocalise(mapNavigator) {
    var response = $.get('https://maps.googleapis.com/maps/api/geocode/json?address='+$('#geolocation').val()+'+FR&key=AIzaSyBe32W5lnmFE2xsUqcu4WGd7ubxWhuC8qY');
    console.log(response);
    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({ 'address': $('#geolocation').val() }, function(results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
          var lng = results[0].geometry.location.lng();
          var lat = results[0].geometry.location.lat();
          var myPoint = ShapeFactory.createPoint(ReferenceProvider.getReference("EPSG:4326"),[lng,lat]);
          mapNavigator.setCenter(myPoint);
          mapNavigator.zoomTo(1/4000);
        }
    });
  }

   

  //Convertie la valeur en format degrès minute-seconde en degrès décimal
  convertDMSToDD(D,M,S) {
  	console.log("DMS vers DD");
  	console.log(D+" - "+M+" - "+S);
  	console.log(parseFloat(D)+parseFloat(M)/60+parseFloat(S)/3600);
    return parseFloat(D)+parseFloat(M)/60+parseFloat(S)/3600;
   }

//Convertie la valeur en format degrès décimal en degrès minute-seconde
  convertDDToDMS(DD) {
  	console.log("DD vers DMS");
    var d = Math.trunc(DD);
    var m = Math.trunc((DD-d)*60)/*%60*/;
    var s = (((DD-d-m/60)*3600)%60).toFixed(2);
    console.log([d,m,s]);
    return [d,m,s];
  }
}