import * as licenseTxt from 'raw-loader!./license/luciadria_development.txt';
import * as License from 'luciad/util/License';
License.setLicenseText(licenseTxt);

import { AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone } from '@angular/core';
import 'rxjs/add/operator/toPromise';
import * as WebGLMap from 'luciad/view/WebGLMap';
import * as Map from "luciad/view/Map";
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
import { LayerFactory } from './LayerFactory';
import { GoogleMaps } from './GoogleMaps';
import * as  ShapeFactory from 'luciad/shape/ShapeFactory';
import * as  LayerGroup from 'luciad/view/LayerGroup';
import * as  LayerTreeControl from 'samples/common/control/LayerTreeControl';
import * as  TooltipPissosHoverController from 'samples/common/agriload/tooltipPissosHovoerController/TooltipHoverController';
import * as  FeaturePainter from "luciad/view/feature/FeaturePainter";
import * as  ColorMap from "luciad/util/ColorMap";
import * as  ParameterizedPointPainter from "luciad/view/feature/ParameterizedPointPainter";
import * as  ExpressionFactory from "luciad/util/expression/ExpressionFactory";
import * as  LayerConfigUtil from 'samples/common/LayerConfigUtil';
import * as  SampleContextMenu from "samples/common/contextmenu/SampleContextMenu";

/* Start Import file for create and edit feature */
import * as  Feature from 'luciad/model/feature/Feature';
import * as  FeatureModel from 'luciad/model/feature/FeatureModel';
import * as  BasicCreateController from 'luciad/view/controller/BasicCreateController';
import * as  EditController from 'luciad/view/controller/EditController';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  RestStore from 'samples/common/store/RestStore';
import * as  ShapeType from 'luciad/shape/ShapeType';
import * as  MemoryStore from 'luciad/model/store/MemoryStore';
import * as templateSample from "samples/template/sample";
import * as  domConstruct from "luciad/dojo/dom-construct";
import * as  dConstruct from "luciad/dojo/dom-construct";

/* Start Import file for create clustering access points feature */
import * as  ClusteringTransformer from 'luciad/view/feature/transformation/ClusteringTransformer';
import * as  ClusteringPainterWrapper from "samples/clustering/ClusteringPainterWrapper";
import * as ClusterIconStyleUtil from "samples/clustering/ClusterIconStyleUtil";
import * as  IconFactory from "samples/common/IconFactory";
import * as TransformationFactory from "luciad/transformation/TransformationFactory";
//import * as variable from 'variableName';

import * as  BasicFeaturePainter from 'luciad/view/feature/BasicFeaturePainter';

import { PlotDataLoader } from './PlotDataLoader';
import { Localisator } from './Localisator';
import { BingMapsDataLoader } from '../../_class/BingMapsDataLoader';
import * as  Promise from "luciad/util/Promise";
import * as LayerType from 'luciad/view/LayerType';
import * as ShapePainterContour from "samples/shapePainter/ShapePainterContour";
import * as ShapePainterObstacle from "samples/shapePainter/ShapePainterObstacle";
import * as ShapePainterNewPlot from "samples/shapePainter/ShapePainterNewPlot";
import * as ZoomControl from "samples/common/navigation/ZoomControl";
import * as PanControl from "samples/common/navigation/PanControl";
/* Start Import file for create and validate a form */
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Router } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { ExportModule } from '../export/export.module';
import swal from 'sweetalert2';
import { NotificationsService } from "angular2-notifications";
import * as $ from 'jquery';
import { } from '@types/googlemaps';
import { retry } from 'rxjs/operator/retry';

@Component({
  selector: 'app-order-v2',
  templateUrl: './order-v2.component.html',
  styleUrls: ['./order-v2.component.css'],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class OrderV2Component implements AfterViewInit, OnDestroy {

  @ViewChild('gmap') gmapElement: any;
  map: google.maps.Map;


  @ViewChild('map') mapElem: ElementRef;

  /*  Notify */
  options: any = {
    position: ["bottom", "right"],
  };
  _coordinateType = "geolocation";
  _coordinateTypeInput = {
    geolocation: true,
    dd: false,
    dms: false
  };
  viewPointCenter: any;
  _tempViewPoint: any;
  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';

  title: string;
  msg: string;
  /*  End    */
  _map: WebGLMap;
  _printLayerControl: boolean = false;
  _featureLayer: FeatureLayer;
  _featureLayerRepere: FeatureLayer;
  _featureLayerPlotsDB: FeatureLayer;
  _featureLayerObstaclesDB: FeatureLayer;
  _featureLayerPissosDB: FeatureLayer;
  _surfaceDetectedPainter: any;
  _pissosPaiterClass: any;
  _slider = {
    value: "0 %"
  };
  _featureLayerBingMap: FeatureLayer;
  _featureLayerAccessPointDB: FeatureLayer;
  _plotDataLoader: any;
  _localisator: any;
  _plot_infos_geometry = [];
  _plot_selected: any;
  _plot_infos_geometryCopy = [];
  _currentUserInfos: any; //--------------!!!!
  _idOfUsersJSON_current: any; //--------------!!!! // = _idOfUsers  these variable is used after the user chose a current user to filter data in the carte
  _usersFarmerByIdTech: any;//--------------!!!!
  _usersFarmerByIdTechCopy: any;
  _currentUserEmailAndToken: any; //--------------!!!!
  _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id": 0, "user_type": "t","year":2020};  //--------------!!!! // use to load a binding datas of a curent user or to filtering data
  _errorInputs = { "name": false, "id_farmer": false, "electricline": false, "irrigationsystem": false }; // use to load a binding datas of a curent user or to filtering data
  _farmer_selected = 0;
  _farmer_id: number;
  // _model :{} ; //= {id_farmer:1,name :'',comment :'',electricline :'',irrigationsystem:'',geom :{}};
  _model = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    id_farmer: null,
    name: '',
    comment: '',
    electricline: '',
    irrigationsystem: '',
    geom: {},
    accesspoint: {},
    obstacles: {},
    plot_id: null,
    editOrStor: 'stor',
    farmer: []
  };
  _newPlot_AcessPoint_Obstacles_features: any = [];
  _model_plot_update = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    id_farmer: null,
    plot_id: null,
    name: '',
    comment: '',
    electricline: '',
    plot_irrigation: '',
    geom: {},
    accesspoint: {},
    obstacles: {},
    farmer: []
  };
  _polt: number = 1;
  EVENT_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(155, 180, 222, 0.8)",
      strokeWidth: 1
    })
  };

  EVENT_SELECTED_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(192, 217, 42, 0.8)",
      strokeWidth: 1.5
    })
  };
  progress: number = 0;
  label: string;
  addPlotlistOnDom = false;
  _list_treatments = [];
  isClosedInfoPanel : boolean = false ;
  isClosedMapContainer : boolean = false;
  orderId : any = {
    order_id : null,
    state : null
  };
  @Input()
  mapReference: string;
  searchTerm = "";
  searchId_farmer = "null";
  searchFarmerTerm: any;
  _globalStatistic = {
    count_total_treatment: 0,
    percentage_total_treatment: 0,
    count_treatment_finished: 0,
    percentage_treatment_finished: 0,
    count_treatment_in_progress: 0,
    percentage_treatment_in_progress: 0,
    count_treatment_preorder: 0,
    percentage_treatment_preorder: 0,
    count_treatment_ordered: 0,
    percentage_treatment_ordered: 0,
    count_total_orders: 0,
    plots_count: 0,
    plot_area: 0,
    tabIdFarmer: [],
    tabIdTech: [],
    tabIdCoop: [],
    tabIdAdhe: [],
    order: {
      tabIdOrder: [],
      order_waiting: [],
      order_validated: [],
      order_in_progress: [],
      order_finished: []
    }
  };
  localDate = {
    mouth: "",
    year: "",
  };
  _selectOptionTraitement: any;
  _plotToTreat_infos_geometry = []; // liste of plot and their properties
  _plotToTreat_infos_geometryCopy = []; // liste of plot and their properties
  _SummaryOfTheOrder = { "visibility": false, "plots_count": 0, "total_area": 0, "technician_id": 1, "current_stock": 0, "treatment": [], "agri_id": [] };

  constructor(private httpService: HttpService,
    public authenticationService: AuthenticationService,
    private router: Router,
    private http: Http,
    private servicePNotify: NotificationsService,
    private cdRef: ChangeDetectorRef,
    private _ngZone: NgZone) {

    if (this.authenticationService.isLoggedIn()) {
      this.setIdOfUsersUsigLocalSorage();
      this.getAllUsersFarmersByIdTech();
    } else {
      this.router.navigate(['/login']); //--------------!!!!
    }

    $("#controlcontainer").click(function () {
      console.log("lahchcehehhehhzehh  ");
    });
    // this.setLocalDate();
    this.getSelectOptionTraitement();
  }
  setLocalDate() {
    var ladate = new Date()
    var tab_mois = new Array("Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre");
    this.localDate.mouth = tab_mois[ladate.getMonth()];
    this.localDate.year = "" + ladate.getFullYear();
  }
  getSelectOptionTraitement(){
    var _obj = this ;
    this.httpService.httpPostPromise('getallproducts', {need_stock :"all"})
    .then((data) => {
      console.log(data);
      this._selectOptionTraitement = data;
    }, (error) => {
      console.error(error);
    });
  }
  checkUncheck(plot_id) {
    for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
      if (this._plotToTreat_infos_geometry[i].plot_id == plot_id) {
        return true;
      }
    }
    return false;
  }
  setSummaryOfTheOrderTreatment(plot_id) {
    var _obj = this;
    var checkBox = document.getElementById('plot-ordered-' + plot_id);
    var treatmentSelected = $('#treatment-' + plot_id + " option:selected").val();
    var treatementText = $('#treatment-' + plot_id + " option:selected").text();
    console.log(this._plotToTreat_infos_geometry);
    console.log((<HTMLInputElement>checkBox).checked);
    if ((<HTMLInputElement>checkBox).checked) {

      console.log(this._SummaryOfTheOrder.treatment);

      var indx = this._SummaryOfTheOrder.treatment.map(function (e) { return e.plot_id; }).indexOf(plot_id);
      this._SummaryOfTheOrder.treatment.splice(indx, 1, { "plot_id": plot_id, "id_product": treatmentSelected });

      var indx1 = this._plotToTreat_infos_geometry.map(function (e) { return e.plot_id; }).indexOf(plot_id);
      this._plotToTreat_infos_geometry.splice(indx1, 1, _obj._plotToTreat_infos_geometry[indx1]);
      console.log(this._plotToTreat_infos_geometry);
      this.checkUncheck(plot_id);
      console.log(this._SummaryOfTheOrder.treatment);

    }
    this._plotToTreat_infos_geometryCopy = this._plotToTreat_infos_geometry;
    this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy.slice();
  }
  getTreamentSelected(plot_id, selectValue) {
    if(this._SummaryOfTheOrder.treatment.length==0){
      if (selectValue == 1) return true ;
    }
    var indx = this._SummaryOfTheOrder.treatment.map(function (e) { return e.plot_id; }).indexOf(plot_id);
    if (indx == -1 && selectValue != 1) {
      return false;
    } else if(indx == -1 && selectValue == 1){
       return true ;
    } else if (indx != -1 ){
      if (selectValue == this._SummaryOfTheOrder.treatment[indx].id_product) return true;
      else return false;
    }
  }
  updatePlotTableToTreat(plot_id) {
    var checkBox = document.getElementById('plot-ordered-' + plot_id);
    console.log((<HTMLInputElement>checkBox).checked);
    var treatmentSelected = $('#treatment-' + plot_id + " option:selected").val();
    var treatementText = $('#treatment-' + plot_id + " option:selected").text();

    if ((<HTMLInputElement>checkBox).checked) {
      this.add_plotToTreat_infos_geometry(plot_id, treatmentSelected);
    } else {
      this.remove_plotToTreat_infos_geometry(plot_id);
    }
    this._plotToTreat_infos_geometryCopy = this._plotToTreat_infos_geometry;
    this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy.slice();
  }
  add_plotToTreat_infos_geometry(plot_id, treatmentSelected) {
    for (var i = this._plot_infos_geometry.length - 1; i >= 0; i--) {
      if (this._plot_infos_geometry[i].plot_id == plot_id) {
        var obj = this._plot_infos_geometry[i];
        // obj.treatement = treatementText ;
        this._plotToTreat_infos_geometry.push(obj);
        this._SummaryOfTheOrder.plots_count++;
        this._SummaryOfTheOrder.treatment.push({ "plot_id": plot_id, "id_product": treatmentSelected });
        console.log(this._SummaryOfTheOrder.treatment);
        if (this._SummaryOfTheOrder.plots_count > 0)
          this._SummaryOfTheOrder.visibility = true;
        this._SummaryOfTheOrder.total_area += parseFloat(this._plot_infos_geometry[i].plot_area);
        if (!this.verifieExistance(this._SummaryOfTheOrder.agri_id, this._plot_infos_geometry[i].farmer_id)) {
          this._SummaryOfTheOrder.agri_id.push(this._plot_infos_geometry[i].farmer_id);
        }
        this.zoomOnFeature(plot_id);
      }
    }
  }
  remove_plotToTreat_infos_geometry(plot_id) {

    for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
      if (this._plotToTreat_infos_geometry[i].plot_id == plot_id) {

        this._SummaryOfTheOrder.total_area -= parseFloat(this._plotToTreat_infos_geometry[i].plot_area);
        this._SummaryOfTheOrder.plots_count--;

        var indx = this._SummaryOfTheOrder.treatment.map(function (e) { return e.plot_id; }).indexOf(plot_id);
        this._SummaryOfTheOrder.treatment.splice(indx, 1);
        console.log(this._SummaryOfTheOrder.treatment);
        if (this._SummaryOfTheOrder.plots_count == 0)
          this._SummaryOfTheOrder.visibility = false;
        this._plotToTreat_infos_geometry.splice(i, 1);
      }
    }
    this.removeAgriIdIfNotSelected();
  }
  removeAgriIdIfNotSelected() {
    this._SummaryOfTheOrder.agri_id = [];
    for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
      if (!this.verifieExistance(this._SummaryOfTheOrder.agri_id, this._plot_infos_geometry[i].farmer_id)) {
        this._SummaryOfTheOrder.agri_id.push(this._plot_infos_geometry[i].farmer_id);
      }
    }
  }
  processWithinAngularZone() {
    this.label = 'inside';
    this.progress = 0;
    this._increaseProgress(() => console.log('Inside Done!'));
  }
  processOutsideOfAngularZone(idOfCurentUsers) {
    this.label = 'outside';
    this.progress = 0;
    this._ngZone.runOutsideAngular(() => {
      this._increaseProgress(() => {
        this.ngOnInitAfterView();
        // reenter the Angular zone and display done
        this._ngZone.run(() => {
          //REMOVE LOADER NODE

          //REMOVE LOADER NODE
          console.log('Outside Done!');
        });
      });
    });
  }
  layerControler() {
    console.log("ffffffffffffffffffffff");
  }
  _increaseProgress(doneCallback: () => void) {
    this.progress += 1;
    this.cdRef.detectChanges();
    console.log(`Current progress: ${this.progress}%`);

    if (this.progress < 100) {
      window.setTimeout(() => this._increaseProgress(doneCallback), 10);
    } else {
      doneCallback();
    }
  }
  setFarmerIdLocalStorage(farmer_id) {
    localStorage.setItem('farmer_id', farmer_id);
  }

  loadFarmerDataPlotIfNeeded() {
    console.log(this._farmer_id);
    if (this._farmer_id) {
      this._idOfUsers = { "cooperative_id": this._idOfUsers.cooperative_id, "technician_id": this._idOfUsers.technician_id, "farmer_id": this._farmer_id, "user_type": "f","year":2020 };
    }
    this.cdRef.detectChanges();
  }

  saveFarmer() {
    this._farmer_id = parseInt(localStorage.getItem('farmer_id'));
    this._model.id_farmer = this._farmer_id;
    this.cdRef.detectChanges();
    localStorage.removeItem('farmer_id');
  }

  ngOnInit() {

  }
  ngOnInitAfterView() {

    if (this._farmer_id) {
      this._model.id_farmer = this._farmer_id;
    } else {
      this._model.id_farmer = "null";
      this.cdRef.detectChanges();
    }

    if (!localStorage.getItem('mapReference2D_3D')) {
      localStorage.setItem('mapReference2D_3D', 'EPSG:900913'); //  EPSG:900913 or EPSG:4326=2D and EPSG:4978=3D
    }
    //idOfUsers il faut initialiser la properete idOfUsers en utilisant les id d'utilisateur connecter
    // this.saveFarmer();
    this._map = new WebGLMap(
      this.mapElem.nativeElement,
      { reference: ReferenceProvider.getReference(localStorage.getItem('mapReference2D_3D')) }
    );
    var REF_EPSG900913 = ReferenceProvider.getReference("EPSG:900913"); // 2D "EPSG:900913"
    var REF_EPSG4326 = ReferenceProvider.getReference("EPSG:4326"); //
    var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); //
    // this._map = new Map( this.mapElem.nativeElement, {
    //   reference: REF_EPSG3857,
    //   includeLayerControl: false,
    //   includeBackground: false
    // });
    this._map.minMapScale = 1/110000000;
    new SampleContextMenu(this._map);
    this.addAllLayer();
    // GoogleMaps.startup(this._map);
    //Add layer controller to the application
    this.addMapLayer().then((data) => {
      console.log(data);
    }).catch((error) => {
      console.log(error);
    });
    this.activeSelectionChanged(this);
    // this.loadFarmerDataPlotIfNeeded();

    this.loadDataMap(this._idOfUsers);
    this._map.controller = new TooltipPissosHoverController();
    $(function () {
      // Toggle info panel
      $("#showinfo").click(function () {
        $('#showinfo').toggleClass('active');
        $("#infopanel").fadeToggle();
      });
    });
  }

  displayInfopanel(){
    var _obj = this ;
    if(!_obj.isClosedInfoPanel){
      _obj.isClosedInfoPanel = true ;
      $("#infopanel").css("left", -310);
    }else{
      this.isClosedInfoPanel = false ;
      $("#infopanel").css("left", 0);
    }
  }
  displayMapContainer(){
    var _obj = this ;
    if(!_obj.isClosedMapContainer){
      _obj.isClosedMapContainer = true ;
      // $("#map-main-container").css("to", -610);fadeToggle
      $("#map-main-container").fadeToggle();
    }else{
      this.isClosedMapContainer = false ;
      // $("#map-main-container").css("left", 0);
      $("#map-main-container").fadeToggle();
    }
  }
  ngAfterViewInit() {
    this.processOutsideOfAngularZone(this._idOfUsers);
  }

  reversePlotDetailListe(plot_id) {

    var idx = this._plot_infos_geometry.map(function (e) { return e.plot_id; }).indexOf(plot_id);
    this._plot_selected = this._plot_infos_geometry[idx];
    $("#plot_detail").fadeToggle();
    $("#plot_list").fadeToggle();
    this.zoomOnFeature(plot_id);
  }
  map2D_3D(ref) {
    localStorage.setItem('mapReference2D_3D', ref);
    location.reload();
  }
  onSelectionChange(coordType) {
    this._coordinateType = coordType;
    console.log(this._coordinateType);
    if (coordType == "geolocation") {
      this._coordinateTypeInput.dd = false;
      this._coordinateTypeInput.dms = false;
      this._coordinateTypeInput.geolocation = true;
    } else if (coordType == "DD") {
      this._coordinateTypeInput.dd = true;
      this._coordinateTypeInput.dms = false;
      this._coordinateTypeInput.geolocation = false;
    } else {
      this._coordinateTypeInput.dd = false;
      this._coordinateTypeInput.dms = true;
      this._coordinateTypeInput.geolocation = false;
    }
    this._localisator.selectionChanged(this._coordinateType, true);
  }

  //Centre la carte sur une adresse
  geolocalise() {
    if (this._coordinateType == "geolocation") {
      this._localisator.geolocalise(this._map.mapNavigator);
    } else {
      if (this._coordinateType == "DMS") {
        this._localisator.selectionChanged("DD", false);
      }
      this._localisator.change_navigator_view(this._map.mapNavigator, this._featureLayerRepere.model);
    }
  }

  addAllLayer() {
    var _obj = this;
    var painterContour = new ShapePainterContour();
    var painterObstacle = new ShapePainterObstacle();
    var painterNewPlot = new ShapePainterNewPlot();
    this._featureLayer = this.createFeatureLayerWithPainter("Nouvelle parcelle", painterNewPlot);
    this._featureLayerRepere = this.createFeatureLayer("Repère");

    this.createFeatureLayerWithClustering("Regroupement");

    this._featureLayerPlotsDB = this.createFeatureLayerWithPainter("Parcelles", painterContour);
    this._featureLayerObstaclesDB = this.createFeatureLayerWithPainter("Obstacles", painterObstacle);
    this._featureLayer.onCreateContextMenu = function (contextMenu, map, contextMenuInfo) {

      var feature = contextMenuInfo.objects[0];
      if (feature.properties.shapeTypePlot == "obstacle") {
        contextMenu.addItem({
          label: "Supprimmer",
          action: function () {
            var baseShape = contextMenuInfo.objects[0].shape.copy();
            contextMenuInfo.layer.model.remove(feature.id);
          }
        });
      }
    }
    this._featureLayerPlotsDB.onCreateContextMenu = function (contextMenu, map, contextMenuInfo) {
      var feature = contextMenuInfo.objects[0];
      console.log(feature);
      contextMenu.addItem({
        label: "Ajouter un obstacle",
        action: function () {
          _obj.addObstacle(feature);
          _obj._model.editOrStor = 'edit';
        }
      });
      contextMenu.addItem({
        label: "Données attributaires",
        action: function () {
          _obj.setModel(feature);
          _obj.openMyModal('effect-7');
          _obj._model.editOrStor = 'edit';
        }
      });
    }
    this._featureLayerObstaclesDB.onCreateContextMenu = function (contextMenu, map, contextMenuInfo) {
      contextMenu.addItem({
        label: "Supprimmer",
        action: function () {
          var feature = contextMenuInfo.objects[0];
          var baseShape = contextMenuInfo.objects[0].shape.copy();
          contextMenuInfo.layer.model.remove(feature.id);
        }
      });
      contextMenu.addItem({
        label: "Modifier",
        action: function () {
          var feature = contextMenuInfo.objects[0];
          var baseShape = contextMenuInfo.objects[0].shape.copy();
          map.controller = new EditController(contextMenuInfo.layer, feature, { finishOnSingleClick: true });
        }
      });
    }
    this._pissosPaiterClass = new FeaturePainter();
    this._pissosPaiterClass.cache = {};
    this._pissosPaiterClass.paintBody = function (geoCanvas, feature, shape, layer, map, state) {
      var fill = this.getIconSize(feature);
      var icon = this.cache[12]; var icon = this.cache[12];
      if (!icon || state.selected) {
        icon = IconFactory.circle({
          stroke: state.selected ? "rgba(0,0,139,0.7)" : fill,
          fill: state.selected ? "rgba(255,0,0,0.5)" : fill,
          strokeWidth: state.selected ? 3 : 2,
          width: 12,
          height: 12
        });
        // if (!state.selected) {
        //   this.cache[12] = icon;
        // }
      }
      //#endsnippet memoization
      geoCanvas.drawIcon(
        shape.focusPoint,
        {
          width: 12 + "px",
          height: 12 + "px",
          image: icon
        }
      );

    };
    this._pissosPaiterClass.getIconSize = function (feature) {
      // console.log(typeof feature.properties.perentage) ;
      if (parseFloat(feature.properties.percentage) < 2) {
        return "rgba(255,0,0)";
      } else if (parseFloat(feature.properties.percentage) > 2 && parseFloat(feature.properties.percentage) < 5) {
        return "rgba(0,0,255)";
      } else {
        return "rgba(255,255,0)";
      }
    };
    this._featureLayerPissosDB = this.createFeatureLayerWithPainter("Pissos", this._pissosPaiterClass);
    // this._featureLayerPissosDB =this.createFeatureLayer("Pissos");
    BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {

      _obj._map.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");

      console.log(data);
    });
    // console.log(BingMapsDataLoader.createLayer("AerialWithLabels")) ;
    // console.log(this._featureLayerBingMap);
    // this._map.layerTree.addChild(LayerFactory.createBackgroundLayer());
    new PanControl(this._map);
    new ZoomControl(this._map, { touch: false });
    this._map.layerTree.addChild(LayerFactory.createLonLatGridLayer());
    this._map.layerTree.addChild(this._featureLayer);
    this._map.layerTree.addChild(this._featureLayerRepere);
    this._map.layerTree.addChild(this._featureLayerPlotsDB);
    this._map.layerTree.addChild(this._featureLayerObstaclesDB);
    this._map.layerTree.addChild(this._featureLayerAccessPointDB);
    this._map.layerTree.addChild(this._featureLayerPissosDB);
    // this._map.layerTree.addChild(this._featureLayerBingMap);
  }

  //--------UI----------
  slideToggleContent(plotDivDescription) {
    $('#' + plotDivDescription + '-content').slideToggle(500, function () {
    });
  }
  //--------UI----------
  setLoadPlotsYear(){
    this.removeAllShapesForAllLayers();
    this.loadDataMap(this._idOfUsers);
  }
  loadDataMap(idOfCurentUsers) {
    var obj = this;
    this._localisator = new Localisator();
    this._plotDataLoader = new PlotDataLoader(this._map,
      this.httpService,
      this._featureLayerPlotsDB,
      this._featureLayerObstaclesDB,
      this._featureLayerAccessPointDB,
      this._featureLayerPissosDB,
      this._plot_infos_geometry);
    this._plotDataLoader.getAndPrintDataPlotFromDB(idOfCurentUsers).then((data) => {
      obj._plot_infos_geometry = data;
      obj._plot_infos_geometryCopy = data;
      this.getGlobalProgress();
      setTimeout(function () {
        var node = document.getElementById("loader");
        if (node) {
          if (node.parentNode) {
            node.parentNode.removeChild(node);
          }
        }
      }, 1000);
    });
  }
  addMapLayer(): Promise<any> {
    var promise = new Promise((resolve, reject) => {
      if (new LayerTreeControl(this._map, { domId: "controlcontainer", title: "CALQUES" })) {
        resolve("hello i'm the promise result");
      } else {
        reject("I'm bad response of the promise");
      }
    });
    return promise;
  }

  openMyModal(event) {
    console.log(this._model.id_farmer);
    document.querySelector("#" + event).classList.add('md-show');
  }

  closeMyModalByDivId(event) {
    document.querySelector("#" + event).classList.remove('md-show');
  }

  closeMyModal(event) {
    ((event.target.parentElement.parentElement).parentElement).classList.remove('md-show');
  }
  addBalloonForm(oo) { }

  deletePlotFromDB(plot_id) {
    // this._idOfUsersJSON_current.f= this._model.id_farmer ;
    // this.updateDataMap(JSON.stringify(this._idOfUsersJSON_current) );
    var del;
    var _obj = this;
    Promise.resolve().then(function () {
      del = _obj.deleteSwal(_obj._idOfUsers, plot_id);
    }).then(function () {
      // _obj._featureLayerAccessPointDB.model.on("ModelChanged", function(event) {
      // if(_obj._idOfUsersJSON_current){
      //    _obj.updateDataMap(JSON.stringify(this._idOfUsersJSON_current)); //chargement des donnés avec le filtrage
      //  }else{
      //   _obj.resetDataMap();//chargement des donnés sans le filtrage
      //  }
      // });
    });
  }

  search(): void {

    if (this.searchTerm == "") {
      this._plot_infos_geometry = this._plot_infos_geometryCopy;
    } else {
      let term = (this.searchTerm.toLowerCase());
      console.log(term);

      this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function (tag) {
        if (tag.plot_name != null) {
          if ((tag.plot_name.toLowerCase()).indexOf(term) >= 0) { return tag.plot_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_adherent != null) {
          if ((tag.cooperative_adherent.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_adherent.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_city != null) {
          if ((tag.cooperative_city.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_city.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.cooperative_country != null) {
          if ((tag.cooperative_country.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_country.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_email != null) {
          if ((tag.farmer_email.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_email.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_first_name != null) {
          if ((tag.farmer_first_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_first_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_name != null) {
          if ((tag.farmer_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.farmer_phone != null) {
          if ((tag.farmer_phone.toLowerCase()).toString().indexOf(term) >= 0) { return tag.farmer_phone.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.plot_comment != null) {
          if ((tag.plot_comment.toLowerCase()).toString().indexOf(term) >= 0) { return tag.plot_comment.toLowerCase().indexOf(term) >= 0; }
        }
      });
      console.log(this._plot_infos_geometry);
    }
    if (this.searchId_farmer != "null" && this.searchId_farmer != "null") {
      this.searchPlotByFarmerId();
    }
  }
  searchPlotByFarmerId() {
    var _obj = this;
    var _plot_infos_geometryCopy = this._plot_infos_geometry;
    this._plot_infos_geometry = _plot_infos_geometryCopy.filter(function (tag) {
      if (tag.farmer_id == _obj.searchId_farmer) { return true; }
    });
  }
  searchFarmer(): void {
    console.log(this.searchFarmerTerm);
    console.log(this._usersFarmerByIdTech);

    if (this.searchFarmerTerm == "") {
      this._usersFarmerByIdTech = this._usersFarmerByIdTechCopy;
    } else {
      let term = (this.searchFarmerTerm.toLowerCase());

      this._usersFarmerByIdTech = this._usersFarmerByIdTechCopy.filter(function (tag) {
        if (tag.name != null) {
          if ((tag.name.toLowerCase()).indexOf(term) >= 0) { return tag.name.toLowerCase().indexOf(term) >= 0; }
        }
        if (tag.first_name != null) {
          if ((tag.first_name.toLowerCase()).indexOf(term) >= 0) { return tag.first_name.toLowerCase().indexOf(term) >= 0; }
        }
        // if (tag.cooperative_adherent != null) {
        //   if ((tag.cooperative_adherent.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_adherent.toLowerCase().indexOf(term) >= 0; }
        // }
        // if (tag.cooperative_city != null) {
        //   if ((tag.cooperative_city.toLowerCase()).toString().indexOf(term) >= 0) { return tag.cooperative_city.toLowerCase().indexOf(term) >= 0; }
        // }
      });
    }
  }

  deleteSwal(idOfCurentUser, plot_id) {

    console.log(idOfCurentUser);
    var functionToCall;
    // if(idOfCurentUser.user_type=="admin") functionToCall = 'getPlotByAdmin';
    // if(idOfCurentUser.user_type=="c") functionToCall = 'getPlotByCooperative';
    // if(idOfCurentUser.user_type=="a") functionToCall = 'getPlotByAdherent';
    // if(idOfCurentUser.user_type=="t") functionToCall = 'getPlotByTechnician';
    // if(idOfCurentUser.user_type=="f") functionToCall = 'getPlotByFarmer';
    var req = { "plot_id": plot_id };
    var _obj = this;
    swal({
      title: 'Êtes-vous sûr?',
      text: "Souhaitez-vous supprimer définitivement cette parcelle ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Supprimer !',
      cancelButtonText: 'Non, Annuler !',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      // alert('lahcen ya rbi tkhdam');
      _obj.httpService.httpPostPromise("deleteplot", req)
        .then((plot_infos_geometry) => {
          swal(
            'Supprimée!',
            'Votre parcelle a été supprimée.',
            'success'
          )

          _obj._plotDataLoader.removeAll();
          if (_obj._idOfUsersJSON_current) {
            _obj.updateDataMap(JSON.stringify(_obj._idOfUsersJSON_current)); //chargement des donnés avec le filtrage
          } else {
            _obj.resetDataMap();//chargement des donnés sans le filtrage
          }
        }, (error) => {
          swal(
            'Annulé !',
            'Votre parcelle n\'a été supprimée,réessayez ultérieurement !',
            'error'
          )
          console.log(error);
        });

    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
          'Annulé',
          'Votre parcelle n\'a pas été supprimée :)',
          'error'
        )
      }
    }).catch(swal.noop);

  }
  zoomToExtend() {
    if ((this._featureLayerPlotsDB.model.store._data.length > 0)) {
      this._map.mapNavigator.fit({ bounds: this._featureLayerPlotsDB.bounds, animate: true });
    } else {
      var crs84 = ReferenceProvider.getReference("CRS:84");
      var _tempModelPoint = ShapeFactory.createPoint(crs84, [2.68, 46.20]);
      var _tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
      var _tempMapPoint = ShapeFactory.createPoint(this._map.reference, [0, 0]);
      var _transformation = TransformationFactory.createTransformation(crs84, this._map.reference);
      _transformation.transform(_tempModelPoint, _tempMapPoint);
      this._map.mapToViewTransformation.transform(_tempMapPoint, _tempViewPoint);
      this._map.mapNavigator.pan({ targetLocation: _tempViewPoint, animate: { duration: 300 } })
        .then(data => {
          this._map.mapNavigator.zoom({
            targetScale: { x: 1 / 11000000, y: 1 / 11000000 },
            animate: true
          });
        });


    }
  }

  zoomOnFeature(plot_id) {
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        var shape_id_poly = this._featureLayerPlotsDB.model.store._data[i].id;
        console.log(this._featureLayerPlotsDB.model.store);
        this._map.mapNavigator.fit(this._featureLayerPlotsDB.model.get(shape_id_poly).shape.bounds);

        // this._map.showBalloon({
        //   panTo: true,
        //   layer: this._featureLayerPlotsDB,
        //   object: this._featureLayerPlotsDB.model.get(shape_id_poly),
        //   contentProvider: function(o){
        //     return "You've selected object with id: " + o.id;
        //   }
        // });
      }
    }
    this.scrolToMap();
  }
  scrolToMap() {
    $('html,body').animate({
      scrollTop: 1 != $("#scroll-tab-2").height() ? $("#scroll-tab-2").height() - 300 : -300
    }, 300);
  }
  editControllerPlot(plot_id) {
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        var feature = this._featureLayerPlotsDB.model.store._data[i];
        var shape_id_poly = this._featureLayerPlotsDB.model.store._data[i].id;
        console.log(this._featureLayerPlotsDB.model.store);
        this._map.mapNavigator.fit(this._featureLayerPlotsDB.model.get(shape_id_poly).shape.bounds).then((data) => {
          console.log(this._featureLayerPlotsDB.model.store._data[i]);
          this._map.controller = new EditController(this._featureLayerPlotsDB, feature, { finishOnSingleClick: true });
        });
      }
    }
  }
  updatePlot() {
    var validate = this._modelValidate();
    var plot_id = null;
    if (validate) {
      var plot_id = this._model.plot_id;
      var obstacles = [];
      for (var i = this._featureLayerObstaclesDB.model.store._data.length - 1; i >= 0; i--) {
        if (this._featureLayerObstaclesDB.model.store._data[i].properties.plot_id == plot_id) {
          obstacles.push(this._featureLayerObstaclesDB.model.store._data[i]);
        }
      }
      for (var i = this._featureLayer.model.store._data.length - 1; i >= 0; i--) {
        if (this._featureLayer.model.store._data[i].properties.plot_id == plot_id) {
          obstacles.push(this._featureLayer.model.store._data[i]);

          var newObstacleFeature = new Feature(this._featureLayer.model.store._data[i]._shape);
          newObstacleFeature.properties = this._featureLayer.model.store._data[i].properties;
          this._featureLayerObstaclesDB.model.add(newObstacleFeature);
          this._featureLayer.model.remove(this._featureLayer.model.store._data[i].id);
        }
      }
      for (var i = this._featureLayer.model.store._data.length - 1; i >= 0; i--) {
        if (this._featureLayer.model.store._data[i].properties.plot_id == plot_id) {
          this._featureLayer.model.remove(this._featureLayer.model.store._data[i].id);
        }
      }

      var getObstaclesGeom = this.getObstaclesGeom(obstacles); // return string POLYGON(((),()...)) using features table
      var poly = this.getPlotGeom(plot_id);
      var accessPoint = this.getAccessPointGeom(plot_id);

      var idx = this._plot_infos_geometry.map(function (e) { return e.plot_id; }).indexOf(plot_id);
      this._model_plot_update.geom = poly;
      this._model_plot_update.accesspoint = accessPoint;
      this._model_plot_update.obstacles = getObstaclesGeom; // _plot_infos_geometry
      this._model_plot_update.name = this._model.name;
      this._model_plot_update.comment = this._model.comment;
      this._model_plot_update.electricline = this._model.electricline;
      this._model_plot_update.plot_irrigation = this._model.irrigationsystem;
      this._model_plot_update.id_farmer = this._model.id_farmer;
      this._model_plot_update.plot_id = this._model.plot_id;

      this.httpService.httpPostPromise('updateplot', this._model_plot_update)
        .then((data) => {
          console.log(data);
          this.addNotify({ title: 'Modification d\'une parcelle', msg: 'La parcelle a été modéfiée avec succes :)', type: 'success' });
          this.closeMyModalByDivId('effect-7');
        }, (error) => {
          console.error(error);
          this.addNotify({ title: 'Modification d\'une parcelle', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
        });
      console.log(this._model_plot_update);
    }
  }
  addObstacle(feature) {
    var properties = feature.properties;
    properties.shapeTypePlot = 'obstacle';
    var shapeType = ShapeType.POLYGON;
    this._map.selectObjects([]);
    var createController = new BasicCreateController(shapeType, properties);
    var _obj = this;
    createController.onChooseLayer = function (map) {
      return _obj._featureLayer;
    }
    createController.onObjectCreated = function (oo, aLayer, aObject) {
      console.log(aObject);
      BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
      console.log(this);
    };

    this._map.controller = createController;
  }
  getAccessPointGeom(plot_id) {
    var accessPoint = 'POINT(';
    var feature = null;
    for (var i = this._featureLayerAccessPointDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerAccessPointDB.model.store._data[i].properties.plot_id == plot_id) {
        feature = this._featureLayerAccessPointDB.model.store._data[i];
      }
    }
    accessPoint += feature.geometry[0] + ' ' + feature.geometry[1] + ')';
    return accessPoint;
  }
  getPlotGeom(plot_id) {
    var feature = null;
    var poly = 'POLYGON((';
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        feature = this._featureLayerPlotsDB.model.store._data[i];
      }
    }

    for (var j = 0; j < feature.geometry.coordinates[0].length; j++) {
      poly += feature.geometry.coordinates[0][j][0] + ' ' + feature.geometry.coordinates[0][j][1] + ' ' + feature.geometry.coordinates[0][j][2] + ',';
    }
    poly += feature.geometry.coordinates[0][0][0] + ' ' + feature.geometry.coordinates[0][0][1] + ' ' + feature.geometry.coordinates[0][0][2] + '))';

    return poly;
  }
  getObstaclesGeom(obstacles) {
    if (obstacles.length == 0) return "";
    var obstaclesCoord = 'POLYGON((';
    for (var i = 0; i < obstacles.length; i++) {
      if (i != obstacles.length - 1) {

        for (var j = 0; j < obstacles[i].geometry.coordinates[0].length; j++) {
          obstaclesCoord += obstacles[i].geometry.coordinates[0][j][0] + ' ' + obstacles[i].geometry.coordinates[0][j][1] + ' ' + obstacles[i].geometry.coordinates[0][j][2] + ',';
        }
        obstaclesCoord += obstacles[i].geometry.coordinates[0][0][0] + ' ' + obstacles[i].geometry.coordinates[0][0][1] + ' ' + obstacles[i].geometry.coordinates[0][0][2] + '),(';
      } else {

        for (var j = 0; j < obstacles[i].geometry.coordinates[0].length; j++) {
          obstaclesCoord += obstacles[i].geometry.coordinates[0][j][0] + ' ' + obstacles[i].geometry.coordinates[0][j][1] + ' ' + obstacles[i].geometry.coordinates[0][j][2] + ',';
        }
        obstaclesCoord += obstacles[i].geometry.coordinates[0][0][0] + ' ' + obstacles[i].geometry.coordinates[0][0][1] + ' ' + obstacles[i].geometry.coordinates[0][0][2] + '))';
      }
    }
    return obstaclesCoord;
  }

  downloadMissionPlaner(plot_id) {
    this.httpService.httpPostPromise('exportMissionPlanner', { plot_id: parseInt(plot_id) })
      .then((data) => {
        console.log(data.pathname);
        this.download_plot_file(data.pathname);
      }
        , (error) => {
          console.error(error);
          this.addNotify({ title: 'Echec du téléchargement', type: 'error' });
        });
  }

  download_plot_file(path) {
    return this.http
      .get('assets/data/missionPlanner_2018/' + path, {
        //.get('assets/../../dist/asssets/data/missionPlanner_2018/'+path, {
        //.get('../dist/assets/data/missionPlanner_2018/'+path, {
        responseType: ResponseContentType.Blob
        // search: // query string if have
      })
      .map(res => {
        return {
          filename: path,
          data: res.blob()
        };
      })
      .subscribe(res => {
        console.log('start download:', res);
        var url = window.URL.createObjectURL(res.data);
        var a = document.createElement('a');
        document.body.appendChild(a);
        a.setAttribute('style', 'display: none');
        a.href = url;
        a.download = res.filename;
        a.click();
        window.URL.revokeObjectURL(url);
        a.remove(); // remove the element
      }, error => {
        console.log('download error:', JSON.stringify(error));
      }, () => {
        console.log('Completed file download.')
      });
  }
  //-------------------Form controler-------------------------
  _modelValidate() {
    var _obj = this;
    var validate = false;
    if (_obj._model.id_farmer == "null") {
      _obj._errorInputs.id_farmer = true;
      console.log(_obj._errorInputs.id_farmer);
      console.log(_obj._model.id_farmer);
    } else {

      _obj._errorInputs.id_farmer = false;
      console.log(_obj._model.id_farmer);
      console.log(_obj._errorInputs.id_farmer);
    }

    if (!_obj._model.name) {
      _obj._errorInputs.name = true;
    } else {
      _obj._errorInputs.name = false;
    }
    // if(!_obj._model.comment);
    if (!_obj._model.electricline) {
      _obj._errorInputs.electricline = true;
    } else {
      _obj._errorInputs.electricline = false;
    }

    if (!_obj._model.irrigationsystem) {
      _obj._errorInputs.irrigationsystem = true;
    } else {
      _obj._errorInputs.irrigationsystem = false;
    }

    if (_obj._model.id_farmer == "null" || !_obj._model.name || !_obj._model.electricline || !_obj._model.irrigationsystem) {
      validate = false;
    } else {
      validate = true;
    }
    return validate;
  }
  // creeate and update a plot
  addBalloonElementSubmiteListner(action) {
    this._model.editOrStor = 'stor';
    var _obj = this;
    var validate = false;
    validate = this._modelValidate();

    if (validate) {

      _obj._model.id_farmer = _obj._model.id_farmer;
      _obj._model.name = _obj._model.name;
      _obj._model.comment = _obj._model.comment;
      _obj._model.electricline = _obj._model.electricline; // document.getElementById("myCheck").checked
      _obj._model.irrigationsystem = _obj._model.irrigationsystem;

      var plotGeometry = _obj._featureLayer.workingSet.get();
      var poly = 'POLYGON((';
      var accessPoint = 'POINT(';
      var obstacles = null;
      if (plotGeometry.length > 2) obstacles = 'POLYGON((';
      for (var i = 0; i < plotGeometry.length; i++) {
        if (i == 0) {
          for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
            poly += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
          }
          poly += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '))';
        } else if (i == 1) {

          accessPoint += plotGeometry[i].geometry[0] + ' ' + plotGeometry[i].geometry[1] + ')';

        } else {
          if (i != plotGeometry.length - 1) {

            for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
              obstacles += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
            }
            obstacles += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '),(';
          } else {

            for (var j = 0; j < plotGeometry[i].geometry.coordinates[0].length; j++) {
              obstacles += plotGeometry[i].geometry.coordinates[0][j][0] + ' ' + plotGeometry[i].geometry.coordinates[0][j][1] + ' ' + plotGeometry[i].geometry.coordinates[0][j][2] + ',';
            }
            obstacles += plotGeometry[i].geometry.coordinates[0][0][0] + ' ' + plotGeometry[i].geometry.coordinates[0][0][1] + ' ' + plotGeometry[i].geometry.coordinates[0][0][2] + '))';
          }
        }

      }
      _obj._model.geom = poly;
      _obj._model.accesspoint = accessPoint;
      _obj._model.obstacles = obstacles;

      _obj.onSubmit(_obj._model, action);

    }
  }
  activePanel(panelId) {

    if (panelId == "scroll-tab-2" || panelId == "scroll-tab-3" || panelId == "scroll-tab-4") {
      $(".tab-pane").removeClass("active in");
      $("[data-toggle='pill']").removeClass('is-active'); // fill of icon

      $("#scroll-tab-2").addClass('active in');
      $("#" + panelId + "-tab").addClass('is-active');
      if (panelId == "scroll-tab-2") {
        $(".asy-titel__tab").css("display", "none");
        $(".text-right-under-map").css("display", "none");

        $("#asy-barre-stat-new-order").css("display", "none");
        $("#asy-add-order-recap").css("display", "none");

        $("#plot_filter").css("display", "block");
        $("#asy-add-order-treatments").css("display", "block");

        $("#scroll-tab-3-tab").removeClass("active-pointer-events");
        $("#scroll-tab-4-tab").removeClass("active-pointer-events");

        $("#btnDisplayMap").removeClass('asy-display-block');
        $("#btnDisplayMap").addClass('asy-display-none');

        if(this.isClosedMapContainer){
          this.displayMapContainer();
        }


      } else if (panelId == "scroll-tab-3") {
        $(".asy-titel__tab").css("display", "none");
        $(".text-right-under-map").css("display", "none");

        $("#asy-add-order-treatments").css("display", "none");
        $("#plot_filter").css("display", "none");
        $("#asy-barre-stat-new-order").css("display", "flex");
        $("#asy-add-order-recap").css("display", "block");

        $("#btnDisplayMap").removeClass('asy-display-none');
        $("#btnDisplayMap").addClass('asy-display-block');

        $("#scroll-tab-4-tab").removeClass("active-pointer-events");
      } else if (panelId == "scroll-tab-4") {

      }
    } else {
      $(".tab-pane").removeClass("active in");
      $("[data-toggle='pill']").removeClass('is-active'); // fill of icon

      $("#" + panelId).addClass('active in');
      $("#" + panelId + "-tab").addClass('is-active');

      $("#asy-add-order-treatments").css("display", "none");
      $("#plot_filter").css("display", "none");
      $("#asy-barre-stat-new-order").css("display", "none");
      $("#asy-add-order-recap").css("display", "none");

      $("#scroll-tab-2-tab").removeClass("active-pointer-events");
      $("#scroll-tab-3-tab").removeClass("active-pointer-events");
      $("#scroll-tab-4-tab").removeClass("active-pointer-events");
      // if (panelId == "scroll-tab-1") {
      //   $(".asy-titel__tab").css("display", "none");
      // }
    }
  }
  updateModel_id_farmer(farmer_id) {
    this._model.id_farmer = farmer_id;
    this._model.farmer = this._usersFarmerByIdTechCopy.filter(function (tag) {
      if (tag.id != null) {
        if (tag.id == farmer_id) { return true; }
      }
    });
    this._model.farmer = this._model.farmer[0];
    console.log(this._model.farmer);
    $("#asy-agri-selected").css("display", "block");
  }

  submitOrder() {
    this.orderId = {
      order_id : null ,
      state : null,
    }
    var data = {
      "id_technician": this._currentUserInfos.tchnicians_id,
      "treatments": this._SummaryOfTheOrder.treatment
    };
    console.log(this._plotToTreat_infos_geometry);
    this.httpService.httpPostPromise('storeorder', data)
      .then((data) => {
        this.orderId = data;
        this.openMyModal("effect-20-validate-order");
        this.activePanel('scroll-tab-2');
        this._plotToTreat_infos_geometry = [];
        this._SummaryOfTheOrder.treatment = [];
        this._SummaryOfTheOrder.plots_count = 0;
        this._SummaryOfTheOrder.total_area = 0;
        this._SummaryOfTheOrder.agri_id = [];
        this._plotToTreat_infos_geometry = [];
        this.resetDataMap();
        $("#validateOrderRecapBtn").removeClass('asy-disabled');
      }, (error) => {
        $("#validateOrderRecapBtn").removeClass('asy-disabled');
        console.log(error);
      });
  }
  openSuccessSwal() {
    swal({
      title: 'Bon travail!',
      text: 'Le traitement à été bien sauvegarder, Votre commande sera traitée dans les plus brefs délais par l\'admin!',
      type: 'success'
    }).catch(swal.noop);
  }
  restartCreatePlotGeomAPObstacle(action) {

    var sizeWSet = this._featureLayer.workingSet.get().length;
    console.log(this._newPlot_AcessPoint_Obstacles_features);
    this._newPlot_AcessPoint_Obstacles_features = this._featureLayer.workingSet.get();

    if (action == "plot") {
      for (var i = 0; i < sizeWSet; i++) {
        this._featureLayer.workingSet.remove(this._newPlot_AcessPoint_Obstacles_features[i].id);
      }
      if (sizeWSet <= 1) {
        this._polt = 1;
        this._newPlot_AcessPoint_Obstacles_features = [];
        this.linkCreateButton('createpolygon');
      } else if (sizeWSet >= 2) {
        this._polt = 1;
        this.linkCreateButton('createpolygon');
      }
      $("#scroll-tab-4-tab").removeClass("active-pointer-events");
      $("#scroll-tab-5-tab").removeClass("active-pointer-events");
      $("#scroll-tab-6-tab").removeClass("active-pointer-events");
      $("#scroll-tab-7-tab").removeClass("active-pointer-events");
    } else if (action == "accessPoint") {
      if (sizeWSet <= 1) {
        this._polt = 1;
        this.linkCreateButton('createpoint');
      } else if (sizeWSet >= 2) {
        for (var i = 0; i < sizeWSet; i++) {
          this._featureLayer.workingSet.remove(this._newPlot_AcessPoint_Obstacles_features[i].id);
        }
        this._polt = 2;
        this._featureLayer.model.add(this._newPlot_AcessPoint_Obstacles_features[0])
        this.linkCreateButton('createpoint');
      }
      $("#scroll-tab-5-tab").removeClass("active-pointer-events");
      $("#scroll-tab-6-tab").removeClass("active-pointer-events");
      $("#scroll-tab-7-tab").removeClass("active-pointer-events");
    }

    console.log(this._newPlot_AcessPoint_Obstacles_features);
    this._map.hideBalloon();
  }
  removeObstcle() {
    this.addNotify({ title: 'Ajout d\'une parcelle', msg: 'Veuillez faire un clic droit avec la souris sur l\'obstacle en question!', type: 'info' });
  }
  addAccessPointIfExist() {
    if (this._newPlot_AcessPoint_Obstacles_features.length >= 2) {
      this._featureLayer.model.add(this._newPlot_AcessPoint_Obstacles_features[1]);
    }
  }

  validateOrderAttribut() {
    // var validate = false;
    // validate = this._modelValidate();
    if (true) {
      this.activePanel("scroll-tab-2");
      $("#scroll-tab-2-tab").addClass('active-pointer-events');
    }
  }
  validateOrderTreatment() {
    if (this._SummaryOfTheOrder.treatment.length < 1) {
      this.addNotify({ title: 'Création d\'une commande', msg: 'Vous devez sélectioner une ou pleursiers parcelles :(', type: 'error' });
    } else {
      this.activePanel("scroll-tab-3");
      $("#scroll-tab-3-tab").addClass('active-pointer-events');

      this.displayMapContainer();
      this.scrolToMap();
    }
  }
  validateOrderRecap() {

    $("#validateOrderRecapBtn").addClass('asy-disabled');

    if (this._SummaryOfTheOrder.treatment.length < 1) {
      this.addNotify({ title: 'Création d\'une commande', msg: 'Vous devez sélectioner une ou pleursiers parcelles :(', type: 'error' });
      $("#validateOrderRecapBtn").removeClass('asy-disabled');
    } else {
      this.submitOrder();
    }
  }
  addNewObstacl() {
    this.linkCreateButton('createpolygon');
  }
  addNewPlot(action) {

    if (action == "cancel") {
      $("#asy-breadcrumb-add-plot").css("display", "none");
      $(".tab-pane").removeClass("active in");
      $("#scroll-tab-3").addClass('active in');
      $(".asy-titel__tab").css("display", "none");
      $(".text-center-under-map").css("display", "none");
      $("#infopanelLocalisator").css("display", "none");

      $("#cancelNewPlot").css("display", "none");
      $("#addNewPlot").css("display", "block");

      $("#asy-agri-selected").css("display", "none");

      $("#scroll-tab-2-tab").removeClass("active-pointer-events");
      $("#scroll-tab-3-tab").removeClass("active-pointer-events");
      $("#scroll-tab-4-tab").removeClass("active-pointer-events");
      $("#scroll-tab-5-tab").removeClass("active-pointer-events");
      $("#scroll-tab-6-tab").removeClass("active-pointer-events");
      $("#scroll-tab-7-tab").removeClass("active-pointer-events");
      this.reset_polt();
      this.resetModel(false);
      this._map.mapNavigator.fit({ bounds: this._featureLayerPlotsDB.bounds, animate: true });
    } else if (action = "add") {
      $("#asy-breadcrumb-add-plot").css("display", "block");
      $(".tab-pane").removeClass("active in");

      $("#cancelNewPlot").css("display", "block");
      $("#addNewPlot").css("display", "none");
    }

  }
  // creeate and update a plot

  onSubmit(parcelleDatas, action) { // VERIFICATION
    this.httpService.httpPostPromise('storeplot', parcelleDatas)
      .then((data) => {
        this.addNotify({ title: 'Ajout d\'une parcelle', msg: 'La parcelle a été créée avec succes :)', type: 'success' });
        if (action == "seeTheList") this.addNewPlot('cancel');
        if (action == "addNewPlot") this.addNewPlot('add');
        this.reset_polt();
        this.resetModel(false);
        this.closeMyModalByDivId('effect-7');
        if (this._idOfUsersJSON_current) {
          this._idOfUsersJSON_current.f = this._model.id_farmer;
          this.updateDataMap(JSON.stringify(this._idOfUsersJSON_current));
        } else {
          this.resetDataMap();
        }
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Ajout d\'une parcelle', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });
  }

  setModel(feature) {
    this._model.id_farmer = feature.properties.farmer_id;
    this._model.name = feature.properties.plot_name;
    this._model.irrigationsystem = feature.properties.plot_irrigation; // A modifier
    this._model.electricline = feature.properties.plot_power_line;
    this._model.comment = feature.properties.plot_comment;
    this._model.plot_id = feature.properties.plot_id;
    console.log(this._model);
  }
  resetModel(saveId_farmer) {
    var id_farmer = this._model.id_farmer;
    this._model = {
      client_id: 2,
      client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
      id_farmer: null,
      name: '',
      comment: '',
      electricline: '',
      irrigationsystem: '',
      geom: {},
      accesspoint: {},
      obstacles: {},
      plot_id: null,
      editOrStor: 'stor',
      farmer: [],
    };
    if (saveId_farmer) this._model.id_farmer = id_farmer;
  }
  //-------------------End Form controler-------------------------
  activeSelectionChanged(o): void {
    o._map.on("SelectionChanged", function (event) {
      // console.log(o._map);
      var selected = o._fetchSelectedObject(o._map);
      console.log(selected);
      if (selected) {
        o._map.controller = new EditController(selected.layer, selected.feature, { finishOnSingleClick: true });
      }
      // updateTextFieldsFromExtrusion();
    });

    o._map.on("ShowBalloon", function (event) {

      var balloon = document.getElementsByClassName('lcdBalloon')[0];
      console.log((<HTMLElement>balloon).offsetWidth);
      console.log((<HTMLElement>balloon).offsetHeight);
      console.log("x = " + o._map.viewSize[0] + "--Y = " + o._map.viewSize[1]);
      $("#detailTreatment").click(function () {
        o.openMyModal("effect-20");
      });
    });
  }

  linkCreateButton(domId): void {
    var cnf = false;
    if (domId == 'createpoint') var shapeType = ShapeType.POINT;
    else if (domId == 'createpolygon') {
      var shapeType = ShapeType.POLYGON;
      if (this._model.editOrStor == "edit") {
        cnf = confirm("Pensez a sauvegarder les modifications avant d'ajouter une nouvele parcelle!");
        if (!cnf) {
          this.reset_polt();
          this._model.editOrStor = "stor";
        }
      }
    }
    if (!cnf) {
      this._map.selectObjects([]);
      //#snippet controller
      var createController;
      if (shapeType == ShapeType.POINT) {
        console.log("shape type = point");
        createController = new BasicCreateController(shapeType, { shapeTypePlot: 'accessPoint' });
      } else {
        console.log("shape type = polygon");
        if (this._featureLayer.workingSet.get().length == 0) {
          createController = new BasicCreateController(shapeType, { shapeTypePlot: 'contour' });
        } else {
          createController = new BasicCreateController(shapeType, { shapeTypePlot: 'obstacle' });
        }
      }
      // var createController = new BasicCreateController(shapeType, {}, {finishOnSingleClick: true});
      //#endsnippet controller
      var _obj = this;
      createController.onChooseLayer = function (map) {
        return _obj._featureLayer;
      }
      createController.onObjectCreated = function (oo, aLayer, aObject) {
        console.log(aObject);
        BasicCreateController.prototype.onObjectCreated.apply(this, arguments);
        if (_obj._polt == 1) {
          if (_obj._newPlot_AcessPoint_Obstacles_features.length > 1) {
            for (var i = 1; i < _obj._newPlot_AcessPoint_Obstacles_features.length; i++) {
              _obj._featureLayer.model.add(_obj._newPlot_AcessPoint_Obstacles_features[i])
            }
          }
        } else if (_obj._polt == 2) {
          if (_obj._newPlot_AcessPoint_Obstacles_features.length > 2) {
            for (var i = 2; i < _obj._newPlot_AcessPoint_Obstacles_features.length; i++) {
              _obj._featureLayer.model.add(_obj._newPlot_AcessPoint_Obstacles_features[i])
            }
          }
        }
        _obj._newPlot_AcessPoint_Obstacles_features = [];
        _obj._polt++;
      };

      this._map.controller = createController;
    }
  }

  reset_polt() {

    var sizeWSet = this._featureLayer.workingSet.get().length;
    var features = this._featureLayer.workingSet.get();
    console.log(features);
    for (var i = 0; i < sizeWSet; i++) {
      this._featureLayer.workingSet.remove(features[i].id);
    }
    this._map.hideBalloon();
    this._polt = 1;
    this._map.controller = null;
  }

  _fetchSelectedObject(map) {
    var objects = map.selectedObjects;
    // console.log(objects);
    for (var idx = 0; idx < objects.length; idx++) {
      if (objects[idx].selected.length > 0 && objects[idx].layer.editable) {
        return {
          layer: objects[idx].layer,
          feature: objects[idx].selected[0]
        };
      }
    }
  }

  createFeatureLayer(label) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: true,
      label: label
    });
  }

  createFeatureLayerWithPainter(label, shapePainter) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: true,
      label: label,
      painter: shapePainter
    });
  }


  verifieExistance(tabId, id) {
    var val = 0;
    for (var i = 0; i < tabId.length; i++) {
      if (tabId[i] == id) { return 1; }
    }
    return val;
  }

  updateDataMap(idOfUsers) {

    this._idOfUsersJSON_current = JSON.parse(idOfUsers);
    this.setIdOfUsers(this._idOfUsersJSON_current);  // set this._idOfUsers

    this.removeAllShapesForAllLayers();
    //this.removeAllLayer();
    //this.addAllLayer();
    this.loadFarmerDataPlotIfNeeded();
    this.loadDataMap(this._idOfUsers);

  }
  getToFixed(tagString) {
    return tagString.toFixed(2).toString();
  }
  resetDataMap() {
    this.setIdOfUsersUsigLocalSorage();
    this.removeAllShapesForAllLayers();
    // this.removeAllLayer();
    //this.addAllLayer();
    this.loadFarmerDataPlotIfNeeded();
    this.loadDataMap(this._idOfUsers);
  }

  getAllUsersFarmersByIdTech() {

    this.httpService.httpPostPromise('getAllUsersFarmersByIdTech', { id_technician: this._currentUserInfos.tchnicians_id })
      .then((data) => {
        this._usersFarmerByIdTech = data;
        this._usersFarmerByIdTechCopy = data;
        console.log(this._usersFarmerByIdTech);
        // alert('yes yes yes yes ');
      }, (error) => {
        // this.addNotify({title:'Arbre des coopératives', msg: 'problème vient de serveur ! rafraichir la page :(', type:'error'});
      });
  }

  setIdOfUsersUsigLocalSorage() {
    this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));


    switch (this._currentUserInfos.right) {
      case 1:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "a";
        break;
      case 2:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "c";

        break;
      case 3:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "t";
        break;
      case 4:
        this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
        this._idOfUsers.user_type = "f";

        break;
      // case '5':
      //         this._idOfUsers.cooperative_id = 0;
      //         this._idOfUsers.adherent_id = 0 ;
      //         this._idOfUsers.technician_id = 0 ;
      //         this._idOfUsers.farmer_id = 0 ;
      //         this._idOfUsers.user_type = "p"  ;

      //     break;
    }
  }

  setIdOfUsers(idOfUsersJSON) {
    this._idOfUsers.cooperative_id = idOfUsersJSON.c
    // this._idOfUsers.adherent_id = idOfUsersJSON.a ;
    this._idOfUsers.technician_id = idOfUsersJSON.t;
    this._idOfUsers.farmer_id = idOfUsersJSON.f;
    this._idOfUsers.user_type = idOfUsersJSON.s;
  }
  getGlobalProgress() {
    this._globalStatistic.plots_count = this._plot_infos_geometry.length;
    for (var i = 0; i < this._globalStatistic.plots_count; i++) {
      this._globalStatistic.count_total_treatment += this._plot_infos_geometry[i].treatment.length;
      this._globalStatistic.plot_area += parseFloat(this._plot_infos_geometry[i].plot_area);
      if (!this.verifieExistance(this._globalStatistic.tabIdFarmer, this._plot_infos_geometry[i].farmer_id)) {
        this._globalStatistic.tabIdFarmer.push(this._plot_infos_geometry[i].farmer_id);
      }
      if (!this.verifieExistance(this._globalStatistic.tabIdTech, this._plot_infos_geometry[i].technician_id)) {
        this._globalStatistic.tabIdTech.push(this._plot_infos_geometry[i].technician_id);
      }
      if (!this.verifieExistance(this._globalStatistic.tabIdCoop, this._plot_infos_geometry[i].cooperative_id)) {
        this._globalStatistic.tabIdCoop.push(this._plot_infos_geometry[i].cooperative_id);
      }
      // if(!this.verifieExistance(globalStatistic.tabIdAdhe, this._plot_infos_geometry[i].farmer_id)){
      //   globalStatistic.tabIdAdhe.push(this._plot_infos_geometry[i].farmer_id);
      // }
      for (var j = 0; j < this._plot_infos_geometry[i].treatment.length; j++) {
        if (!this.verifieExistance(this._globalStatistic.order.tabIdOrder, this._plot_infos_geometry[i].treatment[j].order_id)) {
          this._globalStatistic.order.tabIdOrder.push(this._plot_infos_geometry[i].treatment[j].order_id);

          if (this._plot_infos_geometry[i].treatment[j].order_status == "waiting") {
            this._globalStatistic.order.order_waiting.push(this._plot_infos_geometry[i].treatment[j].order_id);
          } else if (this._plot_infos_geometry[i].treatment[j].order_status == "validated") {
            this._globalStatistic.order.order_validated.push(this._plot_infos_geometry[i].treatment[j].order_id);
          } else if (this._plot_infos_geometry[i].treatment[j].order_status == "in progress") {
            this._globalStatistic.order.order_in_progress.push(this._plot_infos_geometry[i].treatment[j].order_id);
          } else if (this._plot_infos_geometry[i].treatment[j].order_status == "finished") {
            this._globalStatistic.order.order_finished.push(this._plot_infos_geometry[i].treatment[j].order_id);
          }
        }
      }
    }
    this._globalStatistic.plot_area = parseFloat(this._globalStatistic.plot_area.toFixed(2));
    return this._globalStatistic;
  }
  createFeatureLayerWithClustering(label) {
    var _obj = this;

    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    var featureStore = new MemoryStore();
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    var armedEventsPainter = new BasicFeaturePainter();

    armedEventsPainter.getDetailLevelScales = function () {
      return [1 / 2000000];
    };

    armedEventsPainter.paintLabel = function (labelcanvas, feature, shape, layer, map, paintState) {
      if (paintState.level === 1) {
        // labelcanvas.drawLabel(labelForArmedEvent(feature), shape.focusPoint, {
        //   positions: PointLabelPosition.NORTH
        // });
      }
    };

    armedEventsPainter.paintBody = function (geocanvas, feature, shape, layer, map, paintState) {
      if (paintState.selected) {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_SELECTED_STYLE);
      } else {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_STYLE);
      }
    };

    var clusterPainter = new ClusteringPainterWrapper(armedEventsPainter);
    clusterPainter.paintClusterBody = function (geocanvas, feature, shape, layer, map, paintState) {
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getOuterStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getInnerStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getTextStyle(feature));
      if (paintState.selected) {
        // Paint clustered elements when selecting a cluster
        var clusteredFeatures = ClusteringTransformer.clusteredFeatures(feature);
        for (var i = 0; i < clusteredFeatures.length; i++) {
          var clusteredFeature = clusteredFeatures[i];
          armedEventsPainter.paintBody(geocanvas, clusteredFeature, clusteredFeature.shape, layer, map, paintState);
        }
      }
    };

    var j = 0;
    clusterPainter.paintClusterLabel = function (labelCanvas, feature, shape, layer, map, state) {

      layer.balloonContentProvider = function (o) { //============> Start============>
        console.log(o);

        var _tempModelPoint = ShapeFactory.createPoint(o.geometry._reference, [o.geometry[0], o.geometry[1]]);
        this._tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
        var _tempMapPoint = ShapeFactory.createPoint(map.reference, [0, 0]);
        var _transformation = TransformationFactory.createTransformation(o.geometry._reference, map.reference);
        _transformation.transform(_tempModelPoint, _tempMapPoint);
        map.mapToViewTransformation.transform(_tempMapPoint, this._tempViewPoint);
        this.viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var centerOfView = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var xCenter = (map.viewSize[0] / 2) - this._tempViewPoint[0];
        var yCenter = (map.viewSize[1] / 2) - this._tempViewPoint[1];
        var offsetFromCenterOfView = centerOfView.copy();
        offsetFromCenterOfView.translate(xCenter, yCenter + 100);
        map.mapNavigator.pan({ targetLocation: centerOfView, toViewLocation: offsetFromCenterOfView, animate: { duration: 200 } })
        _obj._list_treatments = [];
        console.log(this.viewPointCenter);
        var plots;
        var plots_count = 0;
        var plot_area = 0;
        var tabIdFarmer = [];
        var tabIdTech = [];
        var tabIdCoop = [];
        var tabIdAdhe = [];
        var plot_treatment = {
          count_total_treatment: 0,
          percentage_total_treatment: 0,
          count_treatment_finished: 0,
          percentage_treatment_finished: 0,
          print_div_treatment_finished: "none",
          count_treatment_in_progress: 0,
          percentage_treatment_in_progress: 0,
          print_div_treatment_in_progress: "none",
          count_treatment_preorder: 0,
          percentage_treatment_preorder: 0,
          print_div_treatment_preorder: "none",
          count_treatment_ordered: 0,
          percentage_treatment_ordered: 0,
          print_div_treatment_ordered: "none",
          print_div_treatment: "none",
        }
        var plot_properties = o.properties, node;
        node = domConstruct.toDom('<div class="card-body-ballon"> </div>');

        if (!plot_properties.clusteredElements) {
          plots = plot_properties; // Feature with properties
        } else {
          plots = plot_properties.clusteredElements;
        }

        if (!plot_properties.clusteredElements) {         //========Node for single plot=====> Start

          plots_count++;
          plot_area += parseFloat(plots.plot_area);
          plot_treatment.count_total_treatment = plots.treatments.length;
          if (plots.treatments.length > 0) {
            plot_treatment.print_div_treatment = "block";
          }
          for (var i = 0; i < plots.treatments.length; i++) {
            if (plots.treatments[i].treatment_status == "precommande") {
              plot_treatment.count_treatment_preorder++;
              plot_treatment.print_div_treatment_preorder = "block";

            }
            if (plots.treatments[i].treatment_status == "commande") {
              plot_treatment.count_treatment_ordered++;
              plot_treatment.print_div_treatment_ordered = "block";
            }
            if (plots.treatments[i].treatment_status == "en-cours") {
              plot_treatment.count_treatment_in_progress++;
              plot_treatment.print_div_treatment_in_progress = "block";
            }
            if (plots.treatments[i].treatment_status == "termine") {
              plot_treatment.count_treatment_finished++;
              plot_treatment.print_div_treatment_finished = "block";
            }
          }
          plot_treatment.percentage_total_treatment = (plot_treatment.count_treatment_preorder * 25 + plot_treatment.count_treatment_ordered * 50 + plot_treatment.count_treatment_in_progress * 75 + plot_treatment.count_treatment_finished * 100) * 100 / (plot_treatment.count_total_treatment * 100);
          plot_treatment.percentage_treatment_preorder = plot_treatment.count_treatment_preorder * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_ordered = plot_treatment.count_treatment_ordered * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_in_progress = plot_treatment.count_treatment_in_progress * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_finished = plot_treatment.count_treatment_finished * 100 / plot_treatment.count_total_treatment;

          if (plots.treatments.length > 0) {
            _obj._list_treatments.push(plots);
          }
          console.log(plot_treatment);
          var nodeSinglePlot = domConstruct.toDom('\
                                                        <div class="row">\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title-ballon" style="color: #a9bc14;">Information sur la parcelle</h4>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nom parcelle : '+ plots.plot_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nom agriculteur : '+ plots.farmer_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Prenom agriculteur : '+ plots.farmer_first_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Téléphone : '+ plots.farmer_phone + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Adhérent : '+ plots.cooperative_adherent_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : '+ plots_count + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie Totale : '+ plot_area.toFixed(2).toString() + ' Ha</p>\
                                                          </div>\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title-ballon" style="color: #a9bc14;">Statistique</h4>\
                                                            <p>État d\'avancement</p>\
                                                            <div style="display :'+ plot_treatment.print_div_treatment + '">\
                                                              <div class="progress" style="height: 18px;">\
                                                                  <div class="progress-bar progress-bar-striped active" role="progressbar"aria-valuenow="40" aria-valuemin="0" aria-valuemax="100" style="width:'+ plot_treatment.percentage_total_treatment + '%" title="Nombre de traitements est :' + plot_treatment.count_total_treatment + '">\
                                                                        '+ plot_treatment.percentage_total_treatment.toFixed(2) + '%\
                                                                  </div>\
                                                              </div><br>\
                                                              <div class="progress" id="progressBarDetaille">\
                                                                <div class="progress-bar progress-bar-info" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_preorder + '; width:' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%" ="tooltip" title="Précommande(' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_preorder + '">' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-danger" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_ordered + ';width:' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%" ="tooltip" title="Confirmé(' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_ordered + '">' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-success" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_in_progress + ';width:' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%"; background-color: #AAAAAA" ="tooltip" title="En cours(' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_in_progress + '">' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-warning" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_finished + ';width:' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%"; background-color: #606060" ="tooltip" title="Terminé (' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%)/ Nombre de traitements est :' + plot_treatment.count_treatment_finished + '">' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%</div>\
                                                              </div>\
                                                            </div>\
                                                             <div style="margin-top: 7px;float: right;" id="detailTreatment">\
                                                                <a href="javasript:;" class="btn btn-info btn-mini b-none"><span class="badge">'+ plots.treatments.length + '</span></a>\
                                                            </div>\
                                                          </div>\
                                                        </div>\
                                                   ');
          var domDisplayAllPlots = domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;"><b>Voir toutes les parcelles </b> </p>');
          domDisplayAllPlots.addEventListener("click", function () { _obj.resetDataMap(); });

          domConstruct.place(nodeSinglePlot, node);
          domConstruct.place(domDisplayAllPlots, nodeSinglePlot);
          //========>End
        } else {                          //========Node for multiples plots=====> Start

          plots_count += plot_properties.clusteredElements.length;

          var nodeRow = domConstruct.create("div", null, node, "last");
          nodeRow.setAttribute("class", "row");

          var nodeSelects = domConstruct.create("div", null, nodeRow, 'last');
          nodeSelects.setAttribute("class", "col-sm-12 col-xl-6 m-b-30-ballon");

          var nodeTitle = domConstruct.toDom('\
                                                <h4 class="sub-title-ballon" style="color: #a9bc14;">Filtre</h4>\
                                          ');

          domConstruct.place(nodeTitle, nodeSelects);

          var selectFarmer = domConstruct.create("select", null);
          selectFarmer.setAttribute("class", "form-control form-control-info");
          selectFarmer.setAttribute("name", "farmerSelect");
          selectFarmer.setAttribute("style", "margin-bottom: 10px;");
          selectFarmer.addEventListener("change", function () { _obj.updateDataMap(selectFarmer.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des agriculteurs</option>'), selectFarmer);

          var selectTechnician = domConstruct.create("select", null);
          selectTechnician.setAttribute("class", "form-control form-control-info");
          selectTechnician.setAttribute("name", "technicianSelect");
          selectTechnician.setAttribute("style", "margin-bottom: 10px;");
          selectTechnician.addEventListener("change", function () { _obj.updateDataMap(selectTechnician.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des techniciens</option>'), selectTechnician);

          var selectCooperative = domConstruct.create("select", null);
          selectCooperative.setAttribute("class", "form-control form-control-info");
          selectCooperative.setAttribute("name", "cooperativeSelect");
          selectCooperative.setAttribute("style", "margin-bottom: 10px;");
          selectCooperative.addEventListener("change", function () { _obj.updateDataMap(selectCooperative.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des cooperatives</option>'), selectCooperative);

          var selectAdherent = domConstruct.create("select", null);
          selectAdherent.setAttribute("class", "form-control form-control-info");
          selectAdherent.setAttribute("name", "cooperativeSelect");
          selectAdherent.setAttribute("style", "margin-bottom: 10px;");
          selectAdherent.addEventListener("change", function () { _obj.updateDataMap(selectAdherent.value); });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des adhérents</option>'), selectAdherent);


          if (_obj._currentUserInfos.right == 1/*ADMIN*/) {

            domConstruct.place(selectCooperative, nodeSelects);
            domConstruct.place(selectAdherent, nodeSelects);
            domConstruct.place(selectTechnician, nodeSelects);
            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 2/*COOPERATIVE*/) {

            domConstruct.place(selectAdherent, nodeSelects);
            domConstruct.place(selectTechnician, nodeSelects);
            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 3/*TECHNICIAN*/) {

            domConstruct.place(selectFarmer, nodeSelects);

          } else if (_obj._currentUserInfos.right == 4/*FARMER*/) {

          }

          for (var i = 0; i < plots.length; i++) {
            console.log("i=:" + i);
            console.log(plots[i].properties.treatments);
            plot_area += parseFloat(plots[i].properties.plot_area);
            if (!_obj.verifieExistance(tabIdFarmer, plots[i].properties.farmer_id)) {
              tabIdFarmer[i] = plots[i].properties.farmer_id;
              var hrefAgriParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"f"}';
              var b = dConstruct.create("option", { innerHTML: plots[i].properties.farmer_name + " " + plots[i].properties.farmer_first_name + "</a>" }, selectFarmer, "last");
              b.setAttribute("value", hrefAgriParcelle);
            }
            if (!_obj.verifieExistance(tabIdTech, plots[i].properties.technician_id)) {
              tabIdTech[i] = plots[i].properties.technician_id;
              var hrefTecParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"t"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.technician_name + " " + plots[i].properties.technician_first_name }, selectTechnician, "last");
              c.setAttribute("value", hrefTecParcelle);
            }
            if (!_obj.verifieExistance(tabIdCoop, plots[i].properties.cooperative_id)) {
              tabIdCoop[i] = plots[i].properties.cooperative_id;
              var hrefCoopParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_name }, selectCooperative, "last");
              c.setAttribute("value", hrefCoopParcelle);
            }

            if (!_obj.verifieExistance(tabIdAdhe, plots[i].properties.cooperative_adherent_id)) {
              tabIdAdhe[i] = plots[i].properties.cooperative_adherent_id;
              var hrefAdheParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_adherent_name }, selectAdherent, "last");
              c.setAttribute("value", hrefAdheParcelle);
            }
            //  console.log(plots[i]);


            plot_treatment.count_total_treatment += plots[i].properties.treatments.length;

            if (plots[i].properties.treatments.length > 0) {
              _obj._list_treatments.push(plots[i].properties);
            }

            for (var j = 0; j < plots[i].properties.treatments.length; j++) {

              if (plots[i].properties.treatments[j].treatment_status == "precommande") {
                plot_treatment.count_treatment_preorder++;
                plot_treatment.print_div_treatment_preorder = "block";
              }
              if (plots[i].properties.treatments[j].treatment_status == "commande") {
                plot_treatment.count_treatment_ordered++;
                plot_treatment.print_div_treatment_ordered = "block";
              }
              if (plots[i].properties.treatments[j].treatment_status == "en-cours") {
                plot_treatment.count_treatment_in_progress++;
                plot_treatment.print_div_treatment_in_progress = "block";
              }
              if (plots[i].properties.treatments[j].treatment_status == "termine") {
                plot_treatment.count_treatment_finished++;
                plot_treatment.print_div_treatment_finished = "block";
              }
            }

          }
          _obj._list_treatments = _obj._list_treatments.slice();
          console.log(_obj._list_treatments);
          if (plot_treatment.count_total_treatment > 0) {
            plot_treatment.print_div_treatment = "block";
          }
          plot_treatment.percentage_total_treatment = (plot_treatment.count_treatment_preorder * 25 + plot_treatment.count_treatment_ordered * 50 + plot_treatment.count_treatment_in_progress * 75 + plot_treatment.count_treatment_finished * 100) * 100 / (plot_treatment.count_total_treatment * 100);
          plot_treatment.percentage_treatment_preorder = plot_treatment.count_treatment_preorder * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_ordered = plot_treatment.count_treatment_ordered * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_in_progress = plot_treatment.count_treatment_in_progress * 100 / plot_treatment.count_total_treatment;
          plot_treatment.percentage_treatment_finished = plot_treatment.count_treatment_finished * 100 / plot_treatment.count_total_treatment;

          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : ' + plots.length + '</p>'), nodeSelects);
          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie totale : ' + plot_area.toFixed(2).toString() + ' Ha</p>'), nodeSelects);
          var domAllPlots = domConstruct.toDom('<p  style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;"><b>Voir toutes les parcelles </b> </p>');
          domAllPlots.addEventListener("click", function () { _obj.resetDataMap(); });
          domConstruct.place(domAllPlots, nodeSelects);
          var nodeStatistique = domConstruct.toDom('\
                                                    <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                      <h4 class="sub-title-ballon" style="color: #a9bc14;">Statistiques</h4>\
                                                      <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                      <div style="display :'+ plot_treatment.print_div_treatment + '">\
                                                      <p>État d\'avancement</p>\
                                                              <div class="progress">\
                                                                  <div class="progress-bar progress-bar-striped active" role="progressbar"aria-valuenow="40" aria-valuemin="0" aria-valuemax="100" style="width:'+ plot_treatment.percentage_total_treatment + '%" title="Nombre de traitements est :' + plot_treatment.count_total_treatment + '">\
                                                                        '+ plot_treatment.percentage_total_treatment.toFixed(2) + '%\
                                                                  </div>\
                                                              </div><br>\
                                                              <div class="progress" id="progressBarDetaille" style="height: 18px;">\
                                                                <div class="progress-bar progress-bar-info" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_preorder + '; width:' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%" ="tooltip" title="Précommande(' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_preorder + '">' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-danger" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_ordered + ';width:' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%" ="tooltip" title="Confirmé (' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%)/ Nombre de traitements est :' + plot_treatment.count_treatment_ordered + '">' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-success" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_in_progress + ';width:' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%"; background-color: #AAAAAA" ="tooltip" title="En cours(' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_in_progress + '">' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-warning" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_finished + ';width:' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%"; background-color: #606060" ="tooltip" title="Terminé(' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%) / Nombre de traitements est :' + plot_treatment.count_treatment_finished + '">' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%</div>\
                                                              </div>\
                                                            </div>\
                                                             <div style="margin-top: 7px;float: right;" id="detailTreatment">\
                                                                <a href="javasript:;" class="btn btn-info btn-mini b-none"><span class="badge" >'+ plot_treatment.count_total_treatment + '</span></a>\
                                                            </div>\
                                                          </div>\
                                                    </div>\
                                                  ');
          domConstruct.place(nodeStatistique, nodeRow);
          domConstruct.place(nodeRow, node);
        }    //========Node for multiples plots=====> End
        // var divFooter =  domConstruct.toDom("<br><h1> refNode </h1>");
        // domConstruct.create(node,{},divFooter);
        // domConstruct.place(divFooter,node);

        return node;
      } //============>End ============>


    };

    var clusterParam1 = ClusteringTransformer.create({
      defaultParameters: {
        clusterSize: 150
      }
    });

    var clusterParam2 = ClusteringTransformer.create({
      defaultParameters: {
        noClustering: "disable"
      }
    });

    this._featureLayerAccessPointDB = new FeatureLayer(featureModel, {
      label: label,
      selectable: true,
      editable: true,
      painter: clusterPainter,
      transformer: clusterParam1
    }
    );
  }

  removeAllLayer() {
    this._map.layerTree.removeAllChildren();
  }

  removeAllShapesForAllLayers() {
    this._plotDataLoader.removeAll();
  }

  ngOnDestroy() {
    // if (this._map) {
    //   this._map.destroy();
    // }
  }

  tooltipPissosHoverController() {
    this._map.controller = new TooltipPissosHoverController();

    console.log(this._surfaceDetectedPainter);
    // this._featureLayerPissosDB.painter = this._surfaceDetectedPainter ;
  }

  densityPissosPainterOnOFF() {
    if (!this._featureLayerPissosDB.painter.density) {
      this._featureLayerPissosDB.painter.density = {
        colorMap: ColorMap.createGradientColorMap([
          { level: 0, color: "rgba(  0,   0, 255, 0.0)" },
          { level: 1, color: "rgba(  0,   0, 255, 1.0)" },
          { level: 5, color: "rgba(  0, 255, 255, 1.0)" },
          { level: 10, color: "rgba(255, 255,   0, 1.0)" },
          { level: 20, color: "rgba(255, 200,   0, 1.0)" },
          { level: 80, color: "rgba(250,   0,   0, 1.0)" }
        ])
      };
    } else {
      this._featureLayerPissosDB.painter.density = null;
    }
  }
  // Slider adapts visualization, scheduled once per frame
  sliderChange() {
    var _obj = this;
    var previousSliderValue = -1;
    var slider = document.getElementById("slider");
    var slideListener = function (e) {
      window.requestAnimationFrame(function () {
        var newSliderValue = parseFloat(e.target.value);
        if (newSliderValue !== previousSliderValue) {
          previousSliderValue = newSliderValue;
        }
      });
    };
    slider.addEventListener("input", slideListener);
    slider.addEventListener("change", slideListener);
  }
  // According to the pressure (ie in% of surface detected on total area of the iamge)
  surfaceDetectedPainterInit() {
    var _obj = this;
    //Create a short variable name for ExpressionFactory so it is easier to work with. 2
    var _ = ExpressionFactory;
    //Define a threshold parameter that can be efficiently updated later on. 5
    var threshold = _.numberParameter(0);
    //Base the color of a point on an attribute of that point:
    //if the attribute value is less than the threshold, color it green, otherwise color it red.
    // var color = _.ifThenElse(
    //   _.gt(_.attribute("percentage"), 5),
    //   _.color("rgba(0, 255, 255, 1)"),
    //   _.color("rgba(255, 0, 0, 1)")
    // );
    var defaultExpression = _.color(IconFactory.circle({
      stroke: "rgba(250,   0,   0, 1.0)",
      strokeWidth: 2,
      width: 12,
      height: 12
    }));
    var color1TestExpression = _.between(_.attribute("percentage"), _.number(0), _.number(4));
    var color1ResultExpression = _.color("rgba(  0,   0, 255, 1.0)");
    var color2TestExpression = _.between(_.attribute("percentage"), _.number(4), _.number(6));
    var color2ResultExpression = _.color("rgba(  0, 255, 255, 1.0)");
    var color3TestExpression = _.between(_.attribute("percentage"), _.number(6), _.number(8));
    var color3ResultExpression = _.color("rgba(255, 255,   0, 1.0)");
    var color4TestExpression = _.between(_.attribute("percentage"), _.number(8), _.number(10));
    var color4ResultExpression = _.color("rgba(250,   0,   0, 1.0)");

    var caseExpression = _.cases(defaultExpression);
    caseExpression.when(color1TestExpression).then(color1ResultExpression)
      .when(color2TestExpression).then(color2ResultExpression)
      .when(color3TestExpression).then(color3ResultExpression)
      .when(color4TestExpression).then(color4ResultExpression);
    //Update the threshold parameter when the user drags the corresponding slider in the UI
    var slider = $("#slider");
    slider.on('input change', function () {
      var newSliderValue = parseFloat(slider.val());
      console.log("newSliderValue : " + threshold.value);
      _obj._slider.value = threshold.value.toFixed(2) + " %";
      threshold.value = newSliderValue * 100;
    });
    var yellow = _.color("rgba(255, 255, 0, 1)");
    this._featureLayerPissosDB.painter = new ParameterizedPointPainter({
      regular: { colorExpression: caseExpression },
      selected: { colorExpression: yellow },
      visibilityExpression: _.gt(_.attribute("percentage"), threshold),
      attributes: {
        percentage: "percentage",
      }
    });
  }

  surfaceDetectedPainterClass() {
    this._featureLayerPissosDB.painter = this._pissosPaiterClass;
    document.getElementById("slidercontainer").style.display = "none";
  }

  sliderPissosPainter() {
    this.surfaceDetectedPainterInit();
    document.getElementById("slidercontainer").style.display = "block";
  }

  addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.options = {
      position: [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch (options.type) {
      case 'success':
        this.servicePNotify.success(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg,
          options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
    }
  }
}



