import {AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input} from '@angular/core';
import 'rxjs/add/operator/toPromise'; 
/* Start Import file for create and validate a form */
import { HttpService } from '../../http.service';
import {AuthenticationService } from '../../_services/index'; 
import {OnInit,ViewEncapsulation } from '@angular/core';
import { Router } from '@angular/router';
import {fadeInOutTranslate} from "../../shared/elements/animation";
import {SharedModule} from '../../shared/shared.module';
import swal from 'sweetalert2';
import * as $ from 'jquery';

@Component({
  selector: 'app-order',
  templateUrl: './order.component.html',
  styleUrls: ['./order.component.css'],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class OrderComponent implements AfterViewInit, OnDestroy {  
  _plot_infos_geometry= [] ; // liste of plot and their properties
  _plot_infos_geometryCopy =[];
  _plotToTreat_infos_geometry =[] ; // liste of plot and their properties
  _plotToTreat_infos_geometryCopy =[] ; // liste of plot and their properties
  _selectOptionTraitement :any;
  _currentUserInfos : any ;
  _currentUserEmailAndToken : any ;
  _SummaryOfTheOrder = { "visibility":false,"plots_count" : 0, "total_area" : 0, "technician_id": 1,"current_stock":0,"treatment":[] };
  _idOfUsers = { "cooperative_id" : 1, "technician_id": 1,"farmer_id":0,"user_type":"t" }; // use to load a binding datas of a curent user or to filtering data 
   searchTermPreValidation : any ;
   searchTermSummarizeSite : any ;
  _model ={ client_id : 2,
                   client_secret : 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
                   id_farmer:3,
                   name :'',
                   comment :'',
                   electricline :'',
                   irrigationsystem:'',
                   geom :{},
                   accesspoint :{},
                   obstacles :{}
                 };
                 
  _polt : number = 1 ;

  @Input()
  mapReference: string;

  constructor(private httpService : HttpService,public authenticationService :AuthenticationService, private router : Router) {
    if(this.authenticationService.isLoggedIn()){
         this.setIdOfUsersUsigLocalSorage();
    }else{
      this.router.navigate(['/login']);
    } 
  }

  ngAfterViewInit() {
    this.getSelectOptionTraitement();
    this.getDataPlotFromDB(this._idOfUsers);
  }

  searchSummarizeSite(){

     if(this.searchTermSummarizeSite == "") {
      this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy; 
    }else{
      let term = this.searchTermSummarizeSite;

      this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy.filter(function(tag) {
          if(tag.plot_name!=null){
           if(tag.plot_name.indexOf(term) >= 0){ console.log(1); return tag.plot_name.indexOf(term) >= 0 ; }
          }
          if(tag.cooperative_adherent!=null){
            if(tag.cooperative_adherent.indexOf(term) >= 0){ console.log(2); return tag.cooperative_adherent.indexOf(term) >= 0; }
          }
          if(tag.cooperative_city!=null){
            if(tag.cooperative_city.indexOf(term) >= 0){ console.log(3); return tag.cooperative_city.indexOf(term) >= 0;}
          }
          if(tag.cooperative_country!=null){
            if(tag.cooperative_country.indexOf(term) >= 0){ console.log(4); return tag.cooperative_country.indexOf(term) >= 0;}
          }
          if(tag.farmer_email!=null){
            if(tag.farmer_email.indexOf(term) >= 0){console.log(5); return tag.farmer_email.indexOf(term) >= 0; }
          }
          if(tag.farmer_first_name!=null){
            if(tag.farmer_first_name.indexOf(term) >= 0){console.log(6); return tag.farmer_first_name.indexOf(term) >= 0;}
          }
          if(tag.farmer_name!=null){
            if(tag.farmer_name.indexOf(term) >= 0){ console.log(7); return tag.farmer_name.indexOf(term) >= 0;}
          }
          if(tag.farmer_phone!=null){
            if(tag.farmer_phone.indexOf(term) >= 0){ console.log(8); return tag.farmer_phone.indexOf(term) >= 0;}
          }
          if(tag.plot_comment!=null){
            if(tag.plot_comment.indexOf(term) >= 0){console.log(9);  return tag.plot_comment.indexOf(term) >= 0;}
          }
      }); 
    }
  }
  searchPreValidation(){
    if(this.searchTermPreValidation == "") {
      this._plot_infos_geometry = this._plot_infos_geometryCopy; 
    }else{
      let term = this.searchTermPreValidation;

      this._plot_infos_geometry = this._plot_infos_geometryCopy.filter(function(tag) {
          if(tag.plot_name!=null){
           if(tag.plot_name.indexOf(term) >= 0){ return tag.plot_name.indexOf(term) >= 0 ; }
          }
          if(tag.cooperative_adherent!=null){
            if(tag.cooperative_adherent.indexOf(term) >= 0){ return tag.cooperative_adherent.indexOf(term) >= 0; }
          }
          if(tag.cooperative_city!=null){
            if(tag.cooperative_city.indexOf(term) >= 0){ return tag.cooperative_city.indexOf(term) >= 0;}
          }
          if(tag.cooperative_country!=null){
            if(tag.cooperative_country.indexOf(term) >= 0){ return tag.cooperative_country.indexOf(term) >= 0;}
          }
          if(tag.farmer_email!=null){
            if(tag.farmer_email.indexOf(term) >= 0){ return tag.farmer_email.indexOf(term) >= 0; }
          }
          if(tag.farmer_first_name!=null){
            if(tag.farmer_first_name.indexOf(term) >= 0){ return tag.farmer_first_name.indexOf(term) >= 0;}
          }
          if(tag.farmer_name!=null){
            if(tag.farmer_name.indexOf(term) >= 0){ return tag.farmer_name.indexOf(term) >= 0;}
          }
          if(tag.farmer_phone!=null){
            if(tag.farmer_phone.indexOf(term) >= 0){ return tag.farmer_phone.indexOf(term) >= 0;}
          }
          if(tag.plot_comment!=null){
            if(tag.plot_comment.indexOf(term) >= 0){  return tag.plot_comment.indexOf(term) >= 0;}
          }
      }); 
    }

  }
  getDataPlotFromDB(idOfCurentUser){

    var functionToCall;
    if(idOfCurentUser.user_type=="admin") functionToCall = 'getPlotByAdmin';
    if(idOfCurentUser.user_type=="c") functionToCall = 'getPlotByCooperative';
    if(idOfCurentUser.user_type=="a") functionToCall = 'getPlotByAdherent';
    if(idOfCurentUser.user_type=="t") functionToCall = 'getPlotByTechnician';
    if(idOfCurentUser.user_type=="f") functionToCall = 'getPlotByFarmer';
    

      this.httpService.httpPostPromise(functionToCall,idOfCurentUser)
                .then((plot_infos_geometry) =>  {
                  this._plot_infos_geometry=plot_infos_geometry;
                  this._plot_infos_geometryCopy=plot_infos_geometry;
                  console.log(this._plot_infos_geometry);
                },(error)=>{
                  console.log(error);
                });
  
  }

 getSelectOptionTraitement(){
    this._selectOptionTraitement = [{"id":1,"name":"Pyrale du maïs"},
                                    {"id":4,"name":"Autre traitement"},
                                    {"id":2,"name":"Pulvérisation"},
                                    {"id":3,"name":"Miscanthus"}] ;
    console.log(this._selectOptionTraitement);  
  }
 //-------------------Form controler-------------------------
  checkValidated(plot_id){

        for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
          if(this._plotToTreat_infos_geometry[i].plot_id==plot_id){
            // console.log(true);
            return true;
          }
      }
      // console.log("False");
  return false;
 }
  checkUncheck(plot_id){
        for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
          if(this._plotToTreat_infos_geometry[i].plot_id==plot_id){
          //  console.log(true);
            return true;
          }  
      }
  //console.log(false);
  return false;
 }
 delettePlotFromTableToTreat(plot_id){
  var treatmentSelected = $('#treatment-'+plot_id+" option:selected").val();
        for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
          if(this._plotToTreat_infos_geometry[i].plot_id==plot_id){

            this._SummaryOfTheOrder.plots_count--;
               var indx =  this._SummaryOfTheOrder.treatment.map(function(e) { return e.plot_id; }).indexOf(plot_id);
            // var indx = this._SummaryOfTheOrder.treatment.indexOf({"plot_id": plot_id , "id_product": treatmentSelected});
                this._SummaryOfTheOrder.treatment.splice(indx,1);
                 console.log(this._SummaryOfTheOrder.treatment);
            if(this._SummaryOfTheOrder.plots_count==0)
                 this._SummaryOfTheOrder.visibility = false;
            this._SummaryOfTheOrder.total_area -= parseFloat(this._plotToTreat_infos_geometry[i].plot_area) ;
            // this._plotDataLoader.removePolygoneContour(this._plotToTreat_infos_geometry[i]);
            this._plotToTreat_infos_geometry.splice(i,1);
          }
        }
        this._plotToTreat_infos_geometryCopy =this._plotToTreat_infos_geometry;
        this._plotToTreat_infos_geometry =this._plotToTreat_infos_geometryCopy.slice();
 }
  updatePlotTableToTreat(plot_id){
    var checkBox = document.getElementById('plot-ordered-'+plot_id);
    console.log((<HTMLInputElement>checkBox).checked );
    var treatmentSelected = $('#treatment-'+plot_id+" option:selected").val();
    var treatementText = $('#treatment-'+plot_id+" option:selected").text();

    if ((<HTMLInputElement>checkBox).checked){
        console.log(this._plot_infos_geometry);
 
        for (var i = this._plot_infos_geometry.length - 1; i >= 0; i--) {
          if(this._plot_infos_geometry[i].plot_id==plot_id){
            var obj = this._plot_infos_geometry[i];
            // obj.treatement = treatementText ;
            this._plotToTreat_infos_geometry.push(obj);  
            this._SummaryOfTheOrder.plots_count++;
            this._SummaryOfTheOrder.treatment.push({"plot_id": plot_id , "id_product": treatmentSelected});
            console.log(this._SummaryOfTheOrder.treatment);
            if(this._SummaryOfTheOrder.plots_count>0)
                 this._SummaryOfTheOrder.visibility = true;
            this._SummaryOfTheOrder.total_area += parseFloat(this._plot_infos_geometry[i].plot_area) ;
            document.getElementById('validate-'+plot_id).className = "true-img-validated";
          }
        }
     }else {
      for (var i = this._plotToTreat_infos_geometry.length - 1; i >= 0; i--) {
          if(this._plotToTreat_infos_geometry[i].plot_id==plot_id){

            this._SummaryOfTheOrder.total_area -= parseFloat(this._plotToTreat_infos_geometry[i].plot_area) ;
            this._SummaryOfTheOrder.plots_count--;

            var indx  = this._SummaryOfTheOrder.treatment.map(function(e) { return e.plot_id; }).indexOf(plot_id);
                this._SummaryOfTheOrder.treatment.splice(indx,1);
                console.log(this._SummaryOfTheOrder.treatment);
            if(this._SummaryOfTheOrder.plots_count==0)
                 this._SummaryOfTheOrder.visibility = false;
            // this._plotDataLoader.removePolygoneContour(this._plotToTreat_infos_geometry[i]);  
            this._plotToTreat_infos_geometry.splice(i,1);
            document.getElementById('validate-'+plot_id).className = "false-img-validated";  
          }
        } 
    }
    this._plotToTreat_infos_geometryCopy =this._plotToTreat_infos_geometry;
    this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy.slice();
  }

  setSummaryOfTheOrderTreatment(plot_id){
    var checkBox = document.getElementById('plot-ordered-'+plot_id);
    var treatmentSelected = $('#treatment-'+plot_id+" option:selected").val();
    var treatementText = $('#treatment-'+plot_id+" option:selected").text();
    if ((<HTMLInputElement>checkBox).checked){
 
        console.log(this._SummaryOfTheOrder.treatment);

        var indx  = this._SummaryOfTheOrder.treatment.map(function(e) { return e.plot_id; }).indexOf(plot_id);
        this._SummaryOfTheOrder.treatment.splice(indx,1,{"plot_id": plot_id , "id_product": treatmentSelected});

        var indx1 = this._plotToTreat_infos_geometry.map(function(e){ return e.plot_id; }).indexOf(plot_id);
        this._plotToTreat_infos_geometry.splice(indx1,1,{plot_infos : this._plotToTreat_infos_geometry[indx1], treatment : treatementText});
        console.log(this._SummaryOfTheOrder.treatment);

     }
      this._plotToTreat_infos_geometryCopy =this._plotToTreat_infos_geometry;
      this._plotToTreat_infos_geometry = this._plotToTreat_infos_geometryCopy.slice();
  }
   onSubmit() { 

     var data ={
      "id_technician" : this._currentUserInfos.tchnicians_id,
      "treatments" : this._SummaryOfTheOrder.treatment
     }; 
    console.log(this._plotToTreat_infos_geometry);
    this.httpService.httpPostPromise('storeorder',data)
                .then((data) =>  {
                   this.openSuccessSwal();
                   this._plotToTreat_infos_geometry = [];
                   this._SummaryOfTheOrder.treatment= [];
                   this._SummaryOfTheOrder.plots_count=0;
                   this._SummaryOfTheOrder.total_area =0 ;
                   this._plotToTreat_infos_geometry =[];
                },(error)=>{
                  console.log(error);
                });  
  }
  //---------------------------------Modal Swal-----------------------

  openSuccessSwal() {
    swal({
      title: 'Bon travail!',
      text: 'Le traitement à été bien sauvegarder, Votre commande sera traitée dans les plus brefs délais par l\'admin!',
      type: 'success'
    }).catch(swal.noop);
  }
  //-------------------End Form controler-----------------------------
  setIdOfUsersUsigLocalSorage(){
   this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));
     

        switch (this._currentUserInfos.right) {
          case 1: 
                  this._idOfUsers.cooperative_id = 0; 
                  this._idOfUsers.technician_id = 0  ; 
                  this._idOfUsers.farmer_id = 0  ;
                  this._idOfUsers.user_type = "a"  ;
              break;
          case 2:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0; 
                  this._idOfUsers.farmer_id = 0;
                  this._idOfUsers.user_type = "c"  ;
            
              break;
          case 3:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                  this._idOfUsers.technician_id =  this._currentUserInfos.tchnicians_id ; 
                  this._idOfUsers.farmer_id = 0 ;
                  this._idOfUsers.user_type = "t"  ;
              break;
          case 4:
                  this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0 ; 
                  this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id ;
                  this._idOfUsers.user_type = "f"  ;
              
              break;
          // case '5':
          //         this._idOfUsers.cooperative_id = 0; 
          //         this._idOfUsers.adherent_id = 0 ;
          //         this._idOfUsers.technician_id = 0 ; 
          //         this._idOfUsers.farmer_id = 0 ;
          //         this._idOfUsers.user_type = "p"  ;
              
          //     break;
      }
  }
  setIdOfUsers(idOfUsersJSON){

       this._idOfUsers.cooperative_id = idOfUsersJSON.c 
       this._idOfUsers.technician_id = idOfUsersJSON.t  ; 
       this._idOfUsers.farmer_id = idOfUsersJSON.f  ;
       this._idOfUsers.user_type = idOfUsersJSON.s  ;
  }
  ngOnDestroy() {
    // if (this._map) {
    //   this._map.destroy();
    // }
    //  this.ngAfterViewInit();
    //document.getElementById("controlcontainer").innerHTML="";
  }
  slideToggleContent(plotDivDescription) {
    $('#' + plotDivDescription + '-content').slideToggle(500, function () {
    });
  }
}
