import { Component, OnInit,ViewChild, ViewEncapsulation } from '@angular/core';
import { HttpService } from '../../../http.service';
import { AuthenticationService } from '../../../_services/index';
import { Router } from '@angular/router';
import * as moment from 'moment';
import { NotificationsService } from "angular2-notifications";
import { RiaMapComponent } from '../../ria-map/ria-map.component';
import * as $ from 'jquery';
@Component({
  selector: 'app-order-list',
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class ListComponent implements OnInit {
  _orderlist = [];
  _orderlistCopy = [];
  _plot_infos_geometry = [];
  _filter = {
    priority: "all",
    status: "all",
    date_since: "all",
    search: "",
  };
  _idOfUsers = { "cooperative_id": 1, "technician_id": 1, "farmer_id": 0, "user_type": "t" };
  _currentUserInfos: any;
  optionsNotification: any = {
    position: ["bottom", "right"],
  };
  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';
  title: string;
  msg: string;
  serchParams = [];

  @ViewChild(RiaMapComponent) mapChild;

  constructor(private httpService: HttpService,
    public authenticationService: AuthenticationService,
    private router: Router,
    private servicePNotify: NotificationsService
  ) {
    if (this.authenticationService.isLoggedIn()) {
      this.setIdOfUsersUsigLocalSorage();
    } else {
      this.router.navigate(['/login']);
    }
  }

  ngOnInit() {
    console.log('test_passage');
    this.getAllOrders();
  }
  getAllOrders() {
    this.httpService.httpPostPromise('getOrders', this._idOfUsers)
      .then((orderTable) => {
        console.log(orderTable);
        this.updateOrder_passed_since_atribut(orderTable);
        this.updateOrder_area_atribut(orderTable);
      }, (error) => {
        console.error(error);
      });
  }
  zoomOnFeature(plot_id){
    this.mapChild.zoomOnFeature(plot_id);
  }
  orderStatusChange(objet) {
    console.log(objet);
    console.log(this._currentUserInfos);
    this.httpService.httpPostPromise('orderStatusChange', objet)
      .then((ResponseOfTheRequest) => {
        console.log(ResponseOfTheRequest);
        this.addNotify({ title: 'Modification du statut de la commande', msg: 'Le statut de la commande a été modéfié avec succes :)', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Modification du statut de la commande', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });
  }
  getPlots_infos_geometry(order_id) {
    console.log(this._orderlist);
    this._plot_infos_geometry = this._orderlist.filter(function (tag) {
      
      if (tag.order_id == order_id) { console.log(tag); return true; }
    });
    this._plot_infos_geometry = this._plot_infos_geometry[0].treatments;
  }
  getAreaToFixed(area) {
    return parseFloat(area).toFixed(2);
  }
  slideToggleContent(detailOrderDivDescription) {
    $(detailOrderDivDescription).slideToggle(500, function () {
    });
  }
  updateOrder_passed_since_atribut(orderTable) {
    console.log(orderTable.order_status);
    for (var i = 0; i < orderTable.length; i++) {
      orderTable[i].order_passed_since = this.datePassedSince(orderTable[i].order_created_at);
    }
    this._orderlist = orderTable;
    var obj = this;
    // setInterval(obj.updateOrder_passed_since_atribut(obj._orderlist), 10000);
  }
  testDisplay(){
    alert('my men');
  }
  updateOrder_area_atribut(orderTable) {
    for (var i = 0; i < orderTable.length; i++) {
      var area = 0;
      var status = null;
      for (var j = 0; j < orderTable[i].treatments.length; j++) {
        area += parseFloat(orderTable[i].treatments[j].plot_area);
      }
      this._orderlist[i].order_area = area.toFixed(2);
    }
    this._orderlistCopy = this._orderlist;
  }
  /**
    /* @ param : date du message dans le format YYYY-mm-dd hh-ii-ss
    /* Permet de retourner le message à afficher en fonction du temps écoulé depuis la récéption du message $date
    */
  datePassedSince(datePassed) {
    // console.log('-------------------------------');
    // console.log(datePassed);
    moment.locale('fr');
    moment.relativeTimeThreshold('s', 60);
    moment.relativeTimeThreshold('m', 60);
    moment.relativeTimeThreshold('h', 24);
    moment.relativeTimeThreshold('d', 31);
    moment.relativeTimeThreshold('w', 7);
    moment.relativeTimeThreshold('M', 12);
    // console.log(moment(datePassed).fromNow());
    // console.log('-------------------------------');

    var ago = "il y a " + moment.duration(moment().diff(datePassed)).humanize();
    return ago;
  }
  getStylePriority(option) {
    var priorityStyle = "";
    if (option.tag == "label") {
      priorityStyle = "label label";
    } else if (option.tag == "div") {
      priorityStyle = "card card-border";
    }
    switch (option.priority) {
      case "highest":
        priorityStyle += "-danger";
        break;
      case "high":
        priorityStyle += "-warning";
        break;
      case "normal":
        priorityStyle += "-primary";   
        break;
      case "low":
        priorityStyle += "-success";
        break;
      default:
        priorityStyle = "-primary";
        break;
    }
    return priorityStyle;
  }
  orderFilter() {
    var _obj = this;
    _obj.setSerchParams();
    console.log(this._filter);
    var priority = true;
    var status = true;
    var date_since = true;
    var search = true;
    if (_obj._filter.priority == "all" && _obj._filter.status == "all" && _obj._filter.date_since == "all" && _obj._filter.search == "") {
      _obj._orderlist = _obj._orderlistCopy;
    } else {
      _obj._orderlist = _obj._orderlistCopy.filter(function (tag) {
        if (tag.order_priority == _obj._filter.priority || _obj._filter.priority == "all") {
          priority = true;
        } else {
          priority = false;
        }
        if (tag.order_status == _obj._filter.status || _obj._filter.status == "all") {
          status = true;
        } else {
          status = false;
        }
        if (_obj.filterByDate(new Date(), tag.order_created_at, _obj._filter.date_since) || _obj._filter.date_since == "all") {
          date_since = true;
        } else {
          date_since = false;
        }
        if (_obj.searchByAtributs(tag, _obj._filter.search) || _obj._filter.search == "") {
          search = true;
        } else {
          search = false;
        }
        if (priority && status && date_since && search) {
          return true;
        } else {
          return false;
        }
      });
    }
  }
  setSerchParams() {
    var _obj = this;
    _obj.serchParams = ['Priorité: ' + _obj._filter.priority, 'Statut :' + _obj._filter.status, 'Dépuis :' + _obj._filter.date_since, 'Mot clé :' + _obj._filter.search];
  }
  reset_filter() {
    this._filter = {
      priority: "all",
      status: "all",
      date_since: "all",
      search: "",
    };
    this.orderFilter();
    this.serchParams = [];
  }
  searchByAtributs(tag, term) {
    if (term == "") return true;
    else term = term.toLowerCase();
    for (var i = 0; i < tag.treatments.length; i++) {
      if (tag.treatments[i].plot_name != null) {
        if ((tag.treatments[i].plot_name.toLowerCase()).indexOf(term) >= 0) { return tag.treatments[i].plot_name.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].cooperative_adherent != null) {
        if ((tag.treatments[i].cooperative_adherent.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].cooperative_adherent.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].cooperative_city != null) {
        if ((tag.treatments[i].cooperative_city.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].cooperative_city.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].cooperative_country != null) {
        if ((tag.treatments[i].cooperative_country.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].cooperative_country.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].farmer_email != null) {
        if ((tag.treatments[i].farmer_email.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].farmer_email.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].farmer_first_name != null) {
        if ((tag.treatments[i].farmer_first_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].farmer_first_name.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].farmer_name != null) {
        if ((tag.treatments[i].farmer_name.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].farmer_name.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].farmer_phone != null) {
        if ((tag.treatments[i].farmer_phone.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].farmer_phone.toLowerCase().indexOf(term) >= 0; }
      }
      if (tag.treatments[i].plot_comment != null) {
        if ((tag.treatments[i].plot_comment.toLowerCase()).toString().indexOf(term) >= 0) { return tag.treatments[i].plot_comment.toLowerCase().indexOf(term) >= 0; }
      }
    }
  }
  filterByDate(date1, date2, unity) {
    var now = moment(date1);
    var dateBefore = moment(date2);
    switch (unity) {
      case "today":
        console.log('days : ' + now.diff(dateBefore, 'days'));
        if (now.diff(dateBefore, 'days') != 0) return false;
        else return true;
      case "yesterday":
        if (now.diff(dateBefore, 'days') != 1) return false;
        else return true;
      case "this_week":
        if (now.diff(dateBefore, 'weeks') != 0) return false;
        else return true;
      case "this_month":
        if (now.diff(dateBefore, 'months') != 0) return false;
        else return true;
      case "this_year":
        if (now.diff(dateBefore, 'years') != 0) return false;
        else return true;
      default:
        return true;
    }
  }
  addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.optionsNotification = {
      position: [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch (options.type) {
      case 'success':
        this.servicePNotify.success(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg,
          options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
    }
  }
  setIdOfUsersUsigLocalSorage() {
    this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));


    switch (this._currentUserInfos.right) {
      case 1:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "a";
        break;
      case 2:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "c";

        break;
      case 3:
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.user_type = "t";
        break;
      case 4:
        this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
        this._idOfUsers.user_type = "f";

        break;
      // case '5':
      //         this._idOfUsers.cooperative_id = 0; 
      //         this._idOfUsers.adherent_id = 0 ;
      //         this._idOfUsers.technician_id = 0 ; 
      //         this._idOfUsers.farmer_id = 0 ;
      //         this._idOfUsers.user_type = "p"  ;

      //     break;
    }
  }
}
