import { Component, OnInit } from '@angular/core';
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { Router } from '@angular/router';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import {NotificationsService} from "angular2-notifications";
import * as $ from 'jquery';

@Component({
  selector: 'app-plot-timeline',
  templateUrl: './plot-timeline.component.html',
  styleUrls: ['./plot-timeline.component.css']
})
export class PlotTimelineComponent implements OnInit {
  

  content = 'Modification de la parcelle par le technicien';
  timeline = [];
  _timelinePrint=false;
  _plotHistorys : any ;
  _selectPlot : any;
  _selectFarmer :any;
  _selectTechnician: any;
  _plot_id=null;
  _farmer_id=null;
  _technician_id=null;
  constructor(private httpService : HttpService,
  	          private authenticationService : AuthenticationService,
  	          private servicePNotify : NotificationsService,
  	          private router : Router){

   }

  ngOnInit() {
  	this.getPlotHistorys(22/*plot_id*/);
  	this.getFarmersByIdTech(10);
  	this.getTechnicianssByIdCoop(11);
  	this.getAllPlotByIdFarmer(32);
  }

  getPlotHistorys(plot_id){
  	    this.httpService.httpPostPromise('getPlotHistorys',{plot_id : plot_id})
                .then((data) =>  {
                  console.log();
                  this._plotHistorys = data ;
                  this.setTimeline();
                
                },(error)=>{
                	console.log(error);
                      
                });
  }

   setTimeline(){
   	this._timelinePrint=false;
   	this.timeline=[];
    var item :any;
    for(var i=0; i<this._plotHistorys.length; i++){

    	var captionDate = new Date(this._plotHistorys[i].created_at);
      var options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric',houre:'numeric' };

      if(i==this._plotHistorys.length-1){
   	   item = { caption:  captionDate.toLocaleDateString('fr-EG', options), date: new Date(this._plotHistorys[i].created_at), title: this._plotHistorys[i].type_history, content: this._plotHistorys[i].description,selected:true };
      }else{
         item = { caption:  captionDate.toLocaleDateString('fr-EG', options), date: new Date(this._plotHistorys[i].created_at), title: this._plotHistorys[i].type_history, content: this._plotHistorys[i].description };
      }
      this.timeline.push(item);
    }
    this._timelinePrint=true;
    console.log(this.timeline);
  }

  getAllPlotByIdFarmer(farmer_id){

   this.httpService.httpPostPromise('getAllPlotByIdFarmer',{id_farmer : farmer_id})
                .then((data) =>  {
                  this._selectPlot = data;
                },(error)=>{
                	console.log(error);    
                });
  }
  
  getFarmersByIdTech(id_technician){
   this.httpService.httpPostPromise('getAllUsersFarmersByIdTech',{id_technician : id_technician})
                .then((data) =>  {
                  this._selectFarmer = data ;
                },(error)=>{
                	console.log(error);
                     
                });
  }
 
  getTechnicianssByIdCoop(cooperative_id){

   this.httpService.httpPostPromise('getAllUsersTechniciansByIdCooperative',{cooperative_id : cooperative_id})
                .then((data) =>  {
                	console.log(data);
                  this._selectTechnician = data;
                },(error)=>{
                	console.log(error);    
                });
  }


}
