import {Component, OnInit} from '@angular/core';
import {fadeInOutTranslate} from '../../shared/elements/animation';
import {Http} from '@angular/http';
import { HttpService } from '../../http.service';
import {AuthenticationService } from '../../_services/index'; 
import { Router } from '@angular/router';
import {NotificationsService} from "angular2-notifications";
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import {LocalStorageDefinition } from '../../_class/LocalStorageDefinition'; 
import { TechnicianService, FarmerService, CooperativeService, ProductService } from '../../_services/index';
import { FormsModule }   from '@angular/forms';
import * as $ from 'jquery';

import '../../../assets/echart/echarts-all.js';

@Component({
    selector: 'app-profile',
    templateUrl: './profile.component.html',
    styleUrls: ['./profile.component.css'],
    animations: [fadeInOutTranslate]
})
export class ProfileComponent implements OnInit {

    _currentUserInfos: any ;
    _idOfUsersJSON_current: any ; 
    _currentUserEmailAndToken: any ;
    _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id":0,"user_type":"t" }; 
    _user_type: any;
    _model = {
              "user_id":'',
              "name":'',
              "first_name":'',
              "adress":'',
              "zip_code":'',
              "city":'',
              "country":'',
              "phone":'',
              "comment":'',
              "email":'',
              "company_code":'',
               };
    _modelPassword = {
              "user_id":'',
              "password":'',
              "newPassword":'',
              "newPasswordConfirm":'',
              };
    _userForm: FormGroup;
    _userFormPassword :  FormGroup;


/////////STOCK Attributes
     _userFormStock :  FormGroup;
     _datestock : string;

    _stock = {
      "add" : null,
      "remove" : null,
      "id_stock": null,
      "id_product":1,
      "current_stock": null,
      "last_update": null,
      "product_name": "Pyrale du maïs"
    }
    private localStorageDefinition : LocalStorageDefinition;
///////////////////////////
    /*  Notify */
      options: any = {
        position: ["bottom", "right"],
      };
      selected : number = 2;
      _productList : [any];

      position1: string = 'bottom';
      position2: string = 'right';
      timeOut: number = 6000;
      showProgressBar: boolean = true;
      pauseOnHover: boolean = true;
      lastOnBottom: boolean = true;
      clickToClose: boolean = true;
      maxLength: number = 0;
      maxStack: number = 8;
      preventDuplicates: boolean = false;
      preventLastDuplicates: boolean = false;
      theClass: string;
      rtl: boolean = false;
      animate: string = 'fromRight';
      icons: string;
      subType: string = 'success';

      title: string;
      msg: string;
    /*  End    */
    editProfile = true;
    editProfileIcon = 'icofont-edit';

    editAbout = true;
    editAboutIcon = 'icofont-edit';

    public editor;
    public editorContent = `<p>
                              But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give
                              you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder
                            </p>`;
    public editorConfig = {
        placeholder: 'About Your Self'
    };

    public data: any;
    public rowsOnPage = 10;
    public filterQuery = '';
    public sortBy = '';
    public sortOrder = 'desc';
    profitChartOption: any;

    constructor(public http: Http,
               private httpService : HttpService,
               public authenticationService :AuthenticationService,
               private router : Router,
               private servicePNotify: NotificationsService,
               private technicianService : TechnicianService, 
               private farmerService : FarmerService, 
               private cooperativeService : CooperativeService,
               private productService : ProductService ) {

      this.localStorageDefinition = new LocalStorageDefinition(this.technicianService, this.farmerService, this.cooperativeService);
      if(this.authenticationService.isLoggedIn()){
        this._currentUserInfos = this.localStorageDefinition.setIdOfUsersUsingLocalStorage(this._idOfUsers, this.cooperativeService, this.technicianService);
        this.set_Model();
        this.set_PasswordModel(); 
        
      }else{
           this.router.navigate(['/login']); //--------------!!!!
      }
    }
   
    ngOnInit() {
        this.userFormControl();
        this.userPasswordFormControl();

        setTimeout(() => {
            this.editorContent = this.editorContent;
            console.log('you can use the quill instance object to do something', this.editor);
            // this.editor.disable();
        }, 2800);

        this.http.get(`assets/data/data.json`)
            .subscribe((data) => {
                this.data = data.json();
            });
        setTimeout(() => {
            this.profitChartOption = {
                tooltip: {
                    trigger: 'item',
                    formatter: function(params) {
                        const date = new Date(params.value[0]);
                        const data = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate() + ' ' + date.getHours() + ':' + date.getMinutes();
                        return data + '<br/>' + params.value[1] + ', ' + params.value[2];
                    },
                    responsive: true
                },
                dataZoom: {
                    show: true,
                    start: 70
                },
                legend: {
                    data: ['Profit']
                },
                grid: {
                    y2: 80
                },
                xAxis: [{
                    type: 'time',
                    splitNumber: 10
                }],
                yAxis: [{
                    type: 'value'
                }],
                series: [{
                    name: 'Profit',
                    type: 'line',
                    showAllSymbol: true,
                    symbolSize: function(value) {
                        return Math.round(value[2] / 10) + 2;
                    },
                    data: (function() {
                        const d: any = [];
                        let len = 0;
                        const now = new Date();
                        while (len++ < 200) {
                            const random1: any = (Math.random() * 30).toFixed(2);
                            const random2: any = (Math.random() * 100).toFixed(2);
                            d.push([ new Date(2014, 9, 1, 0, len * 10000), random1 - 0, random2 - 0 ]);
                        }
                        return d;
                    })()
                }]
            };
        }, 1);
        if(this._idOfUsers.user_type == 'c') {
          this.getAllProduct();
          this.getStock();
          this.init_formGroup();
         }

    }
    set_Model(){
        this._model.name = this._currentUserInfos.name;
        this._model.first_name =this._currentUserInfos.first_name;
        this._model.adress   =this._currentUserInfos.adress;
        this._model.country = this._currentUserInfos. country;
        this._model.city = this._currentUserInfos.city;
        this._model.comment = this._currentUserInfos.comment;
        this._model.phone = this._currentUserInfos.phone;
        this._model.email = this._currentUserInfos.email;
        this._model.zip_code = this._currentUserInfos.zip_code;
        this._model.user_id = this._currentUserInfos.user_id ;
    }
    set_PasswordModel(){
      this._modelPassword.user_id = this._currentUserInfos.user_id ;
    }
        
    ///////////Debut du code qui gère les stocks (a mettre dans une classe)///////////
    update_date(new_date) {
      if(!new_date)
        var date = new Date(Date.now());
      else
        var date = new Date(new_date);
      var options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric',houre:'numeric' };
      this._stock.last_update = date.toLocaleDateString('fr-EG', options);
    }

    init_formGroup() {
      this._userFormStock = new FormGroup({
        'add_stock': new FormControl(this._stock.add, [/* Validators.required*/]),
        'remove_stock': new FormControl(this._stock.remove, [/*Validators.required*/])
      }); 
    }

    change_product(id_product, product_name) {
      this._stock.id_product = id_product
      this._stock.product_name = product_name;
      this.cooperativeService.setProduct(this._stock.id_product);
      this.getStock();
    }

    addStock(){
      console.log(this._stock );
      console.log(this._stock.add);
      console.log(this._stock.remove);
      console.log(this._stock.current_stock);
      if(this._stock.add && this._stock.add>0){
        this._stock.current_stock += this._stock.add ;
        this.update_date(null);
        this.updateCooperativeStock(this._stock.current_stock);
      }
    }

    removeStock(){
      if(this._stock.remove && this._stock.remove>0){
        this._stock.current_stock -= this._stock.remove ;
        this.update_date(null);
        this.updateCooperativeStock(this._stock.current_stock);
      }
    }

    getStock() {
      this.cooperativeService.getStock()
      .subscribe(result => {
        var stock = JSON.parse(result['_body']);
          this._stock.current_stock = stock[0].quantity;
          this.update_date(stock[0].created_at);
          this._stock.id_stock = stock[0].id;
          this.cooperativeService.setProduct(this._stock.id_product); //Au chargement on affiche le produit id:1 (biotop)
          this.cooperativeService.setStockID(this._stock.id_stock);
          
        
      }, err => {
        console.error(err) ;
      });
    }

    getAllProduct(){
      this.productService.getProducts()
        .subscribe(result => {
          var product = JSON.parse(result['_body']);
          console.log(product);
          this._productList = product;
      }, err => {
          console.error(err) ;
      });
    }


    get add_stock() {return this._userFormStock.get('add_stock');}
    get remove_stock() {return this._userFormStock.get('remove_stock');}

    updateCooperativeStock(new_stock) {
      this.cooperativeService.updateStock(new_stock)
      .subscribe(result => {
        var stock = JSON.parse(result['_body']);
        console.log(stock);
      }, err => {
        console.error(err) ;
      });
    }
/////////// Fin ///////////
    toggleEditProfile() {
        this.editProfileIcon = (this.editProfileIcon === 'icofont-close') ? 'icofont-edit' : 'icofont-close';
        this.editProfile = !this.editProfile;
    }

    
   async onSubmit() { 

   await this.httpService.httpPostPromise('updateuser',this._model)
                .then((data) =>  {

                  this.addNotify({title:'Modification de mon compte', msg: 'Vos informations ont été modifiées avec succès !', type:'success'});
                  this.toggleEditProfile();
                  this.setCurrentUser();
                
                },(error)=>{
                  console.log(this._model);
                  console.error(error);
                       this.addNotify({title:'Modification de mon compte', msg: 'Vos informations n\'ont pas été modifiées !', type:'error'});
                });
   }
   setCurrentUser(){
              this._currentUserInfos.user_id = this._model.user_id;
              this._currentUserInfos.name = this._model.name  ;
              this._currentUserInfos.first_name = this._model.first_name ;
              this._currentUserInfos.adress = this._model.adress;
              this._currentUserInfos.zip_code = this._model.zip_code;
              this._currentUserInfos.city = this._model.city  ;
              this._currentUserInfos.country = this._model.country  ;
              this._currentUserInfos.phone= this._model.phone;
              this._currentUserInfos.comment = this._model.comment;
              this._currentUserInfos.email =this._model.email;
              localStorage.setItem('currentUserInfos', JSON.stringify(this._currentUserInfos));
   }
   userFormControl(){
    this._userForm = new FormGroup({
    'name': new FormControl(this._model.name, [
      Validators.required,
      Validators.minLength(4)
    ]),
    'first_name': new FormControl(this._model.first_name,[
      Validators.required,
      Validators.minLength(4)
    ]),
    'adress': new FormControl(this._model.adress, Validators.required),
    'zip_code': new FormControl(this._model.zip_code, [
      Validators.required,
      Validators.minLength(5)
      ]),
     'city': new FormControl(this._model.city, [
      Validators.required,
      Validators.minLength(3)
      ]),
    'country': new FormControl(this._model.country, [
      Validators.required,
      Validators.minLength(3)
      ]),
    'phone': new FormControl(this._model.phone, [
      Validators.required,
      Validators.minLength(10)
      ]),
    'email':  new FormControl(this._model.email, [
      Validators.required,
      Validators.minLength(10),
      Validators.email
      ]),
    // 'company_code': new FormControl(this._model.company_code, [
    //   Validators.minLength(4)
    //   ]),
    'comment': new FormControl(this._model.comment, [
      Validators.maxLength(255)
      ])
    });

   }
    userPasswordFormControl(){
    this._userFormPassword = new FormGroup({
    'password': new FormControl(this._modelPassword.password,[
        Validators.required,
        Validators.minLength(6)
        ]),
    'newPassword': new FormControl(this._modelPassword.newPassword,[
        Validators.required,
        Validators.minLength(6)
        ]),
    'newPasswordConfirm': new FormControl(this._modelPassword.newPasswordConfirm, [
        Validators.required,
        Validators.minLength(6)
        ])
     });
    }

    passwordMatchValidator() {
  
      if(this._userFormPassword.get('newPassword').value === this._userFormPassword.get('newPasswordConfirm').value){

          if(!this._userFormPassword.invalid)   document.getElementById("btn_submit_password").removeAttribute('disabled');

          return  null ;
      }else{ 
          if(this._userFormPassword.controls['newPasswordConfirm'].errors== null){
                 this._userFormPassword.controls['newPasswordConfirm'].setErrors({'mismatch': true});

                if(this._userFormPassword.invalid)   document.getElementById("btn_submit_password").setAttribute("disabled", "disabled");

                return  {'mismatch': true};
          }
      }
   }
   get diagnostic() { return JSON.stringify(this._modelPassword); }

   passwordMatchDB(){
   
      this.httpService.httpPostPromise('checkPassword',this._modelPassword)
                .then((data) =>  {
                   if(data.state==true){

                            document.getElementById("newPasswordConfirm").removeAttribute('disabled') ;
                            document.getElementById("newPassword").removeAttribute('disabled');
                   }
                   else{
                            document.getElementById("newPasswordConfirm").setAttribute("disabled", "disabled") ;
                            document.getElementById("newPassword").setAttribute("disabled", "disabled") ;

                   }
                },(error)=>{

                           this.addNotify({title:'Modification de mot de passe', msg: 'Un problème vient de serveur !', type:'error'});

                });
                
   }

   passwordUpdate(){
         this.httpService.httpPostPromise('updateUserPassword',this._modelPassword)
                .then((data) =>  {

                 this.addNotify({title:'Modification de mot de passe', msg: 'Votre mot de passe a été modifié avec succès !', type:'success'});
                 this._userFormPassword.reset();
                 document.getElementById("newPasswordConfirm").setAttribute("disabled", "disabled") ;
                 document.getElementById("newPassword").setAttribute("disabled", "disabled") ;
                
                },(error)=>{
                       this.addNotify({title:'Modification de mot de passe', msg: 'Un problème vient de serveur !', type:'error'});
                });

   }
   
    get name() {return this._userForm.get('name');}
    get first_name() {return this._userForm.get('first_name');}
    get password() {return this._userFormPassword.get('password');}
    get newPassword() {return this._userFormPassword.get('newPassword');}
    get newPasswordConfirm() { return this._userFormPassword.get('newPasswordConfirm');}
    get email() {return this._userForm.get('email');}
    get adress() {return this._userForm.get('adress');}
    get zip_code() {return this._userForm.get('zip_code');}
    get city() {return this._userForm.get('city');}
    get country() {return this._userForm.get('country');}
    get phone() {return this._userForm.get('phone');}
    get comment() {return this._userForm.get('comment');}
   // get company_code() {return this.FarmerForm.get('company_code');}
   // get diagnostic() { return JSON.stringify(this._model); }

   addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.options  = {
      position : [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch(options.type) {
      case 'success':
        this.servicePNotify.success(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg,
            options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
            options.title ? options.title : this.title,
            options.msg ? options.msg : this.msg
        );
        break;
    }
  }


}
