import { SimpleChange, OnChanges,AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone } from '@angular/core';
// import * as licenseTxt from 'raw-loader!./license/luciadria_development.txt';
// import * as License from 'luciad/util/License';
// import { DeviceDetector } from '../../_class/DeviceDetector';
// import { NetworkConnectionDetector } from '../../_class/NetworkConnectionDetector';
// License.setLicenseText(licenseTxt);

import 'rxjs/add/operator/toPromise';
import * as WebGLMap from 'luciad/view/WebGLMap';
import * as Map from "luciad/view/Map";
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
// import { LayerFactory } from './LayerFactory';
import { GoogleMaps } from '../../_class/GoogleMaps';
import { BingMapsDataLoader } from '../../_class/BingMapsDataLoader';
import * as  ShapeFactory from 'luciad/shape/ShapeFactory';
import * as  LayerGroup from 'luciad/view/LayerGroup';
import * as  LayerTreeControl from 'samples/common/control/LayerTreeControl';
import * as  LayerConfigUtil from 'samples/common/LayerConfigUtil';

/* Start Import file for create and edit feature */
import * as  Feature from 'luciad/model/feature/Feature';
import * as  FeatureModel from 'luciad/model/feature/FeatureModel';
import * as  BasicCreateController from 'luciad/view/controller/BasicCreateController';
import * as  EditController from 'luciad/view/controller/EditController';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  RestStore from 'samples/common/store/RestStore';
import * as  ShapeType from 'luciad/shape/ShapeType';
import * as  MemoryStore from 'luciad/model/store/MemoryStore';
import * as templateSample from "samples/template/sample";
import * as  domConstruct from "luciad/dojo/dom-construct";
import * as  dConstruct from "luciad/dojo/dom-construct";

/* Start Import file for create clustering access points feature */
import * as  ClusteringTransformer from 'luciad/view/feature/transformation/ClusteringTransformer';
import * as  ClusteringPainterWrapper from "samples/clustering/ClusteringPainterWrapper";
import * as ClusterIconStyleUtil from "samples/clustering/ClusterIconStyleUtil";
import * as  IconFactory from "samples/common/IconFactory";

import * as  BasicFeaturePainter from 'luciad/view/feature/BasicFeaturePainter';
// import { PlotDataLoader } from './PlotDataLoader';
import * as  Promise from "luciad/util/Promise";
import * as LayerType from 'luciad/view/LayerType';
import * as ShapePainterContour from "samples/shapePainter/ShapePainterContour";
import * as ShapePainterObstacle from "samples/shapePainter/ShapePainterObstacle";
import * as  ShapePainterOrdrePoint from 'luciad/shape/ShapePainterOrdrePoint';
import * as  ShapePainterContourOptimisation from 'luciad/shape/ShapePainterContour';
import * as  ShapePainterCircle from 'luciad/shape/ShapePainterCircle';
import * as  PaintRepresentation from "luciad/view/PaintRepresentation";
import * as GestureEventType from "luciad/view/input/GestureEventType";
import * as TransformationFactory from "luciad/transformation/TransformationFactory";

/* Start Import file for create and validate a form */
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { Router } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { SelectOptionService } from "../../shared/elements/select-option.service";
import { IOption } from "ng-select";
import * as $ from 'jquery';
@Component({
  selector: 'app-ria-map',
  templateUrl: './ria-map.component.html',
  styleUrls: ['./ria-map.component.css']
})
export class RiaMapComponent implements  OnChanges,AfterViewInit, OnDestroy {
  @ViewChild('map') mapElem: ElementRef;

  label = "";
  progress = 0;
  _map: any;
  glLayer: any;
  _featureLayerPlotsDB: FeatureLayer;
  _featureLayerAccessPointDB : FeatureLayer;
  _featureLayerObstaclesDB: FeatureLayer;
  _featureLayerPissosDB: FeatureLayer;
  @Input() MAPREFERENCE;
  @Input() PLOTS;
  changeLog: string[] = [];
  // @Input () ;
  constructor(
    private cdRef: ChangeDetectorRef,
    private _ngZone: NgZone
  ) { }

  ngOnInit() {
  }
  ngOnChanges(changes: {[propKey: string]: SimpleChange}) {
    let log: string[] = [];
    for (let propName in changes) {
      console.log(propName);
      // let changedProp = changes[propName];
      // let to = JSON.stringify(changedProp.currentValue);
      // if (changedProp.isFirstChange()) {
      //   log.push(`Initial value of ${propName} set to ${to}`);
      // } else {
      //   let from = JSON.stringify(changedProp.previousValue);
      //   log.push(`${propName} changed from ${from} to ${to}`);
      // }
      if(propName=="PLOTS"){
        let changedProp = changes[propName];
        if (changedProp.isFirstChange()) {
              // to do
              // this.addAllLayer();
        }else{
          console.log('PLOTS has chaged') ;
          this.removeAllFeatures();
          this.printPolygoneContour(this.PLOTS);
        }
      }
    }
    this.changeLog.push(log.join(', '));
    // console.log(log);
  }
  ngAfterViewInit() {
    
    this.processOutsideOfAngularZone();
  }
  zoomOnFeature(plot_id) {
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      if (this._featureLayerPlotsDB.model.store._data[i].properties.plot_id == plot_id) {
        var shape_id_poly = this._featureLayerPlotsDB.model.store._data[i].id;
        console.log(this._featureLayerPlotsDB.model.store);
        this._map.mapNavigator.fit(this._featureLayerPlotsDB.model.get(shape_id_poly).shape.bounds);
      }
    }
  }
  ngOnInitAfterView() {
    var _obj = this;
    var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); // 2D "EPSG:900913"  EPSG:4326=2D and EPSG:4978=3D
    this._map = new Map(this.mapElem.nativeElement, { reference: ReferenceProvider.getReference(this.MAPREFERENCE) });

    this.glLayer = GoogleMaps.startup(this._map);
    BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {
      _obj._map.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");
    });
    new LayerTreeControl(this._map, { domId: "controlcontainer", title: "CALQUES" });
    this.addAllLayer();
    // this.glLayer = GoogleMaps.startup(this._map);
    // //Add layer controller to the application
    // this.addMapLayer().then((data) => {
    //   console.log(data);
    // }).catch((error) => {
    //   console.log(error);
    // });
    // this.activeSelectionChanged(this);
    // this.loadDataMap(this._idOfUsers);
    // this.roadmap_init();
    // this.fitOnFranceOnLoad(this.roadmap);
    // this.getGeolocation();
    $(function () {
      // Toggle info panel
      $("#showinfo").click(function () {
        $('#showinfo').toggleClass('active');
        $("#infopanel").fadeToggle();
      });
    });
    $(function () {
      // Toggle info panel
      $("#showinfoRoadMap").click(function () {
        $('#showinfoRoadMap').toggleClass('active');
        $("#infopanelRoadMap").fadeToggle();
      });
    });
  }
  addAllLayer() {
    if (this.PLOTS) {
      var painterContour = new ShapePainterContour();
      this._featureLayerPlotsDB = this.createFeatureLayerWithPainter("Parcelles", painterContour);
      this._map.layerTree.addChild(this._featureLayerPlotsDB);
      this.createFeatureLayerWithClustering("Points d'accées");
      this._map.layerTree.addChild(this._featureLayerAccessPointDB);
    }
  }  
  printPolygoneContour(plot_infos_geometry) {
    console.log(plot_infos_geometry);
    var ref = ReferenceProvider.getReference("EPSG:4326");
    for (var i = 0; i < plot_infos_geometry.length; i++) {

      var poly = ShapeFactory.createPolygon(ref, []);
      var access_pointDB = JSON.parse(plot_infos_geometry[i].plot_access_point);
      var access_point = ShapeFactory.createPoint(ref, access_pointDB.coordinates);

      var polyDB = JSON.parse(plot_infos_geometry[i].plot_geometry).coordinates[0];
      for (var j = 0; j < polyDB.length; j++) {
        var marker = ShapeFactory.createPoint(ref, [polyDB[j][0], polyDB[j][1], polyDB[j][2]]);
        poly.insertPoint(j, marker);
      }
      var plot_properties = {
        farmer_id: plot_infos_geometry[i].farmer_id,
        farmer_first_name: plot_infos_geometry[i].farmer_fisrt_name,
        farmer_name: plot_infos_geometry[i].farmer_name,
        farmer_phone: plot_infos_geometry[i].farmer_phone,

        technician_id: plot_infos_geometry[i].technician_id,
        technician_first_name: plot_infos_geometry[i].technician_first_name,
        technician_name: plot_infos_geometry[i].technician_name,

        plot_id: plot_infos_geometry[i].plot_id,
        plot_name: plot_infos_geometry[i].plot_name,
        plot_area: plot_infos_geometry[i].plot_area,
        plot_lat_access_point: access_point[0],
        plot_lon_access_point: access_point[1],
        plot_power_line: plot_infos_geometry[i].plot_power_line,
        plot_irrigation: plot_infos_geometry[i].plot_irrigation,
        plot_comment: plot_infos_geometry[i].plot_comment,

        cooperative_id: plot_infos_geometry[i].cooperative_id,
        cooperative_name: plot_infos_geometry[i].cooperative_name,

        cooperative_adherent_id: plot_infos_geometry[i].cooperative_id,
        cooperative_adherent_name: plot_infos_geometry[i].cooperative_adherent,

      };
      var markerFeaturePlot = new Feature(poly);
      var markerFeatureAccessPoint = new Feature(access_point);
      markerFeaturePlot.properties = plot_properties;
      markerFeatureAccessPoint.properties = plot_properties;
      //Décommenter pour faire apparaitre le tableauDePoints
      var shape_id = this._featureLayerPlotsDB.model.add(markerFeaturePlot);
      this._featureLayerAccessPointDB.model.add(markerFeatureAccessPoint);
    }
    this._map.mapNavigator.fit({bounds: this._featureLayerPlotsDB.bounds, animate: true});
  }
  removeAllFeatures(){
    for (var i = this._featureLayerPlotsDB.model.store._data.length - 1; i >= 0; i--) {
      console.log(this._featureLayerPlotsDB.model.store._data[i].id);
      this._featureLayerPlotsDB.model.remove(this._featureLayerPlotsDB.model.store._data[i].id);
    }
    for (var i = this._featureLayerAccessPointDB.model.store._data.length - 1; i >= 0; i--) {
      console.log(this._featureLayerAccessPointDB.model.store._data);
      this._featureLayerAccessPointDB.model.remove(this._featureLayerAccessPointDB.model.store._data[i].id);
    }
    // for (var i = this._featureLayerObstaclesDB.model.store._data.length - 1; i >= 0; i--) {
    //   console.log(this._featureLayerObstaclesDB.model.store._data);
    //   this._featureLayerObstaclesDB.model.remove(this._featureLayerObstaclesDB.model.store._data[i].id);
    // }
  }
  createFeatureLayerWithPainter(label, shapePainter) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: true,
      label: label,
      painter: shapePainter
    });
  }
  createFeatureLayerWithClustering(label) {
    var _obj = this;
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    var featureStore = new MemoryStore();
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    var armedEventsPainter = new BasicFeaturePainter();

    armedEventsPainter.getDetailLevelScales = function () {
      return [1 / 2000000];
    };

    armedEventsPainter.paintLabel = function (labelcanvas, feature, shape, layer, map, paintState) {
      if (paintState.level === 1) {
      }
    };

    armedEventsPainter.paintBody = function (geocanvas, feature, shape, layer, map, paintState) {
      if (paintState.selected) {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_SELECTED_STYLE);
      } else {
        geocanvas.drawIcon(shape.focusPoint, this.EVENT_STYLE);
      }
    };

    var clusterPainter = new ClusteringPainterWrapper(armedEventsPainter);
    clusterPainter.paintClusterBody = function (geocanvas, feature, shape, layer, map, paintState) {
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getOuterStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getInnerStyle(feature, paintState.selected));
      geocanvas.drawIcon(shape.focusPoint, ClusterIconStyleUtil.getTextStyle(feature));
      if (paintState.selected) {
        // Paint clustered elements when selecting a cluster
        var clusteredFeatures = ClusteringTransformer.clusteredFeatures(feature);
        for (var i = 0; i < clusteredFeatures.length; i++) {
          var clusteredFeature = clusteredFeatures[i];
          armedEventsPainter.paintBody(geocanvas, clusteredFeature, clusteredFeature.shape, layer, map, paintState);
        }
      }
    };

    var j = 0;
    clusterPainter.paintClusterLabel = function (labelCanvas, feature, shape, layer, map, state) {

      layer.balloonContentProvider = function (o) { //============> Start============>
        console.log(o);

        var _tempModelPoint = ShapeFactory.createPoint(o.geometry._reference, [o.geometry[0], o.geometry[1]]);
        this._tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
        var _tempMapPoint = ShapeFactory.createPoint(map.reference, [0, 0]);
        var _transformation = TransformationFactory.createTransformation(o.geometry._reference, map.reference);
        _transformation.transform(_tempModelPoint, _tempMapPoint);
        map.mapToViewTransformation.transform(_tempMapPoint, this._tempViewPoint);
        this.viewPointCenter = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var centerOfView = ShapeFactory.createPoint(null, [map.viewSize[0] / 2, map.viewSize[1] / 2]);
        var xCenter = (map.viewSize[0] / 2) - this._tempViewPoint[0];
        var yCenter = (map.viewSize[1] / 2) - this._tempViewPoint[1];
        var offsetFromCenterOfView = centerOfView.copy();
        offsetFromCenterOfView.translate(xCenter, yCenter + 100);
        map.mapNavigator.pan({ targetLocation: centerOfView, toViewLocation: offsetFromCenterOfView, animate: { duration: 200 } })

        console.log(this.viewPointCenter);
        var plots;
        var plots_count = 0;
        var plot_area = 0;
        var tabIdFarmer = [];
        var tabIdTech = [];
        var tabIdCoop = [];
        var tabIdAdhe = [];
        var plot_treatment = {
          count_total_treatment: 0,
          percentage_total_treatment: 0,
          count_treatment_finished: 0,
          percentage_treatment_finished: 0,
          print_div_treatment_finished: "none",
          count_treatment_in_progress: 0,
          percentage_treatment_in_progress: 0,
          print_div_treatment_in_progress: "none",
          count_treatment_preorder: 0,
          percentage_treatment_preorder: 0,
          print_div_treatment_preorder: "none",
          count_treatment_ordered: 0,
          percentage_treatment_ordered: 0,
          print_div_treatment_ordered: "none",
          print_div_treatment: "none",
        }
        var plot_properties = o.properties, node;
        node = domConstruct.toDom('<div class="card-body-ballon"> </div>');

        if (!plot_properties.clusteredElements) {
          plots = plot_properties; // Feature with properties
         
        } else {

          plots = plot_properties.clusteredElements;
        }

        if (!plot_properties.clusteredElements) {         //========Node for single plot=====> Start 

          plots_count++;
          plot_area += parseFloat(plots.plot_area);
          // plot_treatment.count_total_treatment = plots.plot_treatment.length;
          // if (plots.plot_treatment.length > 0) {
          //   plot_treatment.print_div_treatment = "block";
          // }
          // for (var i = 0; i < plots.plot_treatment.length; i++) {
          //   if (plots.plot_treatment[i].treatment_status == "precommande") {
          //     plot_treatment.count_treatment_preorder++;
          //     plot_treatment.print_div_treatment_preorder = "block";

          //   }
          //   if (plots.plot_treatment[i].treatment_status == "commande") {
          //     plot_treatment.count_treatment_ordered++;
          //     plot_treatment.print_div_treatment_ordered = "block";
          //   }
          //   if (plots.plot_treatment[i].treatment_status == "en-cours") {
          //     plot_treatment.count_treatment_in_progress++;
          //     plot_treatment.print_div_treatment_in_progress = "block";
          //   }
          //   if (plots.plot_treatment[i].treatment_status == "termine") {
          //     plot_treatment.count_treatment_finished++;
          //     plot_treatment.print_div_treatment_finished = "block";
          //   }
          // }
          // plot_treatment.percentage_total_treatment = (plot_treatment.count_treatment_preorder * 25 + plot_treatment.count_treatment_ordered * 50 + plot_treatment.count_treatment_in_progress * 75 + plot_treatment.count_treatment_finished * 100) * 100 / (plot_treatment.count_total_treatment * 100);
          // plot_treatment.percentage_treatment_preorder = plot_treatment.count_treatment_preorder * 100 / plot_treatment.count_total_treatment;
          // plot_treatment.percentage_treatment_ordered = plot_treatment.count_treatment_ordered * 100 / plot_treatment.count_total_treatment;
          // plot_treatment.percentage_treatment_in_progress = plot_treatment.count_treatment_in_progress * 100 / plot_treatment.count_total_treatment;
          // plot_treatment.percentage_treatment_finished = plot_treatment.count_treatment_finished * 100 / plot_treatment.count_total_treatment;

          var nodeSinglePlot = domConstruct.toDom('\
                                                        <div class="row">\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title-ballon" style="color: #a9bc14;">Information sur la parcelle</h4>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nom parcelle : '+ plots.plot_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nom agriculteur : '+ plots.farmer_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Prenom agriculteur : '+ plots.farmer_first_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Téléphone : '+ plots.farmer_phone + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Adhérent : '+ plots.cooperative_adherent_name + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : '+ plots_count + '</p>\
                                                            <p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie Totale : '+ plot_area.toFixed(2).toString() + ' Ha</p>\
                                                          </div>\
                                                          <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                            <h4 class="sub-title-ballon" style="color: #a9bc14;">Statistique</h4>\
                                                            <p>État d\'avancement</p>\
                                                            <div style="display :'+ plot_treatment.print_div_treatment + '">\
                                                              <div class="progress">\
                                                                  <div class="progress-bar progress-bar-striped active" role="progressbar"aria-valuenow="40" aria-valuemin="0" aria-valuemax="100" style="width:'+ plot_treatment.percentage_total_treatment + '%" title="Nombre de traitements est :' + plot_treatment.count_total_treatment + '">\
                                                                        '+ plot_treatment.percentage_total_treatment.toFixed(2) + '%\
                                                                  </div>\
                                                              </div><br>\
                                                              <div class="progress" id="progressBarDetaille">\
                                                                <div class="progress-bar progress-bar-info" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_preorder + '; width:' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%" data-toggle="tooltip" title="Précommande / Nombre de traitements est :' + plot_treatment.count_treatment_preorder + '">' + plot_treatment.percentage_treatment_preorder.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-danger" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_ordered + ';width:' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%" data-toggle="tooltip" title="Confirmé / Nombre de traitements est :' + plot_treatment.count_treatment_ordered + '">' + plot_treatment.percentage_treatment_ordered.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-success" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_in_progress + ';width:' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%"; background-color: #AAAAAA" data-toggle="tooltip" title="En cours / Nombre de traitements est :' + plot_treatment.count_treatment_in_progress + '">' + plot_treatment.percentage_treatment_in_progress.toFixed(2) + '%</div>\
                                                                <div class="progress-bar progress-bar-warning" role="progressbar" style="display :'+ plot_treatment.print_div_treatment_finished + ';width:' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%"; background-color: #606060" data-toggle="tooltip" title="Terminé / Nombre de traitements est :' + plot_treatment.count_treatment_finished + '">' + plot_treatment.percentage_treatment_finished.toFixed(2) + '%</div>\
                                                              </div>\
                                                            </div>\
                                                          </div>\
                                                        </div>\
                                                   ');
                                                   
                                              //  <div style="margin-top: 7px;float: right;">\
                                              //      <a href="javasript:;" class="btn btn-info btn-mini b-none"><span class="badge">'+ plots.plot_treatment.length + '</span></a>\
                                              //  </div>\
          var domDisplayAllPlots = domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;"><b>Voir toutes les parcelles </b> </p>');
          domDisplayAllPlots.addEventListener("click", function () { });

          domConstruct.place(nodeSinglePlot, node);
          domConstruct.place(domDisplayAllPlots, nodeSinglePlot);   //========>End
        } else {                          //========Node for multiples plots=====> Start 


          plots_count += plot_properties.clusteredElements.length;

          var nodeRow = domConstruct.create("div", null, node, "last");
          nodeRow.setAttribute("class", "row");

          var nodeSelects = domConstruct.create("div", null, nodeRow, 'last');
          nodeSelects.setAttribute("class", "col-sm-12 col-xl-6 m-b-30-ballon");

          var nodeTitle = domConstruct.toDom('\
                                                <h4 class="sub-title-ballon" style="color: #a9bc14;">Filtre</h4>\
                                          ');

          domConstruct.place(nodeTitle, nodeSelects);


          var selectFarmer = domConstruct.create("select", null);
          selectFarmer.setAttribute("class", "form-control form-control-info");
          selectFarmer.setAttribute("name", "farmerSelect");
          selectFarmer.setAttribute("style", "margin-bottom: 10px;");
          selectFarmer.addEventListener("change", function () { });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des agriculteurs</option>'), selectFarmer);

          var selectTechnician = domConstruct.create("select", null);
          selectTechnician.setAttribute("class", "form-control form-control-info");
          selectTechnician.setAttribute("name", "technicianSelect");
          selectTechnician.setAttribute("style", "margin-bottom: 10px;");
          selectTechnician.addEventListener("change", function () { });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des techniciens</option>'), selectTechnician);

          var selectCooperative = domConstruct.create("select", null);
          selectCooperative.setAttribute("class", "form-control form-control-info");
          selectCooperative.setAttribute("name", "cooperativeSelect");
          selectCooperative.setAttribute("style", "margin-bottom: 10px;");
          selectCooperative.addEventListener("change", function () { });
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des cooperatives</option>'), selectCooperative);

          var selectAdherent = domConstruct.create("select", null);
          selectAdherent.setAttribute("class", "form-control form-control-info");
          selectAdherent.setAttribute("name", "cooperativeSelect");
          selectAdherent.setAttribute("style", "margin-bottom: 10px;");
          selectAdherent.addEventListener("change", function () {});
          domConstruct.place(domConstruct.toDom('<option value="0">Liste des adhérents</option>'), selectAdherent);


          // if (_obj._currentUserInfos.right == 1/*ADMIN*/) {

          //   domConstruct.place(selectCooperative, nodeSelects);
          //   domConstruct.place(selectAdherent, nodeSelects);
          //   domConstruct.place(selectTechnician, nodeSelects);
          //   domConstruct.place(selectFarmer, nodeSelects);

          // } else if (_obj._currentUserInfos.right == 2/*COOPERATIVE*/) {

          //   domConstruct.place(selectAdherent, nodeSelects);
          //   domConstruct.place(selectTechnician, nodeSelects);
          //   domConstruct.place(selectFarmer, nodeSelects);

          // } else if (_obj._currentUserInfos.right == 3/*TECHNICIAN*/) {

          //   domConstruct.place(selectFarmer, nodeSelects);

          // } else if (_obj._currentUserInfos.right == 4/*FARMER*/) {

          // }

          for (var i = 0; i < plots.length; i++) {

            plot_area += parseFloat(plots[i].properties.plot_area);
            if (!_obj.verifieExistance(tabIdFarmer, plots[i].properties.farmer_id)) {
              tabIdFarmer[i] = plots[i].properties.farmer_id;
              var hrefAgriParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"f"}';
              var b = dConstruct.create("option", { innerHTML: plots[i].properties.farmer_name + " " + plots[i].properties.farmer_first_name + "</a>" }, selectFarmer, "last");
              b.setAttribute("value", hrefAgriParcelle);
            }
            if (!_obj.verifieExistance(tabIdTech, plots[i].properties.technician_id)) {
              tabIdTech[i] = plots[i].properties.technician_id;
              var hrefTecParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"t"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.technician_name + " " + plots[i].properties.technician_first_name }, selectTechnician, "last");
              c.setAttribute("value", hrefTecParcelle);
            }
            if (!_obj.verifieExistance(tabIdCoop, plots[i].properties.cooperative_id)) {
              tabIdCoop[i] = plots[i].properties.cooperative_id;
              var hrefCoopParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_name }, selectCooperative, "last");
              c.setAttribute("value", hrefCoopParcelle);
            }

            if (!_obj.verifieExistance(tabIdAdhe, plots[i].properties.cooperative_adherent_id)) {
              tabIdAdhe[i] = plots[i].properties.cooperative_adherent_id;
              var hrefAdheParcelle = '{"f":' + plots[i].properties.farmer_id + ',"t":' + plots[i].properties.technician_id + ',"a":' + plots[i].properties.cooperative_id + ',"c":' + plots[i].properties.cooperative_adherent_id + ',"s":"c"}';
              var c = dConstruct.create("option", { innerHTML: plots[i].properties.cooperative_adherent_name }, selectAdherent, "last");
              c.setAttribute("value", hrefAdheParcelle);
            }

          }
          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Nombre de parcelles : ' + plots.length + '</p>'), nodeSelects);
          domConstruct.place(domConstruct.toDom('<p style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;">Superficie totale : ' + plot_area.toFixed(2).toString() + ' Ha</p>'), nodeSelects);
          var domAllPlots = domConstruct.toDom('<p  style="border-bottom: 1px solid rgba(204, 204, 204, 0.35);margin-top: 0.5em;margin-bottom: 0.5em;"><b>Voir toutes les parcelles </b> </p>');
          domAllPlots.addEventListener("click", function () {  });
          domConstruct.place(domAllPlots, nodeSelects);
          var nodeStatistique = domConstruct.toDom('\
                                                    <div class="col-sm-12 col-xl-6 m-b-30-ballon">\
                                                      <h4 class="sub-title-ballon" style="color: #a9bc14;">Statistiques</h4>\
                                                      <p style="visibility: hidden;">Add type<code _ngcontent-c6="">&lt;input type="month"&gt;</code></p>\
                                                    </div>\
                                                  ');
          domConstruct.place(nodeStatistique, nodeRow);
          domConstruct.place(nodeRow, node);
        }    //========Node for multiples plots=====> End
        // var divFooter =  domConstruct.toDom("<br><h1> refNode </h1>");
        // domConstruct.create(node,{},divFooter);
        // domConstruct.place(divFooter,node);

        return node;
      } //============>End ============>
    };

    var clusterParam1 = ClusteringTransformer.create({
      defaultParameters: {
        clusterSize: 150
      }
    });

    var clusterParam2 = ClusteringTransformer.create({
      defaultParameters: {
        noClustering: "disable"
      }
    });

    this._featureLayerAccessPointDB = new FeatureLayer(featureModel, {
      label: label,
      selectable: true,
      editable: true,
      painter: clusterPainter,
      transformer: clusterParam1
    }
    );
  }
  verifieExistance(tabId, id) {
    var val = 0;
    for (var i = 0; i < tabId.length; i++) {
      if (tabId[i] == id) { return 1; }
    }
    return val;
  }
  ngOnDestroy() {

  }
  processWithinAngularZone() {
    this.label = 'inside';
    this.progress = 0;
    this._increaseProgress(() => console.log('Inside Done!'));
  }
  processOutsideOfAngularZone() {
    this.label = 'outside';
    this.progress = 0;
    this._ngZone.runOutsideAngular(() => {
      this._increaseProgress(() => {
        this.ngOnInitAfterView();
        // reenter the Angular zone and display done
        this._ngZone.run(() => {
          //REMOVE LOADER NODE

          //REMOVE LOADER NODE
          console.log('Outside Done!');
        });
      });
    });
  }
  _increaseProgress(doneCallback: () => void) {
    this.progress += 1;
    this.cdRef.detectChanges();
    // console.log(`Current progress: ${this.progress}%`);

    if (this.progress < 100) {
      window.setTimeout(() => this._increaseProgress(doneCallback), 10);
    } else {
      doneCallback();
    }
  }
}
