import { Component, OnInit,ViewEncapsulation } from '@angular/core';
import {Http} from "@angular/http";
import { HttpService } from '../../http.service';
import {AuthenticationService,TechnicianService, CooperativeService} from '../../_services/index'; 
import { Router } from '@angular/router';
import {fadeInOutTranslate} from "../../shared/elements/animation"; 
import {NotificationsService} from "angular2-notifications";
import swal from 'sweetalert2';
import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { Technician }    from '../../technician';


@Component({
  selector: 'app-technician-list',
  templateUrl: './technician-list.component.html',
  styleUrls: ['./technician-list.component.css'],
  animations: [fadeInOutTranslate],
  encapsulation: ViewEncapsulation.None
})
export class TechnicianListComponent implements OnInit {
   data: any;
   rowsOnPage: number = 10;
   filterQuery = '';
   sortBy: string = "";
   sortOrder: string = "desc";
  _currentUserInfos : any ;
  _usersTechnicianByIdTech :any ;
  _usersTechnicianByIdTechCopy :any ;
  _currentUserEmailAndToken : any ;
  user = {
    active: 0,
    adherent: null,
    adress: null,
    city: null,
    comment: null,
    company_code: null,
    country: null,
    created_at: null,
    email: null,
    first_name: null,
    id: null,
    id_technician: null,
    id_user: null,
    user_id: null,
    id_user_v1: null,
    name: null,
    password: null, 
    phone: null, 
    remember_token: null,
    right: null, 
    updated_at: null,
    zip_code :null,
  };
  _modal_user = {
    storage: this.user,
    update: this.user,
    idx: null
  };
  _password = {
    user_id: "",
    newPassword: "",
    password: "",
    newPasswordConfirm: ""
  }

  TechnicianForm: FormGroup;
  TechnicianPasswordForm: FormGroup;
  _idOfUsers = { "cooperative_id" : 0, "technician_id": 0, "farmer_id":0,"user_type":"t" };
   searchTerm :any ; 
  /*  Notify */
  options: any = {
    position: ["bottom", "right"],
  };
  _radio = {
    password: "0"
  }

  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';
  model : Technician ;

  title: string;
  msg: string;
  editIcon = 'icofont-edit';
  /*  End    */

  constructor(
  	      public authenticationService: AuthenticationService,
  			  public technicianService: TechnicianService,
  			  public cooperativeService : CooperativeService,
  			  public router: Router,
  			  public http: Http,
          public httpService: HttpService
  			  ) { 
  	
  }

  ngOnInit() {
    this.http.get(`assets/data/data.json`)
      .subscribe((data)=> {
         this.data = data.json();
         //console.log(this.data) ;
      });
    if(this.authenticationService.isLoggedIn()){
         this.setIdOfUsersUsigLocalSorage();
         this.getallTechniciansByIdCoop();
         this.formControl();
    }else{
      this.router.navigate(['/login']);
    } 

  }
   
   setIdOfUsersUsigLocalSorage(){
   this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));
     
        switch (this._currentUserInfos.right) {
          case 1: 
                  this._idOfUsers.cooperative_id = 0; 
                  this._idOfUsers.technician_id = 0  ; 
                  this._idOfUsers.farmer_id = 0  ;
                  this._idOfUsers.user_type = "a"  ;
              break;
          case 2:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0; 
                  this._idOfUsers.farmer_id = 0;
                  this._idOfUsers.user_type = "c"  ;
            
              break;
          case 3:
                  this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
                  this._idOfUsers.technician_id =  this._currentUserInfos.tchnicians_id ; 
                  this._idOfUsers.farmer_id = 0 ;
                  this._idOfUsers.user_type = "t"  ;
              break;
          case 4:
                  this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id; 
                  this._idOfUsers.technician_id = 0 ; 
                  this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id ;
                  this._idOfUsers.user_type = "f"  ;
              
              break;
          // case '5':
          //         this._idOfUsers.cooperative_id = 0; 
          //         this._idOfUsers.adherent_id = 0 ;
          //         this._idOfUsers.technician_id = 0 ; 
          //         this._idOfUsers.farmer_id = 0 ;
          //         this._idOfUsers.user_type = "p"  ;
              
          //     break;
      }
  }
    
  getallTechniciansByIdCoop(){
     // console.log(this._currentUserInfos.cooperatives_id);
    this.cooperativeService.getallTechniciansByIdCoop('getAllUsersTechByIdCoop',{cooperative_id : this._currentUserInfos.cooperatives_id})
                .then((data) =>  {
                  this._usersTechnicianByIdTech = JSON.parse(data['_body']) ;
                  this._usersTechnicianByIdTechCopy = JSON.parse(data['_body']) ;
                  this.data = this._usersTechnicianByIdTech ;
                },(error)=>{
                  console.error(error);
                      // this.addNotify({title:'Arbre des coopératives', msg: 'problème vient de serveur ! rafraichir la page :(', type:'error'});
                });
  }
  
  search(): void {

    if(this.searchTerm == "") {
      this._usersTechnicianByIdTech = this._usersTechnicianByIdTechCopy; 
    }else{
      let term = this.searchTerm;

      this._usersTechnicianByIdTech = this._usersTechnicianByIdTechCopy.filter(function(tag) {
          if(tag.name!=null){
           if(tag.name.indexOf(term) >= 0){ return tag.name.indexOf(term) >= 0 ; }
          }
          if(tag.country!=null){
            if(tag.country.indexOf(term) >= 0){ return tag.country.indexOf(term) >= 0; }
          }
          if(tag.adress!=null){
            if(tag.adress.indexOf(term) >= 0){ return tag.adress.indexOf(term) >= 0;}
          }
          if(tag.email!=null){
            if(tag.email.indexOf(term) >= 0){ return tag.email.indexOf(term) >= 0; }
          }
          if(tag.farmer_name!=null){
            if(tag.farmer_name.indexOf(term) >= 0){ return tag.farmer_name.indexOf(term) >= 0;}
          }
          if(tag.phone!=null){
            if(tag.phone.indexOf(term) >= 0){ return tag.phone.indexOf(term) >= 0;}
          }
          if(tag.comment!=null){
            if(tag.comment.indexOf(term) >= 0){  return tag.comment.indexOf(term) >= 0;}
          }
      }); 
    }
 }

  fillForm(user_id) {
    // Get the user's index in the json of user array (first it transform the object array 
    // into a id_user array then get the index of user's id)   
    this._modal_user.idx = this._usersTechnicianByIdTech.map(function(e) { return e.id_user; }).indexOf(user_id);
    // console.log(this._usersTechnicianByIdTech[idx]);
    
     this._modal_user.storage = Object.assign({}, this._usersTechnicianByIdTech[this._modal_user.idx]);  
     this._modal_user.update = Object.assign({}, this._usersTechnicianByIdTech[this._modal_user.idx]);
     console.log(this._modal_user.storage);
     this._modal_user.update.user_id = this._modal_user.update.id_user;
     this._password.user_id = this._modal_user.update.id_user;
  }    
  
  toggleEditTechnician(user_id) {
    this.fillForm(user_id);
    this.openMyModal('effect-7', user_id);
  }

   openMyModal(event, user_id) {
    document.querySelector("#"+event).classList.add('md-show');
  } 
  
  closeMyModalByDivId(event) {
    document.querySelector("#"+event).classList.remove('md-show');
  }

  closeMyModal(event) {
    ((event.target.parentElement.parentElement).parentElement).classList.remove('md-show');
  }

  updateUser() {
    this.technicianService.updateUser(this._modal_user.update);
    this._usersTechnicianByIdTech[this._modal_user.idx] =  this._modal_user.update;
    this.closeMyModalByDivId('effect-7');
  }

  updatePassword() {
    // this._password.newPassword = "";
    // this.httpService.httpPostPromise('updateUserPassword',this._password);
    var obj = this;
    swal({
      title: 'Êtes-vous sûr ?',
      text: "Souhaitez-vous modifier le mot de passe de cet utilisateur ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Oui',
      cancelButtonText: 'Non, Annuler',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      obj.httpService.httpPostPromise("updateUserPassword",obj._password)
                .then((plot_infos_geometry) =>  {
                   
                    swal(
                        'Modifié !',
                        'Le mot de passe à été modifié.',
                        'success'
                    );
                    obj._password.newPassword = "";
                    obj._password.newPasswordConfirm = "";    
                    
                },(error)=>{
                   swal(
                        'Opération annulée !',
                        'Une erreur est survenue, réessayez ultérieurement ! :(',
                        'error'
                    )
                  console.error(error);
                });
    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
            'Annulé',
            'Le mot de passe n\'a pas été modifié.',
            'error'
        )
      }
    }).catch(swal.noop);
    obj.closeMyModalByDivId("effect-7");
  }

  deleteUser(user_id){
  	this.deleteUserFromDB(this._idOfUsers,user_id);
  }

  deleteUserFromDB(idOfCurentUser,farmer_id){   
    console.log(farmer_id);
    var functionToCall;
    var req ={"user_id" : farmer_id } ;
    var _obj = this;
    swal({
      title: 'Êtes-vous sûr ?',
      text: "Souhaitez-vous supprimer définitivement cette utilisateur ?",
      type: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Supprimer !',
      cancelButtonText: 'Non, Annuler !',
      confirmButtonClass: 'btn btn-success m-r-10',
      cancelButtonClass: 'btn btn-danger',
      buttonsStyling: false
    }).then(function () {
      // alert('lahcen ya rbi tkhdam');
      _obj.technicianService.httpPostPromise("destroyuser",req)
                .then((plot_infos_geometry) =>  {
                   
                    swal(
                        'Supprimée!',
                        'L\'utilisateur a été supprimé.',
                        'success'
                    )
                   
                      _obj.getallTechniciansByIdCoop();
                },(error)=>{
                   swal(
                        'Annulé !',
                        'L\'utilisateur n\'a pas été supprimé,car il a une/des commandes est en cours de traitement, réessayez ultérieurement ! :(',
                        'error'
                    )
                  console.log(error);
                });
      
    }, function (dismiss) {
      if (dismiss === 'cancel') {
        swal(
            'Annulé',
            'L\'utilisateur n\'a pas été supprimé :)',
            'error'
        )
      }
    }).catch(swal.noop);
    } 

  get name() {return this.TechnicianForm.get('_name');}
  get first_name() {return this.TechnicianForm.get('_first_name');}
  get email() {return this.TechnicianForm.get('_email');}
  get adress() {return this.TechnicianForm.get('_adress');}
  get city() {return this.TechnicianForm.get('_city');}
  get country() {return this.TechnicianForm.get('_country');}
  get zip_code() {return this.TechnicianForm.get('_zip_code');}
  get phone() {return this.TechnicianForm.get('_phone');}
  get comment() {return this.TechnicianForm.get('_comment');}

  get password() {return this.TechnicianPasswordForm.get('_password');}
  get passwordConfirm() {return this.TechnicianPasswordForm.get('_passwordConfirm');}

   formControl(){
      this.TechnicianForm = new FormGroup({
      '_name': new FormControl(this._modal_user.update.name, [
        Validators.required,
        Validators.minLength(2)
      ]),
      '_first_name': new FormControl(this._modal_user.update.first_name,[
        Validators.required,
        Validators.minLength(2)
      ]),
      '_adress': new FormControl(this._modal_user.update.adress, [Validators.required]),
      '_zip_code': new FormControl(this._modal_user.update.zip_code, [
        // Validators.required,
        Validators.minLength(5),
        Validators.maxLength(5),
        Validators.pattern("^[0-9]*$")
        ]),
       '_city': new FormControl(this._modal_user.update.city, [
        // Validators.required,
        Validators.minLength(2)
        ]),
      '_country': new FormControl(this._modal_user.update.country, [
        // Validators.required,
        Validators.minLength(3)
        ]),
      '_phone': new FormControl(this._modal_user.update.phone, [
        Validators.required,
        Validators.pattern("^[0-9]*$"),
        Validators.minLength(10),
        Validators.maxLength(10)
        ]),
      '_email':  new FormControl(this._modal_user.update.email, [
        Validators.required,
        Validators.minLength(10),
        Validators.email
        ]),
      '_comment': new FormControl(this._modal_user.update.comment, [
        Validators.maxLength(255)
        ]),
    });

    this.TechnicianPasswordForm = new FormGroup({
    '_passwordConfirm': new FormControl(this._password.newPassword, [
      Validators.minLength(8),
      Validators.required
    ]),
    '_password': new FormControl(this._password.newPasswordConfirm, [
      Validators.minLength(8)
    ])
  });
  }
  
}
