import * as licenseTxt from 'raw-loader!./license/luciadria_development.txt';
import * as License from 'luciad/util/License';
import { DeviceDetector } from '../../_class/DeviceDetector';
import { NetworkConnectionDetector } from '../../_class/NetworkConnectionDetector';
License.setLicenseText(licenseTxt);

import { AfterViewInit, OnDestroy, Component, ElementRef, ViewChild, Input, NgZone } from '@angular/core';
import 'rxjs/add/operator/toPromise';
import * as WebGLMap from 'luciad/view/WebGLMap';
import * as Map from "luciad/view/Map";
import * as ReferenceProvider from 'luciad/reference/ReferenceProvider';
import { LayerFactory } from './LayerFactory';
import { GoogleMaps } from './GoogleMaps';
import * as  ShapeFactory from 'luciad/shape/ShapeFactory';
import * as  LayerGroup from 'luciad/view/LayerGroup';
import * as  LayerTreeControl from 'samples/common/control/LayerTreeControl';
import * as  LayerConfigUtil from 'samples/common/LayerConfigUtil';

/* Start Import file for create and edit feature */
import * as  Feature from 'luciad/model/feature/Feature';
import * as  FeatureModel from 'luciad/model/feature/FeatureModel';
import * as  BasicCreateController from 'luciad/view/controller/BasicCreateController';
import * as  EditController from 'luciad/view/controller/EditController';
import * as  FeatureLayer from 'luciad/view/feature/FeatureLayer';
import * as  RestStore from 'samples/common/store/RestStore';
import * as  ShapeType from 'luciad/shape/ShapeType';
import * as  MemoryStore from 'luciad/model/store/MemoryStore';
import * as templateSample from "samples/template/sample";
import * as  domConstruct from "luciad/dojo/dom-construct";
import * as  dConstruct from "luciad/dojo/dom-construct";

/* Start Import file for create clustering access points feature */
import * as  ClusteringTransformer from 'luciad/view/feature/transformation/ClusteringTransformer';
import * as  ClusteringPainterWrapper from "samples/clustering/ClusteringPainterWrapper";
import * as ClusterIconStyleUtil from "samples/clustering/ClusterIconStyleUtil";
import * as  IconFactory from "samples/common/IconFactory";
//import * as variable from 'variableName';
// import {ClusterIconStyleUtil,ClusteringPainterWrapper} from 'variableName';

import * as  BasicFeaturePainter from 'luciad/view/feature/BasicFeaturePainter';

import { PlotDataLoader } from './PlotDataLoader';
import { Localisator } from './Localisator';
import { OptimizationOfATour } from './OptimizationOfATour';
import { BingMapsDataLoader } from '../../_class/BingMapsDataLoader';
import * as  Promise from "luciad/util/Promise";
import * as LayerType from 'luciad/view/LayerType';
import * as ShapePainterContour from "samples/shapePainter/ShapePainterContour";
import * as ShapePainterObstacle from "samples/shapePainter/ShapePainterObstacle";
import * as  ShapePainterOrdrePoint from 'luciad/shape/ShapePainterOrdrePoint';
import * as  ShapePainterContourOptimisation from 'luciad/shape/ShapePainterContour';
import * as  ShapePainterCircle from 'luciad/shape/ShapePainterCircle';
import * as  PaintRepresentation from "luciad/view/PaintRepresentation";
import * as GestureEventType from "luciad/view/input/GestureEventType";
import * as TransformationFactory from "luciad/transformation/TransformationFactory";
import * as ZoomControl from "samples/common/navigation/ZoomControl";
import * as PanControl from "samples/common/navigation/PanControl";
/* Start Import file for create and validate a form */
// import { FormGroup,FormControl,Validators,FormControlName  } from '@angular/forms';
import { HttpService } from '../../http.service';
import { AuthenticationService } from '../../_services/index';
import { OnInit, ViewEncapsulation } from '@angular/core';
import { Http, ResponseContentType } from '@angular/http';
import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { fadeInOutTranslate } from "../../shared/elements/animation";
import { SharedModule } from '../../shared/shared.module';
import { SelectOptionService } from "../../shared/elements/select-option.service";
import { IOption } from "ng-select";

import swal from 'sweetalert2';
import { NotificationsService } from "angular2-notifications";
import * as $ from 'jquery';
import { } from '@types/googlemaps';
import { allSettled } from 'q';
@Component({
  selector: 'app-tour-list',
  templateUrl: './tour-list.component.html',
  styleUrls: ['./tour-list.component.css']
})
export class TourListComponent implements AfterViewInit, OnDestroy {
  @ViewChild('gmap') gmapElement: any;
  map: google.maps.Map;
  @ViewChild('map') mapElem: ElementRef;
  // Roadmap mapElement
  @ViewChild('map') roadmapElem: ElementRef;
  /*  Notify */
  options: any = {
    position: ["bottom", "right"],
  };
  _coordinateType = null;
  position1: string = 'bottom';
  position2: string = 'right';
  timeOut: number = 6000;
  showProgressBar: boolean = true;
  pauseOnHover: boolean = true;
  lastOnBottom: boolean = true;
  clickToClose: boolean = true;
  maxLength: number = 0;
  maxStack: number = 8;
  preventDuplicates: boolean = false;
  preventLastDuplicates: boolean = false;
  theClass: string;
  rtl: boolean = false;
  animate: string = 'fromRight';
  icons: string;
  subType: string = 'success';

  title: string;
  msg: string;
  /*Tow opt algogithm*/

  _plotsInfoAndAccessPoint = []; // Pour to opt
  _plotsInfoAndAccessPointOrdred = []; // Pour to opt
  _featuresArraySelectedMemory = [];

  /*End Tow opt algogithm*/
  /*  End    */
  _map: WebGLMap;
  // Roadmap variables declarations
  roadmap: WebGLMap;
  rdmap_access_point: FeatureLayer;
  rdmap_plot_layer: FeatureLayer;
  rd_featureLayerTrajetOptimal: FeatureLayer;
  rd_featureLayerOrdrePoint: FeatureLayer;
  rdmap_path: FeatureLayer;
  roadmap_source_data: any;
  roadmap_table_rows: any;
  roadmap_table_rows_dist = { p1: null, p2: null, p3: null };
  roadmap_table_rows_duration = { p1: null, p2: null, p3: null };
  roadmap_itinerary_google_maps = {
    lat_current: null,
    long_current: null,
    lat_destination: null,
    long_destination: null,
    conveyance: 'data=!3m1!4b1!4m7!4m6!1m0!1m3!2m2!1d1.4250958!2d43.5794836!3e0',
    link_google_maps: null
  };
  roadmap_selected_row = 0;
  _sms = {
    type: 0,
    message: "",
    plot_id: null,
    to_farmer: true,
    to_technician: false,
    to_cooperative: false,
  }
  roadmap_columns: any[] = [
    { prop: 'id parcelle' },
    { name: 'Cooperative' },
    { name: 'Parcelle' },
    { name: 'Agriculteur' },
    { name: 'Téléphone' },
    { name: 'Techncien' },
    { name: 'Téléphone' }

  ];

  _printLayerControl: boolean = false;
  _featureLayer: FeatureLayer;
  _featureLayerTrajetOptimal: FeatureLayer;
  _featureLayerOrdrePoint: FeatureLayer;

  _featureLayerRepere: FeatureLayer;
  _featureLayerPlotsDB: FeatureLayer;
  _featureLayerObstaclesDB: FeatureLayer;
  _featureLayerBingMap: FeatureLayer;
  _featureLayerAccessPointDB: FeatureLayer;
  _featureLayerPissosDB: FeatureLayer;
  _featureLayerStartEndPoint: FeatureLayer;
  _featureLayerCircle: FeatureLayer;
  _plotDataLoader: any;
  _localisator: any;
  _plot_infos_geometry = [];
  _tour_plot_infos_geometry = [];
  _plot_infos_geometryCopy = [];
  _currentUserInfos: any; //--------------!!!!
  _idOfUsersJSON_current: any; //--------------!!!! // = _idOfUsers  these variable is used after the user chose a current user to filter data in the carte
  _usersFarmerByIdTech: any;//--------------!!!!
  _currentUserEmailAndToken: any; //--------------!!!!
  _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id": 0, "pilot_id": 0, "admin_id": 0, "user_type": "t" }; //--------------!!!! // use to load a binding datas of a curent user or to filtering data
  _farmer_selected = 0;
  // _model :{} ; //= {id_farmer:1,name :'',comment :'',electricline :'',irrigationsystem:'',geom :{}};
  _model = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    id_farmer: null,
    name: '',
    comment: '',
    electricline: '',
    irrigationsystem: '',
    geom: {},
    accesspoint: {},
    obstacles: {}
  };
  _tourModel = {
    client_id: 2,
    client_secret: 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
    tourName: null,
    teamName: null,
    tourDate: null,
    pilots: [],
    drones: [],
    paths: [],
    dists: [],
    total_dist: 0,
    total_duration: 0,
    durations: [],
    area: 0,
    plot_id: { id: [], treatment: [] },
    start_point: null,
    end_point: null
  };
  _tourSummary = {
    selectedArea: 0,
    plotNumber: 0,
    plotNames: [],
    plotNamesOrdred: [],
    pathDistance: 0,
    pathDistanceUnity: "KM",
    pathDuration: {
      total_duration: 0,
      tmps_min: 0,
      tmps_hour: 0,
      pathDurationText: "..."
    }
  };
  LIST_TREATMENTS: any = [];
  _tourExport = {
    team_id: null,
    tour_date: null,
    pilot_id: null,
    tour_id: null,
    type_filtre: null
  };
  tours = [];
  glLayer: any;
  _polt: number = 1;
  _startEndPoint: number = 1;
  EVENT_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(155, 180, 222, 0.8)",
      strokeWidth: 1
    })
  };

  EVENT_SELECTED_STYLE = {
    draped: true,
    width: "16px",
    height: "16px",
    image: IconFactory.circle({
      width: 16,
      height: 16,
      fill: "rgba(0, 78, 146, 0.8)",
      stroke: "rgba(192, 217, 42, 0.8)",
      strokeWidth: 1.5
    })
  };
  _tourList = [];
  _tourIdx = 0;
  _currentTreatment: any;
  _modelCurrentTreatment = {
    id: null,
    status: "",
    comment: "",
    number_of_capsules: null,
    status_amended: null,
    incident: null,
    incident_comment: "",
    flight_date :{
      picker :{
        year: null,
        month: null,
        day: null
      },
      text: ""
    },
  };
  _modalIsOppened = false;
  progress: number = 0;
  label: string;
  constructor(private httpService: HttpService,
    public authenticationService: AuthenticationService,
    private router: Router,
    private activateRroute: ActivatedRoute,
    private http: Http,
    private servicePNotify: NotificationsService,
    public selectOptionService: SelectOptionService,
    private deviceDetector: DeviceDetector,
    private connectionDetector: NetworkConnectionDetector,
    private cdRef: ChangeDetectorRef,
    private _ngZone: NgZone) {
    if (this.authenticationService.isLoggedIn()) {
      this.setIdOfUsersUsigLocalSorage();
    } else {
      this.router.navigate(['/login']); //--------------!!!!
    }
  }

  ngOnInit() {
  }

  setIdOfUsersUsigLocalSorage() {
    this._currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos'));

    switch (this._currentUserInfos.right) {
      case 1:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.pilot_id = 0;
        this._idOfUsers.admin_id = this._currentUserInfos.admin_id;
        this._idOfUsers.user_type = "a";
        break;
      case 2:
        this._idOfUsers.admin_id = 0;
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.pilot_id = 0;
        this._idOfUsers.user_type = "c";

        break;
      case 3:
        this._idOfUsers.admin_id = 0;
        this._idOfUsers.cooperative_id = this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = this._currentUserInfos.tchnicians_id;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.pilot_id = 0;
        this._idOfUsers.user_type = "t";
        break;
      case 4:
        this._idOfUsers.admin_id = 0;
        this._idOfUsers.cooperative_id = 0;//this._currentUserInfos.cooperatives_id;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = this._currentUserInfos.farmer_id;
        this._idOfUsers.pilot_id = 0;
        this._idOfUsers.user_type = "f";

        break;
      case 5:
        this._idOfUsers.cooperative_id = 0;
        this._idOfUsers.technician_id = 0;
        this._idOfUsers.farmer_id = 0;
        this._idOfUsers.pilot_id = this._currentUserInfos.pilot_id;
        this._idOfUsers.user_type = "p";

        break;
    }

  }
  //Centre la carte sur une adresse
  geolocalise() {
    this._localisator.geolocalise(this._map.mapNavigator);
  }
  ngAfterViewInit() {
    this.roadmap_init();
    $("#bbbbbb").click(function () {
      if ($("#infopanel").css('display') != "block") {
        $("#bbbbbb").css("left", 312);
      } else {
        $("#bbbbbb").css("left", 0);
      }
      $("#infopanel").fadeToggle();
      $("#infopanel").width(312);
    });
  }
  createFeatureLayer(label) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: true,
      label: label
    });
  }

  createFeatureLayerWithPainter(label, shapePainter) {
    //#snippet simplefeaturemodel
    var featureModelReference = ReferenceProvider.getReference("CRS:84");
    //var featureURL = "/createandedit";
    // var codec = new CustomJsonCodec();
    var featureStore = new MemoryStore(); //new RestStore({target: featureURL, codec: codec});
    //#endsnippet simplefeaturemodel

    //#snippet simplefeaturemodel
    var featureModel = new FeatureModel(featureStore, { reference: featureModelReference });
    //#endsnippet simplefeaturemodel

    return new FeatureLayer(featureModel, {
      selectable: true,
      editable: false,
      label: label,
      painter: shapePainter
    });
  }
  // ROADMAP_ CODE START
  roadmap_init() {
    var _obj = this;
    this.roadmap = new WebGLMap(
      this.roadmapElem.nativeElement,
      { reference: 'EPSG:900913' }
    );

    BingMapsDataLoader.createLayer("AerialWithLabels").then(function (data) {
      _obj.roadmap.layerTree.addChild(data, data.type !== LayerType.BASE ? "top" : "bottom");
    });
    this.roadmap.minMapScale = 1 / 110000000;
    new LayerTreeControl(this.roadmap, { domId: "controlcontainer", title: "CALQUES" });
    new PanControl(this.roadmap);
    new ZoomControl(this.roadmap, { touch: false });
    // var REF_EPSG3857 = ReferenceProvider.getReference("EPSG:3857"); // 2D "EPSG:900913"
    // this.roadmap = new Map( this.mapElem.nativeElement, {reference: REF_EPSG3857} );

    //  GoogleMaps.startup(this.roadmap);
    this.rdmap_path = this.createFeatureLayer("Trajet Optimal");

    var painteAccessPoints = new ShapePainterOrdrePoint();
    this.rdmap_access_point = this.createFeatureLayerWithPainter("Access points", painteAccessPoints);

    this.rdmap_plot_layer = this.createFeatureLayerWithPainter("Parcelles", new ShapePainterContour());
    this.rd_featureLayerOrdrePoint = this.createFeatureLayerWithPainter("L'ordre de la tournée", painteAccessPoints);
    this.rd_featureLayerTrajetOptimal = this.createFeatureLayer("Trajets optimals");
    // this._featureLayerPissosDB = this.createFeatureLayer("Pissos");
    // this.rdmap_plot_layer = this.createFeatureLayer("Parcelles");

    _obj.roadmap.layerTree.addChild(this.rdmap_path);
    _obj.roadmap.layerTree.addChild(this.rdmap_access_point);
    _obj.roadmap.layerTree.addChild(this.rdmap_plot_layer);
    _obj.roadmap.layerTree.addChild(this.rd_featureLayerOrdrePoint);
    _obj.roadmap.layerTree.addChild(this.rd_featureLayerTrajetOptimal);
    // _obj.roadmap.layerTree.addChild(this._featureLayerPissosDB);

    this.roadmap.on('MapChange', function () {
      _obj.rd_featureLayerOrdrePoint.setPaintRepresentationVisible(PaintRepresentation.LABEL, (_obj.roadmap.mapScale[0] > 1 / 1000000));
    });

    this.getToursByUser();
    this.getGeolocation();
  }
  getToursByUser() {
    this.httpService.httpPostPromise('getTours', this._idOfUsers)
      .then((data) => {
        this._tourList = data;
        var tour_id = parseInt(this.activateRroute.snapshot.paramMap.get('identify'));
        if (isNaN(tour_id)) { tour_id = 0; }
        if (tour_id) {
          this.loadRoadMapData(this.activateRroute.snapshot.paramMap.get('identify'));

          this._tourIdx = this._tourList.map(function (e) {
            return e.tour_id;
          }).indexOf(tour_id);
          console.log(this._tourIdx);
        }
        else {
          this.loadRoadMapData(this._tourList[this._tourIdx].tour_id);
        }
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Sauvegarder la tournée ', msg: 'problème vient de serveur ! :(', type: 'error' });
      });
    // chrome.storage.local.set({'key': value}, function() {
    //   console.log('Value is set to ' + value);
    // });
  }
  currentTour(idx) {
    console.log(this._tourIdx);
    if (idx > 0) {
      this._tourIdx++;
      if (this._tourIdx <= this._tourList.length) {
        this.loadRoadMapData(this._tourList[this._tourIdx].tour_id);
      } else {
        this._tourIdx--;
      }
    } else if (idx < 0) {
      this._tourIdx--;
      if (this._tourIdx >= 0) {
        this.loadRoadMapData(this._tourList[this._tourIdx].tour_id);
      } else {
        this._tourIdx++;
      }
    }
  }
  exportTour(tour_id) {
    console.log(tour_id);
    console.log(this._idOfUsers);
    this.addNotify({ title: 'Exportation de la tournée ', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('exportCSVTour', { tour_id: tour_id })
      .then((data) => {
        console.log(data);
        this.downloadTour(data.filename);
        this.addNotify({ title: 'Exportation de la tournée ', msg: 'Veuillez télécharger votre tournée.', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Exportation de la tournée', msg: 'Un problème vient de se produire ! Veuillez contacter le support technique :(', type: 'error' });
      });
  }

  downloadTour(path) {
    return this.http
      .get('assets/data/tournees_2018/' + path, {
        responseType: ResponseContentType.Blob
      })
      .map(res => {
        return {
          filename: path,
          data: res.blob()
        };
      })
      .subscribe(res => {
        console.log('start download:', res);
        var url = window.URL.createObjectURL(res.data);
        var a = document.createElement('a');
        document.body.appendChild(a);
        a.setAttribute('style', 'display: none');
        a.href = url;
        a.download = res.filename;
        a.click();
        window.URL.revokeObjectURL(url);
        a.remove(); // remove the element
      }, error => {
        console.log('download error:', JSON.stringify(error));
      }, () => {
        console.log('Completed file download.')
      });
  }
  currentPlot(indx) {
    this.getGeolocation();
    if (typeof this.roadmap_source_data.plot_id != "undefined") {

      if (indx.indx < 0) {

        if (indx.source == "find") {
          this.roadmap_selected_row = indx.indx;
        } else {
          this.roadmap_selected_row += indx.indx;
        }
        if (this.roadmap_selected_row < 1) this.roadmap_selected_row = 0;
        this.zoomOnRoadMapPlot(parseInt(this.roadmap_source_data.plot_id[this.roadmap_selected_row]));
        if (this.roadmap_selected_row >= 1) {
          this.roadmap_table_rows = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1];

          this.roadmap_table_rows_dist.p1 = parseFloat((this.roadmap_source_data.dist[this.roadmap_selected_row - 1])).toFixed(2);
          this.roadmap_table_rows_dist.p2 = parseFloat((this.roadmap_source_data.dist[this.roadmap_selected_row])).toFixed(2);
          this.roadmap_table_rows_dist.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row].plot_name;


          this.roadmap_table_rows_duration.p1 = parseFloat((this.roadmap_source_data.duration[this.roadmap_selected_row - 1])).toFixed(2);
          this.roadmap_table_rows_duration.p2 = parseFloat((this.roadmap_source_data.duration[this.roadmap_selected_row])).toFixed(2);
          this.roadmap_table_rows_duration.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1].plot_name;
          this.smsTypeChange();

        }
      }
      if (indx.indx > 0) {
        if (this.roadmap_selected_row == -1) this.roadmap_selected_row += indx.indx + 1;
        if (indx.source == "find") {
          this.roadmap_selected_row = indx.indx;
        } else {
          this.roadmap_selected_row += indx.indx;
        }
        if (this.roadmap_selected_row > this.roadmap_source_data.plot_id.length - 2) this.roadmap_selected_row = this.roadmap_source_data.plot_id.length - 2;
        this.zoomOnRoadMapPlot(parseInt(this.roadmap_source_data.plot_id[this.roadmap_selected_row]));
        if (this.roadmap_selected_row >= 1) {
          this.roadmap_table_rows = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1];

          this.roadmap_table_rows_dist.p1 = parseFloat((this.roadmap_source_data.dist[this.roadmap_selected_row - 1])).toFixed(2);
          this.roadmap_table_rows_dist.p2 = parseFloat((this.roadmap_source_data.dist[this.roadmap_selected_row])).toFixed(2);
          if (this.roadmap_selected_row == this.roadmap_source_data.plot_info.length) {
            this.roadmap_table_rows_dist.p3 = "Point d'arrivée";
          } else {
            this.roadmap_table_rows_dist.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row].plot_name;
          }

          this.roadmap_table_rows_duration.p1 = parseFloat((this.roadmap_source_data.duration[this.roadmap_selected_row - 1])).toFixed(2);
          this.roadmap_table_rows_duration.p2 = parseFloat((this.roadmap_source_data.duration[this.roadmap_selected_row])).toFixed(2);
          this.roadmap_table_rows_duration.p3 = this.roadmap_source_data.plot_info[this.roadmap_selected_row - 1].plot_name;

          console.log(this.roadmap_table_rows_duration);
          this.smsTypeChange();
        }
      }
    }
  }

  printRoadMap() {
    window.print();
  }

  optimisationRoadMap() {
    var _plotsInfoAndAccessPointOrdred = [];

    _plotsInfoAndAccessPointOrdred.push({ "plot_lon_access_point": this.roadmap_source_data.tour.lat_start_point, "plot_lat_access_point": this.roadmap_source_data.tour.long_start_point, "plot_id": 0, "plot_name": "point de départ" });

    for (var i = 0; i < this.roadmap_source_data.plot_info.length; i++) {
      _plotsInfoAndAccessPointOrdred.push(this.roadmap_source_data.plot_info[i]);
    }

    _plotsInfoAndAccessPointOrdred.push({ "plot_lon_access_point": this.roadmap_source_data.tour.lat_end_point, "plot_lat_access_point": this.roadmap_source_data.tour.long_end_point, "plot_id": 0, "plot_name": "point d'arrivée" });

    console.log(_plotsInfoAndAccessPointOrdred);
    this.addNotify({ title: 'Chargement de feuille de routes ', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('getRoadPathBetween2point', { plotInfosAndAccessPoints: _plotsInfoAndAccessPointOrdred })
      .then((data) => {
        console.log(data);
        this._plot_infos_geometry = _plotsInfoAndAccessPointOrdred;
        this.combinePlotInfoWith(this._plot_infos_geometry, data.path);
        this.printResultOfRoadMap(data.path, _plotsInfoAndAccessPointOrdred);
        this.addNotify({ title: 'Chargement de feuille de routes ', msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Chargement de feuille de routes', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }
  combinePlotInfoWith(plot_infos_geometry, path) {
    var pathJSON;
    for (var i = 0; i < this._plot_infos_geometry.length - 1; i++) {
      pathJSON = JSON.parse(path[i]);
      this._plot_infos_geometry[i].path = pathJSON;
    }
    console.log(this._plot_infos_geometry);
  }
  printResultOfRoadMap(path, _plotsInfoAndAccessPointOrdred) {

    this._tourSummary.pathDistance = 0;
    this._tourSummary.pathDuration = {
      total_duration: 0,
      tmps_min: 0,
      tmps_hour: 0,
      pathDurationText: ""
    };
    this._tourModel.dists = [];
    this._tourModel.durations = [];

    var distanceDureeFinale = [];
    var decodedPath1 = [];
    var distTraget = 0;
    var durationTraget = 0;

    $("#contentdivRodMap").html('<div id="syntheseInitaile" style="background-color : #aeff00; width:100%;"></div><div id="syntheseFinale" style="background-color : #2c3e50; width:100%;"></div><div id="gain" style="background-color : #9fc54d; width:100%;">Gain</div>');


    for (var i = 0; i < path.length; i++) {
      path[i] = JSON.parse(path[i]);

      var strDiv = "detailles" + i;
      // document.getElementById('contentdivRodMap').innerHTML += "<h5 style='color : rgb(254, 254, 254) ;font-size: 12px;' (click)='displayDiv(" + strDiv + ")'>Trajet de " + this._tourSummary.plotNamesOrdred[i] + " à " + this._tourSummary.plotNamesOrdred[i + 1] + "<span style='color : #9fc54d; font-size: 90%'>   " + path[i].routes[0].legs[0].duration.text + "(" + path[i].routes[0].legs[0].distance.text + ")</span></h5> <div id ='" + strDiv + "' class='madiv' style='color :rgb(255, 255, 255);' display='none' ></div>";

      for (var j = 0; j < path[i].routes[0].legs[0].steps.length; j++) {

        // document.getElementById(strDiv).innerHTML += "<br>" + path[i].routes[0].legs[0].steps[j].html_instructions;
        // document.getElementById(strDiv).innerHTML += "<br><span style='color : #9fc54d; font-size: 80%'>" + path[i].routes[0].legs[0].steps[j].duration.text + "(" + path[i].routes[0].legs[0].steps[j].distance.text + ")</span>";

      }
      this._tourModel.dists.push(path[i].routes[0].legs[0].distance.value / 1000);
      this._tourModel.durations.push(path[i].routes[0].legs[0].duration.value / 3600);
      this._tourSummary.pathDistance += path[i].routes[0].legs[0].distance.value;
      this._tourSummary.pathDuration.total_duration += path[i].routes[0].legs[0].duration.value;

      decodedPath1[i] = new Array();
      decodedPath1[i] = google.maps.geometry.encoding.decodePath(path[i].routes[0].overview_polyline.points);
      console.log(decodedPath1[i]);
    }
    if (this._tourSummary.pathDistance > 1000) {
      this._tourSummary.pathDistanceUnity = "KM";
      this._tourSummary.pathDistance = parseFloat((this._tourSummary.pathDistance / 1000).toFixed(2));
    } else {
      this._tourSummary.pathDistanceUnity = "MM";
    }
    if (this._tourSummary.pathDuration.total_duration > 3600) {
      var tmpBmod = (this._tourSummary.pathDuration.total_duration % 60);
      this._tourSummary.pathDuration.tmps_hour = ((this._tourSummary.pathDuration.total_duration - tmpBmod) / 3600);
      this._tourSummary.pathDuration.tmps_min = tmpBmod;
      this._tourSummary.pathDuration.pathDurationText = this._tourSummary.pathDuration.tmps_hour.toFixed(2) + "h" + this._tourSummary.pathDuration.tmps_min;
    } else {
      this._tourSummary.pathDuration.tmps_hour = 0;
      this._tourSummary.pathDuration.tmps_min = parseFloat((this._tourSummary.pathDuration.total_duration / 60).toFixed(2));
      this._tourSummary.pathDuration.pathDurationText = this._tourSummary.pathDuration.tmps_hour.toFixed(2) + "h" + this._tourSummary.pathDuration.tmps_min;
    }
    // document.getElementById('syntheseFinale').innerHTML += "Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration / 3600 + "H";
    $("#syntheseFinale").html("Distance finale :" + this._tourSummary.pathDistance / 1000 + "km<br>La durée finale :" + this._tourSummary.pathDuration.total_duration / 3600 + "H");

    this.removeFeatureFromLayer(this.rd_featureLayerTrajetOptimal);
    this.removeFeatureFromLayer(this.rd_featureLayerOrdrePoint);

    for (var i = 0; i < decodedPath1.length; i++) {
      this.creatAndAddPolylineForTwoOptRoadMap(decodedPath1[i], this.rd_featureLayerTrajetOptimal.model);
    }

    this.createAndAddPointForTwoOptRoadMap(_plotsInfoAndAccessPointOrdred);

  }
  createAndAddPointForTwoOptRoadMap(_plotsInfoAndAccessPointOrdred) {

    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    for (var i = 0; i < _plotsInfoAndAccessPointOrdred.length; i++) {

      var myPoint = ShapeFactory.createPoint(REF_CRS84, [_plotsInfoAndAccessPointOrdred[i].plot_lat_access_point, _plotsInfoAndAccessPointOrdred[i].plot_lon_access_point]);
      var markerFeature = new Feature(myPoint);

      var properties = { order: '<h4 class="sub-title" style="color: #a9bc14;" align="center">' + i + '</h4>' + _plotsInfoAndAccessPointOrdred[i].plot_name };
      // console.log(this.rd_featureLayerOrdrePoint);
      markerFeature.properties = properties;
      this.rd_featureLayerOrdrePoint.model.add(markerFeature);
    }

    this.roadmap.mapNavigator.fit({ bounds: this.rd_featureLayerOrdrePoint.bounds, animate: false });
  }
  smsTypeChange() {
    console.log(this._sms);
    console.log(this.roadmap_table_rows);
    if (this.roadmap_selected_row >= 1) {
      this._sms.plot_id = this.roadmap_table_rows.plot_id;
      if (this._sms.type == 0) this._sms.message = "A propos de la parcelle  " + this.roadmap_table_rows.plot_name + " >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 1) this._sms.message = "Information >> Date prévue pour le traitement de la parcelle " + this.roadmap_table_rows.plot_name + " est le " + this.roadmap_source_data.tour.date + ". >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 2) this._sms.message = "Information >> Traitement de la parcelle " + this.roadmap_table_rows.plot_name + " débutée(traitement commencé par pilote) >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;
      if (this._sms.type == 3) this._sms.message = "Information >> Traitement de la parcelle " + this.roadmap_table_rows.plot_name + " est terminé. >> Superficie " + (parseFloat(this.roadmap_table_rows.plot_area)).toFixed(2) + " Ha >> Lat " + this.roadmap_table_rows.plot_lat_centroid + " >> Long " + this.roadmap_table_rows.plot_long_centroid;

    }
  }

  sendSMS() {

    console.log(this._sms);
    this.addNotify({ title: 'Envoie de message ', msg: 'envoie en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('sms', { sms: this._sms })
      .then((data) => {
        console.log(data);
        this.addNotify({ title: 'Envoie de message  ', msg: 'Le message à été envoyé avec succès !', type: 'success' });
      }, (error) => {
        console.error(error);
        this.addNotify({ title: 'Envoie de message', msg: 'problème vient de serveur ! rafraichir la page :(', type: 'error' });
      });

  }
  getTreatment(plot_id, tour_id) {
    console.log(plot_id, tour_id);

    this.httpService.httpPostPromise('getPlotTreatmentByIdPlot', { plot_id: plot_id, tour_id: tour_id })
      .then((data) => {
        this._currentTreatment = data[0];
        this.set_modelCurrentTreatment();
        this.openMyModal('modalEtat');
        this.treatmentStatusChecked();
        console.log(this._currentTreatment);
        console.log(this._modelCurrentTreatment);
      }, (error) => {
        console.error(error);
      });
  }
  set_modelCurrentTreatment() {
    this._modelCurrentTreatment.id = this._currentTreatment.treatment_id;
    this._modelCurrentTreatment.status = this._currentTreatment.treatment_status;
    this._modelCurrentTreatment.comment = this._currentTreatment.treatment_comment; // comment For no Treatment of plot
    this._modelCurrentTreatment.number_of_capsules = this._currentTreatment.treatment_number_of_capsules;
    this._modelCurrentTreatment.status_amended = this._currentTreatment.treatment_status_amended;

    this._modelCurrentTreatment.incident = this._currentTreatment.treatment_incident;
    this._modelCurrentTreatment.incident_comment = this._currentTreatment.treatment_incident_comment;

    var date_of_flight = new Date(this._currentTreatment.treatment_datura_date_provisinnal_of_flight);

    // console.log(date_of_flight, date_of_flight.getDay,date_of_flight.getMonth,date_of_flight.getFullYear);
     console.log(date_of_flight);
     console.log(this._currentTreatment);
     console.log(this._currentTreatment.treatment_datura_date_provisinnal_of_flight);

    this._modelCurrentTreatment.flight_date.picker = this.transformNgbDatepickerFormat(this._currentTreatment.treatment_datura_date_provisinnal_of_flight);
    this._modelCurrentTreatment.flight_date.text = this._currentTreatment.treatment_datura_date_provisinnal_of_flight;
  }
  setDateText(){
    this._modelCurrentTreatment.flight_date.text = this._modelCurrentTreatment.flight_date.picker.year+""+this._modelCurrentTreatment.flight_date.picker.month+""+this._modelCurrentTreatment.flight_date.picker.day;
  }
  transformNgbDatepickerFormat(date) {
    return { year: parseInt(date.split('-')[0], 10), month: parseInt(date.split('-')[1], 10), day: parseInt(date.split('-')[2], 10) };
  }
  set_modelCurrentTreatmentByIHM(status) {
    switch (status) {
      case 'oui':
        // this._modelCurrentTreatment.status = ;
        // this._modelCurrentTreatment.comment = ;
        // this._modelCurrentTreatment.number_of_capsules = ;
        // this._modelCurrentTreatment.status_amended = ;

        // this._modelCurrentTreatment.incident = ;
        // this._modelCurrentTreatment.incident_comment = ;
        break;
      case 'non':
        // this._modelCurrentTreatment.status = ;
        // this._modelCurrentTreatment.comment = ;
        // this._modelCurrentTreatment.number_of_capsules = ;
        // this._modelCurrentTreatment.status_amended = ;

        // this._modelCurrentTreatment.incident = ;
        // this._modelCurrentTreatment.incident_comment = ;
        break;
      case 'incident':
        // this._modelCurrentTreatment.status = ;
        // this._modelCurrentTreatment.comment = ;
        // this._modelCurrentTreatment.number_of_capsules = ;
        // this._modelCurrentTreatment.status_amended = ;

        // this._modelCurrentTreatment.incident = ;
        // this._modelCurrentTreatment.incident_comment = ;
        break;
      case 'attente':
        // this._modelCurrentTreatment.status = ;
        // this._modelCurrentTreatment.comment = ;
        // this._modelCurrentTreatment.number_of_capsules = ;
        // this._modelCurrentTreatment.status_amended = ;

        // this._modelCurrentTreatment.incident = ;
        // this._modelCurrentTreatment.incident_comment = ;
        break;
    }
  }
  setTreatmentStatus() {
    this._modelCurrentTreatment.flight_date.text = this.formatNgDatepicker(this._modelCurrentTreatment.flight_date.picker);
   // this._modelCurrentTreatment.flight_date.picker.year+""+this._modelCurrentTreatment.flight_date.picker.month+""+this._modelCurrentTreatment.flight_date.picker.day;
    this.httpService.httpPostPromise('setTreatmentStatus', this._modelCurrentTreatment)
      .then((data) => {
        console.log(data);
        this.addNotify({ title: 'Signaler l\'état  ', msg: 'La modification a été bien effectuée !', type: 'success' });
        this.closeMyModalByDivId('modalEtat');
        console.log(this._modelCurrentTreatment);
      }, (error) => {
        this.addNotify({ title: 'Signaler l\'état  ', msg: 'Veuillez verifier votre connexion !', type: 'error' });
        console.error(error);
      });
  }
  formatNgDatepicker(fulldate) {
    var month = fulldate.month;
    var date = fulldate.day;
    var year = fulldate.year;
    if (month < 10)
      month = "0" + month;
    if (date < 10)
      date = "0" + date;
    //TO DO : Change to date = day+"-"+month+"-"+year;
    return year + "-" + month + "-" + date;
  }
  treatmentStatusChecked() {
    //  console.log('treatmentStatusChecked');
    if (
      this._currentTreatment.treatment_status == 'en-cours' &&
      this._currentTreatment.treatment_status_amended == false
    ) {
      this.affiche('attente').then(data => {
        setTimeout(function () {
          (<HTMLInputElement>document.getElementById("radioAttente")).checked = true;
        }, 1000);
      });
      return true;
    }

    if (
      this._currentTreatment.treatment_status == 'termine' &&
      this._currentTreatment.treatment_status_amended == true
    ) {
      this.affiche('oui').then(data => {
        setTimeout(function () {
          (<HTMLInputElement>document.getElementById("radioOui")).checked = true;
        }, 1000);
      });
      return true;
    }

    if (
      this._currentTreatment.treatment_status == 'en-cours' &&
      this._currentTreatment.treatment_status_amended == true &&
      this._currentTreatment.treatment_incident == false
    ) {
      this.affiche('non').then(data => {
        setTimeout(function () {
          (<HTMLInputElement>document.getElementById("radioNon")).checked = true;
        }, 1000);
      });
      return true;
    }
    if (
      this._currentTreatment.treatment_status == 'en-cours' &&
      this._currentTreatment.treatment_incident == true &&
      this._currentTreatment.treatment_status_amended == true
    ) {
      this.affiche('incident').then(data => {
        setTimeout(function () {
          (<HTMLInputElement>document.getElementById("radioIncident")).checked = true;
        }, 1000);
      });
      return true;
    }

    // console.log("default device");

  }
  changeOfTreatmentStatus() {

  }
  verifyThenSendSMS() {
    var deviceInformation = this.deviceDetector.getDeviceInformations();
    if (!this.connectionDetector.isNetworkConnected()) {
      /*switch (deviceInformation.device) {
        case 'window':
          // Process for windows
          // Stockage SQLlite
          break;
        case 'android':
        case 'iphone':
        case 'ipad':
          // Process for android, iPhone and iPad
          if(false {Test 2G}) {
            // Stockage SQLlite
          }
          break;
        default:
          console.log("default device");
      }    */
    } else {
      this.sendSMS();
    }
  }

  removeAllFeatursRoadMap() {
    for (var i = this.rdmap_plot_layer.model.store._data.length - 1; i >= 0; i--) {
      this.rdmap_plot_layer.model.remove(this.rdmap_plot_layer.model.store._data[i].id);
    }
  }

  removeFeatureFromLayer(layer) {
    for (var i = layer.model.store._data.length - 1; i >= 0; i--) {
      layer.model.remove(layer.model.store._data[i].id);
    }
  }

  //ROADMAP DATA LOAD
  loadRoadMapData(tourId) {
    console.log(tourId);
    this.addNotify({ title: 'Chargement de feuille de routes ', msg: 'Chargement en cours, veuillez patienter...', type: 'success' });
    this.httpService.httpPostPromise('getTourById', { tour_id: tourId })
      .then((data) => {

        this.roadmap_source_data = data;
        this.removeAllFeatursRoadMap();
        this.roadmap_selected_row = 0;
        this.printPolygoneContour(this.roadmap_source_data.plot_info);
        this.optimisationRoadMap();
        console.log(this.roadmap_table_rows);

        console.log("Roadmap Source data >> : ");
        console.log(this.roadmap_source_data);
        this.showTourneeListe();
        this.addNotify({
          title: 'Chargement de feuille de routes ',
          msg: 'Le chargement des donneés plus l\'optimisation de trajet sont faits avec succès !',
          type: 'success'
        });
      }, (error) => {
        console.error(error);
        this.addNotify(
          {
            title: 'Chargement de feuille de routes',
            msg: 'problème vient de serveur ! rafraichir la page :(',
            type: 'error'
          });
      });
  }
  getTourArea(area) {
    return parseFloat(area).toFixed(2);
  }
  getTourFarmerNumber() {
    var farmerIds = [];
    for (var i = 0; i < this.roadmap_source_data.plot_info.length; i++) {
      farmerIds.push(this.roadmap_source_data.plot_info[i].farmer_id);
    }
    var farmerIdTable = [];
    for (var i = 0; i < farmerIds.length; i++) {
      if (!this.verifieExistance(farmerIdTable, farmerIds[i])) farmerIdTable.push(farmerIds[i]);
    }
    return farmerIdTable.length;
  }

  verifieExistance(tabId, id) {
    var val = 0;
    for (var i = 0; i < tabId.length; i++) {
      if (tabId[i] == id) { return 1; }
    }
    return val;
  }
  creatAndAddPolylineForTwoOptRoadMap(tableauDePoints, model) {
    var REF_CRS84 = ReferenceProvider.getReference("CRS:84");
    var ligne = '(';
    var poly = ShapeFactory.createPolyline(REF_CRS84, []);

    for (var i = 0; i < tableauDePoints.length; i++) {
      var marker = ShapeFactory.createPoint(REF_CRS84, [parseFloat(tableauDePoints[i].lng()), parseFloat(tableauDePoints[i].lat())]);
      poly.insertPoint(i, marker);

      if (i == tableauDePoints.length - 1) ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ')';
      else ligne += tableauDePoints[i].lng() + ' ' + tableauDePoints[i].lat() + ',';
    }
    this._tourModel.paths.push(ligne);
    var markerFeature = new Feature(poly);
    var shape_id = model.add(markerFeature);
    // this._map.mapNavigator.fit({ bounds: this.rd_featureLayerTrajetOptimal.bounds, animate: false });
    return shape_id;
  }
  printPolygoneContour(plot_infos_geometry) {

    var ref = ReferenceProvider.getReference("EPSG:4326");
    // console.log(ref);

    for (var i = 0; i < plot_infos_geometry.length; i++) {

      var poly = ShapeFactory.createPolygon(ref, []);
      var access_pointDB = JSON.parse(plot_infos_geometry[i].plot_access_point);
      var access_point = ShapeFactory.createPoint(ref, access_pointDB.coordinates);

      var polyDB = JSON.parse(plot_infos_geometry[i].plot_geometry).coordinates[0];
      for (var j = 0; j < polyDB.length; j++) {
        // console.log(polyDB[j][0]);
        // var marker = ShapeFactory.createPoint(ref,[polyDB[j][0],polyDB[j][1],polyDB[j][2]]);
        //var marker = ShapeFactory.createPoint(ref,[polyDB[j][0],polyDB[j][1],polyDB[j][2]]);
        var marker = ShapeFactory.createPoint(ref, [polyDB[j][0], polyDB[j][1], polyDB[j][2]]);
        poly.insertPoint(j, marker);
      }

      var plot_properties = {
        farmer_id: plot_infos_geometry[i].farmer_id,
        farmer_first_name: plot_infos_geometry[i].farmer_first_name,
        farmer_name: plot_infos_geometry[i].farmer_name,
        farmer_phone: plot_infos_geometry[i].farmer_phone,

        technician_id: plot_infos_geometry[i].technician_id,
        technician_first_name: plot_infos_geometry[i].technician_first_name,
        technician_name: plot_infos_geometry[i].technician_name,

        plot_id: plot_infos_geometry[i].plot_id,
        plot_name: plot_infos_geometry[i].plot_name,
        plot_area: plot_infos_geometry[i].plot_area,
        plot_lat_access_point: access_point[0],
        plot_lon_access_point: access_point[1],
        plot_power_line: plot_infos_geometry[i].plot_power_line,
        plot_irrigation: plot_infos_geometry[i].plot_irrigation,
        plot_comment: plot_infos_geometry[i].plot_comment,

        cooperative_id: plot_infos_geometry[i].cooperative_id,
        cooperative_name: plot_infos_geometry[i].cooperative_name,

        cooperative_adherent_id: plot_infos_geometry[i].cooperative_id,
        cooperative_adherent_name: plot_infos_geometry[i].cooperative_adherent,

      };
      var markerFeaturePlot = new Feature(poly);
      var markerFeatureAccessPoint = new Feature(access_point);
      markerFeaturePlot.properties = plot_properties;
      markerFeatureAccessPoint.properties = plot_properties;
      //Décommenter pour faire apparaitre le tableauDePoints
      var shape_id = this.rdmap_plot_layer.model.add(markerFeaturePlot);
      // var shape_id = this._featureLayerAccessPointDB.model.add(markerFeatureAccessPoint);
      // return shape_id;

      // ----- Obstacles
      var obstaclesDB = JSON.parse(plot_infos_geometry[i].plot_obstacles);

      if (obstaclesDB) {
        obstaclesDB = obstaclesDB.coordinates;
        console.log(obstaclesDB);
        for (var j = 0; j < obstaclesDB.length; j++) {
          var obstacleDB = obstaclesDB[j];
          console.log(obstacleDB);
          var obstacle = ShapeFactory.createPolygon(ref, []);
          for (var k = 0; k < obstacleDB.length; k++) {
            var marker = ShapeFactory.createPoint(ref, [obstacleDB[k][0], obstacleDB[k][1], obstacleDB[k][2]]);
            obstacle.insertPoint(k, marker);
          }
          console.log(obstacle);

          var markerFeaturePlot = new Feature(obstacle);
          markerFeaturePlot.properties = plot_properties;
          //Décommenter pour faire apparaitre le tableauDePoints
          // var shape_id = this._featureLayerObstaclesDB.model.add(markerFeaturePlot);
        }
      }
    }
    this.roadmap.mapNavigator.fit({ bounds: this.rdmap_plot_layer.bounds, animate: true });
  }
  zoomOnRoadMapPlot(plot_id) {
    for (var i = this.rdmap_plot_layer.model.store._data.length - 1; i >= 0; i--) {
      if (this.rdmap_plot_layer.model.store._data[i].properties.plot_id == plot_id) {
        var shape_id_poly = this.rdmap_plot_layer.model.store._data[i].id;
        this.roadmap.mapNavigator.fit(this.rdmap_plot_layer.model.get(shape_id_poly).shape.bounds);
      }
    }
  }
  zoomStartEndPoint(obj) {
    var shape_id_point;
    if (obj.item == "startpoint") {
      shape_id_point = 1;
    } else if (obj.item == "endpoint") {
      shape_id_point = this.rd_featureLayerOrdrePoint.model.store._data.length;
    }
    this.roadmap.mapNavigator.fit(this.rd_featureLayerOrdrePoint.model.get(shape_id_point).shape.bounds).then(data => {
      this.roadmap.mapNavigator.zoom({
        targetScale: { x: 1 / 11000, y: 1 / 11000 },
        animate: true
      });
    });
  }
  zoomToExtend() {
    if ((this.rdmap_plot_layer.model.store._data.length > 0)) {
      this.roadmap.mapNavigator.fit({ bounds: this.rdmap_plot_layer.bounds, animate: true });
    } else {
      var crs84 = ReferenceProvider.getReference("CRS:84");
      var _tempModelPoint = ShapeFactory.createPoint(crs84, [2.68, 46.20]);
      var _tempViewPoint = ShapeFactory.createPoint(null, [0, 0]);
      var _tempMapPoint = ShapeFactory.createPoint(this.roadmap.reference, [0, 0]);
      var _transformation = TransformationFactory.createTransformation(crs84, this.roadmap.reference);
      _transformation.transform(_tempModelPoint, _tempMapPoint);
      this.roadmap.mapToViewTransformation.transform(_tempMapPoint, _tempViewPoint);
      this.roadmap.mapNavigator.pan({ targetLocation: _tempViewPoint, animate: { duration: 300 } })
        .then(data => {
          this.roadmap.mapNavigator.zoom({
            targetScale: { x: 1 / 11000000, y: 1 / 11000000 },
            animate: true
          });
        });
    }
  }
  getGeolocation() {
    var _obj = this;
    var options = {
      enableHighAccuracy: true,
      timeout: 5000,
      maximumAge: 0
    };

    if (navigator.geolocation) {
      // L'API est disponible
      navigator.geolocation.getCurrentPosition(function (pos) {
        var crd = pos.coords;
        // console.log('Votre position actuelle est :');
        // console.log(`Latitude : ${crd.latitude}`);
        // console.log(`Longitude: ${crd.longitude}`);
        // console.log(`Plus ou moins ${crd.accuracy} mètres.`);
        _obj.roadmap_itinerary_google_maps.lat_current = crd.latitude;
        _obj.roadmap_itinerary_google_maps.long_current = crd.longitude;
        console.log(_obj.roadmap_itinerary_google_maps);
      }/*this.successGeolocation*/, function (error) { console.log(error) }, options);
    } else {
      // Pas de support, proposer une alternative ?
      console.log("Pas de support, proposer une alternative ?");
    }
  }
  getItinerary_google_maps(lat_destination, long_destination) {

    this.roadmap_itinerary_google_maps.lat_destination = lat_destination;
    this.roadmap_itinerary_google_maps.long_destination = long_destination;
    this.roadmap_itinerary_google_maps.link_google_maps = "https://www.google.fr/maps/dir/" + this.roadmap_itinerary_google_maps.lat_current + ',' + this.roadmap_itinerary_google_maps.long_current + '/' + this.roadmap_itinerary_google_maps.lat_destination + ',' + this.roadmap_itinerary_google_maps.long_destination + '/' + this.roadmap_itinerary_google_maps.conveyance;

    console.log(this.roadmap_itinerary_google_maps);
    window.open(this.roadmap_itinerary_google_maps.link_google_maps);

  }
  ngOnDestroy() {
    // if (this._map) {
    //   this._map.destroy();
    // }
    // this.ngAfterViewInit();
    // //document.getElementById("controlcontainer").innerHTML="";
  }
  showTourneeDetail(indx) {
    if (indx.source == "find") {
      this.currentPlot(indx);
    }
    document.getElementById("tournee-liste").style.display = "none";
    document.getElementById("tournee-detail").style.display = "block";
  }
  hideTourneeDetail() {
    document.getElementById("tournee-detail").style.display = "none";
    document.getElementById("tournee-liste").style.display = "block";
  }
  showTourneeListe() {
    document.getElementById("tournee-liste").style.display = "block";
    document.getElementById("tournee-detail").style.display = "none";
  }
  hideTourneeListe() {
    document.getElementById("tournee-liste").style.display = "none";
    document.getElementById("tournee-detail").style.display = "block";
  }
  showList() {
    document.getElementById("listtoshow").style.display = "block";
  }
  hideList() {
    document.getElementById("listtoshow").style.display = "none";
  }
  openMyModal(event) {
    document.querySelector("#" + event).classList.add('md-show');
  }

  closeMyModalByDivId(event) {
    document.querySelector("#" + event).classList.remove('md-show');
  }

  closeMyModal(event) {
    ((event.target.parentElement.parentElement).parentElement).classList.remove('md-show');
  }
  affiche(element) {
    console.log(this._modelCurrentTreatment);
    return new Promise((resolve, reject) => {
      if (element == "oui") {
        document.getElementById("oui-detail").style.display = "block";
        document.getElementById("non-detail").style.display = "none";
        document.getElementById("incident-detail").style.display = "none";
        this.set_modelCurrentTreatmentByIHM('oui');

        resolve("oui");
      }
      if (element == "non") {
        document.getElementById("non-detail").style.display = "block";
        document.getElementById("oui-detail").style.display = "none";
        document.getElementById("incident-detail").style.display = "none";
        this.set_modelCurrentTreatmentByIHM('non');
        resolve("non");
      }
      if (element == "incident") {
        document.getElementById("incident-detail").style.display = "block";
        document.getElementById("non-detail").style.display = "none";
        document.getElementById("oui-detail").style.display = "none";
        this.set_modelCurrentTreatmentByIHM('incident');
        resolve("incident");
      }
      if (element == "attente") {
        document.getElementById("non-detail").style.display = "none";
        document.getElementById("oui-detail").style.display = "none";
        document.getElementById("incident-detail").style.display = "none";
        this.set_modelCurrentTreatmentByIHM('attente');
        resolve("attente");
      };
    });
  }

  addNotify(options) {
    //this.pauseOnHover = (options.indexOf("pauseOnHover") > -1) ? options.pauseOnHover : this.pauseOnHover;
    this.servicePNotify.remove();
    this.options = {
      position: [("position1" in options) ? options.position1 : this.position1, ("position2" in options) ? options.position2 : this.position2],
      maxStack: ("maxStack" in options) ? options.maxStack : this.maxStack,
      timeOut: options.timeOut ? options.timeOut : this.timeOut,
      showProgressBar: ('showProgressBar' in options) ? options.showProgressBar : this.showProgressBar,
      pauseOnHover: ('pauseOnHover' in options) ? options.pauseOnHover : this.pauseOnHover,
      lastOnBottom: ('lastOnBottom' in options) ? options.lastOnBottom : this.lastOnBottom,
      clickToClose: ('clickToClose' in options) ? options.clickToClose : this.clickToClose,
      maxLength: options.maxLength ? options.maxLength : this.maxLength,
      preventDuplicates: ('preventDuplicates' in options) ? options.preventDuplicates : this.preventDuplicates,
      preventLastDuplicates: ('preventLastDuplicates' in options) ? options.preventLastDuplicates : this.preventLastDuplicates,
      theClass: options.theClass ? options.theClass : this.theClass,
      rtl: ('rtl' in options) ? options.rtl : this.rtl,
      animate: options.animate ? options.animate : this.animate,
      icons: options.icons ? options.icons : this.icons
    }
    switch (options.type) {
      case 'success':
        this.servicePNotify.success(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'error':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'alert':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'warn':
        this.servicePNotify.error(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'info':
        this.servicePNotify.info(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      case 'create':
        this.servicePNotify.create(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg,
          options.type ? options.type : this.subType
        );
        break;
      case 'html':
        this.servicePNotify.html(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
      default:
        this.servicePNotify.alert(
          options.title ? options.title : this.title,
          options.msg ? options.msg : this.msg
        );
        break;
    }
  }

}
