import { Component, OnInit, ChangeDetectionStrategy, SimpleChange, ViewChild, ElementRef, ChangeDetectorRef } from '@angular/core';
import {FileUploader} from "ng2-file-upload";
import { DocumentsService } from '../../_services/index';
import {LocalStorageDefinition } from '../../_class/LocalStorageDefinition'; 
import { TechnicianService, FarmerService, CooperativeService} from '../../_services/index';

// const URL = 'https://evening-anchorage-3159.herokuapp.com/api/';
// const URL = 'http://localhost:8000/storefile';
 const URL = 'http://www.agriload-services.com/agriload-v2/agriload_laravel/public/storefile';

@Component({
  selector: 'app-upload-files',
  templateUrl: './upload-files.component.html',
  changeDetection: ChangeDetectionStrategy.OnPush,
  styleUrls: ['./upload-files.component.css']
})
export class UploadFilesComponent implements OnInit {
  @ViewChild('input1') input : ElementRef;
 model: string = "";
  uploader: FileUploader = new FileUploader({
    url: URL,
    isHTML5: true,
    maxFileSize :20000000
  });
  hasBaseDropZoneOver = false;
  hasAnotherDropZoneOver = false;
  private localStorageDefinition : LocalStorageDefinition;
  private _idOfUsers = { "cooperative_id": 0, "technician_id": 0, "farmer_id":0,"user_type":"t" }; 
  private _userInfo: any;
  private _userId;
  private progress: number = 0;
  private types = [
      //  {id: 'shp', name: "ESRI SHP"},
       {id: 'GeoJSON', name: "GeoJSON"},
     ];
  // private types = [
  //     {id: 'report', name: "Rapport"},
  //     {id: 'bill', name: "Facture"},
  //     {id: 'other', name: "Autres"}
  //   ];
  private selectedType = undefined;


  constructor(private docService : DocumentsService,
               private technicianService : TechnicianService, 
               private farmerService : FarmerService, 
               private cooperativeService : CooperativeService,
               private cd: ChangeDetectorRef) {
    this.localStorageDefinition = new LocalStorageDefinition(this.technicianService, this.farmerService, this.cooperativeService);
    this._userInfo = this.localStorageDefinition.setIdOfUsersUsingLocalStorage(this._idOfUsers, this.cooperativeService, this.technicianService);
    this._userId = this._userInfo.user_id;
    console.log(this._userId);
     this.uploader.onAfterAddingFile = (file) => { file.withCredentials = false; };
     var _obj = this;
    //  this.uploader.response.subscribe( res => {
    //    setInterval(function() { _obj.refresh() }, 150);
    //  });
  }
  refresh() {
    this.cd.detectChanges();
  }
  ngOnInit() {
    this.uploader.onAfterAddingFile = (file) => { file.withCredentials = false; };
  }

  fileOverBase(e: any): void {
    this.hasBaseDropZoneOver = e;
  }

  fileOverAnother(e: any): void {
    this.hasAnotherDropZoneOver = e;
  }

  uploadFile(){
  	// this.uploader.progress = this.uploader.progress;
  }


}