import { Injectable } from '@angular/core';
import { Http, Headers, Response } from '@angular/http';
import { Observable } from 'rxjs';
import { Router } from '@angular/router';
import { BackEndLink } from '../_config/back-end-link';
import 'rxjs/add/operator/map'

@Injectable()
export class AuthenticationService {
    public token: string;
    public right: number;
    public currentUser: {};
    private serverURL: string;
    public asyncLocalStorage = {
        setItem: function (key, value) {
            return Promise.resolve().then(function () {
                localStorage.setItem(key, value);
            });
        }
    };

    constructor(private http: Http, private router: Router, private backEndLink: BackEndLink) {
        // set token if saved in local storage
        this.currentUser = JSON.parse(localStorage.getItem('currentUser'));
        // this.token = this.currentUser && this.currentUser.token;
        // this.serverURL = "http://www.agriload-services.com/agriload-v2/agriload_laravel/public" ;
        this.serverURL = this.backEndLink.getLinks().apiLaravel.serverURL;

    }

    login(email: string, password: string): Observable<boolean> {
        var data = {
            'grant_type': 'password',
            'client_id': '2',
            'client_secret': 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW',
            'username': email,
            'password': password,
        };
        console.log(data);


        return this.http.post(this.serverURL + '/oauth/token', data)
            .map((response: Response) => {
                // console.log(response);
                let token = response.json() && response.json().access_token;

                if (token) {
                    // set token property
                    this.token = token;
                    localStorage.setItem('currentUser', JSON.stringify({ email: email, token: token }));

                    var _obj = this;
                    this.getUserinfos({ email: email, token: token }).subscribe(result => {

                        var currentUser = JSON.parse(result._body);
                        this.asyncLocalStorage.setItem('currentUserInfos', JSON.stringify(currentUser[0])).then(function () {
                            // return asyncLocalStorage.getItem('mykey');
                        }).then(function (value) {
                            console.log('Value has been set to:', value);
                            if (localStorage.getItem('currentUserInfos')) {
                                var currentUserInfos = JSON.parse(localStorage.getItem('currentUserInfos')) ;
                                if (currentUserInfos.right != 5) {
                                    _obj.router.navigate(['/home']);
                                } else {
                                    _obj.router.navigate(['/my-tours']); 
                                }
                            }
                        });

                        // localStorage.setItem('currentUserInfos', JSON.stringify(currentUser[0]))
                        // store useremail and jwt token in local storage to keep user logged in between page refreshes
                    }, err => {
                        console.log(err);
                    });
                }
            }).catch(error => {
                console.log(error);
                return Observable.throw(error);
            });
    }

    logout(): void {
        console.log('log out');

        // clear token remove user from local storage to log user out
        this.token = null;
        localStorage.removeItem('currentUser');
        localStorage.removeItem('currentUserInfos');
        this.router.navigate(['/login']);
    }

    isLoggedIn(): boolean {
        if (localStorage.getItem('currentUser'))
            return true;
        return false;
    }
    getCurrentUser() {
        return this.currentUser;
    }

    getUserinfos(data): Observable<any> {
        return this.http.post(this.serverURL + '/getCurrentUserInfos', data)

            .map((response: Response) => {
                return response;
            }).catch(error => {
                console.log("error");
                return Observable.throw(error);
            });
    }
    getRight(email: string, data: {}): Observable<any> {


        return this.http.post(this.serverURL + '/getRightByEmail', data)

            .map((response: Response) => {
                return response;
            });
    }
}