import { Injectable } from '@angular/core';
import { Http, Headers, Response } from '@angular/http';
import { Observable } from 'rxjs';
import 'rxjs/add/operator/map';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import {BackEndLink} from '../_config/back-end-link';
import 'rxjs/add/operator/toPromise';
import 'rxjs/add/operator/catch';

@Injectable()
export class CooperativeService {
	public token: string;
	public right :  number ;
	public product_id :  number ;
	public data :{};
    private serverURL: string;
    private client_id : string;
    private client_secret : string;
	constructor(private http : Http,private backEndLink : BackEndLink) {
	    this.serverURL = this.backEndLink.getLinks().apiLaravel.serverURL; 
	    this.client_id = '2';
		this.client_secret = 'CEbifFsOxOcgMiso4a10InNPKJoUhPJyIGAgwtxW';
		this.product_id = 1;
		this.data = {
	  	'client_id' : this.client_id,
	  	'client_secret' : this.client_secret,
	  	'product_id' : 1
	  };
	}

	setData(data = <any>{}) {
		var json = data;
		json.client_id = this.client_id;
	 	json.client_secret = this.client_secret;
	 	json.product_id = this.product_id;
	 	//console.log(json);
	  	this.data = json;
	}

	setProduct(product_id) {
		this.data["product_id"] = product_id;
		//console.log(this.data);
	}

	setStockID(stock_id) {
		this.data["stock_id"] = stock_id;
	}

	updateStock(new_stock) : Observable<any> {
		this.data["quantity"] = new_stock;
		//console.log(this.data);
		return this.http.post(this.serverURL+"/" + 'updatecooperativestock', this.data)
		.map((response: Response) => {
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
 
    }
    
   getallTechniciansByIdCoop(sUrlFonctionAPI: string, data: any): Promise<any> {
    let url = this.serverURL +"/" + sUrlFonctionAPI;
    const body = data;
    //console.log(body);
    return this.http.post(url,body)
      .map(response => {
        return response;
      }).toPromise() ;
      // .catch(error => this.handleError(error));
   }

	getCooperativeTechniciansData(): Observable<any> {
		return this.http.post(this.serverURL+"/" + 'getalluserstechbyidcoop', this.data)
		.map((response: Response) => {
                        	   //console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

	getCooperativeFarmersData(/*data :{}*/): Observable<any> {
		return this.http.post(this.serverURL+"/" + 'getcooperativefarmers',this.data)
		.map((response: Response) => {
			//console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

	getCooperativePlotsData(/*data :{}*/): Observable<any> {
		return this.http.post(this.serverURL+"/" + 'getcooperativeplots',this.data)
		.map((response: Response) => {
		    //console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

	getCooperative5LastStocksData(/*data :{}*/): Observable<any> {
		//console.log(this.data);
		return this.http.post(this.serverURL+"/" + 'getcooperative5laststocks',this.data)
		.map((response: Response) => {
		    //console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}


	getStock(): Observable<any> {
		//console.log(this.data);
		return this.http.post(this.serverURL+"/" + 'getcooperativestock',this.data)
		.map((response: Response) => {
		  	//console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

	getCooperativeTreatments(/*data :{}*/): Observable<any> {
		return this.http.post(this.serverURL+"/" + 'getcooperativetreatments',this.data)
		.map((response: Response) => {
		  //console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

	getCooperativeCountTechsFarmersAndPlots(): Observable<any> {
		//console.log(this.data);
		return this.http.post(this.serverURL+"/" + 'getcooperativecounttechsfarmersandplots', this.data)
		.map((response: Response) => {
		  	//console.log(response);
			return response ;
		}).catch(error => {
			console.error("error");
			return Observable.throw(error);
		});
	}

}

