import {Routes} from '@angular/router';
import {AdminLayoutComponent} from './layouts/admin/admin-layout.component';
import {AuthLayoutComponent} from './layouts/auth/auth-layout.component';
import {HomeComponent} from './_components/home/home.component';
import {SmsComponent} from './_components/sms/sms.component';
import {MyRiamapComponent} from './_components/my-riamap/my-riamap.component';
import {OrderComponent} from './_components/order/order.component';
import { OrderV2Component } from './_components/order-v2/order-v2.component';
import { TechnicianFormComponent } from './_components/technician-form/technician-form.component';
import { TechnicianListComponent } from './_components/technician-list/technician-list.component';
import { TechnicianUpdateComponent } from './_components/technician-update/technician-update.component';
import { FarmerFormComponent } from './_components/farmer-form/farmer-form.component';
import { FarmerListComponent } from './_components/farmer-list/farmer-list.component';
import { CooperativeFormComponent } from './_components/cooperative-form/cooperative-form.component';
import { CooperativeListComponent } from './_components/cooperative-list/cooperative-list.component';
import { StockComponent } from './_components/stock/stock.component';
import {ListComponent} from './_components/orders/orderlist/list.component';
import { DocumentsComponent } from './_components/documents/documents.component'; 
import { UploadFilesComponent } from './_components/upload-files/upload-files.component'; 
import { PlanningComponent } from './_components/planning/planning.component'; 
import { TourListComponent } from './_components/tour-list/tour-list.component';
import { NewTourComponent } from './_components/new-tour/new-tour.component';
import { FollowPlotStatesComponent } from './_components/follow-plot-states/follow-plot-states.component';
import { MyToursComponent } from './_components/my-tours/my-tours.component';
export const AppRoutes: Routes = [{
  path: '',
  component: AdminLayoutComponent,
  children: [
    {
      path: '',
      redirectTo: 'home',
      pathMatch: 'full'
    },{
      path: 'ria_map',
      loadChildren : './_components/ria-map/ria-map.module#RiaMapModule'
    },{
      path: 'home',
      component :HomeComponent
    },{
        path: 'plot-timeline',
        loadChildren: './_components/plot-timeline/plot-timeline.module#PlotTimelineModule'
    }
    ,{
        path: 'user-profile',
        loadChildren: './_components/profile/profile.module#ProfileModule'
    },{
        path: 'sms',
        component : SmsComponent
    },{
        path: 'export',
        loadChildren: './_components/export/export.module#ExportModule'
    },{
        path: 'import',
        loadChildren: './_components/import/import.module#ImportModule'
    },{
        path: 'cap2020',
        loadChildren: './_components/cap2020/cap2020.module#Cap2020Module'
    },{
      path: 'pilot',
      loadChildren: './_components/pilot/pilot.module#PilotModule'
    },{ 
      path: 'users/farmer-form',
      //canActivate: [CanActivateViaAuthGuardpkoùùùùùùùù_],
      component : FarmerFormComponent
    },{ path: 'users/farmer-list',
     component : FarmerListComponent
    },{ path: 'technician-form',
     component : TechnicianFormComponent
    },{ path: 'technician-update',
     component : TechnicianUpdateComponent
    },{ path: 'users/technician-list',
     component : TechnicianListComponent
    },{
     path: 'users/cooperative-form', component : CooperativeFormComponent 
    },{ path: 'users/cooperative-list',
     component : CooperativeListComponent
    },{
      path: 'my-riamap',
      component :MyRiamapComponent
    },{
      path: 'documents/list',
      component :DocumentsComponent
    },{
      path: 'upload-files',
      component : UploadFilesComponent
    },
    {
      path: 'planning',
      component : PlanningComponent 
    },{
      path: 'tour-details/:identify',
      component : TourListComponent 
    },{
      path: 'tour-details',
      component : TourListComponent 
    },{
      path: 'my-tours',
      component : MyToursComponent 
    },{
      path: 'new-tour',
      component :  NewTourComponent 
    },{
      path: 'folow-plot-states',
      component :  FollowPlotStatesComponent 
    },{
      path: 'plan-vol',
      loadChildren : './_components/my-riamap-plan-vol/my-riamap-plan-vol.module#MyRiamapPlanVolModule'
    },{
      path: 'orders/order_v1',
      component :OrderComponent 
    },{
      path: 'orders/order',
      component :OrderV2Component  
    },{
      path: 'orders/orderlist',
      component: ListComponent
    },{
      path: 'stock',
      component :StockComponent
    }, {
      path: 'dashboard',
      loadChildren: './dashboard/dashboard.module#DashboardModule'
    }, {
      path: 'widget',
      loadChildren: './widget/widget.module#WidgetModule'
    }, {
      path: 'basic',
      loadChildren: './components/basic/basic.module#BasicModule'
    }, {
      path: 'advance',
      loadChildren: './components/advance/advance.module#AdvanceModule'
    }, {
      path: 'animations',
      loadChildren: './animations/animations.module#AnimationsModule'
    }, {
      path: 'forms',
      loadChildren: './components/forms/forms.module#FormsModule'
    }, {
      path: 'bootstrap-table',
      loadChildren: './components/tables/bootstrap-table/bootstrap-table.module#BootstrapTableModule',
    }, {
      path: 'data-table',
      loadChildren: './components/tables/data-table/data-table.module#DataTableModule',
    }, {
      path: 'map',
      loadChildren: './map/map.module#MapModule',
    }, {
      path: 'charts',
      loadChildren: './charts/charts.module#ChartsModule',
    }, {
      path: 'maintenance/error',
      loadChildren: './maintenance/error/error.module#ErrorModule'
    }, {
      path: 'maintenance/coming-soon',
      loadChildren: './maintenance/coming-soon/coming-soon.module#ComingSoonModule'
    }, {
      path: 'user',
      loadChildren: './user/user.module#UserModule'
    }, {
      path: 'email',
      loadChildren: './email/email.module#EmailModule'
    }, {
      path: 'crm-contact',
      loadChildren: './components/crm-contact/crm-contact.module#CrmContactModule'
    }, {
      path: 'task',
      loadChildren: './components/task/task.module#TaskModule'
    }, {
      path: 'editor',
      loadChildren: './components/editor/editor.module#EditorModule'
    }, {
      path: 'invoice',
      loadChildren: './components/invoice/invoice.module#InvoiceModule'
    }, {
      path: 'file-upload',
      loadChildren: './components/file-upload/file-upload.module#FileUploadModule'
    }, {
      path: 'change-log',
      loadChildren: './change-log/change-log.module#ChangeLogModule'
    }, {
      path: 'simple-page',
      loadChildren: './simple-page/simple-page.module#SimplePageModule'
    }
  ]
}, {
  path: '',
  component: AuthLayoutComponent,
  children: [{
    path: 'authentication',
    loadChildren: './authentication/authentication.module#AuthenticationModule'
  }, {
    path: 'error',
    loadChildren: './error/error.module#ErrorModule'
  }, {
    path: 'landing',
    loadChildren: './landing/landing.module#LandingModule'
  }, {
    path: 'maintenance/offline-ui',
    loadChildren: './maintenance/offline-ui/offline-ui.module#OfflineUiModule'
  }, ]
}, {
  path: '**',
  redirectTo: 'error/404'
},
];
